#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> g;
vector<int> c, l1, r1, k, j, tin, tout, e, ans;
vector<bool> used;
bool ok;

struct st {
    int cost, cnt, num;
};

bool cmp(st a, st b) {
    return (a.cost < b.cost);
}

const int INF = 1e9 + 7;

int cnt = 1;

void tt(int v) {
    e.push_back(v);
    for (int i = 0; i < g[v].size(); i++) {
        int u = g[v][i];
        tt(u);
    }
    e.push_back(v);
}

void dfs(int v) {
    int s = 0;
    for (int i = 0; i < g[v].size(); i++) {
        int u = g[v][i];
        dfs(u);
        s += k[u];
    }
    k[v] = s;
    vector<st> q;
    int i1 = 0;
    while(i1 < e.size() && e[i1] != v) {
        i1++;
    }
    i1++;
    vector<int> was(1000000, 0);
    while(i1 < e.size() && e[i1] != v) {
        int u = e[i1];
        if (was[u] == 0) {
            q.push_back({c[u], j[u], u});
            was[u] = 1;
        }
        i1++;
    }
    q.push_back({c[v], r1[v] - k[v], v});
    j[v] = r1[v] - k[v];
    sort(q.begin(), q.end(), cmp);
    int l = l1[v];
    if (l > s) {
        l -= s;
        int i1 = 0;
        while(l > 0 && i1 < q.size()) {
            if (l >= q[i1].cnt) {
                l -= q[i1].cnt;
                ans[q[i1].num] += q[i1].cnt;
                q[i1].cnt = 0;
                j[q[i1].num] = 0;
            } else {
                q[i1].cnt -= l;
                j[q[i1].num] -= l;
                ans[q[i1].num] += l;
                l = 0;
            }
            i1++;
        }
        k[v] = l1[v];
    }
    if (k[v] < l1[v] || k[v] > r1[v]) {
        ok = false;
    }
    for (int i = 0; i < q.size(); i++) {
        q[i].cnt = max(q[i].cnt, r1[v] - k[v]);
        j[q[i].num] = max(j[q[i].num], r1[v] - k[v]);
        //cout << q[i].cost << " " << q[i].cnt << endl;
    }
    //cout << endl;
}

int main()
{
    int t;
    cin >> t;
    while(t) {
        int n;
        cin >> n;
        g.resize(n);
        c.resize(n);
        l1.resize(n);
        r1.resize(n);
        k.resize(n, 0);
        j.resize(n, 0);
        ans.resize(n, 0);
        ok = true;
        used.resize(n, false);
        for (int i = 1; i < n; i++) {
            int x;
            cin >> x;
            g[x - 1].push_back(i);
        }
        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> l1[i] >> r1[i];
        }
        //vector<st> q;
        //tt(0);
        //dfs(0);
        if (ok) {
            int sum = 0;
            for (int i = 0; i < n; i++) {
                sum += c[i] * ans[i];
            }
            cout << sum << endl;
            for (int i = 0; i < n; i++) {
                cout << ans[i] << " ";
            }
            cout << endl;
        } else {
            cout << "-1";
        }
        t--;
    }
}
