#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr long long INFLL = numeric_limits<long long>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ll = long long;

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("A-input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> v(n);
    cin >> v;
    auto z = v;
    sort(all(z));
    vector<vector<int>> d(n, vector<int>(n, 0));
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int ii = lower_bound(all(z), v[i]) - z.begin();
            int jj = lower_bound(all(z), v[j]) - z.begin();
            d[i][j] = abs(ii - jj);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            {
                int l = i, cnt = 0, mn = INF;
                while (l >= 0) {
                    mn = min(mn, l + cnt);
                    --l;
                    if (l >= 0 && v[l] < v[i]) {
                        ++cnt;
                    }
                }
                d[i][j] = max(d[i][j], j - mn);
            }
            {
                int r = j, cnt = 0, mx = -INF;
                while (r < n) {
                    mx = max(mx, j + cnt);
                    ++r;
                    if (r < n && v[r] < v[j]) {
                        ++cnt;
                    }
                }
                d[i][j] = max(d[i][j], mx - i);
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
//            cout << v[i] << " " << v[j] << ": " << d[i][j] << "\n";
            ans += d[i][j];
        }
    }
    cout << ans;
}
