#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr long long INFLL = numeric_limits<long long>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ll = long long;

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("C-input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int k = a[n - 1] - 1;
    int q;
    cin >> q;
    while (q--) {
        pair<int, int> u, v;
        cin >> u.first >> u.second >> v.first >> v.second;
        int nomeru = 2, nomerv = 2;
        if (abs(u.second - u.first) <= k) {
            nomeru = 1;
        }
        if (abs(v.second - v.first) <= k) {
            nomerv = 1;
        }
        auto solve1 = [](pair<int, int> u, pair<int, int> v) {
            if (u.second - u.first == v.second - v.first) {
                cout << min(u, v).first << " " << min(u, v).second << "\n";
            } else {
                pair root1 = {abs(u.second - u.first), 0}, root2 = {abs(v.second - v.first), 0};
                cout << min(root1, root2).first << " 0\n";
            }
        };
        if (nomeru == nomerv) {
            if (nomeru == 1) {
                solve1(u, v);
            } else {
                if (u.second == v.second) {
                    cout << min(u, v).first << " " << min(u, v).second << "\n";
                } else {
                    pair root1 = {k + u.second, u.second}, root2 = {k + v.second, v.second};
                    cout << min(root1, root2).first << " " << min(root1, root2).second << "\n";
                }
            }
        } else {
            if (nomeru != 1) {
                swap(u, v);
            }
            pair root2 = {k + v.second, v.second};
            solve1(u, root2);
        }
    }
}
