#include <bits/stdc++.h>

using namespace std;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr long long INFLL = numeric_limits<long long>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ll = long long;

vector<vector<int>> tin, tout;

bool isuancv(pair<int, int> u, pair<int, int> v) {
    return tin[u.first][u.second] <= tin[v.first][v.second] && tout[v.first][v.second] <= tout[u.first][u.second];
}

vector<vector<vector<pair<int, int>>>> g;

int timer = 0;

vector<vector<bool>> used;

void dfs(pair<int, int> v, pair<int, int> p) {
    used[v.first][v.second] = true;
    tin[v.first][v.second] = timer++;
    for (auto u: g[v.first][v.second]) {
        if (!used[u.first][u.second]) {
            dfs(u, v);
        } else if (used[u.first][u.second] && u != p) {
            assert(false);
        }
    }
    tout[v.first][v.second] = timer++;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("C-input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    if (n <= 3000) {
        for (auto &i: a) {
            --i;
        }
        vector<bool> m(n);
        g.resize(n + 1, vector<vector<pair<int, int>>>(n + 1));
        vector<vector<pair<int, int>>> p(n + 1, vector<pair<int, int>>(n + 1, {-1, -1}));
//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j <= n; ++j) {
//            g[i][j].reserve(3);
//        }
//    }
//    p[0][0] = {-1, -1};
        for (int i = 0; i <= n; ++i) {
            pair<int, int> rc = {0, 0};
            for (int j = 0; j < n; ++j) {
                auto gg = rc;
                if (m[j]) {
                    ++gg.first;
                } else {
                    ++gg.first;
                    ++gg.second;
                }
                p[gg.first][gg.second] = rc;
                rc = gg;
            }
            if (i < n) {
                m[a[i]] = true;
            }
        }
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= n; ++j) {
                if (p[i][j] != pair(-1, -1)) {
                    g[i][j].push_back(p[i][j]);
                    g[p[i][j].first][p[i][j].second].push_back({i, j});
                }
            }
        }
        tin.resize(n + 1, vector<int>(n + 1));
        tout.resize(n + 1, vector<int>(n + 1));
        used.resize(n + 1, vector<bool>(n + 1));
        dfs({0, 0}, {-1, -1});
        int q;
        cin >> q;
        while (q--) {
            pair<int, int> u, v;
            cin >> u.first >> u.second >> v.first >> v.second;
            while (!isuancv(u, v)) {
                u = p[u.first][u.second];
            }
//        vector<pair<int, int>> pu, pv;
//        while (u != pair(-1, -1)) {
//            pu.push_back(u);
//            u = p[u];
//        }
//        while (v != pair(-1, -1)) {
//            pv.push_back(v);
//            v = p[v];
//        }
//        pair ans = {0, 0};
//        for (auto i: pu) {
//            for (auto j: pv) {
//                if (i == j) {
//                    ans = max(ans, i);
//                }
//            }
//        }
            cout << u.first << " " << u.second << "\n";
        }
    } else {
        int k = a[n - 1] - 1;
        int q;
        cin >> q;
        while (q--) {
            pair<int, int> u, v;
            cin >> u.first >> u.second >> v.first >> v.second;
            int nomeru = 2, nomerv = 2;
            if (abs(u.second - u.first) <= k) {
                nomeru = 1;
            }
            if (abs(v.second - v.first) <= k) {
                nomerv = 1;
            }
            auto solve1 = [](pair<int, int> u, pair<int, int> v) {
                if (u.second - u.first == v.second - v.first) {
                    cout << min(u, v).first << " " << min(u, v).second << "\n";
                } else {
                    pair root1 = {abs(u.second - u.first), 0}, root2 = {abs(v.second - v.first), 0};
                    cout << min(root1, root2).first << " 0\n";
                }
            };
            if (nomeru == nomerv) {
                if (nomeru == 1) {
                    solve1(u, v);
                } else {
                    if (u.second == v.second) {
                        cout << min(u, v).first << " " << min(u, v).second << "\n";
                    } else {
                        pair root1 = {k + u.second, u.second}, root2 = {k + v.second, v.second};
                        cout << min(root1, root2).first << " " << min(root1, root2).second << "\n";
                    }
                }
            } else {
                if (nomeru != 1) {
                    swap(u, v);
                }
                pair root2 = {k + v.second, v.second};
                solve1(u, root2);
            }
        }
    }
}
