/*
 * author: WeetHet
 */
#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template <typename T, typename U>
bool ckmin(T& a, const U& b) {
    return a > b && (a = b, true);
}

template <typename T, typename U>
bool ckmax(T& a, const U& b) {
    return a < b && (a = b, true);
}

constexpr int MAX_N = 1e5;
vi g[MAX_N];
int w[MAX_N], c[MAX_N], l[MAX_N], r[MAX_N], par[MAX_N], answ[MAX_N];

set<pii> now[MAX_N];

int min_path(int v, int u) {
    return v == u? r[v]: min(r[v], min_path(par[v], u));
}

void add_path(int v, int u, int value) {
    w[v] += value;
    if (v != u) add_path(par[v], u, value);
}

ll ans = 0;

void dfs(int v) {
    if (ans == -1) return;
    for (auto u: g[v]) {
        dfs(u);
        w[v] += w[u];
        now[v].insert({c[u], u});
    }

    now[v].insert({c[v], v});

    if (w[v] > r[v]) {
        ans = -1;
        return;
    }

    while (w[v] < l[v]) {
        if (now[v].empty() || ans == -1) {
            ans = -1;
            return;
        }
        int u = now[v].begin()->second, add = min(l[v] - w[v], min_path(u, v) - w[u]);
        answ[u] += add;
        ans += 1LL * c[u] * add;
        add_path(u, v, add);
        now[v].erase(now[v].begin());
    }
}

void solve() {
    int n;
    cin >> n;

    rep(i, 1, n) {
        cin >> par[i], --par[i];
        g[par[i]].push_back(i);
    }
    rep(i, 0, n) cin >> c[i];
    rep(i, 0, n) cin >> l[i] >> r[i];

    dfs(0);
    cout << ans << '\n';

    if (ans != -1) {
        rep(i, 0, n) cout << answ[i] << ' ';
        cout << '\n';
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int T;
    cin >> T;
    while (T--) solve();
}