#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;

#define int ll
#define len(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

template<typename T, typename comparator = less<T>>
using ordered_set = tree<T,
                         null_type,
                         comparator,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (auto & e : p)
        cin >> e;
    vector<pair<int, int>> p_sorted(n);
    for (int i = 0; i < n; ++i) {
        p_sorted[i].first = p[i];
        p_sorted[i].second = i;
    }
    sort(all(p_sorted));
    vector<int> sorted_pos(n);
    for (int i = 0; i < n; ++i) {
        sorted_pos[p_sorted[i].second] = i;
    }
    vector<vector<int>> ans(n, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans[i][j] = abs(sorted_pos[i] - sorted_pos[j]);
        }
    }
    ordered_set<int, greater<>> cnt_greater;
    for (int i = 0; i < n - 1; ++i) {
        int pos = i - cnt_greater.order_of_key(p[i]);
        for (int j = i + 1; j < n; ++j) {
            ans[i][j] = max(ans[i][j], j - pos);
        }
        cnt_greater.insert(p[i]);
    }
    ordered_set<int> cnt_less;
    for (int j = n - 1; j > 0; --j) {
        int pos = j + cnt_less.order_of_key(p[j]);
        for (int i = j - 1; i >= 0; --i) {
            ans[i][j] = max(ans[i][j], pos - i);
        }
        cnt_less.insert(p[j]);
    }
    ll ans_sum = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans_sum += ans[i][j];
        }
    }
    cout << ans_sum << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
