#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<vector<long long> > a;
vector<long long> tin, tout;

vector<long long> c;

vector<long long> ls, rs;



long long ctr = -1;
vector<long long> sz;
vector<long long> p;
void dfs(long long v) {
	sz[v] = 1;
	for (auto h : a[v]) {
		dfs(h);
		sz[v] += sz[h];
	}
	if (a[v].size() > 0) {
		long long bpos = 0;
		for (long long i = 0; i < a[v].size(); i++) {
			if (sz[a[v][i] > sz[a[v][bpos]]]) {
				bpos = i;
			}
		}
		swap(a[v][0], a[v][bpos]);
	}

}
vector<long long> from;
vector<long long> pos;

void dfs1(long long v, long long to) {
	from[v] = to;
	pos[v] = ctr++;
	if (a[v].size() > 0) {
		dfs1(0, to);
		for (long long i = 1; i < a[v].size(); i++) {
			dfs1(a[v][i], a[v][i]);
		}
	}
}
vector<long long> vals;
long long findmin(long long v) {
	if (vals[v] == rs[v]) {
		return -1;
	}
	long long ans = c[v];
	long long anspos = v;
	for (auto h : a[v]) {
		long long hh = findmin(h);

		if (hh != -1 && c[hh] < c[anspos]) {
			anspos = hh;
		}
	}
	return anspos;
}
unsigned long long ans = 0;
vector<long long> bought;
long long dfs2(long long v) {
	long long curval = 0;
	for (auto h : a[v]) {
		long long val = dfs2(h);
		if (val == -1) {
			return -1;
		}
		curval += val;
		if (curval > rs[v]) {
			return -1;
		}
	}
	if (curval > rs[v]) {
		return -1;
	}
	else if (curval >= ls[v]) {
		return vals[v] = curval;
	}
	else {
		vals[v] = curval;
		while (vals[v] < ls[v]) {
			long long need = ls[v] - vals[v];
			long long mnm = findmin(v);
			if (mnm == -1) {
				return -1;
			}
			else {
				long long have = need;
				long long cur = mnm;
				while (cur != v) {
					have = min(have, rs[cur] - vals[cur]);
					cur = p[cur];
				}
				cur = mnm;
				while (cur != v) {
					vals[cur] += have;
					cur = p[cur];
				}
				vals[v] += have;
				ans += (long long)c[mnm] * have;
				bought[mnm] += have;
			}
		}
		return vals[v];


	}
}

int main() {
	long long t;
	cin >> t;
	for (long long tt = 0; tt < t; tt++) {
		long long n;
		cin >> n;
		a.clear();
		p.clear();
		vals.clear();
		bought.clear();
		c.clear();
		ls.clear();
		sz.clear();
		rs.clear();

		ans = 0;

		a.resize(n);
		p.resize(n);
		vals.resize(n);
		bought.resize(n);
		sz.resize(n);
		c.resize(n);
		ls.resize(n);
		rs.resize(n);
		p[0] = -1;
		for (long long i = 1; i < n; i++) {
			long long x;
			cin >> x;
			x--;
			a[x].push_back(i);
			p[i] = x;

		}
		for (long long i = 0; i < n; i++) {
			cin >> c[i];
		}
		for (long long i = 0; i < n; i++) {
			cin >> ls[i] >> rs[i];
		}
		dfs(0);
		//dfs1(0,0);
		long long anss = dfs2(0);
		if (anss == -1) {
			cout << -1 << '\n';
			continue;

		}
		cout << ans << '\n';
		for (long long i = 0; i < n; i++) {
			cout << bought[i] << ' ';
		}
		cout << '\n';

	}
}