
#include <iostream>
#include<vector>
#include<set>
#include<algorithm>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
typedef long long ll;
typedef long double ld;
using namespace std;
vector<int> a;
vector<int> tmin;
void buildmin(int i, int l, int r) {
    if (l+1 == r) tmin[i] = a[l];
    else {
        int k=(l+r)/2;
        buildmin(2*i+1, l, k);
        buildmin(2*i+2, k, r);
        tmin[i] = min(tmin[2*i+1], tmin[2*i+2]);
    }
}
int getmin(int i, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return 1e9;
    if (ql <= l && r <= qr) return tmin[i];
    int k=(l+r)/2;
    return min(getmin(2*i+1, l, k, ql, qr), getmin(2*i+2, k, r, ql, qr));
}
struct node {
    int sum=0, lg, rg;
    node *l = nullptr, *r = nullptr;
};
void buildsum(node *root) {
    if (root->lg+1 != root->rg) {
        int k=(root->lg+root->rg)/2;
        root->l = new node;
        root->l->lg = root->lg;
        root->l->rg = k;
        root->r = new node;
        root->r->lg = k;
        root->r->rg = root->rg;
        buildsum(root->l);
        buildsum(root->r);
    }
}
node* upd(node *root, int j) {
    node *n = new node;
    n->sum = root->sum+1;
    n->lg = root->lg;
    n->rg = root->rg;
    n->l = root->l;
    n->r = root->r;
    if (n->lg+1 != n->rg) {
        int k=(n->lg+n->rg)/2;
        if (j < k) n->l = upd(root->l, j);
        else n->r = upd(root->r, j);
    }
    return n;
}
int get(node *root, int x) {
    if (root->sum < x) return root->rg;
    if (x == 0) return -1;
    if (root->lg+1 == root->rg) return root->lg;
    if (root->l->sum >= x) get(root->l, x);
    else get(root->r, x - root->l->sum);
}
int getsum(node *root, int ql, int qr) {
    if (qr <= root->lg || root->rg <= ql) return 0;
    if (ql <= root->lg && root->rg <= qr) return root->sum;
    return getsum(root->l, ql, qr)+getsum(root->r, ql, qr);
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q, r1, c1, r2, c2;
    cin >> n;
    a.resize(n);
    vector<pair<int, int>> va(n);
    for (int i=0;i<n;i++) {
        cin >> a[i];
        va[i] = {a[i], i};
    }
    sort(all(va));
    vector<node*> ver={new node};
    ver[0]->lg = 0;
    ver[0]->rg = n;
    buildsum(ver[0]);
    for (int i=0;i<n;i++) ver.push_back(upd(ver.back(), va[i].sc));
    tmin.resize(4*n);
    buildmin(0,0,n);
    cin >> q;
    for (int t=0;t<3;t++) {
        cin >> r1 >> c1 >> r2 >> c2;
        int lq1=get(ver[r1], r1-c1), rq1=get(ver[r1], r1-c1+1);
        int lq2=get(ver[r2], r2-c2), rq2=get(ver[r2], r2-c2+1);
        int lq=min(lq1, lq2), rq=max(rq1, rq2);
        if (lq+1 == rq) {
            if (r1 < r2) cout << r1 << " " << c1 << "\n";
            else cout << r2 << " " << c2 << "\n";
            continue;
        }
        int ra=getmin(0, 0, n,lq+1, rq)-1;
        if (ra == 1e9-1) {
            cout << "0 0\n";
            continue;
        }
        int ca=getsum(ver[ra], 0, lq+1);
        cout << ra << " " << ra-ca << "\n";
    }
}