#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int MAXN = 1e5 + 1;
const int inf = 9e18 + 1329;

int p[MAXN];
vector <int> g[MAXN];
int l[MAXN];
int r[MAXN];
int c[MAXN];
int ans;
int res[MAXN];

int dfs(int v) {
	int vl = 0, vr = 0;
	int mn = v;
	for (int u : g[v]) {
		vl += l[u];
		vr += r[u];
		int y = dfs(u);
		if (c[y] < c[mn]) mn = y;
	}
	ans += max((int)0, l[v] - vl) * c[mn];
	res[mn] += max((int)0, l[v] - vl);
	if (vl > l[v]) l[v] = vl;
	return mn;
}

signed main() {
	p[0] = 0;
	int t; cin >> t;
	while (t--) {
		int n; cin >> n;
		for (int i = 0; i <= n; i++)  g[i].clear();
		for (int i = 1; i < n; i++) {
			int fr; cin >> fr; fr--;
			g[fr].push_back(i);
		}
		for (int i = 0; i < n; i++) cin >> c[i];
		for (int i = 0; i < n; i++) {
			cin >> l[i] >> r[i];
		}
		ans = 0;
		dfs(0);
		if (ans != inf) {
			cout << ans << endl;
			for (int i = 0; i < n; i++) cout << res[i] << ' ';
			cout << endl;
		}
		else cout << -1 << endl;
	}
}