#include <bits/stdc++.h>
#define int long long

using namespace std;

const int maxn = 3e3 + 1;

int g[maxn][maxn][2];
int tin[maxn][maxn], tout[maxn][maxn];
pair <int, int> p[maxn][maxn];
int tme = 1;

void dfs(int x, int y) {
    tin[x][y] = tme++;
    if (g[x][y][1]) {
        dfs(x + 1, y + 1);
    }
    if (g[x][y][0]) {
        dfs(x + 1, y);
    }
    tout[x][y] = tme++;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n; cin >> n;
    vector <int> a(n);
    vector <bool> st(n, 1);
    int x = 0, y = 0;
    for (int i = 0; i < n; ++i) {
        if (st[i] == 1) {
            g[x][y][1] = 1;
            x++; y++;
            p[x][y] = {x - 1, y - 1};
        } else {
            g[x][y][0] = 1;
            x++;
            p[x][y] = {x - 1, y};
        }
    }
    for (int j = 0; j < n; ++j) {
        cin >> a[j];
        st[a[j] - 1] = 0;
        x = 0; y = 0;
        for (int i = 0; i < n; ++i) {
            if (st[i] == 1) {
                g[x][y][1] = 1;
                x++; y++;
                p[x][y] = {x - 1, y - 1};
            } else {
                g[x][y][0] = 1;
                x++;
                p[x][y] = {x - 1, y};
            }
        }
    }
    dfs(0, 0);
    int q; cin >> q;
    for (int t = 0; t < q; ++t) {
        int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
        while (tin[r1][c1] > tin[r2][c2] || tout[r1][c1] < tout[r2][c2]) {
            auto nc = p[r1][c1];
            r1 = nc.first; c1 = nc.second;
        }
        cout << r1 << ' ' << c1 << "\n";
    }
}
