#include <bits/stdc++.h>

using namespace std;

#define int long long

int n;
vector < vector <int> > a;
vector <int> b, c, l, r, used, p, kol;
vector <int> dp;
bool ok = 1;
int otv = 0;

void dfs0(int v){
    int sm = 0;
    dp[v] = l[v];
    for(auto to : a[v]){
        dfs0(to);
        sm += dp[to];
    }

    dp[v] = max(dp[v], sm);

    if(dp[v] > r[v]){
        ok = 0;
    }
}

int cur = -1, kl = 0;

void dfs2(int v, int mn){
    if(c[cur] > c[v]){
        cur = v;
        kl = mn;
    }
    for(auto to : a[v]){
        if(kol[to] > 0) {
            dfs2(to, min(mn, kol[to]));
        }
    }
}

void dfs1(int v){
    int sm = 0;
    for(auto to : a[v]){
        dfs1(to);
        sm += dp[to];
    }

    while(sm < l[v]){
        cur = v;
        kl = l[v] - sm;
        dfs2(v, l[v] - sm);
        sm += kl;
        b[cur] += kl;
        kol[cur] -= kl;
        while(p[cur] > v){
            cur = p[cur];
            kol[cur] -= kl;
        }

        //cout << kl << " " << cur << '\n';
    }

    kol[v] = r[v] - dp[v];
}

vector < pair <int, int> > low;

void dfs3(int v){
    low[v] = {c[v], v};
    int sm = 0;
    dp[v] = l[v];

    for(auto to : a[v]){
        dfs3(to);
        low[v] = min(low[v], low[to]);
        sm += dp[to];
    }

    dp[v] = max(dp[v], sm);

    if(sm < l[v]){
        b[low[v].second] += l[v] - sm;
    }
}

void solve(){
    cin >> n;

    a.clear();
    c.clear();
    l.clear();
    r.clear();
    used.clear();
    dp.clear();
    b.clear();
    kol.clear();
    p.clear();
    ok = 1;
    otv = 0;

    a.resize(n);
    c.resize(n);
    l.resize(n);
    r.resize(n);
    used.resize(n);
    dp.resize(n);
    b.resize(n);
    p.resize(n);
    kol.resize(n);

    for(int i = 1; i < n; ++i){
        int x;
        cin >> x;
        --x;

        a[x].push_back(i);
        p[i] = x;
    }

    for(int i = 0; i < n; ++i){
        cin >> c[i];
    }

    for(int i = 0; i < n; ++i){
        cin >> l[i] >> r[i];
    }

    if(n <= 5000) {

        dfs0(0);
        if (!ok) {
            cout << -1 << '\n';
            return;
        }

        dfs1(0);

        for (int i = 0; i < n; ++i) {
            otv += b[i] * c[i];
        }

        cout << otv << '\n';
        for (int i = 0; i < n; ++i) {
            cout << b[i] << " ";
        }
        cout << '\n';
    }else{
        dfs3(0);

        for (int i = 0; i < n; ++i) {
            otv += b[i] * c[i];
        }

        cout << otv << '\n';
        for (int i = 0; i < n; ++i) {
            cout << b[i] << " ";
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //solve();

    int tests;
    cin >> tests;
    while(tests--){
        solve();
    }
}
