#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define sz(x) (int) size(x)
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define uniq(x) x.resize(unique(all(x)) - begin(x));
#define mp make_pair

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 998244353;
const int N = (100000) + 1;

template<typename T>
bool ckmx(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool ckmn(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct SegTree {
    vector<ll> mn, add;
    int sz = 1;

    void init(int n) {
        while (sz < n) sz <<= 1;
        mn.resize(sz << 1, infL);
        fill(all(mn), infL);
        add.resize(sz << 1);
        fill(all(add), 0);
    }

    void cl() {
        mn.clear();
        add.clear();
        sz = 1;
    }

    void st(int i, ll v) {
        int x = i + sz;
        while (x) {
            assert(add[x] == 0);
            ckmn(mn[x], v + add[x]);
            x >>= 1;
        }
    }

    void Add(int l, int r, ll v, int x, int lx, int rx) {
        if (l >= rx || lx >= r) return;
        if (l <= lx && rx <= r) {
            mn[x] += v;
            add[x] += v;
            return;
        }
        int m = (lx + rx) >> 1;
        Add(l, r, v, x << 1, lx, m), Add(l, r, v, x << 1 | 1, m, rx);
        mn[x] = min(mn[x << 1], mn[x << 1 | 1]) + add[x];
    }

    ll get(int l, int r, int x, int lx, int rx) {
        if (l >= rx || lx >= r) return infL;
        if (l <= lx && rx <= r) {
            return mn[x];
        }
        int m = (lx + rx) >> 1;
        return min(get(l, r, x << 1, lx, m), get(l, r, x << 1 | 1, m, rx)) + add[x];
    }

    ll get(int l, int r) {
        return get(l, r, 1, 0, sz);
    }

    void Add(int l, int r, ll v) {
        Add(l, r, v, 1, 0, sz);
    }

};

int tin[N], tout[N], c[N], sz[N], p[N], head[N], T = 0;
vector<int> g[N];


set<pii > st[N];

ll L[N], R[N], mn[N], yy[N];
ll ans = 0;

void gg(int v) {
    sz[v] = 1;
    for (int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        gg(to);
        sz[v] += sz[to];
        if (sz[to] > sz[g[v][0]]) swap(g[v][0], g[v][i]);
    }
}

void precalc(int v, int hed = -1) {
    tin[v] = T++;
    if (hed == -1) {
        head[v] = v;
    } else
        head[v] = hed;
    for (int i = 0; i < sz(g[v]); ++i) {
        int to = g[v][i];
        if (i == 0) {
            precalc(to, head[v]);
        } else
            precalc(to);
    }
    tout[v] = T;
}

SegTree t;

vector<pii> get(int a, int b) {

    vector<pii > an;
    while(b != -1 && tin[a] <= tin[b] && tout[a] >= tout[b]) {
        an.emplace_back(tin[b], tin[b]);
        b = p[b];
    }
//    while (head[a] != head[b]) {
//        assert((tin[a] <= tin[b] && tout[a] >= tout[b]));
//        assert(tin[a] <= tin[b]);
//        an.emplace_back(tin[head[b]], tin[b]);
//        b = p[head[b]];
//    }
//    assert((tin[a] <= tin[b] && tout[a] >= tout[b]));
//    assert(tin[a] <= tin[b]);
//    an.emplace_back(tin[a], tin[b]);
    return an;
}

bool ok = true;

void dfs(int v) {
    st[v].insert(mp(c[v], v));
    for (int to: g[v]) {
        dfs(to);
        if (!ok) return;
        if (sz(st[to]) > sz(st[v])) swap(st[to], st[v]);
        for (auto x: st[to]) st[v].insert(x);
        st[to].clear();
        mn[v] += mn[to];
    }
    if (mn[v] > R[v]) {
        ok = false;
        return;
    }
    t.st(tin[v], R[v] - mn[v]);
    if (mn[v] < L[v]) {
        while (!st[v].empty()) {
            auto[ww, to] = *st[v].begin();
            st[v].erase(st[v].begin());
            auto vv = get(v, to);
            ll nw = infL;
            for (auto[l, r]: vv) {
                ckmn(nw, t.get(l, r + 1));
            }
            if (nw + mn[v] >= L[v]) {
                ll zz = L[v] - mn[v];
                yy[to] += zz;
                mn[v] = L[v];
                ans += zz * c[to];
                for (auto[l, r]: vv) {
                    t.Add(l, r + 1, -zz);
                }
                if (zz != nw) {
                    st[v].insert(mp(c[to], to));
                }
                break;
            } else {
                yy[to] += nw;
                mn[v] += nw;
                ans += nw * c[to];
                for (auto[l, r]: vv) {
                    t.Add(l, r + 1, -nw);
                }
            }
        }
    }
    if (mn[v] < L[v]) {
        ok = false;
        return;
    }
}

ll gz[N];

void check(int a) {
    gz[a] = yy[a];
    for (int to : g[a]) {
        check(to);
        gz[a] += gz[to];
    }
    assert(L[a] <= gz[a] && gz[a] <= R[a]);
}

void solve() {
    int n;
    cin >> n;
    ok = true;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        st[i].clear();
        yy[i] = 0;
        gz[i] = 0;
        head[i] = -1;
        p[i] = -1;
    }
    p[0] = -1;
    T = 0;
    for (int i = 1; i < n; ++i) {
        int a;
        cin >> a;
        --a;
        p[i] = a;
        g[a].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
    }
    gg(0);
    precalc(0);
    t.cl();
    t.init(T);
    ans = 0;
    dfs(0);
    if (ok) {
        check(0);
        cout << ans << '\n';
        for (int i = 0; i < n; ++i) cout << yy[i] << " ";
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    while (test--)
        solve();
    return 0;
}
