#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>

using namespace std;


const int MN = 3050;

bool used[MN];
bool gr[MN * MN][2];
int n;
int tin[MN * MN];
int tout[MN * MN];
int timer = 1;
const int l = 12;
int up[l][MN * MN];

void dfs (pair<int, int> v, int z) {
    if (z == n - 1) {
        return;
    }
    int vv = v.first * n + v.second;
    if (!used[z]) {
        gr[vv][1] = true;
        dfs({v.first + 1, v.second + 1}, z + 1);
    }
    else {
        gr[vv][0] = true;
        dfs({v.first + 1, v.second}, z + 1);
    }
}

void fu(pair<int, int> v, int p) {
    int vv = v.first * n + v.second;
    up[0][vv] = p;
    tin[vv] = timer++;
    for (int i = 1; i < l; i++) {
        up[i][vv] = up[i - 1][up[i - 1][vv]];
    }
    if (gr[vv][0]) {
        fu({v.first + 1, v.second}, vv);
    }
    if (gr[vv][1]){
        fu({v.first + 1, v.second + 1}, vv);
    }
    tout[vv] = timer++;
}

bool upper(int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}



signed main() {
    cin >> n;
    n++;
    vector <int> a(n - 1);
    dfs({0, 0}, 0);
    for (int i = 0; i < n - 1; i++) {
        cin >> a[i];
        a[i]--;
        used[a[i]] = true;
        pair<int, int> st = {0, 0};
        dfs(st, 0);
    }
    fu({0, 0}, 0);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int aa = r1 * n + c1;
        int b = r2 * n + c2;
        if (upper(aa, b)) {
            cout << r1 << " " << c1 << "\n";
        }
        else {
            for (int ii = l - 1; ii > -1; ii--) {
                int nr = up[ii][aa];
                if (!upper(nr, b)) {
                    aa = nr;
                }
                if (upper(up[0][aa], b)) {
                    aa = up[0][aa];
                    break;
                }
            }
            cout << aa / n << " " << aa % n << "\n";
        }
    }
}