//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

vector<int> v;
int get(int l, int r, int i, int j, int n){
    vector<int> w = v;
    sort(w.begin() + l, w.begin() + r + 1);
    int i_ind = -1;
    int j_ind = -1;
    for (int k = 0; k < n; ++k) {
        if (w[k] == v[i]) {
            i_ind = k;
        }
        if (w[k] == v[j]) {
            j_ind = k;
        }
    }
    return abs(i_ind - j_ind);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    ifstream cin("A.in");
#endif
    int n;
    while (cin >> n){
        v.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> v[i];
        }
        vector<vector<int>> dp(n, vector<int>(n, 0));
        vector<int> sorted;
        for (int i = 0; i < n; ++i) {
            sorted.push_back(v[i]);
            sort(sorted.begin(), sorted.end());
            int more = 0;
            for (int j = 0; j < sorted.size(); ++j) {
                more += (sorted[j] >= v[i]);
            }
            for (int j = i + 1; j < n; ++j){
                dp[i][j] = max(dp[i][j], more + j - i - 1);
            }
        }
        sorted.resize(0);
        for (int i = n - 1; i >= 0; --i){
            sorted.push_back(v[i]);
            sort(sorted.begin(), sorted.end());
            int less = 0;
            for (int j = 0; j < sorted.size(); ++j){
                less += (sorted[j] <= v[i]);
            }
            for (int j = 0; j < i; ++j){
                dp[i][j] = max(dp[i][j], less + i - j - 1);
            }
        }
        long long sum = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < i; ++j) {
                int mx = max({i - j, abs(v[i] - v[j]), dp[i][j], dp[j][i]});
                sum += mx;
            }
        }
        cout << sum << endl;
    }
}