#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;


#define F first
#define S second
#define int long long

vector<vector<int>> g;
vector<int> costs;
vector<pair<int, int>> lr;
vector<int> sz;
vector<int> sm;
vector<int> ans;
ll ansm = 0;
bool fl = true;

void get_sz(int v) {
    ll s = 0;
    for (int i = 0; i < g[v].size(); i++) {
        get_sz(g[v][i]);
        if (sz[g[v][i]] > sz[g[v][0]]) swap(g[v][0], g[v][i]);
        s += sz[g[v][i]];
    }
    sz[v] = s + 1;
}

map<int, vector<pair<int, int>>> dfs(int v) {

    if (empty(g[v])) {
        map<int, vector<pair<int, int>>> mp;
        if (lr[v].S - lr[v].F)
            mp[costs[v]].emplace_back(v, lr[v].S - lr[v].F);
        ans[v] = lr[v].F;
        ansm += lr[v].F * costs[v];
        sm[v] = lr[v].F;
        return mp;
    }

    map<int, vector<pair<int, int>>> mp = dfs(g[v][0]);
    if (!fl) return mp;
    sm[v] += sm[g[v][0]];
    for (int i = 1; i < g[v].size(); i++) {
        auto u = g[v][i];
        auto mem = dfs(u);
        if (!fl) return mem;
        sm[v] += sm[u];
        for (auto [a, b] : mem){
            for (auto c : b) mp[a].emplace_back(c);
        }
    }
    if (sm[v] > lr[v].S){
        fl = false;
        return mp;
    }
    mp[costs[v]].emplace_back(v, lr[v].S - sm[v]);
    ll s = sm[v];

    if (s < lr[v].F) {
        for (auto &[k, z]: mp) {
            if (s >= lr[v].F) break;
            for (int i = z.size() - 1; i >= 0; i--) {
                if (z[i].S < lr[v].F - s) {
                    ans[z[i].F] += z[i].S;
                    ansm += z[i].S * costs[z[i].F];
                    s += z[i].S;
                    z.pop_back();
                } else {
                    ans[z[i].F] += (lr[v].F - s);
                    ansm += (lr[v].F - s) * costs[z[i].F];
                    z[i].S -= (lr[v].F - s);
                    s = lr[v].F;
                    if (z[i].S == 0) z.pop_back();
                    break;
                }
            }
        }
        sm[v] = lr[v].F;
    }
    if (mp[costs[v]].back().F == v){
        mp[costs[v]].back().S = lr[v].S - sm[v];
    }
    s = sm[v];
    auto last = mp.end();

    for (auto i = mp.begin(); i != mp.end(); i = next(i)){
        int last2 = -1;
        for (int j = 0; j < i->S.size(); j++){
            if (s + i->S[j].S < lr[v].S) s += i->S[j].S;
            else{
                last = i, last2 = j, i->S[j].S = lr[v].S - s;
                assert(i->S[j].S >= 0);
                break;
            }
        }
        if (last2 != -1) {
            for (int j = i->S.size() - 1; j > last2; j--)
                i->S.pop_back();
            assert(i->S.size() == last2 + 1);
            break;
        }
    }
    if (last == mp.end()){
        return mp;
    }
    auto i = prev(mp.end());
    while (i != last){
        i = prev(i);
        mp.erase(next(i));
    }
    return mp;
}

void solve(){
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    g.assign(n, vector<int>());
    sz.assign(n, 0);
    lr.assign(n, {0, 0});
    costs.assign(n, 0);
    ans.assign(n, 0);
    sm.assign(n, 0);
    fl = true;
    ansm = 0;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[--p].emplace_back(i);
    }
    for (auto &c: costs) cin >> c;
    for (auto &[l, r]: lr) cin >> l >> r;

    get_sz(0);

    dfs(0);
    if (!fl) cout << -1;
    else {
        cout << ansm << '\n';
        for (auto a: ans) cout << a << ' ';
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--){
        solve();
    }
    return 0;
}
