#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<vi> vvi;
typedef string str;
typedef vector<pii> vii;
typedef vector<bool> vb;

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vii points(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].X >> points[i].Y;
    }
    sort(all(points), [&](const pii &a, const pii &b) {
        return a.Y < b.Y;
    });
    int l = 0, r = w;
    int best_ans = 0;
    int now_ans = 0;
    for (int i = 0; i < n - 1; i++) {
        if (points[i].X <= l || points[i].X >= r) {
            now_ans += (r - l) * (h - points[i].Y);
            best_ans = max(best_ans, now_ans);
            l = r;
            break;
        } else if (points[i + 1].X >= points[i].X) {
            best_ans = max(best_ans, now_ans + (r - l) * (h - points[i].Y) - (points[i].X - l) * (points[i + 1].Y - points[i].Y));
            now_ans += (points[i].X - l) * (h - points[i].Y);
            l = points[i].X;
        } else {
            best_ans = max(best_ans, now_ans + (r - l) * (h - points[i].Y) - (r - points[i].X) * (points[i + 1].Y - points[i].Y));
            now_ans += (r - points[i].X) * (h - points[i].Y);
            r = points[i].X;
        }
        //cout << best_ans << ' ' << now_ans << ' ' << l << ' ' << r << endl;
    }
    if (points[n - 1].X > l && points[n - 1].X < r) {
        best_ans = max(best_ans, now_ans + max(points[n - 1].X - l, r - points[n - 1].X) * points[n - 1].Y);
    }
    cout << best_ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k;
    cin >> k;
    vi navigation(k);
    for (int i = 0; i < k; i++) {
        cin >> navigation[i];
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}