#pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;

struct ordered_set {
    size_t _size;
    size_t d[12001];

    void clear() {
        _size = 0;
        memset(d, 0, sizeof d);
    }

    void _insert(size_t n, size_t nl, size_t nr, size_t v) {
        if (nl == nr) return;
        if (v < nl || v >= nr) return;

        d[n]++;

        if (nr == nl + 1) return;
        _insert(n * 2 + 1, nl, (nl + nr) / 2, v);
        _insert(n * 2 + 2, (nl + nr) / 2, nr, v);
    }

    size_t _sum(size_t n, size_t nl, size_t nr, size_t ql, size_t qr) {
        if (nl == nr) return 0;
        if (qr <= nl || nr <= ql) return 0;

        if (ql <= nl && qr >= nr) return d[n];

        return _sum(n * 2 + 1, nl, (nl + nr) / 2, ql, qr) +
               _sum(n * 2 + 2, (nl + nr) / 2, nr, ql, qr);
    }

    void insert(size_t v) {
        _insert(0, 1, 3001, v);
        _size++;
    }

    size_t size() {
        return _size;
    }

    size_t order_of_key(size_t v) {
        return _sum(0, 1, 3001, 1, v + 1);
    }
};

/*
using namespace __gnu_pbds;

using ordered_set = tree<
  size_t, null_type, less<size_t>,
  rb_tree_tag,
  tree_order_statistics_node_update>;
*/

ordered_set full, prefix, suffix;

vector<size_t> p;
size_t ans, n, i, j;
int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    cin >> n;
    p.resize(n); for (auto& v : p) cin >> v;

    for (i = 0; i < n; i++)
        full.insert(p[i]);

    for (i = 0; i < n; i++) {
        size_t f1 = full.order_of_key(p[i]);
        size_t pref = prefix.size() - prefix.order_of_key(p[i]);

        suffix.clear();
        for (j = n; --j > i;) {
            size_t f2 = full.order_of_key(p[j]);

            size_t d3 = j - i + suffix.order_of_key(p[j]);
            size_t d4 = max(f1, f2) - min(f1, f2);
            size_t d6 = j - i + pref;

            ans += max(max(d3, d4), d6);

            suffix.insert(p[j]);
        }

        prefix.insert(p[i]);
    }

    cout << ans << endl;

    return 0;
}
