#include <iostream>

using namespace std;

typedef long long ll;

bool type[3030];
bool pr[3030][3030];
int used[3030][3030];

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        type[a - 1] = 1;
        int r = 0, c = 0;
        for (int i = 0; i < n; ++i) {
            if (type[i] == 0) {
                ++r;
                ++c;
            } else {
                pr[r + 1][c] = 1;
                ++r;
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        used[r1][c1] = i;
        while (r1 != 0 || c1 != 0) {
            c1 = c1 - 1 + pr[r1][c1];
            --r1;
            used[r1][c1] = i;
        }
        while (used[r2][c2] < i) {
            c2 = c2 - 1 + pr[r2][c2];
            --r2;
        }
        cout << r2 << ' ' << c2 << '\n';
    }
    return 0;
}
