#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <math.h>

//#define int long long

#define type pair<pair<int,int>,int>

using namespace std;

vector<vector<int>> nums;
vector<int> cost;
vector<int> vertL;
vector<int> vertR;
vector<int> minCnt;
vector<int> minCntCh;
vector<int> resCnt;
int resSum;
bool stop = false;

void out(set<type> a,int v) {
	cout <<v+1<< "{" << endl;;
	for (auto& i : a)
	{
		cout << i.first.first << " ";
		cout << i.first.second << " ";
		cout << i.second + 1 << endl;
	}
	cout << "}" << endl;;
}
//   cnt  set
void dfs_sum(int v) {
	minCnt[v] = 0;
	for (int i = 0; i < nums[v].size(); i++)
	{
		dfs_sum(nums[v][i]);
		minCnt[v] += minCnt[nums[v][i]];
	}
	minCntCh[v] = minCnt[v];
	minCnt[v] = max(minCnt[v], vertL[v]);
}

set<type> dfs(int v) {
	set<type> res;
	for (int i = 0; i < nums[v].size(); i++)
	{
		int nxt = nums[v][i];
		auto now = dfs(nxt);
		for (auto& el : now)
			res.insert(el);
	}
	//out(res,v);
	int nowAdded = minCntCh[v];
	if (nowAdded > vertR[v])stop = true;
	while (nowAdded<vertL[v])
	{
		type beg;
		if (res.size()!=0)
			beg = *res.begin();
		if (res.size() == 0||beg.first.first > cost[v])
			break;
		int left = vertL[v] - nowAdded;
		if (left >= beg.first.second) {
			nowAdded += beg.first.second;
			resSum += beg.first.first * beg.first.second;
			resCnt[beg.second] += beg.first.second;
			res.erase(res.begin());
		}
		else {
			nowAdded += left;
			resSum += beg.first.first * left;
			resCnt[beg.second] += left;
			beg.first.second -= left;
			res.erase(res.begin());
			res.insert(beg);
		}
	}
	if (nowAdded < vertL[v]) {
		int left = vertL[v] - nowAdded;
		resCnt[v] += left;
		resSum += left * cost[v];
		nowAdded = vertL[v];
	}

	int resSetSum = 0;
	for (auto& i : res)
		resSetSum += i.first.second;

	while (resSetSum > vertR[v])
	{
		int d = resSetSum - vertR[v];
		auto beg = *res.rbegin();
		if (beg.first.second < d) {
			resSetSum -= beg.first.second;
			res.erase(--res.end());
		}
		else {
			res.erase(--res.end());
			beg.first.second -= d;
			res.insert(beg);
			break;
		}
	}

	//out(res, v);
	res.insert({ {cost[v],vertR[v] - nowAdded},v });
	return res;
}



int32_t main()
{
	int t;
	cin >> t;
	for (int tkl = 0; tkl < t; tkl++)
	{
		int n;
		cin >> n;
		nums = vector<vector<int>> (n);
		for (int i = 1; i < n; i++)
		{
			int a;
			cin >> a;
			a--;
			int b = i;
			nums[a].push_back(b);
			//nums[b].push_back(a);
		}
		stop = false;
		resSum = 0;
		resCnt = vector<int>(n, 0);
		minCntCh = vector<int>(n, 0);
		cost = vector<int> (n);
		vertL = vector<int> (n);
		vertR = vector<int> (n);
		minCnt = vector<int> (n);
		
		for (int i = 0; i < n; i++)
			cin >> cost[i];
		for (int i = 0; i < n; i++) {
			cin >> vertL[i];
			cin >> vertR[i];

		}
			
		dfs_sum(0);
		dfs(0);
		if (!stop) {
			cout << resSum << endl;
			for (int i = 0; i < n; i++)
				cout << resCnt[i] << " ";
			cout << endl;
		}
		else
			cout << -1 << endl;
	}
}

