#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector<int> vec;
int A[4000][4000];
int INF = 1000000000;

int main()
{
	cin >> n;
	vec.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> vec[i];
	}
	for (int L = 0; L < n; ++L)
	{
		for (int R = 0; R < L; ++R)
		{
			A[L][R] = L - R;
		}
	}

	for (int LS = 0; LS < n; LS++)
	{
		vector<pair<int, int>> vec2;
		for (int RS = LS; RS < n; RS++)
		{
			vec2.push_back(make_pair(vec[RS], RS));
			sort(vec2.begin(), vec2.end());
			for (int O = LS; O <= RS; ++O)
			{
				for (int S = 0; S < n; ++S)
				{
					int ind1 = vec2[O - LS].second;
					int ind2 = S;
					if (LS <= S && S <= RS)
					{
						ind2 = vec2[ind2 - LS].second;
					}
					if (ind1 < ind2)
						swap(ind1, ind2);
					A[ind1][ind2] = max(A[ind1][ind2], abs(O - S));
				}
			}
		}
	}
	long long sum = 0;
	for (int L = 0; L < n; ++L)
	{
		for (int R = 0; R < n; ++R)
		{
			if (A[L][R] != INF)
				sum += A[L][R];
		}
	}
	cout << sum;
}
