#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const int INF = 1000000000;

bool ifCan = true;
int n, q;
vector<vector<int>> vec;
vector<int> c;
vector<int> L, R;
vector<vector<pair<int, pair<int, int>>>> cVec;
vector<int> ans;


pair<int, int> DFS(int ver, int pr)
{
	int nowSum = 0;
	int nowB = 0;
	for (auto j : vec[ver])
	{
		if (j == pr) continue;
		pair<int, int> p = DFS(j, ver);
		nowSum += p.first;
		nowB += p.second;
		for (int i = 0; i < cVec[j].size(); ++i)
		{
			cVec[ver].push_back(cVec[j][i]);
		}
	}
	cVec[ver].push_back(make_pair(c[ver], make_pair(INF, ver)));
	sort(cVec[ver].begin(), cVec[ver].end());
	ifCan &= L[ver] >= nowB;

	int i = 0;
	for (i = 0; i < cVec[ver].size() && nowB + cVec[ver][i].second.first < L[ver]; ++i)
	{
		nowB += cVec[ver][i].second.first;
		nowSum += cVec[ver][i].first * cVec[ver][i].second.first;
		ans[cVec[ver][i].second.second] += cVec[ver][i].second.first;
		cVec[ver][i].second.first = 0;
	}
	nowSum += (L[ver] - nowB) * cVec[ver][i].first;
	cVec[ver][i].second.first -= L[ver] - nowB;
	ans[cVec[ver][i].second.second] += L[ver] - nowB;
	nowB = L[ver];
	int nowMx = nowB;
	vector<pair<int, pair<int, int>>> normVec;
	for (i = 0; i < cVec[ver].size() && nowMx + cVec[ver][i].second.first < R[ver]; ++i)
	{
		if (cVec[ver][i].second.first > 0)
		{
			normVec.push_back(cVec[ver][i]);
			nowMx += cVec[ver][i].second.first;
		}
	}
	normVec.push_back(make_pair(cVec[ver][i].first, make_pair(R[ver] - nowMx, cVec[ver][i].second.second)));
	nowMx = R[ver];
	cVec[ver] = normVec;
	return make_pair(nowSum, nowB);
}

int main()
{
	cin >> q;
	while (q--)
	{
		cin >> n;
		vec.resize(0);
		vec.resize(n);
		c.resize(n);
		L.resize(n);
		R.resize(n);
		cVec.resize(0);
		cVec.resize(n);
		ans.resize(0);
		ans.resize(n);
		for (int i = 1; i < n; ++i)
		{
			int u;
			cin >> u;
			u--;
			vec[u].push_back(i);
		}
		for (int i = 0; i < n; ++i)
		{
			cin >> c[i];
		}
		for (int i = 0; i < n; ++i)
		{
			cin >> L[i] >> R[i];
		}

		ifCan = true;
		pair<int, int> p = DFS(0, 0);
		if (ifCan)
		{
			cout << p.first << endl;
			for (int i = 0; i < n; ++i)
				cout << ans[i] << " ";
		}
		else
		{
			cout << -1;
		}
		cout << endl;
	}
}
