#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

int n;
const int N = 4000;

vector<vector<pair<int, int>>> p;
bool l[N];

void solve() {
	cin >> n;

	p.resize(n + 1);
	for (int i = 0; i <= n; ++i) p[i].resize(i + 1);

	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n - i; ++j) {
			p[i][j] = { i, j };
		}
	}

	for (int i = 0; i < n; ++i) {
		int ind;
		cin >> ind;
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; ++i) {
		pair<int, int> a, b;
		cin >> a.first >> a.second >> b.first >> b.second;
		if (a.first > b.first) swap(a, b);
		cout << p[a.first][a.second].first << ' ' << p[a.first][a.second].second << '\n';
	}
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}