#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>

using namespace std;

int main() {
    long long n;
    cin >> n;
    vector <long long> p(n);
    for (long long i = 0; i < n; i++) {
        cin >> p[i];
    }
    vector <pair <long long, long long>> count(n);
    for (long long i = 0; i < n; i++) {
        count[i] = { 0, 0 };
        for (long long j = 0; j < i; j++) {
            if (p[j] > p[i]) count[i].first++;
        }
        for (long long j = i + 1; j < n; j++) {
            if (p[j] < p[i]) count[i].second++;
        }
    }
    long long res = 0;
    for (long long i = 0; i < n - 1; i++) {
        for (long long j = i + 1; j < n; j++) {
            res += max(j - i + max(count[i].first, count[j].second), abs(p[j] - p[i]));
        }
    }
    cout << res;
    return 0;
}
