#include <bits/stdc++.h>
using namespace std;

#define int long long

vector <vector <int>> t1;
vector <vector <int>> t2;
vector <int> a;
vector <int> pos;
vector <vector <int>> pref;
vector <vector <int>> suf;

const int INF = 1e5;

void build1(int i, int v, int l, int r) {
    if (r-l == 1) {
        t1[i][v] = pref[l][i] - l;
        return;
    }
    int m = (l+r)/2;
    build1(i,2*v+1, l, m);
    build1(i,2*v+2, m, r);
    t1[i][v] = max(t1[i][2*v+1], t1[i][2*v+2]);
    return;
}

void build2(int i, int v, int l, int r) {
    if (r-l == 1) {
        t2[i][v] = suf[l][i] + l;
        return;
    }
    int m = (l+r)/2;
    build2(i,2*v+1,l,m);
    build2(i,2*v+2,m,r);
    t2[i][v] = max(t2[i][2*v+1], t2[i][2*v+2]);
    return;
}

int get1(int i, int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return -INF;
    if (ql <= l && r <= qr) return t1[i][v];
    int m = (l+r)/2;
    if (qr <= l || m <= ql) return get1(i,2*v+2,m,r,ql,qr);
    if (qr <= m || r <= ql) return get1(i,2*v+1,l,m,ql,qr);
    return max(get1(i,2*v+1,l,m,ql,qr), get1(i,2*v+2,m,r,ql,qr));
}

int get2(int i, int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) return -INF;
    if (ql <= l && r <= qr) return t2[i][v];
    int m = (l+r)/2;
    if (qr <= l || m <= ql) return get2(i,2*v+2,m,r,ql,qr);
    if (qr <= m || r <= ql) return get2(i,2*v+1,l,m,ql,qr);
    return max(get2(i,2*v+1,l,m,ql,qr), get2(i,2*v+2,m,r,ql,qr));
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    pos.resize(n);
    for (int i = 0; i<n; ++i) {
        cin >> a[i];
        a[i]--;
        pos[a[i]] = i;
    }
    vector <vector <int>> d(n, vector<int>(n, 0));
    for (int i = 0; i<n-1; ++i) {
        for (int j = i+1; j<n; ++j) {
            d[i][j] = max(d[i][j], abs(pos[i] - pos[j]));
            d[i][j] = max(d[i][j], abs(i-j));
        }
    }

    pref.resize(n, vector<int>(n, 0));
    suf.resize(n, vector<int>(n, 0));
    for (int l = 0; l<n; ++l) {
        for (int i = 0; i<n; ++i) {
            if (l > 0) pref[l][i] = pref[l-1][i];
            if (a[l] > i) {
                pref[l][i]++;
            }
        }
    }

    for (int r = n-1; r>=0; --r) {
        for (int j = 0; j<n; ++j) {
            if (r < n-1) suf[r][j] = suf[r+1][j];
            if (a[r] < j) {
                suf[r][j]++;
            }
        }
    }


    /*for (int i = 0; i<n; ++i) {
        cout << i << ':';
        for (auto el: d[i]) cout << el << ' ';
        cout << endl;
    }*/

    int cnt = 0;




    for (int i = 0; i<n-1; ++i) {
        for (int j = i+1; j<n; ++j) {
            if (pos[i] < pos[j]) {
                d[i][j] = max(d[i][j], pos[j] + pref[pos[i]][i] - pos[i]);
                d[i][j] = max(d[i][j], -pos[i] + suf[pos[j]][j] + pos[j]);
            }
            else {
                d[i][j] = max(d[i][j], pos[i] + pref[pos[j]][j] - pos[j]);
                d[i][j] = max(d[i][j], -pos[j] + suf[pos[i]][i] + pos[i]);
            }
            cnt += d[i][j];
        }
    }

    /*for (int i = 0; i<n; ++i) {
        cout << i << ':';
        for (auto el: d[i]) cout << el << ' ';
        cout << endl;
    }*/

    cout << cnt << endl;
    return 0;
}

