#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
#ifdef _DEBUG
#pragma warning(disable : 4996)
	//freopen("input.txt", "r", stdin);
#endif // _DEBUG

	long long n;
	cin >> n;
	vector<long long> a(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	a.insert(a.begin(), 0);

	long long q;
	cin >> q;
	for (long long qr = 0; qr < q; qr++)
	{
		long long r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		long long q1 = 0;
		long long dc = r1 - c1;
		for (long long i = 1; i <= n; i++)
		{
			if (a[i] <= r1)
			{
				dc--;
			}
			if (dc == 0)
			{
				q1 = i;
				break;
			}
		}

		long long q2 = 0;
		dc = r2 - c2;
		for (long long i = 1; i <= n; i++)
		{
			if (a[i] <= r2)
			{
				dc--;
			}
			if (dc == 0)
			{
				q2 = i;
				break;
			}
		}

		if (q1 == q2)
		{
			cout << min(r1, r2) << " " << min(c1, c2) << "\n";
			continue;
		}

		if (q2 < q1)
		{
			swap(q1, q2);
		}

		long long minq = q2;
		for (long long i = q1 + 1; i <= q2; i++)
		{
			if (a[i] < a[minq])
			{
				minq = i;
			}
		}

		long long rlca = a[minq] - 1;
		long long clca = rlca;
		for (long long i = 1; i <= minq; i++)
		{
			if (a[i] <= rlca)
			{
				clca--;
			}
		}

		cout << rlca << " " << clca << "\n";
	}
	return 0;
}