#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
#ifdef _DEBUG
#pragma warning(disable : 4996)
	//freopen("input.txt", "r", stdin);
#endif // _DEBUG

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	a.insert(a.begin(), 0);

	int q;
	cin >> q;
	for (int qr = 0; qr < q; qr++)
	{
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int q1 = 0;
		int dc = r1 - c1;
		if (dc != 0)
		{
			for (int i = 1; i <= n; i++)
			{
				if (a[i] <= r1)
				{
					dc--;
				}
				if (dc == 0)
				{
					q1 = i;
					break;
				}
			}
		}

		int q2 = 0;
		dc = r2 - c2;
		if (dc != 0)
		{
			for (int i = 1; i <= n; i++)
			{
				if (a[i] <= r2)
				{
					dc--;
				}
				if (dc == 0)
				{
					q2 = i;
					break;
				}
			}
		}

		if (q1 == q2)
		{
			cout << min(r1, r2) << " " << min(c1, c2) << "\n";
			continue;
		}

		if (q2 < q1)
		{
			swap(q1, q2);
		}

		int minq = -1;
		for (int i = q1 + 1; i < q2; i++)
		{
			if (minq == -1 || a[i] < a[minq])
			{
				minq = i;
			}
		}

		if (minq == -1)
		{
			cout << min(r1, r2) << " " << min(c1, c2) << "\n";
			continue;
		}
		int rlca = a[minq] - 1;
		int clca = rlca;
		for (int i = 1; i <= minq; i++)
		{
			if (a[i] <= rlca)
			{
				clca--;
			}
		}

		cout << rlca << " " << clca << "\n";
	}
	return 0;
}