#include <bits/stdc++.h>


#define ll long long


using namespace std;

const int MAXN = 5000 + 10;
const ll INF = 1e14 + 7;


vector<int> graph[MAXN];
vector<vector<int>> p[MAXN];

ll dp[MAXN][MAXN];
int l[MAXN], r[MAXN];
ll c[MAXN];

int sum_l[MAXN], sum_r[MAXN];

ll get_dp(int v, int w) {
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    if (w < mx_size) return dp[v][w];
    return dp[v][mx_size] + max(0, w - mx_size) * c[v];
}

void dfs(int v) {
    for (int u: graph[v]) {
        r[u] = min(r[u], r[v]);
        dfs(u);
        sum_l[v] += l[u];
        sum_r[v] += r[u];
    }
    l[v] = max(sum_l[v], l[v]);
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    for (int i = 0; i <= mx_size; ++i) {
        dp[v][i] = i * c[v];
    }
    p[v].resize(graph[v].size(), vector<int>(mx_size + 1));
    int mn_sum = 0;
    for (int i = 0; i < graph[v].size(); ++i) {
        int u = graph[v][i];
        for (int w = mx_size; w >= l[u]; --w) {
            ll best = INF;
            int best_p = -1;
            for (int w2 = l[u]; w2 <= min({w, r[u]}) ; ++w2) {
                if (dp[v][w - w2] + get_dp(u, w2) < best) {
                    best = dp[v][w - w2] + get_dp(u, w2);
                    best_p = w2;
                }
            }
            p[v][i][w] = best_p;
            dp[v][w] = best;
        }
        mn_sum += l[u];
    }
}

int res[MAXN];

//
void ans(int v, int w) {
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    if (w > mx_size) {
        res[v] += w - mx_size;
        w = mx_size;
    }
    for (int i = ((int) graph[v].size()) - 1; i >= 0; --i) {
        ans(graph[v][i], p[v][i][w]);
        w -= p[v][i][w];
    }
    res[v] += w;
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
//    srand(time(0));
    while (t-- > 0) {
        int n;
        cin >> n;
//        n = 2;
//        cout << n << endl;
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            --p;
//            p = rand() % i;
//            cout << p << " ";
            graph[p].push_back(i);
        }
//        cout << endl;
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
//            c[i] = rand() % 10;
//            cout << c[i] << " ";
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
//            l[i] = rand() % 10;
//            r[i] = l[i] + rand() % 10;
//            cout << l[i] << ' ' << r[i] << endl;
        }
        dfs(0);
        ll mn = INF;
        int best_w = -1;
        for (int i = l[0]; i <= r[0]; ++i) {
            if (get_dp(0, i) < mn) {
                mn = get_dp(0, i);
                best_w = i;
            }
        }
        if (best_w != -1) {
            ans(0, best_w);
            cout << mn << endl;
            int sum = 0;
            for (int i = 0; i < n; ++i) {
                cout << res[i] << " ";
                sum += res[i] * c[i];
            }
            cout << "\n";
        } else {
            cout << "-1" << "\n";
        }
        for (int i = 0; i < n; ++i) {
            graph[i].clear();
            p[i].clear();
            sum_r[i] = 0;
            res[i] = 0;
        }
    }
    return 0;
}