#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <math.h>
using namespace std;
#define vll vector<ll>
#define sll set<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvpll vector<vpll>
#define siz(x) ((ll)(x.size()))
#define all(x) x.begin(), x.end()
#define INF 30000000000000
#define mp make_pair
typedef long long ll;
ll _ = 1, n;
ll dad[300000]; // ancestor
ll c[300000]; // cost
ll pc[300000];
ll l[300000]; // minimum allowed quantity of a subtree
ll r[300000]; // maximum allowed quantity of a subtree
vvll a(300000);
ll q[300000];
bool possible;
sll dfs(ll cur) {
	if (possible == 0) return sll();
	sll subtree;
	subtree.insert(cur);
	for (int i = 0; i < siz(a[cur]); i++)
	{
		if (a[cur][i] == cur) continue;
		sll p = dfs(a[cur][i]);
		for (auto pp : p) {
			subtree.insert(pp);
		}
	}
	ll cq = 0;
	for (auto ss : subtree) {
		cq += q[ss];
	}
	while (cq < l[cur]) {
		ll mini = c[cur];
		for (auto ss : subtree) {
			if ((mini == INF and c[ss] != INF) or (mini != INF and c[ss] < c[mini])) {
				mini = ss;
			}
		}
		if ((mini == INF and cq < l[cur]) or possible == 0) {
			possible = false;
			return sll();
		}

		ll p = mini;
		ll tam = l[cur] - cq;
		while (p != cur) {
			tam = min(tam, r[p] - q[p]);
			if (dad[p] == p) break;
			p = dad[p];
		}
		if (tam == 0) {
			c[mini] = INF;
			continue;
		}
		p = mini;
		while (p != cur) {
			q[p] += tam;
			if (dad[p] == p) break;
			p = dad[p];
		}
		cq += tam;
	}
	return subtree;
}
sll dfsq(ll cur) {
	if (possible == 0) return sll();
	sll subtree;
	subtree.insert(cur);
	for (int i = 0; i < siz(a[cur]); i++)
	{
		if (a[cur][i] == cur) continue;
		sll p = dfsq(a[cur][i]);
		for (auto pp : p) {
			subtree.insert(pp);
		}
	}
	ll cq = 0;
	for (auto ss : subtree) {
		cq += q[ss];
	}
	if (cq < l[cur] or cq > r[cur]) {
		possible = false;
		return sll();
	}
	return subtree;
}
void solve() {
	cin >> n;
	for (int i = 1; i < n; i++)
	{
		cin >> dad[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
		pc[i] = c[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}
	for (int i = 0; i < n; i++)
	{
		a[i].clear();
	}
	for (int i = 1; i < n; i++)
	{
		dad[i]--;
	}
	for (int i = 0; i < n; i++)
	{
		a[dad[i]].push_back(i);
	}

	possible = true;
	dfs(0);
	dfsq(0);
	if (possible == 0) {
		cout << -1 << endl;
		return;
	}
	ll res = 0;
	for (int i = 0; i < n; i++)
	{
		res += pc[i] * q[i];
	}
	cout << res << endl;
	for (int i = 0; i < n; i++)
	{
		cout << q[i] << " ";
	}
	cout << endl;
}
int main() {
	freopen("in.txt", "r", stdin);
	cin >> _;
	while (_--) {
		solve();
	}
}