//Komershan
//@defineintlonglong (telegram channel)
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

inline void operator delete (void*) {};

#define int long long

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int k;
	cin >> k;
	vector <int> dim(k);
	for (auto& i : dim)
		cin >> i;
	sort(dim.begin(), dim.end());
	if (k == 1 && dim[0] == 1) {
		int t;
		cin >> t;
		while (t--) {
			int n, w, h;
			cin >> n >> w >> h;
			vector <pair <int, int>> dots(n);
			for (auto& i : dots)
				cin >> i.first >> i.second;
			sort(dots.begin(), dots.end());
			reverse(dots.begin(), dots.end());
			vector <pair <int, int>> stack(1, dots[0]);
			for (int i = 0; i < n; i++) {
				while (stack.size() && dots[i].second <= stack.back().second)
					stack.pop_back();
				stack.push_back(dots[i]);
			}
			reverse(stack.begin(), stack.end());
			int res = (w - stack.back().first) * (h - stack.back().second);
			for (int i = stack.size() - 2; i >= 0; i--)
				res += (stack[i + 1].first - stack[i].first) * (h - stack[i].second);
			cout << res << '\n';
		}
	}
	else if (k == 2 && dim[0] == 1 && dim[1] == 2) {
		int t;
		cin >> t;
		while (t--) {
			int n, w, h;
			cin >> n >> w >> h;
			vector <pair <int, int>> dots(n);
			for (auto& i : dots)
				cin >> i.first >> i.second;
			sort(dots.begin(), dots.end(), [&](pair <int, int> a, pair <int, int> b) {return a.second < b.second || (a.second == b.second && a.first < b.first); });
			int res = 0;
			int id = n;
			for (int i = 0; i < n - 1; i++) {
				if (dots[i].second == dots[i + 1].second)
					id = i;
			}
			res += (h - dots[id].second) * w;
			for (int i = id - 1; i >= 0; i--) {
				res += max(dots[id].first, w - dots[id].first) * ((id + 1 < n ? dots[id + 1].second : h) - dots[id].second);
			}
			cout << res << '\n';
		}
	}
}