#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>

#define len(a) (int)a.size()

typedef long long ll;

const int INF = (int)1e9;

using namespace std;

void run();

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void run()
{
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
    }
    int q;
    cin >> q;
    for (; q > 0; --q)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int kekw1, kekw2;
        kekw1 = r1 - c1;
        kekw2 = r2 - c2;
        if (kekw1 != kekw2)
        {
            cout << max(kekw1, kekw2) << " 0\n";
        }
        else
        {
            if (r1 < r2)
            {
                cout << r1 << ' ' << c1 << '\n';
            }
            else
            {
                cout << r2 << ' ' << c2 << '\n';
            }
        }
        cout << max(kekw1, kekw2) << " 0\n";
    }
}
