#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <cmath>

#define len(a) (int)a.size()

typedef long long ll;

const int INF = (int)1e9;

using namespace std;

void run();

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void solve_test()
{
    int n, w, h;
    cin >> n >> w >> h;
    vector< pair<int, int> > points(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> points[i].first >> points[i].second;
    }
    sort(points.begin(), points.end());

    vector< pair<int, int> > st;
    st.push_back(points[0]);
    ll ans = (ll)(w - points[0].first) * (h - points[0].second);
    for (int i = 1; i < n; ++i)
    {
        if (points[i].second >= st.back().second)
        {
            continue;
        }
        ans += (ll)(w - points[i].first) * (st.back().second - points[i].second);
        st.push_back(points[i]);
    }

    cout << ans << '\n';
}

void run()
{
    int k;
    cin >> k;
    if (k != 1)
    {
        cout << "Nu pizdec\n";
        return;
    }
    cin >> k;
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}
