#include <iostream>
#include <vector>
#include <algorithm>
int main()
{
	int n; std::cin >> n;
	//only left included -> sort range to minimize left element position
	//only right included -> sort range to maximize right element position
	//if only right is included, it must be the start of the range
	//if only left is included, it must be the end of the range
	//both included -> maximize number of elements between a and b
	//this means "sort the whole array"
	//on each
	std::vector<int> p(n);
	for(int& x : p) std::cin >> x, x -= 1;
	std::vector<int> s = p;
	std::sort(s.begin(), s.end());
	std::vector<int> si = p;
	for(int i = 0; i < n; i++)
		si[s[i]] = i;
	std::vector<std::vector<int>> ans(n, std::vector<int>(n, 0));
	for(int i = 0; i < n; i++)
	for(int j = 0; j < i; j++)
	{
		// sort array
		ans[i][j] = std::max(ans[i][j], std::abs(si[p[i]]-si[p[j]]));
	}
	//for(int i = 0; i < n; i++)
	//{
	//	for(int j = 0; j < n; j++)
	//		printf("%d ", ans[i][j]);
	//	printf("\n");
	//}
	//for each element compute its minimal possible position by sorting a range ending at it
	std::vector<int> minpos(n), maxpos(n);
	for(int si = 0; si < n; si++)
	{
		//count greater elements before si
		int g = 0;
		for(int i = 0; i < si; i++) g += p[i] > p[si];
		int mp = si - g; // e.g. si=1,g=1 -> it will become first
		minpos[p[si]] = mp;
	}
	for(int si = 0; si < n; si++)
	{
		//count smaller elements after si
		int g = 0;
		for(int i = si+1; i < n; i++) { g += p[i] < p[si]; }
		int mp = si + g; // e.g. si=0, g=1 -> it will become second
		maxpos[p[si]] = mp;
	}
	//printf("minpos: "); for(int x : minpos) printf("%d ", x); printf("\n");
	//printf("maxpos: "); for(int x : maxpos) printf("%d ", x); printf("\n");
	for(int i = 0; i < n; i++)
	for(int j = 0; j < i; j++)
	{
		//printf("i=%d (%d) j=%d (%d) maxpos=%d minpos=%d\n", i, p[i]+1, j, p[j]+1, maxpos[p[i]], minpos[p[j]]);
		// move earlier element back
		ans[i][j] = std::max(ans[i][j], i-minpos[p[j]]);
		// move latter element forward
		ans[i][j] = std::max(ans[i][j], maxpos[p[i]]-j);
	}
	int64_t gans = 0;
	for(int i = 0; i < n; i++)
	{
		//printf("i=%d: ", i);
		for(int j = 0; j < n; j++)
		//	printf("%d ", ans[i][j]),
			gans += ans[i][j];
		//printf("\n");
	}
	printf("%lld\n", gans);
}
