#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <queue>

#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;
using db = double;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

void solve() {
	int n; cin >> n;
	int k = 0;
	vi a(n);
	rep(n) cin >> a[i];
	rep(n) {
		if (i < n - 1 && a[i + 1] == n) {
			k = a[i];
			break;
		}
	}
	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int n1 = r1 - c1;
		int n2 = r2 - c2;
		if (n1 <= k && n2 <= k) {
			if (r1 - c1 == r2 - c2) {
				if (r1 <= r2) cout << r1 << " " << c1 << "\n";
				else cout << r2 << " " << c2 << "\n";
			}
			else {
				if (r1 - c1 < r2 - c2) {
					cout << r1 - c1 << " 0\n";
				}
				else {
					cout << r2 - c2 << " 0\n";
				}
			}
		}
		else if (n1 <= k && c2 <= n - k) {
			if (n1 == k) {
				int x = r2 - c2 - k;
				int rr = r2 - x;
				int cc = c2;
				if (r1 <= rr)
					cout << r1 << " " << c1 << "\n";
				else
					cout << rr << " " << cc << "\n";
			}
			else {
				cout << r1 - c1 << " 0\n";
			}
		}
		else if (n2 <= k && c1 <= n - k) {
			swap(r1, r2);
			swap(c1, c2);
			if (n1 == k) {
				int x = r2 - c2 - k;
				int rr = r2 - x;
				int cc = c2;
				if (r1 <= rr)
					cout << r1 << " " << c1 << "\n";
				else
					cout << rr << " " << cc << "\n";
			}
			else {
				cout << r1 - c1 << " 0\n";
			}
		}
		else {
			if (c1 == c2) {
				if (r1 <= r2) cout << r1 << " " << c1 << "\n";
				else cout << r2 << " " << c2 << "\n";
			}
			else {
				if (c1 < c2) {
					int x = r1 - c1 - k;
					int rr = r1 - x;
					int cc = c1;
					cout << rr << " " << cc << "\n";
				}
				else {
					int x = r2 - c2 - k;
					int rr = r2 - x;
					int cc = c2;
					cout << rr << " " << cc << "\n";
				}
			}
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;// cin >> t;
	while (t--) solve();
}