#include<bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define mp make_pair
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define Time() clock() / (ld) CLOCKS_PER_SEC
//#define int long long

//#pragma GCC optimize("O3,ofast")
//#pragma target ("sse,sse2,sse3,ssse4,avx,avx2")

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef pair<long double, long double> pld;

const int MAXN = 3e3 + 10;

vector<int> revg[MAXN][MAXN];

bool go[MAXN][MAXN][2];

int n;

void up(int &i, vector<int> &p) {
    vector<int> ans;
    for (auto j : p) {
        for (auto to : revg[i][j]) ans.push_back(to);
    }
    sort(all(ans));
    ans.resize(unique(all(ans)) - ans.begin());
    ans.swap(p);
    i--;
}

pii query(int i1, int j1, int i2, int j2) {
    //cerr << "query" _ i1 _ j1 _ i2 _ j2 << endl;
    if (i1 > i2) {
        swap(i1, i2);
        swap(j1, j2);
    }
    vector<int> p1, p2;
    p2.push_back(j2);
    p1.push_back(j1);
    while (i2 > i1) up(i2, p2);
    vector<int> tmp(n * 2);
    while (set_intersection(all(p1), all(p2), tmp.begin()) - tmp.begin() == 0) {
        up(i1, p1);
        up(i2, p2);
        /*cerr << "up for h" _ i1 _ i2 << endl;
        cerr << "p1:" << endl;
        for (auto el : p1) cerr << el << ' ';
        cerr << endl;
        cerr << "p2:" << endl;
        for (auto el : p2) cerr << el << ' ';
        cerr << endl;
        cerr << "sz is" _ set_intersection(all(p1), all(p2), tmp.begin()) - tmp.begin() << endl;*/
    }
    //cerr << "end!"<< endl;
    tmp.resize(set_intersection(all(p1), all(p2), tmp.begin()) - tmp.begin());
    return {i1, tmp[0]};
}

int a[MAXN];

int now[MAXN];

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    fill(now, now + n, 1);
    for (int i = 0; i < n + 1; i++) {
        //cerr << "start path!" << endl;
        pii p = {0, 0};
        for (int j = 0; j < n; j++) {
            //cerr << p.f _ p.s << endl;
            go[p.f + 1][p.s + now[j]][now[j]] = 1;
            p.f++;
            p.s += now[j];
        }
        //cerr << p.f _ p.s << endl;
        now[a[i] - 1] = 0;
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            if (go[i][j][0]) revg[i][j].push_back(j);
            if (go[i][j][1]) revg[i][j].push_back(j - 1);
        }
    }
    int i1, j1, i2, j2;
    int q;
    pii ans;
    cin >> q;
    while (q--) {
        cin >> i1 >> j1 >> i2 >> j2;
        ans = query(i1, j1, i2, j2);
        cout << ans.f _ ans.s << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

