#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

const int INF = (int) 2e9;
const int N = 100500;
int x[N];
int y[N];
int n, w, h;

int f(int x1, int y1, int x2, int y2, vector<pair<int, int>> pts) {
  if (pts.empty()) {
    return 0;
  }
  if (pts.size() == 1) {
    int o1 = (x2 - pts[0].first) * (y2 - pts[0].second);
    int o2 = (pts[0].first - x1) * (pts[0].second - y1);
    return max(o1, o2);
  }
  int miny = INF, indy = 0;
  for (int i = 0; i < (int) pts.size(); i++) {
    if (pts[i].second >= miny) {
      int sus = 0;
      sus += (pts[i].first - x1) * (pts[i].second - y1);
      sus += (x2 - pts[indy].first) * (y2 - pts[indy].second);
      sus -= (pts[i].first - pts[indy].first) * (pts[i].second - pts[indy].second);
      vector<pair<int, int>> pts2, pts3;
      for (auto pr: pts) {
        if (pr.first <= pts[indy].first && pr.second >= pts[i].second && pr != pts[i] && pr != pts[indy]) {
          pts2.pb(pr);
        } else if (pr != pts[i] && pr != pts[indy] && pr.first >= pts[i].first && pr.second <= pts[indy].second) {
          pts3.pb(pr);
        }
      }
      int ans = sus + f(x1, pts[i].second, pts[indy].first, y2, pts2) + f(pts[i].first, y1, x2, pts[indy].second, pts3);
      return ans;
    }
    if (pts[i].second < miny) {
      miny = pts[i].second;
      indy = i;
    }
  }

  int las = 0;
  for (int _ = 0; _ < 7777; _++) {
    int prevx = x1;
    int prevy = y1;
    int as = 0;
    for (int i = 0; i < (int) pts.size(); i++) {
      if (rand() % 2) {
        as += (pts[i].first - prevx) * (pts[i].second - y1);
        prevx = pts[i].first;
      } else {
        as += (pts[i].second - prevy) * (x2 - pts[i].first);
        prevy = pts[i].second;
      }
    }
    las = max(las, as);
  }

  return las;


}


void solve() {
  cin >> n >> w >> h;
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  vector<pair<int, int>> pts;
  for (int i = 0; i < n; i++) {
    pts.pb({x[i], y[i]});
  }
  int ans = 0;
  sort(all(pts));
  cout << f(0, 0, w, h, pts) << '\n';
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int k;
  cin >> k;
  vector<int> gd(k);
  for (int i = 0; i < k; i++) {
    cin >> gd[i];
  }
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}