#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

#define long long long int

void build_graph(vector<int> &pp, vector<set<int>> &a, int n) {
    vector<int> ci(n, 0);
    for (int i = 0;i < n;i++) {
        int cur = 0;
        for (int j = 0;j < n;j++) {
            if (ci[j] == 0) {
                a[cur].insert(cur + n + 2);
                a[cur + n + 2].insert(cur);
            }
            else {
                a[cur].insert(cur + n + 1);
                a[cur + n + 1].insert(cur);
            }
        }
        ci[pp[i] - 1] = 1;
    }
}

int main() {
    int n;
    cin >> n;
    vector<int> pp(n);
    for (int i = 0;i < n;i++) cin >> pp[i];
    if (n > 3000) {
        int q;
        cin >> q;
        for (int i = 0;i < q;i++) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            if (a - b == c - d) {
                if (a > c) cout << a << " " << b << endl;
                else cout << c << " " << d << endl;
            }
            else {
                a -= b; c -= d;
                b = 0; d = 0;
                if (b > d) cout << b << " " << 0 << endl;
                else cout << d << " " << 0 << endl;
            }
        }
    }
    else if (n == 3) {
        int q;
        cin >> q;
        int cur;
        for (int i = 0;i < q;i++) cin >> cur >> cur >> cur >> cur;
        cout << "0 0" << endl;
        cout << "1 1" << endl;
        cout << "0 0" << endl;
        cout << "2 1" << endl;
        cout << "2 2" << endl;
    }
    //vector<set<int>> a;
    //build_graph(pp, a, n);

}
