#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e : v) o << e << " ";
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e : v) o >> e;
    return o;
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    cin >> p;

    vector<int> left(n, 0), right(n, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (p[j] > p[i]) left[i]++;
        }
        for (int j = i + 1; j < n; ++j) {
            if (p[j] < p[i]) right[i]++;
        }
    }
    dbg(left);
    dbg(right);
    ll total = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int case1 = abs(p[i] - p[j]);
            int case2 = j - i + left[i];
            int case3 = j - i + right[j];
            int res = max({case1, case2, case3});
            dbg(i);
            dbg(j);
            dbg(res);
            total += res;
        }
    }
    cout << total << "\n";
}

int main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while(q--) solve();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
#endif
    return 0;
}
