//#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>
#include<numeric>
#include<string>
#include<set>
#include<map>


using namespace std;
typedef long long ll;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(x, y) make_pair(x, y)

int n;
vector<vector<int>> g;
vector<int> pr;
vector<ll> c, l, r;
//vector<int> tin, tout;
vector<ll> a, b;
vector<int> eu;
vector<int> first, last;



bool operator <(pair<ll, int> aa, pair<ll, int> b) {
	if (aa.first < b.first) {
		return true;
	}
	else if (aa.first > b.first) {
		return false;
	}
	else {
		if (aa.second == -1) {
			return false;
		}
		if (b.second == -1) {
			return true;
		}
		if (r[aa.second] - a[aa.second] > r[aa.second] - a[aa.second]) {
			return true;
		}
		else {
			return false;
		}
	}
}

pair<ll, int> min(pair<ll, int> aa, pair<ll, int> b) {
	if (aa < b) {
		return aa;
	}
	return b;
}

const ll INF = 1e9 * 2;

ll ans = 0;

void dfse(int v) {
	first[v] = eu.size();
	eu.push_back(v);
	for (auto to : g[v]) {
		dfse(to);
	}
	last[v] = eu.size();
	eu.push_back(v);
}

vector<pair<ll, int>> t;
vector<bool> p;
int N;
int bn;


void push(int v, int tl, int tr) {
	if (p[v] == false) {
		return;
	}
	t[v].first = INF;
	if (tl + 1 == tr) {
		p[v] = 0;
		return;
	}
	p[v * 2] = true;
	p[v * 2 + 1] = true;
	p[v] = 0;
}

void build(int v, int tl, int tr) {
	if (tl + 1 == tr) {
		t[v].first = c[eu[tl]];
		t[v].second = eu[tl];
		return;
	}
	int mid = (tl + tr) / 2;
	build(v * 2, tl, mid);
	build(v * 2 + 1, mid, tr);
	t[v] = min(t[v * 2], t[v * 2 + 1]);

}

void upd(int v, int tl, int tr, int l, int r) {
	push(v, tl, tr);

	if (tl >= r || tr <= l) {
		return;
	}
	if (l <= tl && tr <= r) {
		p[v] = true;
		return;
	}
	int mid = (tl + tr) / 2;
	upd(v * 2, tl, mid, l, r);
	upd(v * 2 + 1, mid, tr, l, r);
	push(v * 2, tl, mid);
	push(v * 2 + 1, mid, tr);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

pair<ll, int> get(int v, int tl, int tr, int l, int r) {
	push(v, tl, tr);
	if (tl >= r || tr <= l) {
		return { INF, -1 };
	}
	if (l <= tl && tr <= r) {
		return t[v];
	}
	pair<ll, int> res = { INF, -1 };
	int mid = (tl + tr) / 2;
	res = min(res, get(v * 2, tl, mid, l, r));
	res = min(res, get(v * 2 + 1, mid, tr, l, r));
	return res;
}


void build() {
	N = eu.size() * 4;
	bn = eu.size();

	t.assign(N, { INF, -1 });
	p.assign(N, 0);
	build(1, 0, eu.size());
}


bool dfs(int v) {
	for (auto to : g[v]) {
		if (!dfs(to)) {
			return false;
		}
		a[v] += a[to];
	}

	int p1 = first[v], p2 = last[v];

	while (a[v] < l[v]) {
		pair<ll, int> temp = get(1, 0, bn, p1, p2 + 1);
		if (temp.first == INF) {
			return false;
		}
		int tv = temp.second;
		++a[v];
		++b[tv];
		if (b[tv] == r[tv]) {
			upd(1, 0, bn, first[tv], last[tv] + 1);
		}
	}
	if (a[v] == r[v]) {
		upd(1, 0, bn, first[v], last[v] + 1);
	}
	if (a[v] > r[v]) {
		return false;
	}
	return true;
}


void solve() {
	cin >> n;
	g.assign(n + 1, {});
	eu.clear();

	l.assign(n + 1, 0);
	r.assign(n + 1, 0);
	c.assign(n + 1, 0);
	pr.assign(n + 1, 0);
	a.assign(n + 1, 0);
	b.assign(n + 1, 0);
	first.assign(n + 1, 0);
	last.assign(n + 1, 0);
	ans = 0;

	for (int i = 2; i <= n; ++i) {
		cin >> pr[i];
		g[pr[i]].push_back(i);
	}
	for (int i = 1; i <= n; ++i) {
		cin >> c[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> l[i] >> r[i];
	}
	dfse(1);
	build();

	for (int i = 1; i <= n; ++i) {
		if (r[i] == 0) {
			upd(1, 0, bn, first[i], last[i] + 1);
		}
	}

	bool ok = dfs(1);
	if (!ok) {
		cout << -1 << '\n';
		return;
	}

	for (int i = 1; i <= n; ++i) {
		ans += c[i] * b[i];
	}
	cout << ans << '\n';
	for (int i = 1; i <= n; ++i) {
		cout << b[i] << ' ';
	}
	cout << '\n';
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	//freopen("input.txt", "r", stdin);
	int T;
	cin >> T;
	while (T--) {
		solve();
	}

	return 0;
}