#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<algorithm>
#include<numeric>
#include<string>
#include<set>
#include<map>


using namespace std;
typedef long long ll;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(x, y) make_pair(x, y)

void solve() {
	
	int n;
	ll w, h;
	cin >> n >> w >> h;

	vector<pair<ll, ll>> p(n);
	for (auto& i : p) {
		cin >> i.first >> i.second;
	}
	p.push_back({ 0, h });
	p.push_back({ w, 0 });
	sort(all(p));
	
	ll miny = p[0].second;
	ll ans = w * h;
	ll lx = p[0].first, ly = p[0].second;
	for (int i = 1; i <= n+1; ++i) {
		if (p[i].second > miny) {
			continue;
		}
		ans -= (ly * (p[i].first - lx));
		lx=p[i].first, ly = p[i].second;
		miny = min(miny, ly);
	}
	cout << ans << '\n';
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);

	int k;
	cin >> k;
	vector<int> al(k);
	for (auto& i : al) {
		cin >> i;
	}
	int T;
	cin >> T;
	while (T--) {
		solve();
	}
	
  	return 0;
}
