#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define endl '\n'
typedef long double ld;
using namespace std;

const int MAXN = 3179;
int ans[MAXN][MAXN];

void solve (vector<int> &P) {
    int n = P.size();
    vector<int> pre(n);
    vector<int> suf(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (P[i] < P[j]) {
                pre[i]++;
            }
        }
        for (int j = n - 1; j > i; j--) {
            if (P[j] < P[i]) {
                suf[i]++;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int a = min(P[i], P[j]);
            int b = max(P[i], P[j]);
            ans[a][b] = max({ans[a][b], j - i + pre[i], j - i + suf[j]});
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> P(n);
    for (int i = 0; i < n; i++) {
        cin >> P[i];
    }
    vector<int> kekw = P;
    sort(kekw.begin(), kekw.end());
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int a, b;
            a = min(kekw[i], kekw[j]);
            b = max(kekw[i], kekw[j]);
            ans[a][b] = j - i;
        }
    }
    solve(P);
    int answer = 0;
    for (int i = 1; i < n; i++) {
        for (int j = i + 1; j <= n; j++) {
            answer += ans[i][j];
        }
    }
    cout << answer << endl;
    return 0;
}
