#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int INF = 1e9 + 228;

int n;
vector<int> arr;

vector<int> tree1;

void build1(int v, int l, int r) {
    if (l + 1 == r) {
        tree1[v] = arr[l];
    } else {
        int m = (l + r) / 2;
        build1(2 * v + 1, l, m);
        build1(2 * v + 2, m, r);
        tree1[v] = min(tree1[2 * v + 1], tree1[2 * v + 2]);
    }
}

int get1(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return INF;
    }
    if (ql <= l && r <= qr) {
        return tree1[v];
    }
    int m = (l + r) / 2;
    return min(get1(2 * v + 1, l, m, ql, qr), get1(2 * v + 2, m, r, ql, qr));
}

int get_time(int r, int c) {
    if (r == c) {
        return 0;
    }
    int cur = r;
    for (int i = 0; i < n; i++) {
        if (arr[i] <= r) {
            cur--;
        }
        if (cur == c) {
            return i + 1;
        }
    }
    assert(false);
}

int get_mn(int l, int r) {
    return get1(0, 0, n, l, r);
    int ans = INF;
    for (int i = l; i < r; i++) {
        ans = min(ans, arr[i]);
    }
    return ans;
}

int get_in_time(int t, int r) {
    int c = r;
    for (int i = 0; i < t; i++) {
        if (arr[i] <= r) {
            c--;
        }
    }
    return c;
}

void solve() {
    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    tree1.resize(4 * n);
    build1(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int t1 = get_time(r1, c1);
        int t2 = get_time(r2, c2);
        if (t2 < t1) {
            swap(t1, t2);
            swap(r1, r2);
            swap(c1, c2);
        }
        int mn = get_mn(t1, t2);
        if (mn <= min(r1, r2)) {
            cout << mn - 1 << " " << get_in_time(t1, mn - 1) << endl;
        } else {
            if (r1 < r2) {
                cout << r1 << " " << c1 << endl;
            } else {
                cout << r2 << " " << c2 << endl;
            }
        }
    } 
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
