#include <bits/stdc++.h>

using namespace std;
//#pragma GCC optimize("Ofast")

#define ll int
#define vl vector<ll>
#define pr pair<ll, ll>

const ll MAXN = 10000000;
const ll LOGN = 12;

map<pr, ll>ind;
pr unind[MAXN];
map<pr, ll>mp;
vector<pr> gr[MAXN];
ll way[MAXN];
ll n;

void dfs0(ll r, ll c){
    if(way[r] == 0){
        if(!mp[{ind[{r + 1, c + 1}], ind[{r, c}]}]) {
            mp[{ind[{r + 1, c + 1}], ind[{r, c}]}] = 1;
            gr[ind[{r + 1, c + 1}]].push_back({r, c});
            gr[ind[{r, c}]].push_back({r + 1, c + 1});
        }
        if(r + 1 < n) {
            dfs0(r + 1, c + 1);
        }
    }
    else{
        if(!mp[{ind[{r + 1, c}], ind[{r, c}]}]) {
            mp[{ind[{r + 1, c}], ind[{r, c}] }] = 1;
            gr[ind[{r + 1, c}]].push_back({r, c});
            gr[ind[{r, c}]].push_back({r + 1, c});
        }
        if(r + 1 < n) {
            dfs0(r + 1, c);
        }
    }

}

ll tin[MAXN];
ll tout[MAXN];
ll dp[MAXN][LOGN];
ll tim;

bool a(ll u, ll v){
    if(tin[u] <= tin[v] && tout[u] > tin[v]){
        return true;
    }
    return false;
}

void dfs(ll r, ll c, ll r2 = -1, ll c2 = -1){
    if(r2 == -1){
        dp[ind[{r, c}]][0] = -1;
    }
    else{
        dp[ind[{r, c}]][0] = ind[{r2, c2}];
    }
    for(ll i = 1; i < LOGN;i++){
        if(dp[ind[{r, c}]][i - 1] == -1){
            dp[ind[{r, c}]][i] = -1;
        }
        else{
            dp[ind[{r, c}]][i] = dp[dp[ind[{r, c}]][i - 1]][i - 1];
        }
    }
    tin[ind[{r, c}]] = tim++;
    for(auto u: gr[ind[{r, c}]]){
        if(u.first == r2 && u.second == c2)continue;
        dfs(u.first, u.second, r, c);
    }
    tout[ind[{r, c}]] = tim;
}

pr lca(ll r1, ll c1, ll r2, ll c2){
    if(a(ind[{r1, c1}], ind[{r2, c2}]))return {r1, c1};
    if(a(ind[{r2, c2}], ind[{r1, c1}]))return {r2, c2};
    for(ll i = LOGN - 1;i >=0;i--){
        if(dp[ind[{r1, c1}]][i] == -1)continue;
        if(!a(dp[ind[{r1, c1}]][i], ind[{r2, c2}])){
            pr p = unind[dp[ind[{r1, c1}]][i]];
            r1 = p.first;
            c1 = p.second;
        }
    }
    return unind[dp[ind[{r1, c1}]][0]];
}

void solve(){
    cin >> n;
    vl a(n);
    for(ll i =0 ; i < n;i++){
        cin >> a[i];
    }
    ll cnt =0 ;
    for(ll i =0 ; i <= n;i++){
        for(ll j =0 ; j <= i;j++){
            ind[{i, j}] = cnt;
            unind[cnt] = {i, j};
            ++cnt;
        }
    }
    dfs0(0, 0);
    for(ll i =0 ; i < n;i++) {
        way[a[i] - 1] = 1;
        dfs0(0, 0);
    }
    dfs(0, 0);
    ll q;
    cin >> q;
    while(q--){
        ll r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        pr res = lca(r1, c1, r2, c2);
        cout << res.first << ' ' << res.second << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
