// mukar.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#ifdef  LOCAL
#include <C:\Users\roi\Desktop\stdc++.h>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
#define int ll
typedef vector <int> vi;
typedef vector <vi> vii;
typedef pair <int, int> pii;

#define all(a) (a).begin(), (a).end()

vii g;
vi c, l, r;
vi cur;

vector <vector<pii>> change;

vii dp;

void dfs(int v) {
	int nl = 0;
	int sum = 0;
	for (auto& u : g[v]) {
		dfs(u);
		nl += l[u];
		cur[u] = l[u];
		sum += dp[u][l[u]];
	}
	if (nl > r[v]) {
		l[v] = 1000000;
		return;
	}
	//l[v] = max(nl, l[v]);
	dp[v][nl] = sum;
	for (int i = nl + 1; i <= r[v]; ++i) {
		pii m = { c[v], -1 };
		for (auto& u : g[v]) {
			if (cur[u] < r[u] && dp[u][cur[u] + 1] - dp[u][cur[u]] < m.first) {
				m.first = dp[u][cur[u] + 1] - dp[u][cur[u]];
				m.second = u;
			}
		}
		if (m.second != -1) {
			++cur[m.second];
		}
		change[v][i] = m;
		dp[v][i] = dp[v][i - 1] + m.first;
	}
	for (int i = 0; i < l[v]; ++i) {
		dp[v][i] = -1;
	}
	l[v] = max(l[v], nl);
}

vi res;

void restore(int v, int k) {
	for (auto& u : g[v]) {
		cur[u] = l[u];
	}
	for (int i = 0; i <= k; ++i) {
		if (change[v][i].first == 0) {
			continue;
		}
		if (change[v][i].second == -1) {
			++res[v];
		}
		else {
			++cur[change[v][i].second];
		}
	}
	for (auto& u : g[v]) {
		restore(u, cur[u]);
	}
}


signed main() {
	ios::sync_with_stdio(0); cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		g.resize(n);
		for (int i = 1; i < n; ++i) {
			int p;
			cin >> p;
			p--;
			g[p].push_back(i);
		}
		c.resize(n);
		l.resize(n);
		r.resize(n);
		for (auto& x : c) {
			cin >> x;
		}
		for (int i = 0; i < n; ++i) {
			cin >> l[i] >> r[i];
		}
		dp.resize(n, vi(1001, -1));
		cur.resize(n);
		change.resize(n, vector <pii>(1001, { 0, 0 }));
		dfs(0);
		int ans = -1, k = -1;
		for (int i = l[0]; i <= r[0]; ++i) {
			if (dp[0][i] != -1) {
				if (ans == -1) {
					ans = dp[0][i];
					k = i;
				}
				else {
					if (dp[0][i] < ans) {
						ans = dp[0][i];
						k = i;
					}
				}
			}
		}
		cout << ans << "\n";
		if (ans != -1) {
			res.resize(n);
			restore(0, k);
			for (int i = 0; i < n; ++i) {
				cout << res[i] << " ";
			}
		}
		cout << "\n";
		g.clear();
		c.clear();
		l.clear();
		r.clear();
		cur.clear();
		dp.clear();
	}
	return 0;
}