#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int long long
const int INF = 1e16;

bool cmp(const pair<int, int> &a, const pair<int, int> &b) {
    if (a.second != b.second)
        return a.second < b.second;
    return a.first < b.first;
}

bool isin(pair<int, int> &p, int x0, int y0, int x1, int y1) {
    return x0 <= p.first && p.first <= x1 && y0 <= p.second && p.second <= y1;
}

int solverec(vector<pair<int, int>> &arr, int x0, int y0, int x1, int y1) {
    if (arr.empty())
        return 0;
    auto a = arr[0];
    if (arr.size() == 1) {
        int s1 = (x1 - a.first) * (y1 - a.second);
        int s2 = (a.first - x0) * (y1 - a.second);
        return max(s1, s2);
    }
    auto b = arr[1];
    int S = 0;
    {
        if (a.first <= b.first) {
            int s = (x1 - a.first) * (y1 - a.second) + (b.first - x0) * (y1 - b.second);
            s -= (b.first - a.first) * (y1 - b.second);
            S = max(s, S);
        } else {
            int s = (x1 - b.first) * (y1 - b.second) + (a.first - x0) * (y1 - a.second);
            s -= (a.first - b.first) * (y1 - b.second);
            S = max(s, S);
        }
    }
    {
        auto A = a, B = b;
        if (A.first > B.first)
            swap(A, B);
        vector<pair<int, int>> brr;
        int mn = y1;
        for (int i = 2; i < arr.size(); ++i) {
            if (isin(arr[i], x0, A.second, A.first, y1)) {
                mn = arr[i].second;
                break;
            }
        }
        for (int i = 2; i < arr.size(); ++i) {
            if (isin(arr[i], B.first, B.second, x1, y1)) {
                mn = min(mn, arr[i].second);
                break;
            }
        }
        for (int i = 2; i < arr.size(); ++i) {
            if (arr[i].second >= mn)
                break;
            if (isin(arr[i], x0, A.second, A.first, y1))
                continue;
            if (isin(arr[i], B.first, B.second, x1, y1))
                continue;
            brr.push_back(arr[i]);
        }
        int s = (A.first - x0) * (y1 - A.second);
        s += (x1 - B.first) * (y1 - B.second);
        s += (B.first - A.first) * (y1 - mn);
        int vals = solverec(brr, A.first, max(A.second, B.second), B.second, mn);
        s += vals;
        S = max(S, s);
    }
    {
        if (a.first <= b.first) {
            int s = (a.first - x0) * (y1 - a.second);
            s += (b.first - x0) * (y1 - b.second);
            s -= (a.first - x0) * (y1 - b.second);
            int mn = y1;
            for (int i = 2; i < arr.size(); ++i) {
                if (isin(arr[i], x0, b.second, b.first, y1)) {
                    mn = arr[i].second;
                    break;
                }
            }
            s += (x1 - b.first) * (y1 - mn);
            vector<pair<int, int>> brr;
            for (int i = 2; i < arr.size(); ++i) {
                if (arr[i].second >= mn)
                    break;
                if (isin(arr[i], x0, b.second, b.first, y1))
                    continue;
                brr.push_back(arr[i]);
            }
            int vals = solverec(brr, b.first, b.second, x1, mn);
            s += vals;
            S = max(S, s);
        } else {
            int s = (x1  - a.first) * (y1 - a.second);
            s += (x1 - b.first) * (y1 - b.second);
            s -= (x1 - a.first) * (y1 - b.second);
            int mn = y1;
            for (int i = 2; i < arr.size(); ++i) {
                if (isin(arr[i], b.first, b.second, x1, y1)) {
                    mn = arr[i].second;
                    break;
                }
            }
            s += (b.first - x0) * (y1 - mn);
            vector<pair<int, int>> brr;
            for (int i = 2; i < arr.size(); ++i) {
                if (arr[i].second >= mn)
                    break;
                if (isin(arr[i], b.first, b.second, x1, y1))
                    continue;
                brr.push_back(arr[i]);
            }
            int vals = solverec(brr, x0, b.second, b.first, mn);
            s += vals;
            S = max(S, s);
        }
    }
    return S;
}

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        arr[i] = {x, y};
    }
    sort(arr.begin(), arr.end(), cmp);
    int S = solverec(arr, 0, 0, w, h);
    cout << S;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k;
    cin >> k;
    vector<int> aval(k);
    for (int &el: aval)
        cin >> el;
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}