#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

const int N = 2e5;

void solve() {
    int n, w, h; cin >> n >> w >> h;
    vector<pii> a;
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;
        a.emplace_back(x, y);
    }
    sort(a.rbegin(), a.rend());
    vector<pii> b;
    for (int i = 0; i < n; ++i) {
        while (b.size() && b.back().second >= a[i].second) b.pop_back();
        b.push_back(a[i]);
    }
    int ans = 0;
    int last_x = w;
    for (int i = 0; i < b.size(); ++i) {
        ans += (h - b[i].second) * (last_x - b[i].first);
        last_x = b[i].first;
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int k; cin >> k;
    for (int i = 0; i < k; ++i) {
        int x; cin >> x;
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
