#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int MAXN = 1e6 + 10;
const int INF = 1e9 + 7;

vector<pair<int, int>> g;
int tin[MAXN];
int tout[MAXN];
int lca[MAXN][25];
int n;
int ttt = 0;

void dfs(int v, int p) {
    tin[v] = ttt++;
    if (p == -1) lca[v][0] = v;
    else lca[v][0] = p;
    for (int i = 1; i < 25; ++i) lca[v][i] = lca[lca[v][i - 1]][i - 1];
    if (g[v].first == 1) dfs(v + 1, v);
    if (g[v].second == 1) dfs(v + n, v);
    tout[v] = ttt++;
}

bool ispr(int u, int v) {
    if (tin[u] <= tin[v] && tout[v] <= tout[u]) return true;
    return false;
}

int get_lca(int u, int v) {
    if (ispr(u, v)) return u;
    if (ispr(v, u)) return v;
    for (int i = 24; i >= 0; --i) {
        int o = lca[v][i];
        if (ispr(o, u)) continue;
        v = o;
    }
    return lca[v][0];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    n++;
    vector<int> a(n);
    a[0] = -1;
    for (int i = 1; i < n; ++i) cin >> a[i];
    g.assign(n * n, {0, 0});
    vector<int> vec(n, 0);
    for (auto it: a) {
        if (it != -1) vec[it - 1] = 1;
        int ind = 0;
        for (int i = 0; i < n - 1; ++i) {
            if (vec[i] == 0) {
                g[ind].first = 1;
                ind++;
            }
            else {
                g[ind].second = 1;
                ind += n;
            }
        }
    }
    dfs(0, -1);
    //cout << lca[2][0] << endl;
    int q; cin >> q;
    while (q--) {
        int x1, y1, x2, y2; cin >> x1 >> y1 >> x2 >> y2;
        x1 -= y1;
        x2 -= y2;
        //cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
        int v1 = x1 * n + y1;
        int v2 = x2 * n + y2;
        //cout << v1 << " " << v2 << endl;
        int l = get_lca(v1, v2);
        //cout << l << endl;
        int x = l / n;
        int y = l % n;
        cout << x + y << " " << y << '\n';
    }
}

