#include <bits/stdc++.h>

#define int long long

using namespace std;

vector <vector <int>> graph;
vector <int> costs;
vector <pair <int, int>> can;
vector <int> taken;

tuple <bool, int, int, map <int, vector <pair <int, int>>>> solve(int v)
{
    auto [left, right] = can[v];
    map <int, vector <pair <int, int>>> strat;
    int cnt = 0, cost = 0;
    for (auto u: graph[v]) {
        auto [ugood, ucnt, ucost, ustrat] = solve(u);
        if (!ugood) {
            return {false, -1, -1, {}};
        }
        cnt += ucnt;
        cost += ucost;
        for (auto p: ustrat) {
            for (auto [u, ucnt]: p.second)
                strat[p.first].push_back({u, ucnt});
        }
    }

    if (cnt > right)
        return {false, -1, -1, {}};

    strat[costs[v]].push_back({v, right - cnt});
    while (cnt < left) {
        if (strat.empty()) {
            return {false, -1, -1, {}};
        }
        //auto [ucost, &uvec] = *strat.begin();
        int ucost = strat.begin()->first;
        auto& uvec = strat.begin()->second;
        while (!uvec.empty()) {
            auto [u, ucnt] = uvec.back();
            if (cnt + ucnt <= left) {
                cost += ucost * ucnt;
                taken[u] += ucnt;
                cnt += ucnt;
                uvec.pop_back();
            }
            else {
                cost += ucost * (left - cnt);
                //strat[ucost] -= (left - cnt);
                uvec[uvec.size() - 1].second -= (left - cnt);
                taken[u] += (left - cnt);
                cnt = left;
                break;
            }
            if (cnt == left)
                break;
        }
        if (uvec.empty())
            strat.erase(strat.begin());
    }

    int can = right - cnt;
    map <int, vector <pair <int, int>>> res_strat;
    while (!strat.empty()) {
        if (can == 0)
            break;
        int ucost = strat.begin()->first;
        auto& uvec = strat.begin()->second;
        for (auto [u, ucnt]: uvec) {
            if (ucnt <= can) {
                res_strat[ucost].push_back({u, ucnt});
                can -= ucnt;
            }
            else {
                res_strat[ucost].push_back({u, can});
                can = 0;
                break;
            }
        }
        strat.erase(strat.begin());
    }

    return {true, cnt, cost, res_strat};
}

signed main()
{
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif // LOCAL

    int Q; cin >> Q;
    while (Q--) {
        int n; cin >> n;
        graph.clear(); graph.resize(n);
        for (int i = 1; i < n; ++i) {
            int parent; cin >> parent; parent -= 1;
            graph[parent].push_back(i);
        }
        costs.resize(n);
        for (auto& i: costs)
            cin >> i;
        can.resize(n);
        for (auto& i: can)
            cin >> i.first >> i.second;

        taken.assign(n, 0);
        auto [good, cnt, cost, strat] = solve(0);
        if (good) {
            cout << cost << "\n";
            for (auto i: taken)
                cout << i << " ";
            cout << "\n";
        }
        else
            cout << "-1\n";
    }
}
