#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

const int inf = 1e9 + 228;
vector<vector<int>> ans;

void solve(vector<int> a, int n, bool rev = false) {
	vector<pair<int, int>> pos(n, {inf, -inf});
	for (int i = 0; i < n; ++i) {
		pos[a[i]].first = min(pos[a[i]].first, i);
		pos[a[i]].second = max(pos[a[i]].second, i);
	}
	vector<vector<pair<int, int>>> who(n, vector<pair<int, int>> (n, {inf, -inf}));
	for (int i = 0; i < n; ++i) {
		auto b = a;
		sort(b.begin() + n - i - 1, b.begin() + n);
		if (rev)
			reverse(b.begin() + n - i - 1, b.begin() + n);
		for (int j = 0; j < n; ++j) {
			who[i][b[j]].first = min(who[i][b[j]].first, j);
			who[i][b[j]].second = max(who[i][b[j]].second, j);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (who[0][i].first == inf || who[0][j].first == inf)
				continue;
			ans[i][j] = max(ans[i][j], abs(who[n - 1][i].first - who[n - 1][j].second));
			ans[i][j] = max(ans[i][j], abs(who[n - 1][j].first - who[n - 1][i].second));
		}
	}
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			who[i][j].first = min(who[i][j].first, who[i - 1][j].first);
			who[i][j].second = max(who[i][j].second, who[i - 1][j].second);
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < n; ++j)
	// 		cout << who[i][j].first << ':' << who[i][j].second << ' ';
	// 	cout << '\n';
	// }
	// cout << "-----------\n";
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (who[0][i].first == inf || who[0][j].first == inf)
				continue;
			{
				int ind1 = pos[i].first, ind2 = pos[j].second;
				if (ind1 < ind2) {
					// if (i == 0 && j == 1) {
					// 	cout << ind1 << ':' << n - 2 - ind1 << ' ' << who[ind1 + 1][j].second << ' ' << who[n - 2 - ind1][j].second << '\n';
					// }
					ans[i][j] = max(ans[i][j], abs(ind1 - who[n - 2 - ind1][j].second));
				}
			}
			{
				int ind1 = pos[i].second, ind2 = pos[j].first;
				if (ind2 < ind1) {
					ans[i][j] = max(ans[i][j], abs(ind2 - who[n - 2 - ind2][i].second));
				}
			}
		}
	}
}

int main() {
	#ifndef LOCAL
		ios_base::sync_with_stdio(0);
		cin.tie(0);
	#endif

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	ans.resize(n, vector<int> (n));
	solve(a, n);
	reverse(all(a));
	solve(a, n, 1);
	long long res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			// cerr << i + 1 << ' ' << j + 1 << ':' << ans[i][j] << '\n';
			res += ans[i][j];
		}
	}
	cout << res << '\n';
}