#include <iostream>
#include <algorithm>

int main() {
    int32_t n;
    std::cin >> n;

    int32_t* arr = new int32_t[n];
    for(int32_t i = 0; i < n; i++) {
        std::cin >> arr[i];
        arr[i]--;
    }

    int32_t** prefix_pos = new int32_t*[n + 1];
    int32_t* test = new int32_t[n];
    for(int32_t i = 0; i < n; i++)
        test[i] = arr[i];
    for(int32_t i = 1; i <= n; i++) {
        prefix_pos[i] = new int32_t[n];

        std::sort(test, test + i);
        for(int32_t j = 0; j < i; j++)
            prefix_pos[i][test[j]] = j;
    }
    int32_t** suffix_pos = new int32_t*[n + 1];
    for(int32_t i = 0; i < n; i++)
        test[i] = arr[i];
    for(int32_t i = 1; i <= n; i++) {
        suffix_pos[i] = new int32_t[n];

        std::sort(test + n - i, test + n);
        for(int32_t j = n - i; j < n; j++)
            suffix_pos[i][test[j]] = j;
    }

    int32_t* inv_arr = new int32_t[n];
    for(int32_t i = 0; i < n; i++)
        inv_arr[arr[i]] = i;

    int32_t ans_global = 0;
    for(int32_t i = 0; i < n; i++)
        for(int32_t j = 0; j < n; j++) {
            int32_t p1 = inv_arr[i], p2 = inv_arr[j];
            if(p2 < p1 || i == j)
                continue;
            int32_t ans = std::abs(j - i);

            //...
            /*for(int32_t k = 0; k < n; k++)
                test[k] = arr[k];
            std::sort(test, test + std::min(p1, p2) + 1);

            for(int32_t k = 0; k < n; k++)
                if(test[k] == i || test[k] == j) {
                    ans = std::max(ans, std::max(p2, p1) - k);
                    break;
                }*/
            ans = std::max(ans, p2 - prefix_pos[p1 + 1][i]);

            //...
            /*for(int32_t k = 0; k < n; k++)
                test[k] = arr[k];
            std::sort(test, test + std::max(p1, p2));

            for(int32_t k = 0; k < n; k++)
                if(test[k] == i || test[k] == j) {
                    ans = std::max(ans, std::max(p2, p1) - k);
                    break;
                }*/
            ans = std::max(ans, p2 - prefix_pos[p2][i]);

            //...
            /*for(int32_t k = 0; k < n; k++)
                test[k] = arr[k];
            std::sort(test + std::max(p1, p2), test + n);

            for(int32_t k = std::max(p1, p2); k < n; k++)
                if(test[k] == i || test[k] == j) {
                    ans = std::max(ans, k - std::min(p2, p1));
                    break;
                }*/
            ans = std::max(ans, suffix_pos[n - p2][j] - p1);

            //...
            /*for(int32_t k = 0; k < n; k++)
                test[k] = arr[k];
            std::sort(test + std::min(p1, p2) + 1, test + n);

            for(int32_t k = std::min(p1, p2) + 1; k < n; k++)
                if(test[k] == i || test[k] == j) {
                    ans = std::max(ans, std::min(p2, p1) - k);
                    break;
                }*/
            ans = std::max(ans, suffix_pos[n - p1 - 1][j] - p1);

            ans_global += ans;
        }
    std::cout << ans_global;
    return 0;
}
