#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
typedef vector<ll> v64;
typedef vector<v64> vv64;
typedef pair<ll,ll> p64;
typedef vector<p64> vp64;
typedef vector<vp64> vvp64;

#define forn(i,n) for(ll i = 0;i < n;i++)
#define forsn(i,a,n) for(ll i = a;i < n;i++)
#define rforn(i,n) for(ll i = n;i >= 0;i--)
#define all(v) v.begin(),v.end()
#define fast_cin() ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)
#define ln '\n'

vv64 gr;
v64 cost;
vp64 def;
vp64 dp;
v64 cnt;
v64 bought;
bool can;
ll ans;

void dfs(ll v,ll p = -1){
    dp[v] = {cost[v],v};
    cnt[v] = 0;
    for(auto u : gr[v]){
        if(u != p){
            dfs(u,v);
            dp[v] = min(dp[v],dp[u]);
            cnt[v] += cnt[u];
        }
    }

    if(cnt[v] < def[v].first){
        bought[dp[v].second] += (def[v].first-cnt[v]);
        ans += (def[v].first-cnt[v])*dp[v].first;
        cnt[v] = def[v].first;
    }
    if(cnt[v] > def[v].second){
        can = false;
    }
}

int main() {
    fast_cin();
    ll t;
    cin >> t;
    while (t--){
        ll n;
        cin >> n;
        can = true;
        ans = 0;
        gr.assign(n,{});
        cost.assign(n,0);
        def.assign(n,{});
        dp.assign(n,{});
        bought.assign(n,0);
        cnt.assign(n,0);
        forsn(i,1,n){
            ll a;
            cin >> a;
            --a;
            gr[a].push_back(i);
            gr[i].push_back(a);
        }

        forn(i,n){
            cin >> cost[i];
        }

        forn(i,n){
            cin >> def[i].first >> def[i].second;
        }

        dfs(0);
        if(can){
            cout << ans << ln;
            forn(i,n){
                cout << bought[i] << " ";
            }
            cout << ln;
        }
        else{
            cout << "-1" << ln;
        }

    }

    return 0;
}
