#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define sz(x) (int)x.size()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long
#define pii pair<int, int>
#define fi first
#define se second

int n;
vector<vector<int>> g;
vector<int> c, l, r, a, tk;
vector<set<pair<pii, int>>> st;
const int inf = 2e9;
int res = 0;

bool dfs(int v) {
    for (int u: g[v]) {
        bool f = dfs(u);
        if (!f)
            return false;

        a[v] += a[u];
        for (auto t: st[u])
            st[v].insert(t);
    }

    if (a[v] > r[v]) {
        cout << "-1\n";
        return false;
    }

    st[v].insert({{c[v], v}, inf});

    while (a[v] < l[v] && !st[v].empty()) {
       auto t = *st[v].begin();
       int cost = t.fi.fi, u = t.fi.se, cnt = t.se;
       st[v].erase(t);
       int need = min(l[v] - a[v], cnt);
       res += need * cost;
       a[v] += need;
       cnt -= need;
       tk[u] += need;

       if(cnt != 0)
           st[v].insert({{cost, u}, cnt});
    }

    set<pair<pii, int>> nst;
    while(!st[v].empty()){
        auto t = *st[v].begin();
        int cost = t.fi.fi, u = t.fi.se, cnt = t.se;
        st[v].erase(t);
        nst.insert({{cost, u}, min(cnt, r[v] - a[v])});
    }

    swap(nst, st[v]);

    return true;
}

void clear() {
    g.clear();
    c.clear();
    l.clear();
    r.clear();
    a.clear();
    st.clear();
    tk.clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        clear();
        cin >> n;
        g.resize(n);
        c.resize(n);
        l.resize(n);
        r.resize(n);
        a.resize(n);
        st.resize(n);
        tk.resize(n);

        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            g[--p].push_back(i);
        };

        for (int i = 0; i < n; ++i)
            cin >> c[i];

        for (int i = 0; i < n; ++i)
            cin >> l[i] >> r[i];

        auto f = dfs(0);

        if(f){
            for(int i = 0; i < n; ++i){
                assert(a[i] >= l[i] && a[i] <= r[i]);
            }
            
            cout << res << '\n';
            for(int i : tk)
                cout << i << " ";
            cout << '\n';
        }
    }
}
