#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;

    vector<int> nums(n);
    for (auto &a: nums) cin >> a;

    vector<int> pref(n),
            post(n);

    for (int pos = 0; pos < n; ++pos) {
        for (int i = 0; i < pos; ++i) {
            if (nums[i] > nums[pos]) pref[pos] += 1;
        }
    }

    for (int pos = n - 1; pos >= 0; --pos) {
        for (int i = n - 1; i > pos; --i) {
            if (nums[i] < nums[pos]) post[pos] += 1;
        }
    }

    ll sum = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ll delta = max(max(pref[i], post[j]) + abs(i - j), abs(nums[i] - nums[j]));
            sum += delta;
        }
    }

    cout << sum << endl;

    return 0;
}
