#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int ll
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << ' ' <<
#define __ << ' '

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int mod = 1e9 +7, inf = 1e10, MAXN = 1e5 + 10;
vector<int> gr[MAXN];
int lt[MAXN], rt[MAXN], sz[MAXN];
int mn[MAXN], cost[MAXN];
int pr[MAXN], nx[MAXN];
int tmp2[MAXN];
int ans = 0;
int tr[MAXN * 6], ad[MAXN * 6], pos[MAXN], lf[MAXN];
int tmp3[MAXN];
int ind = 0;
int n;
bool fl;

void push(int v) {
    tr[v] += ad[v];
    ad[2 * v  + 1] += ad[v];
    ad[2 * v  + 2] += ad[v];
    ad[v] = 0;
    return;
}

void build(int v, int l, int r) {
    if (r - l == 1) {
        tr[v] = tmp3[l];
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tr[v] = min(tr[2 * v + 1], tr[2 * v + 2]);
}

void upd(int v, int l, int r, int ql, int qr, int qx) {
    if (ql <= l && r <= qr) {
        ad[v] -= qx;
        push(v);
        return;
    }
    if (ql >= r || l >= qr) {
        push(v);
        return;
    }
    push(v);
    int m = (r + l) / 2;
    upd(2 * v + 1, l, m, ql, qr, qx);
    upd(2 * v + 2, m, r, ql, qr, qx);
    tr[v] = min(tr[2 * v + 1], tr[2 * v + 2]);
    return;
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        push(v);
        return tr[v];
    }
    if (ql >= r || l >= qr) {
        return inf;
    }
    push(v);
    int m = (r + l) / 2;
    return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

void dfs(int v) {
    int a = 0;
    sz[v] = 1;
    int id = -1, mx = -1;
    for (auto &u : gr[v]) {
        dfs(u);
        sz[v] += sz[u];
        if (sz[u] > mx) {
            mx = sz[u];
            id = u;
        }
        a += mn[u];
    }
    nx[v] = id;
    if (a > rt[v]) {
        fl = 0;
        return;
    }
    mn[v] = max(lt[v], a);
    return;
}

void dfs3(int v, int fr) {
    pos[v] = ind;
    lf[v] = fr;
    tmp3[ind++] = rt[v];
    if (nx[v] != -1) {
        dfs3(nx[v], fr);
    }
    for (auto &u : gr[v]) {
        if (u != nx[v]) {
            dfs3(u, u);
        }
    }
}

void dfs2(int v, set<pii> &st) {
    mn[v] = 0;
    if (nx[v] != -1) {
        dfs2(nx[v], st);
    }
    for (auto &u : gr[v]) {
        if (u != nx[v]) {
            set<pii> nw;
            dfs2(u, nw);
            for (auto &x : nw) {
                st.insert(x);
            }
        }
    }
    st.insert({cost[v], v});
    int b = rt[v] - get(0, 0, n, pos[v], pos[v] + 1);
    if (b < lt[v]) {
        int a, k = lt[v] - b;
        //cout << '#' _ v _ k _ b << endl;
        pii x;
        auto tmp = st.begin();
        while (true) {
            if (tmp == st.end()) break;
            x = (*tmp);
            a = x.ss;
            b = inf;
            while (true) {
                b = min(b, get(0, 0, n, pos[lf[a]], pos[a] + 1));
                a = lf[a];
                if (a == 0) break;
                a = pr[a];
            }
            if (b == 0) {
                tmp = st.erase(tmp);
                continue;
            }
            if (b >= k) {
                ans += k * x.ff;
                a = x.ss;
                tmp2[a] += k;
                while (true) {
                    upd(0, 0, n, pos[lf[a]], pos[a] + 1, k);
                    a = lf[a];
                    if (a == 0) break;
                    a = pr[a];
                }
                k = 0;
                break;
            }
            else {
                ans += b * x.ff;
                a = x.ss;
                tmp2[a] += b;
                while (true) {
                    upd(0, 0, n, pos[lf[a]], pos[a] + 1, b);
                    a = lf[a];
                    if (a == 0) break;
                    a = pr[a];
                }
                k -= b;
                tmp = st.erase(tmp);
            }
        }
    }
    return;
}

void solve() {
    cin >> n;
    for (int i = 0; i < n * 6; ++i) {
        ad[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        gr[i].resize(0);
        tmp2[i] = 0;
    }
    int a;
    for (int i = 1; i < n; ++i) {
        cin >> a; a--;
        pr[i] = a;
        gr[a].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> lt[i] >> rt[i];
    }
    fl = 1;
    dfs(0);
    if (!fl) {
        cout << -1 << '\n';
        return;
    }
    ind = 0;
    dfs3(0, 0);
    build(0, 0, n);
    set<pii> st;
    ans = 0;
    dfs2(0, st);
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        cout << tmp2[i] __;
    }
    cout << '\n';
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
    }
}


