#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

const int maxn = 500000;

int n;
int t[2*maxn];

void upd(int i) {
    for (t[i += n]++; i > 1; i >>= 1) t[i >> 1] = t[i] + t[i ^ 1];
}

int query(int l, int r) {
    int res = 0;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res += t[l++];
        if (r & 1) res += t[--r];
    }
    return res;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int q;
    cin >> q;
    vector<pair<pair<int, int>, vector<array<int, 7>>>> b(1);
    b[0].first = {0, n};
    for (int i = 0; i < q; i++) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int p1 = 0, p2 = 0;
        {
            int ct = 0;
            while (ct < r1 - c1) {
                if (a[p1] <= r1) {
                    ct++;
                }
                p1++;
            }
        } {
            int ct = 0;
            while (ct < r2 - c2) {
                if (a[p2] <= r2) {
                    ct++;
                }
                p2++;
            }
        }
        b[0].second.push_back({r1, c1, r2, c2, i, p1, p2}); // TODO: find p1 and p2
    }
    vector<pair<int, int>> ta;
    for (int i = 0; i < n; i++) ta.emplace_back(a[i], i);
    sort(all(ta));

    vector<pair<int, int>> ans(q, {-1, -1});
    for (int _ = 0; _ < 20; _++) {
        fill(t, t + 2*maxn, 0);
        vector<pair<pair<int, int>, vector<array<int, 7>>>> nb;
        int ti = 0;
        for (auto const &tp: b) {
            int lb = tp.first.first, ub = tp.first.second + 1;
           int tm = (lb + ub) / 2;
            while (ti < gsize(ta) && ta[ti].first <= tm) {
                upd(ta[ti].second);
                ti++;
            }

            if (lb == ub - 1) {
                for (auto p: tp.second) {
                    ans[p[4]].first = lb;
                    ans[p[4]].second = lb - query(0, p[5]);
                }
                continue;
            }
            vector<array<int, 7>> r1, r2;
            for (auto p: tp.second) {
                bool good = false;
                if (max(p[0], p[2]) < tm) {
                    good = true;
                } else {
                    int p1 = p[5], p2 = p[6];

                    if (query(0, p1) == query(0, p2)) {
                        good = false;
                    } else {
                        good = true;
                    }
                }
                if (good) {
                    r1.push_back(p);
                } else {
                    r2.push_back(p);
                }
            }
            if (gsize(r1)) {
                nb.push_back({{lb, tm - 1},
                              {}});
                for (auto p: r1) {
                    nb.back().second.push_back(p);
                }
            }
            if (gsize(r2)) {
                nb.push_back({{tm, ub - 1},
                              {}});
                for (auto p: r2) {
                    nb.back().second.push_back(p);
                }
            }
        }
        b = nb;
    }

    for (int i = 0; i < q; i++) {
        cout << ans[i].first << ' ' << ans[i].second << nl;
    }
}
