#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define vi vector<int>

vi tree;
int n;

void add(int i, int val) {
    for (; i < n; i = i | (i + 1)) tree[i] += val;
}

int pref_sum(int i) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) res += tree[i];
    return res;
}

int get_sum(int l, int r) {
    int res = pref_sum(r);
    if (l) res -= pref_sum(l - 1);
    return res;
}

void solve() {
    cin >> n;
    vi arr(n);
    tree.assign(n, 0);
    for (int &i: arr) {
        cin >> i;
        i--;
    }
    vi cnt_less_left(n), cnt_bigger_right(n);
    for (int i = 0; i < n; i++) {
        add(arr[i], 1);
        cnt_less_left[i] = get_sum(0, arr[i] - 1);
    }
    tree.assign(n, 0);
    for (int i = n - 1; i >= 0; i--) {
        add(arr[i], 1);
        cnt_bigger_right[i] = get_sum(arr[i] + 1, n - 1);
    }

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int best_dist = abs(arr[i] - arr[j]);
            best_dist = max(best_dist, j - cnt_less_left[i]);
            best_dist = max(best_dist, n - 1 - cnt_bigger_right[j] - i);
            ans += best_dist;
        }
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
