#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 5e3 + 5;

int n, from[N];
vector<int> g[N];
int c[N];
pii a[N];

int answ[N];

void clear_all() {
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        answ[i] = 0;
    }
}

void read() {
    cin >> n;
    clear_all();
    for (int i = 2; i <= n; ++i) {
        cin >> from[i];
        g[from[i]].emplace_back(i);
    }
    for (int i = 1; i <= n; ++i) cin >> c[i];
    for (int i = 1; i <= n; ++i) cin >> a[i].fi >> a[i].se;
}

const int C = 5e3 + 5;

//int sz[N];
int64 dp[N][C], newdp[C];
pii pr[N][C];

void dfs(int v) {
//    sz[v] = 1;
    for (int k = 0; k <= a[v].se; ++k) {
        dp[v][k] = (int64) c[v] * k;
        pr[v][k] = mp(v, k);
    }
    for (int u : g[v]) if (u != from[v]) {
        dfs(u);
        for (int x = 0; x <= a[v].se; ++x) newdp[x] = dp[v][x];
        for (int x = 0; x <= a[v].se; ++x) {
            for (int y = a[u].fi; y <= a[u].se && x + y <= a[v].se; ++y) {
                newdp[x + y] = min(newdp[x + y], dp[v][x] + dp[u][y]);
                if (newdp[x + y] == dp[v][x] + dp[u][y]) {
                    pr[v][x + y] = mp(u, y);
                }
            }
        }
        for (int x = 0; x <= a[v].se; ++x) dp[v][x] = min(dp[v][x], newdp[x]);
//        sz[v] += sz[u];
    }
}

void calc_ans(int v, int k) {
    while (k) {
        pii p = pr[v][k];
        if (p.fi == v) {
            answ[v] = k;
            return;
        }
        calc_ans(p.fi, p.se);
        k -= p.se;
    }
}

int64 sum[N];

bool check(int v) {
    sum[v] = answ[v];
    for (int u : g[v]) if (u != from[v]) {
        if (!check(u)) return false;
        sum[v] += sum[u];
    }
    return (int64) a[v].fi <= sum[v] && sum[v] <= (int64) a[v].se;
}

void solve() {
    dfs(1);
    pair<int64, int> ans = mp(dp[1][a[1].fi], a[1].fi);
    for (int k = a[1].fi + 1; k <= a[1].se; ++k) {
        ans = min(ans, mp(dp[1][k], k));
    }
    calc_ans(1, ans.se);
    if (!check(1)) {
        cout << "-1\n";
        return;
    }
    cout << ans.fi << "\n";
    for (int i = 1; i <= n; ++i) cout << answ[i] << " ";
    cout << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        read();
        solve();
    }
    return 0;
}