#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 1e5 + 5;

int n, from[N];
vector<int> g[N];
int c[N];
pii a[N];

int buy[N], answ[N];

void clear_all() {
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        buy[i] = 0;
        answ[i] = 0;
    }
}

void read() {
    cin >> n;
    clear_all();
    for (int i = 2; i <= n; ++i) {
        cin >> from[i];
        g[from[i]].emplace_back(i);
    }
    for (int i = 1; i <= n; ++i) cin >> c[i];
    for (int i = 1; i <= n; ++i) cin >> a[i].fi >> a[i].se;
}

bool calc_buy(int v) {
    for (int u : g[v]) if (u != from[v]) {
        if (!calc_buy(u)) return false;
        buy[v] += buy[u];
    }
    buy[v] = max(buy[v], a[v].fi);
    return buy[v] <= a[v].se;
}

int64 dp[N];
set<pair<int, pii>> rem[N];

void dfs(int v) {
    dp[v] = 0;
    int sum = 0;
    answ[v] = 0;
    pii max_son = mp(0, 0);
    for (int u : g[v]) if (u != from[v]) {
        dfs(u);
        sum += buy[u];
        dp[v] += dp[u];
        max_son = max(max_son, mp(sz(rem[u]), u));
    }
    if (max_son == mp(0, 0)) {
        answ[v] = buy[v];
        dp[v] = (int64) c[v] * answ[v];
        if (a[v].se - answ[v] > 0) {
            rem[v].emplace(c[v], mp(a[v].se - answ[v], v));
        }
        return;
    }
    rem[v].swap(rem[max_son.se]);
    for (int u : g[v]) if (u != from[v] && u != max_son.se) {
        for (auto &key : rem[u]) {
            rem[v].emplace(key);
        }
    }
    while (sum < buy[v]) {
        auto min_cost = *rem[v].begin();
        rem[v].erase(rem[v].begin());
        int curr_buy = min(min_cost.se.fi, buy[v] - sum);
        dp[v] += (int64) curr_buy * min_cost.fi;
        answ[min_cost.se.se] += curr_buy;
        assert(curr_buy > 0);
        sum += curr_buy;
        min_cost.se.fi -= curr_buy;
        if (min_cost.se.fi > 0) {
            rem[v].emplace(min_cost);
        }
    }
}

void solve() {
    if (!calc_buy(1)) {
        cout << "-1\n";
        return;
    }
    dfs(1);
    cout << dp[1] << "\n";
    for (int i = 1; i <= n; ++i) cout << answ[i] << " ";
    cout << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        read();
        solve();
    }
    return 0;
}