#include<bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 1e5 + 5;

int n, w, h;
pii a[N];

void read() {
    cin >> n >> w >> h;
    for (int i = 1; i <= n; ++i) cin >> a[i].x >> a[i].y;
}

int64 solve() {
    sort(a + 1, a + n + 1, [&](pii &A, pii &B) {
        return mp(-A.x, A.y) < mp(-B.x, B.y);
    });
    vector<pii> st;
    for (int i = 1; i <= n; ++i) {
        while (!st.empty() && st.back().first > a[i].y) {
            st.pop_back();
        }
        st.emplace_back(a[i].y, i);
    }
    int64 ans = 0;
    pii last = mp(w, 0);
    for (auto p : st) {
        int i = p.second;
        ans += (int64) (last.x - a[i].x) * (h - a[i].y);
        last = a[i];
    }
    return ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int k;
    cin >> k;
    vector<int> directions(k);
    for (int i = 0; i < k; ++i) cin >> directions[i];
    int T;
    cin >> T;
    while (T--) {
        read();
        cout << solve() << "\n";
    }
    return 0;
}