#pragma GCC optimize("O3","Ofast","unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;
#define int long long
mt19937 rnd;
const int maxn=4e5+5;
pair<int,int> t[4*maxn];int delay[4*maxn];int wex[maxn];int wey[maxn];
void build(int node,int tl,int tr)
{
    if((tr-tl)==1) {t[node]={0,wey[tl]};delay[node]=0;return;}
    int tm=(tl+tr)/2;build(2*node+1,tl,tm);build(2*node+2,tm,tr);t[node].first=0;t[node].second=t[2*node+1].second+t[2*node+2].second;delay[node]=0;
}
pair<int,int> merg(pair <int,int> u,pair<int,int> v)
{
    if(u.first<v.first) return u;
    if(u.first>v.first) return v;
    return {u.first,u.second+v.second};
}
void push(int node)
{
    int val=delay[node];
    t[2*node+1].first+=val;t[2*node+2].first+=val;
    delay[2*node+1]+=val;delay[2*node+2]+=val;
    delay[node]=0;
}
void to(int node,int tl,int tr,int l,int r,int val)
{
    if(l==r) return;
    if(tl>=l && tr<=r)
    {
        t[node].first+=val;
        delay[node]+=val;
        return;
    }
    if(tl>=r || tr<=l) return;
    push(node);
    int tm=(tl+tr)/2;
    to(2*node+1,tl,tm,l,r,val);to(2*node+2,tm,tr,l,r,val);
    t[node]=merg(t[2*node+1],t[2*node+2]);
}
struct sol
{
    vector<vector<vector<int> > > v;
    int sz;
    void clear()
    {
        sz=0;v.clear();
    }
    void init(int sz)
    {
        this->sz=sz;
        build(0,0,sz);
        v.resize(sz);
    }
    void upd(int x1,int y1,int x2,int y2)
    {
        v[x1].push_back({y1,y2,1});v[x2].push_back({y1,y2,-1});
    }
    void upd(pair <int,int> u,pair<int,int> v)
    {
        upd(u.first,u.second,v.first,v.second);
    }
    int sq()
    {
        int sumwe=0;for(int i=0;i<sz;++i) sumwe+=wey[i];
        //cout<<sumwe<<" sumwe "<<endl;
        int ans=0;
        for(int i=0;i<v.size();++i)
        {
            int we=wex[i];
            for(auto h:v[i])
            {
                int l=h[0];int r=h[1];int val=h[2];
                to(0,0,sz,l,r,val);
            }
            //cout<<we<<' '<<t[0].first<<' '<<(sumwe-t[0].second)<<endl;
            if(t[0].first==0) ans+=we*(sumwe-t[0].second);
            else ans+=we*sumwe;
        }
        return ans;
    }
};
int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    rnd.seed(228239);
    int sz;cin>>sz;int a[sz];for(int i=0;i<sz;++i) cin>>a[i];
    int q;cin>>q;
    while(q--)
    {
        int n,w,h;cin>>n>>w>>h;
        pair<int,int> b[n];
        vector<int> momx,momy;
        for(int i=0;i<n;++i) {cin>>b[i].first>>b[i].second;momx.push_back(b[i].first);momy.push_back(b[i].second);}
        momx.push_back(0);momy.push_back(0);momx.push_back(w);momy.push_back(h);sort(momx.begin(),momx.end());sort(momy.begin(),momy.end());momx.erase(unique(momx.begin(),momx.end()),momx.end());momy.erase(unique(momy.begin(),momy.end()),momy.end());
        w=momx.size()-1;h=momy.size()-1;
        for(int i=0;i<n;++i) {b[i].first=lower_bound(momx.begin(),momx.end(),b[i].first)-momx.begin();b[i].second=lower_bound(momy.begin(),momy.end(),b[i].second)-momy.begin();}
        for(int i=0;i<momx.size()-1;++i) wex[i]=momx[i+1]-momx[i];
        for(int i=0;i<momy.size()-1;++i) wey[i]=momy[i+1]-momy[i];
        wex[momx.size()]=0;wex[momx.size()+1]=0;wex[momx.size()+2]=0;
        wey[momy.size()]=0;wey[momy.size()+1]=0;wey[momy.size()+2]=0;
        //for(int i=0;i<momy.size()-1;++i) cout<<i<<" i "<<wey[i]<<" wey[i] "<<endl;
        sol z;
        int ans=0;
        if(n>=10)
        {
            int lx=1e18,rx=(-1e18),ly=1e18,ry=(-1e18);
            for(auto h:b) {lx=max(lx,h.first);rx=min(rx,h.first);ly=max(ly,h.second);ry=min(ry,h.second);}
            cout<<(w-rx)*ly+(h-ry)*lx<<'\n';
            continue;
        }
        for(int iter=0;iter<2000;++iter)
        {
            z.clear();z.init(max(w,h)+2);
            for(int i=0;i<n;++i) {int dir=a[((int) (abs((int) rnd())))%sz];if(iter<sz) {dir=a[iter];}int x=b[i].first;int y=b[i].second;if(dir==1) {z.upd({x,y},{w,h});} else if(dir==4) {z.upd({x,0},{w,y});} else if(dir==3) {z.upd({0,0},{x,y});} else if(dir==2) {z.upd({0,y},{x,h});} else assert(false);}
            ans=max(ans,z.sq());
        }
        cout<<ans<<'\n';
    }
    return 0;
}
/*
4
1 2 3 4
2
10 10 10
1 2
2 3
3 4
4 5
5 6
6 7
7 8
8 9
3 5
4 5
10 10 10
1 2
2 3
3 4
4 5
5 6
6 7
7 8
8 9
3 5
4 5
*/
