#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
//#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 3030;

int n;
int arr[MAXN];

void build() {
	for (int i = 0; i < n; ++i)
		arr[i]--;
}

int go(int l, int r) {
	int lid = find(arr, arr + n, l) - arr;
	int rid = find(arr, arr + n, r) - arr;
	if (lid > rid) swap(lid, rid);
	int lval = 0;
	for (int i = 0; i < lid; ++i)
		lval += arr[i] > arr[lid];
	int rval = 0;
	for (int i = n - 1; i > rid; --i)
		rval += arr[i] < arr[rid];
	int ans = r - l;
	ans = max(ans, rid - (lid - lval));
	ans = max(ans, (rid + rval) - lid);
//	cerr << l + 1 << ',' << r + 1 << ' ' << ans << endl;
	return ans;
}

int solve() {
	int ans = 0;
	for (int l = 0; l < n; ++l)
		for (int r = l + 1; r < n; ++r)
			ans += go(l, r);
	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> arr[i];
	build();
	cout << solve() << endl;
}