#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = int;

ll INF = 1e18;

ll N;
string S;
ll Y;

string S0;
ll B0 = -1e9;

ll diff(vector<ll> o) {
    ll ans = 0;
    for (ll i = 0; i < N; i++) {
        ll j0 = 0;
        for (ll j = i; j < N; j++) {
            if (o[j] == i) {
                j0 = j;
                break;
            }
        }
        for (ll j = j0 - 1; j >= i; j--) swap(o[j], o[j + 1]), ans++;
    }
    return ans;
}

void combo(const set<ll> &r, vector<ll> &o, ll i) {
    if (i == N) {
        ll pen = diff(o) * Y;
        string s1(N, ' ');
        for (ll j = 0; j < N; j++)s1[j] = S[o[j]];
        ll b = stoll(s1);
        b -= pen;
        if (b > B0 || (b == B0 && s1 > S0))
            S0 = s1, B0 = b;
        ll kek = diff(o);
        return;
    }
    set<ll> r1 = r;
    for (ll x: r) {
        r1.erase(x);
        o.push_back(x);
        combo(r1, o, i + 1);
        o.pop_back();
        r1.insert(x);
    }
}

string solve_slow(string s, ll y) {
    N = s.length();
    S = s;
    Y = y;
    B0 = -INF;
    S0 = "";
    vector<ll> o;
    set<ll> r;
    for (ll i = 0; i < N; i++) r.insert(i);
    combo(r, o, 0);
    return S0;
}

string move_c(const string &s, ll i, ll j) {
    if (i == j) return s;
    string s1 = s.substr(0, j);
    s1 += s[i];
    s1 += s.substr(j, i - j);
    s1 += s.substr(i + 1);
    return s1;
}

int main() {
#ifndef AVEVAD
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    string s;
    ll y;
    cin >> s >> y;
    ll n = s.length();
    vector<pair<ll, ll>> v;
    for (ll i = 0; i < n; i++) v.emplace_back(ll(s[i] - '0'), i);
    sort(v.rbegin(), v.rend());
    vector<ll> w(n);
    ll k = min(n, 10);
    ll i0 = n - k;
    string ans1;
    for (ll i = 0; i < i0; i++) {
        ans1 += char(v[i].first + '0');
        w[v[i].second] = 1;
    }
    string ans2;
    for (ll i = 0; i < n; i++) if (!w[i]) ans2 += s[i];
    ans2 = solve_slow(ans2, y);
    auto ans = ans1 + ans2;
    cout << ans << '\n';
}