#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll T = 0;

void
bridges(const vector<vector<pair<ll, ll>>> &g, vector<ll> &b, vector<ll> &w, vector<ll> &ti, vector<ll> &fu, ll v) {
    w[v] = 1;
    fu[v] = ti[v] = ++T;
    for (auto[u, j]: g[v]) {
        if (w[u]) fu[v] = min(fu[v], ti[u]);
        else {
            bridges(g, b, w, ti, fu, u);
            fu[v] = min(fu[v], fu[u]);
        }
        if (fu[u] > ti[v]) b[j] = 1;
    }
}

const ll INF = 1e18;

int main() {
#ifndef AVEVAD
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector<vector<pair<ll, ll>>> g(n);
        for (ll j = 0; j < m; j++) {
            ll v, u;
            cin >> v >> u;
            v--, u--;
            g[v].emplace_back(u, j);
            g[u].emplace_back(v, j);
        }
        vector<ll> b(m);
        {
            vector<ll> w(n), ti(n), fu(n);
            bridges(g, b, w, ti, fu, 0);
        }
        vector<ll> d0(n, INF), d1(n, INF);
        d0[0] = 0;
        for (ll i = 0; i < 2 * n; i++) {
            for (ll v = 0; v < n; v++) {
                for (auto[u, j]: g[v]) {
                    if (b[j]) continue;
                    d1[u] = min(d1[u], d0[v] + 1);
                    d0[u] = min(d0[u], d1[v] + 1);
                }
            }
        }
        for (ll v = 1; v < n; v++) cout << (d0[v] >= INF ? -1 : d0[v]) << ' ';
        cout << '\n';
    }
}