#include <bits/stdc++.h>

#define int long long

using namespace std;

int all_points, all_delta;

struct dsu {
    int n;
    int diff;
    vector<int> p;
    vector<int> sz;
    vector<int> points;
    vector<int> less;

    dsu(int _n, vector<int> _p) {
        diff = _n;
        n = _n;
        p.resize(n);
        points.resize(n);
        sz.resize(n, 1);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            points[i] = _p[i];
        }

    }

    int get(int a) {
        if (p[a] == a) {
            return a;
        }
        p[a] = get(p[a]);
        return p[a];
    }

    void merge(int i, int j, int how_many) {
        i = get(i);
        j = get(j);
        if (i == j) {
            return;
        }
        if (sz[i] > sz[j]) {
            swap(i, j);
        }
        vector<int> newl(n), newp(n);
        for (int k = 0; k < n; ++k) {
            int cur = get(k);
            if (points[cur] < points[i]) {
                newl[cur] = less[cur] - 1;
                all_delta -= 1;
            }
            newp[cur] = p[cur] + how_many * (diff - less[cur] - 1);
        }
        diff -= 1;
        points = newp;
        less = newl;
        p[i] = p[j];
        sz[i] += sz[j];
    }

};

bool cmp(const tuple<int, int, int>& a, const tuple<int, int, int>& b) {
    return get<1>(a) < get<1>(b);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
        b[i] = a[i].first;
    }
    dsu d(n, b);

    vector<pair<int, int>> change;
    set<pair<int, int>> st;
    sort(a.begin(), a.end());

    int delta = 0;

    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1].first - a[i].first != 0) {
            st.insert({a[i + 1].first - a[i].first, a[i].second});
            all_delta += i;
        }
        all_points += a[i].first;
    }

    all_points += a.back().first;
    for (auto elem: st) {
        change.push_back(elem);
    }

    vector<int> number_of_player(q);
    vector<tuple<int, int, int>> req(q);
    for (int i = 0; i < q; ++i) {
        cin >> get<0>(req[i]) >> get<1>(req[i]);
        get<2>(req[i]) = i;
        if (get<0>(req[i]) == 3) {
            cin >> number_of_player[i];
        }
    }

    sort(req.begin(), req.end(), cmp);

    int prev_k = 0;

    int ch = 0;

    vector<int> ans(q);

    int pref_k = 0;

    for(auto[ty,k,j] : req) {
        while (k > change[ch].first) {
            d.merge(change[ch].second, change[ch].second + 1, change[ch].first - pref_k);
            pref_k = change[ch].first;
            ch++;
        }
        if (ty == 1) {
            ans[j] = d.diff;
        } else if (ty == 2) {
            ans[j] = all_points + (k - pref_k) * all_delta;
        } else {
            ans[j] = d.points[d.get(number_of_player[j])] + (d.diff - 1 - d.less[d.get(number_of_player[j])]) * (k - pref_k);
        }
    }
}

int32_t main() {
    solve();
    return 0;
}
