#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

//#define int unsigned long long
#define endl '\n'

struct T3
{
	unsigned long long num, i, k;

	bool operator<(T3 t)
	{
		return k < t.k;
	}
};

bool cmp(pair<unsigned long long, int> p1, pair<unsigned long long, int> p2)
{
	return p1.second < p2.second;
}

struct S
{
	vector<pair<unsigned long long, int>> v;
	vector<int> add;
};

void task()
{
	int n, q;
	cin >> n >> q;

	vector<pair<unsigned long long, int>> v(n);

	for (int i = 0; i < n; i++)
	{
		cin >> v[i].first;
		v[i].second = i;
	}

	sort(v.begin(), v.end());

	vector<unsigned long long> diff;

	for (int i = 1; i < n; i++)
	{
		if (v[i].first - v[i - 1].first > 0)
		{
			diff.push_back(v[i].first - v[i - 1].first);
		}
	}

	sort(diff.begin(), diff.end());

	vector<pair<unsigned long long, int>> q1, q2;
	vector<T3> q3;

	vector<unsigned long long> ans(q);

	for (int i = 0; i < q; i++)
	{
		int t;
		cin >> t;

		if (t == 1)
		{
			unsigned long long k;
			cin >> k;

			q1.push_back({ i,k });
		}
		else if (t == 2)
		{
			unsigned long long k;
			cin >> k;

			q2.push_back({ i,k });
		}
		else if (t == 3)
		{
			unsigned long long p, k;
			cin >> k >> p;

			p--;

			q3.push_back({ i,p,k });
		}
	}

	for (int f = 0; f < q1.size(); f++)
	{
		unsigned long long k = q1[f].second;

		if (diff.size() == 0)
		{
			ans[q1[f].first] = 1;
			continue;
		}
		else if (diff[0] > k)
		{
			ans[q1[f].first] = diff.size() + 1;
			continue;
		}

		int l = 0;
		int r = diff.size();

		while (r - l > 1)
		{
			int m = (r + l) / 2;

			if (diff[m] <= k)
			{
				l = m;
			}
			else
			{
				r = m;
			}
		}

		ans[q1[f].first] = diff.size() - r + 1;
	}

	vector<S> vv;

	vector<int> add(n);
	add[n - 1] = 0;
	for (int i = n - 2; i >= 0; i--)
	{
		if (v[i + 1].first > v[i].first)
		{
			add[i] = add[i + 1] + 1;
		}
		else
		{
			add[i] = add[i + 1];
		}
	}
	vv.push_back({ v, add });

	int dlast = 0;

	for (int i = 0; i < diff.size(); i++)
	{
		vector<pair<unsigned long long, int>> v1 = vv.back().v;
		vector<int> a = vv.back().add;
		unsigned long long mu = diff[i] - dlast;
		dlast = diff[i];

		for (int j = 0; j < n; j++)
		{
			v1[j].first += mu * (unsigned long long)a[j];
		}

		vector<int> ad(n);
		ad[n - 1] = 0;

		for (int i = n - 2; i >= 0; i--)
		{
			if (v1[i + 1].first > v1[i].first)
			{
				ad[i] = ad[i + 1] + 1;
			}
			else
			{
				ad[i] = ad[i + 1];
			}
		}

		vv.push_back({ v1,ad });
	}

	sort(q2.begin(), q2.end(), cmp);

	unsigned long long p = 0;
	unsigned long long total = 0;

	for (int f = 0; f < q2.size(); f++)
	{
		unsigned long long k = q2[f].second;

		while (p < diff.size() && diff[p] <= k)
		{
			p++;
		}

		unsigned long long sum = 0;
		unsigned long long l;

		if (p == 0)
		{
			l = k;
		}
		else
		{
			l = k - diff[p - 1];
		}

		for (int i = 0; i < n; i++)
		{
			sum += vv[p].v[i].first - vv[0].v[i].first;
			sum += l * (unsigned long long)vv[p].add[i];
		}

		ans[q2[f].first] = sum;
	}

	sort(q3.begin(), q3.end());

	p = 0;

	for (int f = 0; f < q3.size(); f++)
	{
		unsigned long long k = q3[f].k;
		unsigned long long ind = q3[f].i;

		for (int i = 0; i < n; i++)
		{
			if (v[i].second == ind)
			{
				ind = i;
				break;
			}
		}

		while (p < diff.size() && diff[p] <= k)
		{
			p++;
		}

		unsigned long long sum = 0;
		unsigned long long l;

		if (p == 0)
		{
			l = k;
		}
		else
		{
			l = k - diff[p - 1];
		}

		sum = vv[p].v[ind].first + (unsigned long long)vv[p].add[ind] * l;

		ans[q3[f].num] = sum;
	}

	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	task();

	return 0;
}