#include<iostream>
#include<vector>
#include<algorithm>
#include<math.h>
#include<map>

#define fori(n) for(int i=0;i<n;i++)
#define ll long long
using namespace std;
struct query {
	int id = 0;
	int t;
	ll k;
	ll v = 0;
};
bool cmp(query a, query b) {
	if(a.k!=b.k)return a.k < b.k;
	return a.t < b.t;
}
struct node;
vector<node>dsu;
struct node {
	ll sz = 1;
	ll szonleft = 0;
	int parent, id;
	node() {
		id = 0;
		sz = 0;
		parent = 0;
	}
	node(int id) :id(id), parent(id){
		sz = 1;
	}
	int getup() {
		if (parent == id)return id;
		return parent = dsu[parent].getup();
	}
	void merge(int j) {
		dsu[dsu[j].getup()].sz+= dsu[getup()].sz;
		dsu[getup()].parent = dsu[j].getup();
	}
	ll getsize() {
		return dsu[getup()].sz;
	}
};
vector<ll>c;
map<ll, int>geti;

int main() {
	int n, q, t,j;
	ll k;
	cin >> n >> q;
	vector<ll>cfirst(n);
	c.resize(n);
	vector<query>ans;
	fori(n)cin >> cfirst[i];
	fori(n)c[i] = cfirst[i];
	fori(q) {
		cin >> t >> k;
		if (t == 3) {
			cin >> j;
			ans.push_back({ i, t, k, c[j] });
		}
		else ans.push_back({ i, t, k });
	}
	
	sort(c.rbegin(), c.rend());
	ll cnt = 1;
	ll l = -1;
	fori(n) {
		if (l == -1) {
			l = c[i];
			geti[c[i]] = cnt-1;
		}
		else if (c[i] != l) {
			ans.push_back({-1, 0, l - c[i], c[i] });
			l = c[i];
			cnt++;
			geti[c[i]] = cnt-1;
		}
	}
	dsu.resize(cnt);
	fori(n) {
		dsu[geti[c[i]]].parent = dsu[geti[c[i]]].id = geti[c[i]];
		dsu[geti[c[i]]].sz++;
		
	}
	ll plus = 0;
	ll szonleft = 0;
	for (auto& i : dsu) {
		plus += i.sz * i.id;
		i.szonleft = szonleft;
		szonleft += i.sz;
	}
	sort(ans.begin(), ans.end(), cmp);
	ll sum=0;
	vector<ll>forcout(q);
	fori (ans.size()) {
		//plus
		t = ans[i].t;
		if (i != 0)sum += plus * (ans[i].k - ans[i - 1].k);
		else sum += plus * (ans[i].k);
		if (t == 0) {
			cnt--;
			int tmp = geti[ans[i].v];
			plus -= dsu[tmp].getsize();
			dsu[tmp].merge(tmp-1);
			plus -= n - dsu[tmp].getsize() - dsu[dsu[tmp].getup()].szonleft;
		}
		if (t == 1) {
			forcout[ans[i].id]=cnt;
		}
		else if (t == 2) {
			forcout[ans[i].id]= sum;
		}
		else if (t == 3) {
			//....
		}
	}
	fori(q)cout << forcout[i] << '\n';

	return 0;
}