#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>


using namespace std;
using ll = long long;




int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    string s;
    cin >> s;
    ll y;
    cin >> y;
    int s_size = s.size();
    vector<ll> num(s_size);
    for (int i = 0; i < s_size; ++i) {
        num[i] = s[i] - '0';
    }
    if (s_size >= 18) {
        sort(num.begin(), num.end());
        for (int i = s_size - 1; i > -1; --i) {
            cout << num[i];
        }
        return 0;
    }
    vector<ll> dp(s_size * s_size, 0);
    vector<vector<int>> dp0(s_size * s_size, vector<int>(s_size));
    for (int i = 0; i < s_size * s_size; ++i) {
        int now = i;
        vector<int> num0(s_size);
        for (int j = 0; j < s_size; ++j) {
            num0[j] = num[j];
        }
        vector<int> used(s_size, false);
        if (now == 0) {
            ll exy0 = 1;
            for (int x = s_size - 1; x > -1; --x) {
                dp[i] +=  num0[x] * exy0;
                exy0 *= 10;
            }
            for (int x = 0; x < s_size; ++x) {
                dp0[i][x] = num0[x];
            }
        } else {
            for (int j = 0; j < s_size; ++j) {
                int ind;
                int maxx = -1;
                for (int x = j; x < s_size; ++x) {
                    if (!used[x] && maxx < num0[x]) {
                        maxx = num0[x];
                        ind = x;
                    }
                }
                used[ind] = true;
                if (now >= ind - j) {
                    now -= ind - j;
                    for (int x = ind; x > j; --x) {
                        swap(num0[x], num0[x - 1]);
                        swap(used[x], used[x - 1]);
                    }
                    if (now == 0) {
                        ll exy0 = 1;
                        for (int x = s_size - 1; x > -1; --x) {
                            dp[i] += num0[x] * exy0;
                            exy0 *= 10;
                        }
                        for (int x = 0; x < s_size; ++x) {
                            dp0[i][x] = num0[x];
                        }
                        break;
                    }
                } else {
                    --j;
                    continue;
                }
            }
        }
    }
    ll maxx = -1;
    int ind;
    for (int i = 0; i < s_size * s_size; ++i) {
        if (maxx < dp[i] - y * i) {
            maxx = dp[i] - y * i;
            ind = i;
        }
    }
    for (int i = 0; i < s_size; ++i) {
        cout << dp0[ind][i];
    }
    return 0;
}