#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

#define int ll

vector<pair<vector<ll>, vector<ll>>> tt;


void build(int v, int l, int r, vector<ll> diff) {
	if (l + 1 == r) {
		tt[v] = { {diff[l] }, { diff[l] }};
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v + 1, l, mid, diff);
	build(2 * v + 2, mid, r, diff);

	merge(tt[2 * v + 1].first.begin(), tt[2 * v + 1].first.end(), tt[2 * v + 2].first.begin(), tt[2 * v + 2].first.end(), back_inserter(tt[v].first));
	tt[v].second.resize(tt[v].first.size());
	for (int i = tt[v].first.size() - 1; i >= 0; i--) {
		tt[v].second[i] += tt[v].first[i];
		if (i + 1 != tt[v].first.size()) {
			tt[v].second[i] += tt[v].second[i + 1];
		}
	}
}


pair<int, ll> get_res(int v, int l, int r, int a, int b, int k) {
	if (b <= l || r <= a) {
		return { 0, 0 };
	}
	if (a <= l && r <= b) {
		// return { tt[v].first.size() - (lower_bound(tt[v].first.begin(), tt[v].first.end(), k) - tt[v].first.begin()), 1};
		auto it = lower_bound(tt[v].first.begin(), tt[v].first.end(), k);
		if (it == tt[v].first.end()) {
			return { 0, 0 };
		}
		else {
			int idx = it - tt[v].first.begin();
			return { tt[v].first.size() - idx, tt[v].second[idx] };
		}
	}
	int mid = (l + r) / 2;
	auto v1 = get_res(2 * v + 1, l, mid, a, b, k);
	auto v2 = get_res(2 * v + 2, mid, r, a, b, k);
	return { v1.first + v2.first, v1.second + v2.second };
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	/*while (true) {
		int n = rand() % 5 + 1;
		vector<int> arr(n);
		for (int i = 0; i < n; i++) {
			arr[i] = rand() % 10;
		}
		while (true) {
			for (int i = 0; i < n; i++) {
				cout << arr[i] << ' ';
			}
			cout << '\n';
			if (count(arr.begin(), arr.end(), arr[0]) == n) {
				break;
			}
			set<int> ss;
			for (auto el : arr) {
				ss.insert(el);
			}
			for (int i = 0; i < n; i++) {
				auto it = ss.end();
				it--;
				int lala = 0;
				while (*it != arr[i]) {
					lala++;
					it--;
				}
				arr[i] += lala;
			}
		}
		cout << "===\n";
	}*/
	int n, q;
	cin >> n >> q;
	vector<ll> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<ll> aaa = arr;
	sort(aaa.begin(), aaa.end());
	vector<ll> diff;
	for (int i = 0; i + 1 < n; i++) {
		diff.push_back(aaa[i + 1] - aaa[i]);
	}
	vector<ll> eee = diff;
	sort(eee.begin(), eee.end());
	vector<vector<ll>> fff;
	map<ll, ll> ggg;
	for (int i = 0; i + 1 < n; i++) {
		// diff[i], i + 1
		
		ggg[diff[i]] += i + 1;
	}
	ggg[0] = 0;


	ll ooo = 0;
	for (auto el : ggg) {
		ooo += el.second;
	}
	ll summ = 0;
	for (auto el : ggg) {
		ll last = 0;
		ooo -= el.second;
		summ += (ll)el.second * el.first;
		fff.push_back({ el.first, ooo * el.first + summ, ooo });
	}
	map<ll, int> idxs;
	for (int i = 0; i < n; i++) {
		if (idxs.find(aaa[i]) == idxs.end()) {
			idxs[aaa[i]] = i;
		}
	}
	vector<ll> suff(n);
	for (int i = n - 2; i >= 0; i--) {
		suff[i] = diff[i];
		if (i + 1 < n) {
			suff[i] += suff[i + 1];
		}
	}
	tt.resize(4 * n);
	build(0, 0, n - 1, diff);
	while (q--) {
		int t;
		cin >> t;
		if (t == 1) {
			ll k;
			cin >> k;
			auto it = upper_bound(eee.begin(), eee.end(), k);
			cout << eee.end() - it + 1 << '\n';
		}
		else if (t == 2) {
			ll k;
			cin >> k;
			vector<ll> lala = { k + 1, -1LL, -1LL };
			auto it = upper_bound(fff.begin(), fff.end(), lala);
			it--;
			lala = *it;
			cout << lala[1] + lala[2] * (k - lala[0]) << '\n';
			
		}
		else if (t == 3) {
			ll k, idx;
			cin >> k >> idx;
			idx--;
			idx = idxs[arr[idx]];
			/*ll ans = aaa[idx] + suff[idx];
			if (idx != n - 1) {
				ans -= get_res(0, 0, n - 1, idx, n - 1, k).second;
				ans += get_res(0, 0, n - 1, idx, n - 1, k).first * k;
			}*/
			ll ans = aaa[idx];
			for (int j = idx; j + 1 < n; j++) {
				ans += min(diff[j], k);
			}
			cout << ans << '\n';
		}
	}
	return 0;
}