#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e5 + 5;

int dp[2][maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        dp[0][i] = dp[1][i] = -1;
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp[0][0] = 0;
    queue<pair<int, int>> q;
    q.push({0, 0});
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto u : g[v.second]) {
            if (dp[v.first ^ 1][u] == -1) {
                dp[v.first ^ 1][u] = dp[v.first][v.second];
                q.push({v.first ^ 1, u});
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << dp[0][i] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
