#include <bits/stdc++.h>

using namespace std;

typedef __int128 lll;
typedef long long ll;

struct query {
    int t;
    ll k;
    int i, idx;
};

bool isLessThan(query a, query b) {
    return a.k < b.k;
}

int main() {
    int n, q;
    cin >> n >> q;
    vector <pair <ll, int>> a(n);
    ll st_sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        st_sum += a[i].first;
        a[i].second = i;
    }
    vector <query> qs(q);
    for (int i = 0; i < q; ++i) {
        cin >> qs[i].t >> qs[i].k;
        if (qs[i].t == 3) {
            cin >> qs[i].i;
        }
        qs[i].idx = i;
    }
    sort(qs.begin(), qs.end(), isLessThan);
    sort(a.begin(), a.end(), greater());
    vector <ll> ans(q);
    ll curr_k = 0;
    for (auto [t, k, i, idx]: qs) {
        while (true) {
            ll min_diff = 1000000000000000000;
            for (int j = 0; j < n - 1; ++j) {
                if (a[j].first != a[j + 1].first) {
                    min_diff = min(min_diff, a[j].first - a[j + 1].first);
                }
            }
            if (curr_k + min_diff <= k) {
                vector <ll> to_add(n, 0);
                for (int j = 1; j < n; ++j) {
                    if (a[j].first != a[j - 1].first) {
                        to_add[j] = to_add[j-1] + 1;
                    } else {
                        to_add[j] = to_add[j-1];
                    }
                }
                for (int j = 1; j < n; ++j) {
                    a[j].first += to_add[j] * min_diff;
                }
                curr_k += min_diff;
            } else {
                break;
            }
        }
        vector <ll> to_add(n, 0);
        for (int j = 1; j < n; ++j) {
            if (a[j].first != a[j - 1].first) {
                to_add[j] = to_add[j-1] + 1;
            } else {
                to_add[j] = to_add[j-1];
            }
        }
        for (int j = 1; j < n; ++j) {
            a[j].first += to_add[j] * (k - curr_k);
        }
        curr_k = k;
        for (int j = 0; j < n; ++j) {
            cerr << a[j].first << ' ' << a[j].second << '\n';
        }
        cerr << "\n\n\n";
        if (t == 1) {
            ans[idx] = 1;
            for (int j = 0; j < n - 1; ++j) {
                if (a[j].first != a[j + 1].first) {
                    ans[idx]++;
                }
            }
        } else if (t == 2) {
            ans[idx] = 0;
            for (int j = 0; j < n; ++j) {
                ans[idx] += a[j].first;
            }
            ans[idx] -= st_sum;
        } else {
            for (int j = 0; j < n; ++j) {
                if (a[j].second == i-1) {
                    ans[idx] = a[j].first;
                    break;
                }
            }
        }
    }
    for (auto el: ans) {
        cout << el << '\n';
    }
}
