//
// Created by roi on 28.03.2022.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <set>
#include <map>
#include <cassert>

using namespace std;
#define int long long

map<int, int> parent;
map<int, int> size;
map<int, int> pref;

int h_p(int v){
    if (v == parent[v]){
        return v;
    }
    int u = h_p(parent[v]);
    parent[v] = u;
    return u;
}

int plus_by_tack = 0;

void unite(int v, int u){
    u = h_p(u);
    v = h_p(v);
    if (u == v){
        return;
    }
    if (u < v){
        swap(u, v);
    }
    // u >= v
    parent[v] = u;
    plus_by_tack -= pref[v];
}

signed main() {
#ifdef LOCAL
    ifstream cin("B.in");
#endif
    int n, q;
    while (cin >> n >> q){
        vector<int> c(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
//            c[i] = c1[i].first;
        }
        sort(c.begin(), c.end());
        vector<int> c11 = c;
        c.resize(unique(c.begin(), c.end()) - c.begin());
        for (auto el : c){
            parent[el] = el;
            pref[el] = upper_bound(c11.begin(), c11.end(), el) - c11.begin();
            plus_by_tack += pref[el];
        }
        plus_by_tack -= n;
        vector<pair<int, pair<int, int>>> events(c.size() - 1);
        for (int i = 0; i < c.size() - 1; ++i) {
            events[i] = {c[i + 1] - c[i], {c[i], c[i + 1]}};
        }
        events.push_back({0, {-1, -1}});
        sort(events.begin(), events.end());
        map<int, vector<pair<int, pair<int, int>>>> mp;
        vector<int> times;
        for (int i = 0; i < q; ++i) {
            int t, time;
            cin >> t >> time;
            times.push_back(time);
            if (t == 3){
                int x; cin >> x;
                mp[time].push_back({t, {x, i}});
//                cin >> qq[i].second.second.first;
            } else{
                mp[time].push_back({t, {0, i}});
            }
//            qq[i].second.second.second = i;
//            cin >> qq[i].second >> qq[i].first;
        }
//        sort(qq.begin(), qq.end());
        vector<int> basec = c;
        for (auto el : events){
            times.push_back(el.first);
            mp[el.first].push_back({0, el.second});
        }
        sort(times.begin(), times.end());
        times.resize(unique(times.begin(), times.end()) - times.begin());
        int last_time = 0;
        long long sum = 0;
        vector<int> ans(q, -1);
        for (int time : times){
            sum += (time - last_time) * plus_by_tack;
            last_time = time;
            for (auto el : mp[time]){
                if (el.first == 0){
                    unite(el.second.first, el.second.second);
                }
            }
            for (auto el : mp[time]){
                if (el.first == 1){
                    auto it = (upper_bound(events.begin(), events.end(), make_pair(time, make_pair(c.back(), c.back()))) - events.begin());
                    ans[el.second.second] = c.size() - it + 1;
                } else if (el.first == 2){
                    ans[el.second.second] = sum;
                } else if (el.first == 3){

                }
            }
        }
        for (int i = 0; i < q; ++i) {
            cout << ans[i] << '\n';
        }
        cout << endl;
    }
}
