//
// Created by roi on 28.03.2022.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <fstream>

using namespace std;

vector<vector<int>> g;

int main(){
#ifdef LOCAL
    ifstream cin("C.in");
#endif
    int t;
    cin >> t;
    int n, m;
    while (cin >> n >> m){
        g.resize(0);
        g.resize(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            g[a - 1].push_back(b - 1);
            g[b - 1].push_back(a - 1);
        }
        int inf = -1;
        vector<int> dist1(n, inf);
        vector<int> dist2(n, inf);
        queue<int> q;
        q.push(0);
        int now_dist = 0;
        while (!q.empty()){
            queue<int> qq;
            while (!q.empty()){
                int v = q.front();
                q.pop();
                for (int u : g[v]){
                    if (now_dist % 2 == 0){
                        if (dist1[u] == inf){
                            dist1[u] = now_dist + 1;
                            qq.push(u);
                        }
                    } else {
                        if (dist2[u] == inf) {
                            dist2[u] = now_dist + 1;
                            qq.push(u);
                        }
                    }
                }
            }
            swap(qq, q);
            now_dist++;
        }
        for (int i = 1; i < n; ++i) {
            cout << dist2[i] << ' ';
        }
        cout << endl;
    }
}
