#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

bool comp(char a, char b) {
	return a < b;
}

const int C = 11;

bool bi(string a, string b) {
	int id = 0;
	while (id < a.size() && a[id] == b[id])
		id++;
	if (id == a.size())
		return false;
	return a[id] > b[id];
}

long long mysub(string a, string b) {
	if (!bi(a, b))
		return 0;
	int n = (int)a.size();
	long long res = 0;
	long long tpow = 1;
	for (int i = n - 1; i >= 0; i--) {
		if (a[i] < b[i]) {
			int id = i - 1;
			while (a[id] == '0') {
				a[id] = '9';
				id--;
			}
			a[id] = (char)((int)a[id] - 1);
			res += (a[i] - b[i] + 10) * tpow;
		}
		else {
			res += (a[i] - b[i]) * tpow;
		}
		tpow *= 10;
	}
	return res;
}

string ans = "";
long long prof = 0;

long long res = 0;
string path;
string s0;

auto start = clock();

void f(string x, long long y) {
	auto fff = clock();
	if ((float)(fff - start) / CLOCKS_PER_SEC > 0.95)
		return;
	if (x.empty()) {
		res += mysub(path, s0);
		if (prof < res) {
			prof = res;
			ans = path;
		}
		else if (prof == res && bi(path, ans))
			ans = path;
		res -= mysub(path, s0);
		return;
	}
	for (int i = 0; i < x.size(); i++) {
		res -= i * y;
		string t = x;
		t.erase(t.begin() + i);
		path.push_back(x[i]);
		f(t, y);
		path.pop_back();
		res += i * y;
	}
}

void solve() {
	string x;
	cin >> x;
	s0 = x;
	long long y;
	cin >> y;
	string anst = "";
	vector <char> temp;
	for (auto e : x)
		temp.push_back(e);
	sort(temp.begin(), temp.end());
	for (int i = temp.size() - 1; i >= C; i--)
		anst += temp[i];
	vector <int> cnt(10, 0);
	for (int i = 0; i < min((int)temp.size(), C); i++)
		cnt[temp[i] - '0']++;
	string rest = "";
	for (int j = x.size() - 1; j >= 0; j--) {
		if (cnt[x[j] - '0']) {
			cnt[x[j] - '0']--;
			rest += x[j];
		}
	}
	reverse(rest.begin(), rest.end());
	f(rest, y);
	cout << anst + ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	//  cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}