#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;

const int MAXN = 20000 + 7;

int a[MAXN];
int a0[MAXN];
int l[MAXN];
int l0[MAXN];
int r[MAXN];
int r0[MAXN];
int c[MAXN];
int c0[MAXN];
int t[MAXN];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		a0[i] = a[i];
	for (int i = 0; i < m; i++) {
		cin >> l[i] >> r[i] >> c[i] >> t[i];
		l[i]--; r[i]--;
		l0[i] = l[i]; r0[i] = r[i];
		c0[i] = c[i];
	}
	for (int x = 0; x < n; x++) {
		for (int i = 0; i < n; i++) {
			c[i] = c0[i];
			a[i] = a0[i];
		}
		for (int i = 0; i < m; i++) {
			if (t[i] == 1) {
				l[i] = min(l0[i], x);
				r[i] = max(r0[i], x);
			}
		}
		set <pair <int, int>> se;
		vector <pair <pair <int, int>, int>> cc;
		for (int i = 0; i < m; i++)
			cc.push_back({ { l[i], r[i] }, i });
		sort(cc.begin(), cc.end());
		int id = 0;
		for (int i = 0; i < n; i++) {
			while (id < cc.size() && cc[id].first.first == i) {
				se.insert({ cc[id].first.second, cc[id].second });
				er[cc[id].first.second].push_back(cc[id].second);
				id++;
			}
			while (se.begin()->first < i)
				se.erase(se.begin());
			while (a[i] > 0 && se.size()) {
				int need = min(a[i], c[se.begin()->second]);
				c[se.begin()->second] -= need;
				a[i] -= need;
				if (c[se.begin()->second] == 0)
					se.erase(se.begin());
			}
		}
		long long sum = 0;
		for (int i = 0; i < n; i++)
			sum += (a0[i] - a[i]);
		cout << sum << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}