#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vc vector
#define sz(a) (int)a.size()
#define pb push_back

struct robot {
    int l, r, c, t;
};

struct event {
    int t, p, i;
    bool operator < (event const &e)const {
        return t < e.t || (t == e.t && p > e.p);
    }
};

void solve () {
    int n, m;
    cin >> n >> m;
    vc <int> a(n);
    vc <robot> b(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) {
        cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t; --b[i].l; --b[i].r;
    }
    for (int x = 0; x < n; ++x) {
        vc <robot> c(m);
        vc <event> ev;
        for (int i = 0; i < m; ++i) {
            c[i] = b[i];
            if (c[i].t) {
                c[i].l = min(x, c[i].l);
                c[i].r = max(x, c[i].r);
            }
            ev.pb({c[i].l, 1, i});
            ev.pb({c[i].r, -1, i});
        }
        for (int i = 0; i < n; ++i) ev.pb({i, 0, i});
        int sum = 0, col = 0;
        sort(ev.begin(), ev.end());
        vc <int> cnt(n);
        for (int i = 0; i < sz(ev); ++i) {
            int t = ev[i].t, p = ev[i].p, j = ev[i].i;
            col += p;
            if (p == 0) cnt[t] = col;
        }
        vc <int> who(n);
        for (int i = 0; i < m; ++i) {
            vc <pair <int, int>> tt;
            for (int j = c[i].l; j <= c[i].r; ++j) {
                tt.pb({cnt[j], j});
            }
            sort(tt.begin(), tt.end());
            int ost = c[i].c;
            for (auto &it: tt) {
                int j = it.second;
                int nd = min(ost, a[j] - who[j]);
                who[j] += nd;
                ost -= nd;
            }
        }
        for (int i = 0; i < n; ++i) {
            sum += who[i];
        }
        cout << sum << ' ';
    }
    cout << '\n';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
