#include <bits/stdc++.h>

using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,fma,popcnt")


//#define int long long

const int N = 5005;

vector<int> gr[N];

int dp[N][N];
const int INF = 1e9 + 7;

int cnt = 0;

deque<pair<int, int>> deq;


int used[N];

int timer = 1;
vector<pair<int, int>> vec;

void dfs(int u, int v, int d) {
    used[u] = timer;
    dp[u][v] = d;
    for (auto c: gr[u]) {
        if (c == v) continue;
        if (dp[c][v] <= d) continue;
        dfs(c, v, d);
    }
    pair<int, int> now4 = {u, v};
    int ind2 = lower_bound(vec.begin(), vec.end(), now4) - vec.begin();
    if (ind2 < vec.size() and vec[ind2] == now4) {
        for (auto c2: gr[u]) {
            if (dp[u][v] + 2 < dp[u][c2]) {
                dp[u][c2] = dp[u][v] + 2;
                deq.push_back({u, c2});
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        gr[i].clear();
        for (int j = 0; j < n; ++j) {
            dp[i][j] = INF;
        }
    }
    vec.clear();
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vec.push_back({a, b});
        vec.push_back({b, a});
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    sort(vec.begin(), vec.end());

    for (auto c: gr[0]) {
        deq.push_back({0, c});
        dp[0][c] = 1;
    }

    while (!deq.empty()) {
        pair<int, int> now = deq.front();
        deq.pop_front();
        int u = now.first;
        int v = now.second;
        timer++;
        dfs(u, v, dp[u][v]);

        cnt++;
        if (cnt > 2000000) exit(1);
    }


    for (int i = 1; i < n; ++i) {
        int minn = INF;
        for (auto c: gr[i]) {
            minn = min(minn, dp[i][c]);
        }
        if (minn == INF) cout << -1 << " ";
        else cout << minn + 1 << " ";
    }
    cout << '\n';
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}