#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define pb push_back
#define all(x) (x).begin(), (x).end()

struct rob {
    ll l, r, k, t;
};

bool cmp(const pll& a, const pll& b) {
    return a.first > b.first;
}


const int maxN = 2e5 + 9;
ll arr[maxN];
vector<pll> sl[maxN];
rob rs[maxN];
void clear(int n, int m) {
    for(int i = 0; i <= n; ++i) {
//        arr[i] = 0;
        sl[i].clear();
    }
//    for(int i = 0; i <= m; ++i) {
//        rs[i] = {0, 0, 0, 0};
//    }
}
vector<pll> g;
ll go(int n) {
    g.clear();
    ll res = 0;
    for(int i = 0; i < n; ++i) {
        while(!g.empty() && g[0].first < i) {
            pop_heap(all(g), cmp);
            g.pop_back();
        }
        for(auto &j: sl[i]) {
            g.pb({j.first, j.second});
            push_heap(all(g), cmp);
        }

        ll x = arr[i];
        while(x > 0 && !g.empty()) {
            ll spnd = min(x, g[0].second);
            x -= spnd;
            g.begin()->second -= spnd;
            if(g.begin()->second == 0) {
                pop_heap(all(g), cmp);
                g.pop_back();
            }
            res += spnd;
        }
    }
    return res;
}

void solve() {
    int n, m; cin >> n >> m;
    clear(n, m);
    for(int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    for(int i = 0; i < m; ++i) {
        ll l, r, k, t; cin >> l >> r >> k >> t;
        --l; --r;
        rs[i] = {l, r, k, t};
    }

    for(int x = 0; x < n; ++x) {
        clear(n, m);
        for(int i = 0; i < m; ++i) {
            int nl = rs[i].l, nr = rs[i].r;
            if(rs[i].t == 1) {
                nl = min(nl, x);
                nr = max(nr, x);
            }
            sl[nl].pb({nr, rs[i].k});
        }
        cout << go(n) << ' ';
    }
    cout << '\n';

}
int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*
1
4 3
3 3 2 2
1 2 2 0
3 3 3 0
2 2 4 1

 */