#include <bits/stdc++.h>
 
using namespace std;

const long long INF = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> l(m), r(m), c(m), t(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i] >> c[i] >> t[i];
        --l[i];
        --r[i];
    }
    
    vector<int> p(m);
    iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](const int &i, const int &j) {
    	return r[i] > r[j];
    });
    
    vector<long long> pref(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; ++i) {
    	pref[i + 1] = pref[i] + a[i];
    }

    vector<long long> mn(n, INF);

    long long sum_c = 0;
    for (int i = 0; i < m; ++i) {
    	sum_c += c[i];
    }

    vector<long long> sum(m, 0);

    for (int i = 0; i < m; ++i) {
    	long long mx = -INF;
    	for (int j = 0; j < m; ++j) {
    		sum[j] = 0;
    	}
    	
    	long long cur_sum = 0;
    	for (int j : p) {
    		if (l[j] >= l[i]) {
    			cur_sum += c[j];
    		}
    		sum[j] = cur_sum;
    	}

    	int ptr = 0;
    	for (int x = n - 1; x >= l[i]; --x) {
    		while (ptr < m && r[p[ptr]] >= x) {
    			if (l[p[ptr]] >= l[i]) {
    				mx = max(mx, sum[p[ptr]] - pref[r[p[ptr]] + 1] + pref[l[i]]);
    			}
    			++ptr;
    		}
    		mn[x] = min(mn[x], sum_c - mx);
    	}
    }

    for (int i = 0; i < n; ++i) {
    	cout << mn[i] << " "; 
    }
    cout << "\n";
}
 
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}