#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = uint32_t;
using int64 = int64_t;
using uint64 = uint64_t;

int64 fpow(int64 a, int64 n) {
	if (n == 0) return 1;

	int64 b = fpow(a, n / 2);
	b *= b;
	if (n % 2 == 1) b *= a;

	return b;
}

int32_t main() {
	string s; cin >> s;
	string y; cin >> y;

	int64 ny = stoll(y);
	int n = s.size();

	int i = 0, j = 0;
	while (i < n && j < n) {
		j = max(j, i);
		if (s[i] == '2') {
			++i;
			continue;
		}

		while (j < n && s[j] == '1') {
			++j;
		}
		if (j == n) break;

		if (n - i - 1 > y.size()) {
			swap(s[i], s[j]);
			continue;
		}

		int64 d = fpow(10, n - i - 1) - fpow(10, n - j - 1);

		if (d >= ny * (j - i)) {
			swap(s[i], s[j]);
			continue;
		}

		++i;
	}

	cout << s;
}