#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el;
    return out;
}

int get_cost(vector <int> b, vector <int> a) {
    int ans = 0;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (a[j] == b[i]) {
                int x = a[j];
                for (int d = j; d > i; d--) a[d] = a[d - 1];
                a[i] = x;
                ans += j - i;
                break;
            }
        }
    }
    return ans;
}

int get_arr_value(vector <int> a) {
    int x = 0;
    for (int i = a.size() - 1, p = 1; i >= 0; i--, p *= 10) x += a[i] * p;
    return x;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    string s;
    cin >> s;
    int n = s.size();
    vector <int> a(n);
    for (int i = 0; i < n; i++) a[i] = s[i] - '0';
    int y;
    cin >> y;
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    for (auto el: a) cout << el;
    return 0;

    int k = min(5ll, n);
    vector <int> p(k);
    for (int i = 0; i < k; i++) p[i] = i;

    pair <int, vector <int> > best = {get_arr_value(a), a};

    vector <int> b = a, last_k;
    sort(b.begin(), b.end());
    reverse(b.begin(), b.end());
    for (int i = n - k; i < n; i++) last_k.push_back(b[i]);

    while (true) {
        for (int i = n - k; i < n; i++) b[i] = last_k[p[i - (n - k)]];
        best = max(best, {get_arr_value(b) - get_cost(b, a) * y, b});
        if (!next_permutation(p.begin(), p.end())) break;
    }
//    cout << get_cost(best.second, a) << endl;
    for (auto el: best.second) cout << el;
    cout << endl;
}
