#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <unordered_map>

using namespace std;

#define all(a) (a).begin(), (a).end()

typedef long long ll;


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int t;
	cin >> t;

	for (; t; t--) {
		int n, m;
		cin >> n >> m;

		vector < vector < int > > g(n);
		for (; m; m--) {
			int u, v;
			cin >> u >> v;

			g[--u].push_back(--v);
			g[v].push_back(u);
		}

		vector < vector < bool > > used(n, vector < bool >(n, false));
		vector < vector < int > > dp(n, vector < int >(n, -1));
		dp[0][0] = 0;
		deque < int > q;
		q.push_back(0);
		for (; !q.empty(); ) {
			int x = q.front();
			q.pop_front();
			int y = x % n;
			x /= n;

			if (used[x][y])
				continue;
			used[x][y] = true;

			for (int to : g[x]) {
				int nx = to, ny = y, nd = 0;
				if (x == y) {
					nx = x;
					ny = to;
					nd = 1;
				}
				else if (to == y) {
					nx = x;
					ny = x;
					nd = 1;
				}

				if (used[nx][ny])
					continue;

				if (dp[nx][ny] == -1 || dp[nx][ny] > dp[x][y] + nd) {
					dp[nx][ny] = dp[x][y] + nd;
					if (nd == 0)
						q.push_front(nx * n + ny);
					else
						q.push_back(nx * n + ny);
				}
			}
		}

		for (int i = 1; i < n; i++)
			cout << dp[i][i] << " ";
		cout << "\n";
	}

	return 0;
}
