#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cstring>
#include <bitset>
#include <algorithm>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front


#define int long long


using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;


const int NMAX = 30;

__int128 p[NMAX];


__int128 get_delta(int aaa, int pos, string s) {
    int n = sz(s);


    __int128 d = s[pos] - s[aaa];
    __int128 delta = d * (p[n - 1 - aaa] - p[n - 1 - pos]);

    return delta;
}


__int128 to_int(string s) {
    __int128 x = 0;

    for (char c : s) {
        x *= 10;
        x += c - '0';
    }

    return x;
}



void stupid (string s, int n, __int128 k) {

    string t = s;
    sort(all(t));

    string res;
    __int128 ans = -1;

    do {
        __int128 delta = to_int(t) - to_int(s);
        __int128 sw = 0;


        string r = s;
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                if (t[i] == r[j]) {
                    //cout << "!!! " << i << " " << j << " " << t << " " << r << "\n";

                    sw += (j - i);

                    auto tmp = r[j];
                    for (int pos = j - 1; pos >= i; pos--) {
                        r[pos + 1] = r[pos];
                    }
                    r[i] = tmp;
                    break;
                }
            }
        }
        /*
        if (t != r) {
            cout << "WA\n";
        }
        */

        delta -= k * sw;

        if (delta > ans || (delta == ans && t > res)) {
            ans = delta;
            res = t;
        }

        //cout << t << " " << s << " " << (int)sw << "\n";

    } while (next_permutation(all(t)));


    cout << res << "\n";
}


void solve_solve_solve() {

    const int BORD = 10;

    string s;
    int k;
    cin >> s >> k;
    int n = sz(s);

    string t = s;
    sort(rall(t));

    cout << t.substr(0, max(0ll, n - BORD));

    int c[10] = {0};

    for (int i = 0; i < n - BORD; i++) {
        c[t[i] - '0']--;
    }
    string r = "";
    for (int i = 0; i < n; i++) {
        c[s[i] - '0']++;

        if (c[s[i] - '0'] > 0) {
            r += s[i];
        }
    }

    stupid(r, sz(r), k);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);


    p[0] = 1;
    for (int i = 1; i < NMAX; i++) {
        p[i] = p[i - 1] * 10;
    }

    int Q = 1;
    // cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
