#include<iostream>
#include<vector>
#include<string>
#include<algorithm>

#define int long long

using namespace std;

signed main(){
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (int i = 0; i < n; ++i){
        cin >> v[i];
    }
    vector<pair<int, int>> v2(n);
    for (int i = 0; i < n; ++i){
        v2[i] = {v[i], i};
    }
    sort(v.begin(), v.end());
    sort(v2.begin(), v2.end());
    vector<int> new_i(n);
    for (int i = 0; i < n; ++i){
        new_i[v2[i].second] = i;
    }
    vector<int> d(n - 1);
    for (int i = 0; i < n - 1; ++i){
        d[i] = v[i + 1] - v[i];
    }
    vector<pair<int, int>> ds(n - 1);
    for (int i = 0; i < n - 1; ++i){
        ds[i] = {d[i], i};
    }
    sort(ds.begin(), ds.end());
    /*for (int i = 0; i < n - 1; ++i){
        cout << ds[i].first << "; " << ds[i].second << "   ";
    }
    cout << endl;*/
    vector<int> ans2(n);
    vector<int> loss(n);
    int prev = 0;
    for (int j = 0; j < n - 1; ++j){
        ans2[j + 1] = ans2[j] + (n * (n - 1) / 2 - loss[j]) * (ds[j].first - prev);
        loss[j + 1] = loss[j] + ds[j].second + 1;
        prev = ds[j].first;
        //cout << ans2[j + 1] << endl;
        //cout << loss[j + 1] << endl;
    }
    while(q--){
        int t, k;
        cin >> t >> k;
        if (t == 1){
            cout << ds.end() - upper_bound(ds.begin(), ds.end(), pair<int, int>{k, 1e10}) + 1 << endl;
        }
        if (t == 2){
            int x = upper_bound(ds.begin(), ds.end(), pair<int, int>{k, 1e10}) - ds.begin();
            int ans = ans2[x];
            if (x == 0){
                ans += (n * (n - 1) / 2 - loss[x]) * k;
            } else {
                ans += (n * (n - 1) / 2 - loss[x]) * (k - ds[x - 1].first);
            }
            cout << ans << endl;
        }
        if (t == 3){
            int a;
            cin >> a;
            a--;
            int x = new_i[a];
            int ans = v[x];
            int cnt = n - x - 1;
            //cout << cnt << endl;
            int prev = 0;
            for (int j = 0; j < n - 1; ++j){
                if (k <= prev){
                    break;
                }
                ans += cnt * min(k, ds[j].first - prev);
                prev = ds[j].first;
                if (ds[j].second >= x){
                    cnt--;
                }
                //cout << ans << endl;
            }
            cout << ans << endl;
        }
    }
    return 0;
}
