#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>

using namespace std;

void dfs1(vector<vector<int>>& g, vector<int>& cl, int x, int b, int c) {
	cl[x] = c;
	for (int v : g[x]) {
		if (v == b || cl[v] != 0)
			continue;
		dfs1(g, cl, v, b, c);
	}
}
int main()
{
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<vector<int>> g(n), g1(n);
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			g[a].push_back(b);
			g[b].push_back(a);
		}
		for (int b = 0; b < n; b++) {
			vector <int> cl(n);
			int cc = 1;
			for (int v : g[b]) {
				if (cl[v] != 0)
					continue;
				dfs1(g, cl, v, b, cc);
				cc++;
			}
			for (int u : g[b]) {
				for (int v : g[b]) {
					if (u != v && cl[u] == cl[v]) {
						g1[u].push_back(v);
					}
				}
			}
		}

		vector <int> d(n, 1e9);
		d[0] = 0;
		queue <int> q;
		q.push(0);
		while (!q.empty()) {
			int x = q.front();
			q.pop();
			for (int v : g1[x]) {
				if (d[v] == 1e9) {
					d[v] = d[x] + 1;
					q.push(v);
				}
			}
		}
		for (int i = 1; i < n; i++) {
			cout << (d[i] == 1e9 ? -1 : d[i] * 2) << " ";
		}
		cout << endl;
	}
}
