#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;

using i128 = __int128;

bool bit(int mask, int pos) {
    return (mask >> pos) & 1;
}

int main() {+
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    vector<i128> p10(30);
    p10[0] = 1;
    for (int i = 1; i < ssize(p10); ++i) {
        p10[i] = p10[i - 1] * 10;
    }

    string a_str;
    ll y;
    cin >> a_str >> y;


    int n = ssize(a_str);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = a_str[i] - '0';
    }

    vector<vector<int>> where(10);
    for (int i = 0; i < n; ++i) {
        where[a[i]].push_back(i);
    }

    vector<pair<i128, string>> dp(1 << n, {-1, ""});
    dp[0] = {0, ""};

    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> cnt(10);
        for (int i = 0; i < n; ++i) {
            if (bit(mask, i)) {
                ++cnt[a[i]];
            }
        }

        int len = ssize(dp[mask].second);

        for (int i = 0; i < n; ++i) {
            if (!bit(mask, i)) {
                string new_s = dp[mask].second;
                new_s.push_back(a[i] + '0');

                i128 new_cost = dp[mask].first + a[i] * p10[n - 1 - len];

                int pos = where[a[i]][cnt[a[i]]];

                if (pos >= len) {
                    new_cost -= y * (pos - len);
                }

                int nmask = mask | (1 << i);
                dp[nmask] = max(dp[nmask], pair(new_cost, new_s));
            }
        }
    }

    cout << dp[(1 << n) - 1].second;

    return 0;
}
