#include <bits/stdc++.h>

using namespace std;

const long long zero = 0;
const int Inf = 1e9;

vector<vector<int> > colors;
vector<vector<int> > old_g;

void dfs(int v, int color, int stop) {
    if (v == stop || colors[stop][v] != -1) {
        return;
    }
    colors[stop][v] = color;
    for (auto u: old_g[v]) {
        dfs(u, color, stop);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int ui = 0; ui < t; ++ui) {
        int n, m;
        cin >> n;
        cin >> m;
        int mat[n][n];
        colors.clear();
        old_g.clear();
        colors.resize(n, vector<int>(n, -1));
        for (int i = 0; i < n; ++i) {
            fill(mat[i], mat[i] + n, 0);
        }
        old_g.resize(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a;
            cin >> b;
            a--;
            b--;
            mat[a][b] = 1;
            mat[b][a] = 1;
            old_g[a].push_back(b);
            old_g[b].push_back(a);
        }
        for (int stop = 0; stop < n; ++stop) {
            int c = 0;
            for (int i = 0; i < n; ++i) {
                if (i != stop && colors[stop][i] == -1) {
                    dfs(i, c, stop);
                    c++;
                }
            }
        }
        int new_mat[n][n];
        for (int i = 0; i < n; ++i) {
            fill(new_mat[i], new_mat[i] + n, 0);
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (mat[i][j] == 1) {
                    for (int k = 0; k < n; ++k) {
                        if (mat[j][k] == 1 && colors[j][i] == colors[j][k]) {
                            new_mat[i][k] = 1;
                            //cout << i << ' ' << j << ' ' << k << endl;
                        }
                    }
                }
            }
        }
        /*for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                cout << new_mat[i][j] << ' ';
            }
            cout << endl;
        }*/
        vector<vector<int> > g(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (new_mat[i][j] == 1) {
                    g[i].push_back(j);
                }
            }
        }
        int d[n];
        fill(d, d + n, Inf);
        queue<int> Q;
        Q.push(0);
        d[0] = 0;
        while (!Q.empty()) {
            int x = Q.front();
            Q.pop();
            for (auto u: g[x]) {
                if (d[u] == Inf) {
                    d[u] = d[x] + 1;
                    Q.push(u);
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            if (d[i] == Inf) {
                cout << -1 << ' ';
            }
            else {
                cout << d[i] * 2 << ' ';
            }
        }
        cout << endl;
    }
    return 0;
}
