#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <deque>

using namespace std;

#define long long long int

int main() {
    int n, q;
    cin >> n >> q;
    vector<long> c(n);
    for (int i = 0;i < n;i++) cin >> c[i];
    vector<vector<int>> ans(10001, vector<int>(2, 0));
    vector<vector<long>> states(10001, vector<long>(n, 0));
    set<long> s;
    for (int i = 0;i < n;i++) {
        if (s.find(c[i]) == s.end()) s.insert(c[i]);
    }
    long ps = 0;
    for (int k = 0;k < 10001;k++) {
        ans[k][0] = s.size();
        ans[k][1] = ps;
        states[k] = c;
        map<long, long> tr;
        set<long> ns;
        int cn = s.size();
        int j = 1;
        for (auto i : s) {
            ns.insert(i + cn - j);
            tr[i] = i + cn - j;
            j++;
        }
        s = ns;
        for (int i = 0;i < n;i++) {
            ps += (tr[c[i]] - c[i]);
            c[i] = tr[c[i]];
        }
    }
    for (int i = 0;i < q;i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            cout << ans[k][0] << endl;
        }
        else if (t == 2) {
            int k;
            cin >> k;
            cout << ans[k][1] << endl;
        }
        else {
            int k, ind;
            cin >> k >> ind;
            cout << states[k][ind - 1] << endl;
        }
    }
}
