#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

ll n, q;
vector<ll> vec, ans, death;
ll uni = 0;

ll rnd(ll a, ll b) {
	if (a == 0) return 0;
	return (a - 1) / b + 1;
}
void pretypeone() {
	vector<ll> cur = vec;

	sort(cur.begin(), cur.end());
	auto it = unique(cur.begin(), cur.end());
	cur.erase(it, cur.end());
	uni = cur.size();

	for (int i = 0; i < cur.size() - 1; i++) {
		ll speed = cur.size() - i - 1;
		death.push_back(cur[i + 1] - cur[i]);
	}

	sort(death.begin(), death.end());
}

int main() {
	fastInp;
	
	cin >> n >> q;
	vec.resize(n);
	for (auto& c : vec) cin >> c;

	pretypeone();
	


	ans.resize(q);
	for (int i = 0; i < q; i++) {
		ll t;
		cin >> t;

		if (t == 1) {
			ll k;
			cin >> k;

			ans[i] = uni - (upper_bound(death.begin(), death.end(), k) - death.begin());
		}
	}

	for (auto c : ans) cout << c << "\n";
	
	return 0;
}

/*
5 2
0 3 5 4 2
1 0
1 1

6 3
5 4 4 2 2 2
1 0
1 1
1 2
*/