#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 3e5 + 100, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;

ll n, m;
vector<ll> vec;

struct robot {
	ll l, r, c, t;
};

vector<robot> rbs;
vector<ll> add;

void sol() {
	cin >> n >> m;

	vec.resize(n);

	for (auto& c : vec) cin >> c;

	add.clear();

	add.resize(n);
	rbs.clear();
	for (int i = 0; i < m; i++) {
		ll l, r, c, t;
		cin >> l >> r >> c >> t;
		l--; r--;
		rbs.push_back({ l, r, c, t });
		add[l] += c;
	}

	ll sm = 0;
	vector<ll> res(n);

	for (int i = 0; i < n; i++) {
		sm += add[i];
		ll q = min(vec[i], sm);
		sm -= q;
		res[i] += q;
		if (i > 0) res[i] += res[i - 1];
	}
	ll tt = 0;

	sm = 0;
	for (int i = 0; i < n; i++) add[i] = 0;
	for (auto c : rbs) {
		add[c.r] += c.c;
	}

	for (int i = n - 1; i >= 0; i--) {
		sm += add[i];
		ll q = min(vec[i], sm);
		sm -= q;
		res[i] += tt;
		tt += q;
	}

	for (auto c : res) cout << c << " ";
	cout << "\n";
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		sol();
	}

	return 0;
}

/*
1
4 3
3 3 2 2
1 2 2 0
3 3 3 0
2 2 4 1
*/