#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#define int long long
using namespace std;

void solve() {
	int n, q; cin >> n >> q;
	set <int> cc;
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		cc.insert(x);
	}
	vector <int> c;
	for (auto x : cc) {
		c.push_back(x);
	}
	int n = c.size();
	vector <int> p(n);
	for (int i = n - 2; i >= 0; i--) {
		int d = c[i + 1] - c[i];
		p[i] = max(p[i + 1], d);
	}
	reverse(p.begin(), p.end());

}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int tt = 1; cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}
