#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
#define pb emplace_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &c : a) cin >> c;
    vector<pii> seg(m);
    vector<int> b(m), t(m);
    for (int i = 0; i < m; i++) {
        cin >> seg[i].fi >> seg[i].se;
        seg[i].fi--;
        seg[i].se--;
        cin >> b[i] >> t[i];
    }
    vector<int> now(n);
    for (int x = 0; x < n; x++) {
        ll ans = 0;
        vector<int> cur = b;
        vector<pii> start(n), finish(n);
        for (int i = 0; i < m; i++) {
            int l = seg[i].fi, r = seg[i].se;
            if (t[i] == 1) l = min(l, x);
            if (t[i] == 1) r = max(r, x);
            start.pb(l, i);
            finish.pb(r, i);
        }
        sort(all(start));
        sort(all(finish));
        priority_queue<pii, vector<pii>, greater<pii>> s;
        now.assign(n, 0);
        vector<int> ban(m);
        int si = 0, fi = 0;
        for (int i = 0; i < n; i++) {
            while (si < (int)start.size() && start[si].fi == i) {
                int c = start[si].se;
                if (t[c] == 1) s.push(mp(max(x, seg[c].se), c));
                else s.push(mp(seg[c].se, c));
                si++;
            }
            while (s.size() && now[i] < a[i]) {
                int id = s.top().se;
                if (ban[id]) {
                    s.pop();
                    continue;
                }
                int mn = min(a[i] - now[i], cur[id]);
                now[i] += mn;
                cur[id] -= mn;
                if (cur[id] == 0) s.pop();
                ans += mn;
            }
            while (fi < (int)finish.size() && finish[fi].fi == i) {
                int c = finish[fi].se;
                ban[c] = 1;
                fi++;
            }
        }
        cout << ans << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
