#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
#define pb emplace_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

const int INF = 1e9 + 1;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto &c : a) cin >> c;
    vector<ll> pr(n + 1);
    for (int i = 0; i < n; i++) pr[i + 1] = pr[i] + a[i];
    vector<pii> seg(m);
    vector<int> b(m), t(m);
    for (int i = 0; i < m; i++) {
        cin >> seg[i].fi >> seg[i].se;
        seg[i].fi--;
        seg[i].se--;
        cin >> b[i] >> t[i];
    }
    vector<int> now(n);
    for (int x = 0; x < n; x++) {
        ll ans = 0;
        vector<int> cur = b;
        vector<pii> start, finish;
        vector<int> kek;
        vector<ll> now, total;
        for (int i = 0; i < m; i++) {
            int l = seg[i].fi, r = seg[i].se;
            if (t[i] == 1) l = min(l, x);
            if (t[i] == 1) r = max(r, x);
            kek.pb(l);
            kek.pb(r);
        }
        sort(all(kek));
        kek.resize(unique(all(kek)) - kek.begin());
        vector<pii> diff;
        for (int i = 0; i < (int)kek.size(); i++) {
            diff.pb(kek[i], kek[i]);
            if (i + 1 < (int)kek.size() && kek[i] + 1 < kek[i + 1]) diff.pb(kek[i] + 1, kek[i + 1] - 1);
            if (i == (int)kek.size() - 1 && kek[i] != n - 1) diff.pb(kek[i] + 1, n - 1);
        }
        for (auto &c : diff) {
            total.pb(pr[c.se + 1] - pr[c.fi]);
            now.pb(0);
        }
        vector<pii> seg1(m);
        for (int i = 0; i < m; i++) {
            int l = seg[i].fi, r = seg[i].se;
            if (t[i] == 1) l = min(l, x);
            if (t[i] == 1) r = max(r, x);
            int l1 = upper_bound(all(diff), mp(l, INF)) - diff.begin() - 1;
            int r1 = upper_bound(all(diff), mp(r, INF)) - diff.begin() - 1;
            seg1[i] = mp(l1, r1);
            start.pb(l1, i);
            finish.pb(r1, i);
        }
        sort(all(start));
        sort(all(finish));
        priority_queue<pii, vector<pii>, greater<pii>> s;
        vector<int> ban(m);
        int si = 0, fi = 0;
        for (int i = 0; i < (int)now.size(); i++) {
            while (si < (int)start.size() && start[si].fi == i) {
                int c = start[si].se;
                if (t[c] == 1) s.push(mp(max(x, seg[c].se), c));
                else s.push(mp(seg[c].se, c));
                si++;
            }
            while (s.size() && now[i] < total[i]) {
                int id = s.top().se;
                if (ban[id]) {
                    s.pop();
                    continue;
                }
                int mn = min(total[i] - now[i], (ll)cur[id]);
                now[i] += mn;
                cur[id] -= mn;
                if (cur[id] == 0) s.pop();
                ans += mn;
            }
            while (fi < (int)finish.size() && finish[fi].fi == i) {
                int c = finish[fi].se;
                ban[c] = 1;
                fi++;
            }
        }
        cout << ans << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
