#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

const int MAXN = 300000;

int dsu[MAXN];
int cnt[MAXN];
ll value[MAXN];

int get(int x) {
	if (dsu[x] == x)
		return x;
	return dsu[x] = get(dsu[x]);
}
void unite(int a, int b) {

}


struct myOp {
	int a = 0, b = 0;
	ll round = 0;
};
struct query {
	int t;
	ll k;
	int i;
	int id;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n, q;
	cin >> n >> q;
	vector<ll> arr(n);
	input(arr);
	auto cp = arr;
	sort(cp.begin(), cp.end());
	map<ll, int> ids;
	int freeId = 0;
	for (auto& e : cp) {
		if (ids.find(e) != ids.end()) {
			cnt[ids[e]]++;
		}
		else {
			ids[e] = freeId;
			dsu[freeId] = freeId;
			cnt[freeId] = 1;
			value[freeId] = e;
			freeId++;
		}
	}

	vector<myOp> important;
	for (int i = 1; i < n; i++) {
		if (cp[i - 1] != cp[i]) {
			int i1 = ids[cp[i - 1]];
			int i2 = ids[cp[i]];
			ll roundid = cp[i] - cp[i - 1];
			important.push_back({i1, i2, roundid});
		}
	}
	sort(important.begin(), important.end(), [](myOp& a, myOp& b) {
		return a.round < b.round;
	});


	vector<ll> anses(q, -1);
	vector<query> tasks(q);
	for (int i = 0; i < q; i++) {
		auto& now = tasks[i];
		now.id = i;
		cin >> now.t >> now.k;
		if (now.t == 3)
			cin >> now.i;
	}
	sort(tasks.begin(), tasks.end(), [](query& a, query& b) {
		return a.k < b.k;
	});

	int impId = 0;
	int lastk = 0;
	int cntUniq = freeId;
	for (int i = 0; i < q; i++) {
		while (important[impId].round <= tasks[i].k) {
			unite(important[impId].a, important[impId].b);
			cntUniq--;
			impId++;
		}
		if (tasks[i].t == 1) {
			anses[tasks[i].id] = cntUniq;
		}
	}
	for (auto& e : anses)
		cout << e << "\n";
}