#include <bits/stdc++.h>
#define ll long long

using namespace std;

#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>


struct dlin {
    vector <ll> a;
};

dlin oke(string s) {
    ll n = s.size();
    dlin a;
    for (int i = n - 1; i >= 0; --i) a.a.push_back(s[i] - '0');
    while (a.a.size() > 1 && a.a.back() == 0) a.a.pop_back();
    return a;
}

dlin sum(dlin a, dlin b) {
    ll carry = 0;
    dlin c;
    for (int i = 0; i < a.a.size() || i < b.a.size() || carry; ++i) {
        ll fo = carry;
        carry = 0;
        if (i < a.a.size()) fo += a.a[i];
        if (i < b.a.size()) fo += b.a[i];
        c.a.push_back(fo % 10);
        carry = fo / 10;
    }
    while (c.a.size() > 1 && c.a.back() == 0) c.a.pop_back();
    return c;
}

void print(dlin a) {
    for (int i = a.a.size() - 1; i >= 0; --i) cout << a.a[i];
}

dlin um(dlin a, ll v) {
    ll carry = 0;
    dlin c;
    for (int i = 0; i < a.a.size() || carry; ++i) {
        ll fo = carry;
        carry = 0;
        if (i < a.a.size()) fo += a.a[i] * v;
        c.a.push_back(fo % 10);
        carry = fo / 10;
    }
    while (c.a.size() > 1 && c.a.back() == 0) c.a.pop_back();
    return c;
}

int is_bigger(dlin a, dlin b) {
    if (a.a.size() > b.a.size()) return 2;
    if (a.a.size() < b.a.size()) return 0;
    for (int i = a.a.size() - 1; i >= 0; --i) {
        if (a.a[i] > b.a[i]) return 2;
        if (a.a[i] < b.a[i]) return 0;
    }
    return 1;
}


pair <pair <dlin, dlin>, string> solve(string s, int n, dlin y, ll k) {
    string se = "";
    vector <vector <int> > lol(10);
    for (int i = n - 1; i >= 0; --i) {
        lol[s[i] - '0'].push_back(i);
    }
    ordered_set used;
    ll nowe = k;
    for (int i = 0; i < n; ++i) {
        for (int j = 9; j >= 0; --j) {
            if (lol[j].size() == 0) continue;
            int fo = lol[j].back(); // индекc
            int dist = fo - used.order_of_key(fo); // реальное расстояние
            if (dist <= nowe) {
                se += char('0' + j);
                /*Ufor (int l = 0; l <= 9; ++l) {
                    for (int m = 0; m < lol[l].size(); ++m) {
                        if (lol[l][m] > fo) --lol[l][m];
                    }
                }*/
                used.insert(fo);
                lol[j].pop_back();
                nowe -= dist;
                break;
            }
        }
    }
    dlin kek = oke(se);
    dlin tmp = y;
    tmp = um(tmp, k);
    return {{kek, tmp}, se};
    //return {stoi(se) - y * k, se};
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s, ane = "", y1, tmpe = "0";
    int n;
    dlin ans, y, ans2;
    cin >> s >> y1;
    ans = oke(s);
    ans2 = oke(tmpe);
    y = oke(y1);
    n = s.size();
    ll left = 0, right = 1e11;
    while (left + 10 < right) {
        ll fi = (right - left) / 3 + left;
        ll si = right - (right - left) / 3;
        auto fii = solve(s, n, y, fi);
        auto sii = solve(s, n, y, si);
        dlin fiii = sum(fii.first.first, sii.first.second);
        dlin siii = sum(sii.first.first, fii.first.second);
        if (is_bigger(fiii, siii)) right = si;
        else left = fi;
    }
    /*for (int i = left; i <= right; ++i) {
        auto fii = solve(s, n, y, i);
        dlin fiii = sum(ans, fii.first.second);
        if (is_bigger(fii.first.first, fiii) == 2 || (is_bigger(fii.first.first, fiii) == 1 && fii.second > ane)) ane = fii.second;
    }
    cout << ane;*/
    /*for (int i = 0; i < 10; ++i) {
        auto fii = solve(s, n, y, i);
        cout << "-----------" << endl;
        //print(fii.first.first);
        //cout << endl;
        //cout << fii.second << endl;
        print(fii.first.second);
        cout << "-----------" << endl;
    }*/
    /*
    314599
    17713
    */
    for (ll i = left; i <= right; ++i) {
        auto fii = solve(s, n, y, i);
        /*cout << "-----------" << endl;
        print(fii.first.first);
        cout << endl;
        print(fii.first.second);
        cout << endl;*/
        dlin fiii = sum(fii.first.first, ans2);
        dlin siii = sum(ans, fii.first.second);
        if (is_bigger(fiii, siii) == 2 || (is_bigger(fiii, siii) == 1 && fii.second > ane)) {ane = fii.second; ans = fii.first.first; ans2 = fii.first.second;}
        //cout << "-----------" << endl;
    }
    cout << ane;
    return 0;
}
