#include <iostream>
#include <algorithm>

int main() {
    std::string str;
    std::cin >> str;
    int32_t n = str.size();

    int64_t cost;
    std::cin >> cost;

    __int128_t* powers_10 = new __int128_t[21];
    powers_10[0] = 1;
    for(int32_t i = 1; i < 21; i++)
        powers_10[i] = powers_10[i - 1] * 10;

    int32_t* arr = new int32_t[n];
    int64_t src_cost = 0;
    for(int32_t i = 0; i < n; i++) {
        arr[i] = str[i] - '0';
        src_cost += arr[i] * powers_10[n - i - 1];
    }

    int32_t* arr2 = new int32_t[n];
    for(int32_t i = 0; i < n; i++)
        arr2[i] = arr[i];
    int32_t* arr3 = new int32_t[n];
    int64_t best_cost = -1, best_num = -1;
    do {
        int64_t cost_cur = 0;
        for(int32_t i = 0; i < n; i++)
            cost_cur += arr2[i] * powers_10[n - i - 1];
        int64_t num_cur = cost_cur;
        cost_cur -= src_cost;
        /*int a = 0;
        if(num_cur == 931459)
            a++;*/

        for(int32_t i = 0; i < n; i++)
            arr3[i] = arr[i];
        for(int32_t i = 0; i < n; i++)
            for(int32_t j = i; j < n; j++)
                if(arr3[j] == arr2[i]) {
                    cost_cur -= (j - i) * cost;
                    for (int32_t k = j - 1; k >= i; k--)
                        std::swap(arr3[k], arr3[k + 1]);
                    break;
                }

        if(cost_cur > best_cost || (cost_cur == best_cost && num_cur > best_num)) {
            best_num = num_cur;
            best_cost = cost_cur;
        }
    } while(std::next_permutation(arr2, arr2 + n));

    std::string res = std::to_string(best_num);
    while(res.size() < n)
        res = "0" + res;
    std::cout << res;
    return 0;
}
