#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
// #pragma GCC optimize("O3")
// #pragma GCC optimize("fast-math")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("avx2,popcnt,lzcnt,bmi,bmi2")
#endif

#include <algorithm>
#include <cassert>
#include <chrono>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
using ll = long long;

const ll INFLL = 0x3f3f3f3f3f3f3f3fll;

void solve() {
    string a;
    cin >> a;
    int n = (int)a.size();
    ll k;
    cin >> k;
    vector<vector<int>> b(10);
    for (int i = 0; i < n; i++) {
        b[a[i] - '0'].push_back(i);
    }
    vector<pair<int, int>> c;
    int cnt = 0;
    for (int i = 0; i < 10; i++) {
        reverse(b[i].begin(), b[i].end());
        for (int j : b[i]) {
            if (cnt == 18) break;
            c.emplace_back(j, i);
            cnt++;
        }
    }
    sort(c.begin(), c.end());
    vector<int> d;
    for (auto [x, y] : c) {
        d.push_back(y);
    }
    vector<int> ans = d;
    ll ansval = 0;
    int m = min(n, 18);
    vector<ll> p(m);
    p[0] = 1;
    for (int i = 1; i < m; i++) {
        p[i] = p[i - 1] * 10;
    }
    reverse(p.begin(), p.end());
    for (int mask = 1; mask < (1 << m); mask++) {
        ll val = 0;
        vector<int> dd = d;
        for (int i = 0; i < m; i++) {
            if ((mask & (1 << i)) == 0) continue;
            for (int j = i; j > 0; j--) {
                if (dd[j] > dd[j - 1]) {
                    val += dd[j] * p[j - 1] + dd[j - 1] * p[j];
                    val -= dd[j - 1] * p[j - 1] + dd[j] * p[j];
                    val -= k;
                    swap(dd[j], dd[j - 1]);
                }
            }
        }
        if (val > ansval) {
            ans = dd;
            ansval = val;
        } else if (val == ansval && dd > ans) {
            ans = dd;
        }
    }
    cnt = 0;
    for (int i = 9; i >= 0; i--) {
        for (int j : b[i]) {
            if (n - cnt <= 18) break;
            cout << i;
            cnt++;
        }
    }
    for (auto x : ans) {
        cout << x;
    }
    cout << '\n';
    return;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();
}