#include<bits/stdc++.h>

#define int long long

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 5111;
const ll INF = 1e18 + 7;

int n, m;

vector<int> g[MXN];
ll dst[MXN][MXN];

bool is_in(vector<int> & v, int x) {
    for (auto to: v) if (to == x) return true;
    return false;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) g[i].clear();
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
        dst[i][j] = INF;
    }}
    dst[0][0] = 0;
    set<pair<ll, pii>> st;
    for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
        st.insert(make_pair(dst[i][j], make_pair(i, j)));
    }}
    while (!st.empty()) {
        pii from = (*st.begin()).ss;
        st.erase(st.begin());
        if (from.ff == from.ss) {
            for (auto x: g[from.ff]) {
                pii to = make_pair(x, from.ss);
                if (dst[to.ff][to.ss] > dst[from.ff][from.ss] + 1) {
                    st.erase(make_pair(dst[to.ff][to.ss], to));
                    dst[to.ff][to.ss] = dst[from.ff][from.ss] + 1;
                    st.insert(make_pair(dst[to.ff][to.ss], to));
                }
            }
            continue;
        } else {
            for (auto y: g[from.ss]) {
                int ln = 0;
                pii to = make_pair(from.ff, y);
                if (from.ff == y) {
                    ln = 1;
                    to = make_pair(from.ss, from.ss);
                }
                if (dst[to.ff][to.ss] > dst[from.ff][from.ss] + ln) {
                    st.erase(make_pair(dst[to.ff][to.ss], to));
                    dst[to.ff][to.ss] = dst[from.ff][from.ss] + ln;
                    st.insert(make_pair(dst[to.ff][to.ss], to));
                }
            }
        }
    }
    for (int x = 1; x < n; ++x) {
        int lans = dst[x][x];
        if (lans == INF) cout << "-1 ";
        else cout << lans << " ";
    } cout << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

