#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;
using ii = __int128_t;


string solve_short(string s, const ll y) {
    const int n = s.size();
    vector<ii> dp(1 << n, (ii)-1e24);
    vector<int> pr(1 << n, -1);

    vector<ii> pow10(n+1);

    pow10[0] = 1;
    for (int i = 1; i <= n; ++i) pow10[i] = pow10[i-1] * 10;


    dp[0] = 0;
    for (int msk = 1; msk < (1 << n); ++msk) {
        int k = 0;
        for (int i = 0; i < n; ++i) k += (msk >> i) & 1;

        for (int i = 0; i < n; ++i) {
            int sub = msk ^ (1 << i);
            if (sub >= msk) continue;
            
            ii new_cost = dp[sub] + (s[i] - '0') * pow10[k-1];
            for (int j = i+1; j < n; ++j) if ((~msk >> j)&1) new_cost -= y;

            if (new_cost > dp[msk] || pr[msk] == -1) {
                dp[msk] = new_cost;
                pr[msk] = i;
            }

            if (new_cost == dp[msk] && s[i] > s[pr[msk]]) {
                pr[msk] = i;
            }
        }
    }

    string res;

    for (int cur = (1 << n) - 1; cur != 0; ) {
        const int i = pr[cur];
        res.push_back(s[i]);
        cur ^= 1 << i;
    }

    return res;
}

void solve() {
    string s; cin >> s;
    const int n = s.size();
    string u = s;
    sort(u.begin(), u.end(), greater<char>());

    ll y; cin >> y;

    const int m = max<int>(0, n-20);
    u.resize(m);

    for (int i = 0; i < 10; ++i) {
        int k = count(u.begin(), u.end(), '0'+i);
        for (char& c : s) {
            if (k == 0) break;
            if (c == '0'+i) {
                c = '?';
                k--;
            }
        }
    }

    string s0;
    for (char c : s) if (c != '?') s0.push_back(c);
    s0 = solve_short(s0, y);
    cout << u << s0 << endl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
}