#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

struct Robot {
    int l, r, c, t;
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    vector<Robot> robots(m);
    for (auto& [l, r, c, t] : robots) cin >> l >> r >> c >> t, --l, --r;

    vector<ll> res(n);

    for (int x = 0; x < n; ++x) {
        auto rob = robots;
        for (auto& [l, r, c, t] : rob) {
            if (t != 0) {
                l = min(l, x);
                r = max(r, x);
            }
        }

        vector<vi> def(n);
        for (int i = 0; i < m; ++i) {
            def[rob[i].r].push_back(i);
        }
        
        ll cur = 0;
        priority_queue<pi> q;
        for (int i = n; i--; ) {
            for (int j : def[i]) {
                q.emplace(rob[j].l, rob[j].c);
            }

            int x = a[i];
            while (!q.empty() && x != 0) {
                auto [l, c] = q.top(); q.pop();
                if (l > i) continue;
                
                int df = min(c, x);
                c -= df;
                x -= df;
                cur += df;

                if (c != 0) q.emplace(l, c);
            }
        }

        res[x] = cur;
    }

    for (ll t : res) cout << t << ' ';
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}