#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define pii pair<int, int>
#define fi first
#define se second
#define ld double
#define sz(x) (int)x.size()
#define int long long

int get_bit(int x, int i) {
    return (x >> i) & 1ll;
}

const ld inf = 9e18;

ld p10[30];

void prec() {
    p10[0] = 1;
    for (int i = 1; i <= 29; ++i)
        p10[i] = p10[i - 1] * 10;
}

string solveSmall(string &s, int y) {
    int n = sz(s);
    int siz = (1 << n);

    vector<ld> dp(siz, -inf);
    vector<string> rdp(siz);
    dp[0] = 0;

    for (int mask = 0; mask < siz; ++mask) {
        vector<int> cnt(n);
        for (int i = 0; i < n; ++i)
            if (get_bit(mask, i) == 1)
                cnt[i]++;

        string p = rdp[mask];

        for (int i = 0; i < n; ++i) {
            if (get_bit(mask, i) == 0) {
                p.push_back(s[i]);

                ld cur = dp[mask] + (s[i] - '0') * p10[n - __builtin_popcount(mask) - 1];

                for (int j = i + 1; j < n; ++j) {
                    cur -= (ld)cnt[j] * y;
                }

                ld op = dp[mask | (1 << i)];
                if (cur > op || (cur == op && p > rdp[mask | (1 << i)])) {
                    rdp[mask | (1 << i)] = p;
                    dp[mask | (1 << i)] = cur;
                }

                p.pop_back();
            }
        }

    }


    return rdp[siz - 1];
}

const int lPart = 19;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    prec();


    string s;
    int y;
    cin >> s >> y;

    if (sz(s) <= lPart) {
        cout << solveSmall(s, y);
    } else {
        int n = sz(s);

        string f;
        for (int i = 0; i < n - lPart; ++i)
            f.push_back(s[i]);

        string t;
        for(int i = n - lPart; i < n; ++i)
            t.push_back(s[i]);

        sort(all(f));
        reverse(all(f));

        while(true){
            int id = 0;
            for(int i = 0; i < sz(t); ++i){
                if(t[i] > t[id])
                    id = i;
            }

            if(t[id] > f.back()){
                for(int i = id; i > 0; --i){
                    swap(t[i], t[i - 1]);
                }
                swap(t[0], f[sz(f) - 1]);
                sort(all(f));
                reverse(all(f));
            }else{
                break;
            }
        }

        cout << f + solveSmall(t, y);
    }
}