#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <queue>


using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	
	int n, q; cin >> n >> q;
	vector <int> a(n);
	for (auto& x : a) cin >> x;
	vector <int> ds;
	sort(a.begin(), a.end());
	for (int i = 1; i < n; ++i)
		ds.push_back(a[i] - a[i - 1]);
	sort(ds.begin(), ds.end());
	while (q--) {
		int typ; cin >> typ;
		if (typ == 1) {
			int k; cin >> k;
			int id = upper_bound(ds.begin(), ds.end(), k) - ds.begin();
			cout << n - id << '\n';
		}
		else if (typ == 2) {
			int k; cin >> k;
		}
		else if (typ == 3) {
			int k, i; cin >> k >> i;
		}
	}

}