#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cassert>
#include <cstring>
#include <map>

using namespace std;

//#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;

//const long long INFll = 1e18 + 3;
const int INF = 1e8 + 3;
const int N = 5e5 + 228;

vi g[N];
int tin[N], tout[N], tup[N];
bool isOnEdge[N];
bool isPoint[N];
int timer;

void dfs(int v, int p) {
	tin[v] = timer++;
	tup[v] = tin[v];
	isPoint[v] = false;
	for (int u : g[v]) {
		if (u == p) continue;
		if (tin[u] == -1) {
			dfs(u, v);
			tup[v] = min(tup[v], tup[u]);
			if (tup[u] >= tin[v]) {
				isOnEdge[u] = true;
				isPoint[v] = true;
			}
		}
		else {
			tup[v] = min(tup[v], tin[u]);
		}
	}
}

vi comp2[N];

void dfs2(int v, int c) {
	comp2[v].push_back(c);
	if (isPoint[v]) {
		return;
	}
	used[v] = true;
	for (int u : g[v]) {
		if (!used[v]) {
			dfs2(u, c);
		}
	}
}

map<int, int> dp1[N];
int dp2[N];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		tin[i] = -1;
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0, 0);
	int cnow = 0;
	for (int v = 0; v < n; ++v) {
		if (!used[v] && !isPoint[v]) {
			dfs2(v, cnow++);
		}
	}
	/*for (int v = 0; v < n; ++v) {
		sort(all(comp2[v]));
	}*/
	for (int v = 0; v < n; ++v) {
		for (int u : g[v]) {

		}
	}
	dp2[0] = 0;
	vector<pair<int, pair<int, pi>>> st;
	//set<pair<int, pi>> st;
	st.push_back(make_pair(0, make_pair(0, make_pair(2, -1))));
	int pos = 0;
	while (!st.empty()) {
		int k = st[pos].first;
		int v = st[pos].second.first;
		int t = st[pos].second.second.first;
		int cp = st[pos].second.second.second;
		++pos;
		if (t == 1) {
			for (int u : g[v]) {

			}
		}
		else {
			for (int u : g[v]) {

			}
		}
	}
	for (int i = 1; i < n; ++i) {
		
	}
	cout << "\n";
}

int dp2[N];
set<pi> st;
bool used[N];

void dfs2(int v, int r, int k) {
	used[v] = true;
	for (int u : g[v]) {
		if (used[u]) continue;
		if (u == r) {
			if (k < dp2[v]) {
				st.erase(make_pair(dp2[v], v));
				dp2[v] = k;
				st.insert(make_pair(dp2[v], v));
			}
		}
		else {
			dfs2(u, r, k);
		}
	}
}

void solve2() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		dp2[i] = INF;
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dp2[0] = 0;
	st.insert(make_pair(0, 0));
	while (!st.empty()) {
		int k = st.begin()->first;
		int v = st.begin()->second;
		st.erase(st.begin());
		for (int u : g[v]) {
			memset(used, 0, sizeof used);
			dfs2(v, u, k + 2);
		}
	}
	for (int i = 1; i < n; ++i) {
		if (dp2[i] < INF) {
			cout << dp2[i] << " ";
		}
		else {
			cout << "-1 ";
		}
	}
	cout << "\n";
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve2();
	}
}

/*
1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
*/