#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;

const ll C = 20;

int main() {
	string s;
	cin >> s;
	ll y;
	cin >> y;
	string s2 = s;
	sort(s2.begin(), s2.end(), greater<char>());
	ll cpos[10];
	v<bool> used(s.size());
	fill(cpos, cpos + 10, 0ll);
	for (ll i = 0; i < (ll)s2.size() - C; ++i) {
		while (s[cpos[s2[i] - '0']] != s2[i]) {
			++cpos[s2[i] - '0'];
		}
		used[cpos[s2[i] - '0']] = true;
		++cpos[s2[i] - '0'];
	}
	string begin_s = s2.size() > C ? s2.substr(0, s2.size() - C) : "";
	string end_s;
	for (ll i = 0; i < s.size(); ++i) {
		if (!used[i]) {
			end_s.push_back(s[i]);
		}
	}
	v<ll> dpv(1ll << end_s.size());
	v<ll> ans(1ll << end_s.size());
	v<ll> pows(end_s.size());
	pows[0] = 1;
	for (ll i = 1; i < end_s.size(); ++i) {
		pows[i] = pows[i - 1] * 10;
	}
	for (ll mask = 1; mask < (1ll << end_s.size()); ++mask) {
		ll cnt = 0;
		for (ll i = 0; i < end_s.size(); ++i) {
			if (mask & (1ll << i)) {
				++cnt;
			}
		}
		ll cmares = -1e18;
		ll cmaans = -1;
		ll cc = 0;
		for (ll i = 0; i < end_s.size(); ++i) {
			if (mask & (1ll << i)) {
				ll cres = pows[cnt - 1] * end_s[i] - cc * y + dpv[mask ^ (1ll << i)];
				if (cres > cmares || ((cres == cmares) && (cmaans == -1 || end_s[i] > end_s[cmaans]))) {
					cmares = cres;
					cmaans = i;
				}
				++cc;
			}
		}
		dpv[mask] = cmares;
		ans[mask] = cmaans;
	}
	string e_res = "";
	ll cmask = (1ll << end_s.size()) - 1;
	while (cmask != 0) {
		ll ci = ans[cmask];
		e_res.push_back(end_s[ci]);
		cmask ^= (1ll << ci);
	}
	string res = begin_s + e_res;
	cout << res;
}