#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;

template <typename T>
istream& operator>> (istream& in, v<T>& a) {
	for (T& x : a) {
		in >> x;
	}
	return in;
}

int main() {
	ll n, q;
	cin >> n >> q;
	v<ll> c(n);
	cin >> c;
	v<pair<ll, ll>> cc(c.size());
	for (ll i = 0; i < c.size(); ++i) {
		cc[i] = { c[i], i };
	}
	sort(cc.begin(), cc.end(), greater<pair<ll, ll>>());
	v<pair<ll, v<pair<ll, ll>>>> r(1, { 0ll, cc });
	v<ll> a;
	for (ll i = 0; i < cc.size() - 1; ++i) {
		if (cc[i].first != cc[i + 1].first) {
			a.push_back(cc[i].first - cc[i + 1].first);
		}
	}
	sort(a.begin(), a.end());
	a.resize(unique(a.begin(), a.end()) - a.begin());
	v<ll> aa(a.size());
	if (a.size() > 0) {
		aa[0] = a[0];
		for (ll i = 0; i < (ll)a.size() - 1; ++i) {
			aa[i + 1] = a[i + 1] - a[i];
		}
	}
	v<ll> d;
	for(ll midiff : aa) {
		ll p = 0;
		for (ll i = 0; i < n; ) {
			ll j = i;
			while (j < n && cc[i].first == cc[j].first) {
				++j;
			}
			for (ll k = i; k < j; ++k) {
				cc[k].first += p * midiff;
			}
			i = j;
			++p;
		}
		d.push_back(p);
		r.push_back({ r.back().first + midiff, cc });
	}
	d.push_back(1);
	for (ll req = 0; req < q; ++req) {
		ll t;
		cin >> t;
		ll k;
		cin >> k;
		ll ci = 0;
		while (ci < r.size() && r[ci].first <= k) {
			++ci;
		}
		--ci;
		if (t == 1) {
			cout << d[ci] << '\n';
		}
		else if (t == 2) {
			ll p = 0;
			ll cres = 0;
			for (ll i = 0; i < n; ) {
				ll j = i;
				while (j < n && r[ci].second[i].first == r[ci].second[j].first) {
					++j;
				}
				for (ll ck = i; ck < j; ++ck) {
					cres += r[ci].second[ck].first + p * (k - r[ci].first);
				}
				i = j;
				++p;
			}
			for (ll x : c) {
				cres -= x;
			}
			cout << cres << '\n';
		}
		else {
			ll ii;
			cin >> ii;
			--ii;

			ll p = 0;
			ll cres = 0;
			for (ll i = 0; i < n; ) {
				ll j = i;
				while (j < n && r[ci].second[i].first == r[ci].second[j].first) {
					++j;
				}
				for (ll ck = i; ck < j; ++ck) {
					if (r[ci].second[ck].second == ii) {
						cres = r[ci].second[ck].first + p * (k - r[ci].first);
					}
				}
				i = j;
				++p;
			}
			cout << cres << '\n';
		}
	}
}