#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
vector <vector <int>> tree;
vector <int> a;
int n;
void build(int l = 0, int r = n, int v = 0) {
	if (l == r - 1) {
		tree[v].push_back(a[l]);
		return;
	}
	build(l, (l + r) / 2, v * 2 + 1);
	build((l + r) / 2, r, v * 2 + 2);
	for (auto i : tree[v * 2 + 1]) tree[v].push_back(i);
	for (auto i : tree[v * 2 + 2]) tree[v].push_back(i);
	sort(tree[v].begin(), tree[v].end());
}
int getk(int ql, int qr, int x, int l = 0, int r = n, int v = 0) {
	if (r <= ql || qr <= l) return 0;
	if (l >= ql && r <= qr) return (lower_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin());
	return getk(ql, qr, x, l, (l + r) / 2, v * 2 + 1) + getk(ql, qr, x, (l + r) / 2, r, v * 2 + 2);
}
int main() {
	cin >> n;
	a.resize(n);
	tree.resize(4 * n);
	vector <vector <int>> dpp(n, vector <int>(n + 1, 0)), dps(n, vector <int>(n + 1, 0));
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int j = 1; j <= n; j++) {
		if (a[0] < j) dpp[0][j] = 1;
		if (a[n - 1] < j) dps[n - 1][j] = 1;
	}
	for (int i = 1; i < n; i++) {
		for (int j = 1; j <= n; j++) {
			dpp[i][j] = dpp[i - 1][j];
			if (a[i] < j) dpp[i][j]++;
		}
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int j = 1; j <= n; j++) {
			dps[i][j] = dps[i + 1][j];
			if (a[i] < j) dps[i][j]++;
		}
	}
	//build();
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ll len1 = j - dpp[i][a[i]], len2 = (j + dps[j][a[j]]) - i, len3 = abs(a[j] - a[i]);
			ans += max({ len1, len2, len3 });
		}
	}
	cout << ans;
	return 0;
}