#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
vector <int> a;
int n;
int main() {
	cin >> n;
	a.resize(n);
	vector <vector <ll>> dpp(n, vector <ll>(n + 1, 0)), dps(n, vector <ll>(n + 1, 0));
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int j = 1; j <= n; j++) {
		if (a[0] < j) dpp[0][j] = 1;
		if (a[n - 1] < j) dps[n - 1][j] = 1;
	}
	for (int i = 1; i < n; i++) {
		for (int j = 1; j <= n; j++) {
			dpp[i][j] = dpp[i - 1][j];
			if (a[i] < j) dpp[i][j]++;
		}
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int j = 1; j <= n; j++) {
			dps[i][j] = dps[i + 1][j];
			if (a[i] < j) dps[i][j]++;
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ll len1 = j - dpp[i][a[i]], len2 = (j + dps[j][a[j]]) - i, len3 = abs(a[j] - a[i]);
			ans += max({ len1, len2, len3 });
		}
	}
	cout << ans;
	return 0;
}