#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define all(x) x.begin(), x.end()
#define int long long
#define endl '\n'

#pragma GCC optimize("03")

signed main() {
	int n; cin >> n;
	vec<int> a(n);
	bool f = 1;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] - 1 != i) f = 0;
	}
	int q; cin >> q;
	if (n <= 3000 && q <= 3000) {
		vec<vec<int>> s(n + 1, vec<int>(n + 1));
		for (int i = 0; i <= n; ++i)
			s[0][i] = i;
		vec<bool> pr(n + 1, 1);
		for (int i = 1; i <= n; ++i) {
			pr[a[i - 1]] = 0;
			for (int j = 1; j <= n; ++j) {
				s[i][j] = s[i][j - 1] + pr[j];
			}
		}
		for (int i = 0; i < q; ++i) {
			int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
			int a = 0, b = 0;
			for (int i = 0; i <= n; ++i)
				if (s[i][r1] == c1)
					a = i;
			for (int i = 0; i <= n; ++i)
				if (s[i][r2] == c2)
					b = i;
			int l = 0, r = min(r1, r2) + 1;
			while (l + 1 != r) {
				int j = (l + r) / 2;
				if (s[a][j] != s[b][j]) r = j;
				else l = j;
			}
			cout << l << " " << s[a][l] << endl;
		}
	}
	else if (f) {
		for (int i = 0; i < q; ++i) {
			int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
			int j =  n - c1 - (n - r1), q = n - c2 - (n - r2);
			if (c1 == 0) j = n;
			if (c2 == 0) q = n;
			//cout << j << " " << q << endl;
			if (j == q) cout << r1 << " " << c1 << endl;
			else cout << min(r2, min(r1, min(j, q))) << " " << 0 << endl;
		}
	}
	else {
		for (int i = 0; i <= 1e18; ++i) {}
	}
}