#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
//#pragma GCC optimize("Ofast,unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;


const ll M = 1000, INF = 1e18, N = 500;
vector<ll> g[N];
vector<ll> z[N][M + 1];
ll d[N][M + 1];
ll cd[N + 1][M + 1];
ll cp[N + 1][M + 1];


void dfs(vector<ll> &o, ll v = 0) {
    for (ll u: g[v]) dfs(o, u);
    o.push_back(v);
}


void dfs_restore(vector<ll> &ans, ll v, ll j) {
    ll rem = j;
    for (ll i = 0; i < g[v].size(); i++) {
        ll u = g[v][i];
        rem -= z[v][j][i];
        dfs_restore(ans, u, z[v][j][i]);
    }
    ans[v] = rem;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        for (ll u = 1, v; u < n; u++) cin >> v, v--, g[v].push_back(u);
        vector<ll> f(n);
        for (ll &x: f) cin >> x;
        vector<pair<ll, ll>> s(n);
        for (auto&[l, r]: s) cin >> l >> r;
        vector<ll> o;
        dfs(o);
        for (ll v: o) {
            for (ll i = 0; i <= g[v].size(); i++) for (ll j = 0; j <= M; j++) cd[i][j] = INF, cp[i][j] = -1;
            for (ll j = 0; j <= M; j++) cd[0][j] = j * f[v];
            for (ll i = 0; i < g[v].size(); i++) {
                ll u = g[v][i];
                for (ll j = 0; j <= M; j++) {
                    for (ll k = s[u].first; k <= s[u].second; k++) {
                        if (k > j) continue;
                        ll ns = cd[i][j - k] + d[u][k];
                        if (ns < cd[i + 1][j]) {
                            cd[i + 1][j] = ns;
                            cp[i + 1][j] = k;
                        }
                    }
                }
            }
            for (ll j0 = 0; j0 <= M; j0++) {
                ll j = j0;
                d[v][j] = cd[g[v].size()][j];
                ll i = g[v].size();
                while (i != 0) {
                    ll k = cp[i][j];
                    if (k == -1) break;
                    z[v][j0].push_back(k);
                    i--;
                    j -= k;
                }
                reverse(z[v][j0].begin(), z[v][j0].end());
            }
        }
        ll ans_s = INF, ans_j = -1;
        for (ll j = s[0].first; j <= s[0].second; j++) if (d[0][j] < ans_s) ans_s = d[0][j], ans_j = j;
        if (ans_s >= INF) cout << "-1\n";
        else {
            cout << ans_s << '\n';
            vector<ll> ans(n);
            dfs_restore(ans, 0, ans_j);
            for (ll k: ans) cout << k << ' ';
            cout << '\n';
        }
        for (ll v = 0; v < n; v++) {
            g[v].clear();
            for (ll j = 0; j <= M; j++) z[v][j].clear();
        }
    }
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

 */