#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else

#endif

#include <bits/stdc++.h>

using namespace std;
using ll = int;

ll get_id(ll i, ll j) {
    return i * (i + 1) / 2 + j;
}

ll T = 0;

void dfs(const vector<set<ll>> &g, vector<ll> &ti, vector<ll> &to, vector<ll> &h, ll v, ll w = -1) {
    ti[v] = T++;
    if (w != -1) h[v] = h[w] + 1;
    for (ll u: g[v]) dfs(g, ti, to, h, u, v);
    to[v] = T++;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll n;
    cin >> n;
    ll m = (n + 1) * (n + 2) / 2;
    vector<ll> p(m, -1), h(m, 0), ti(m, 0), to(m, 0);
    vector<set<ll>> g(m);
    vector<ll> f(n);
    vector<pair<ll, ll>> s;
    s.reserve((n + 1) * (n + 2) / 2);
    for (ll i = 0; i <= n; i++) for (ll j = 0; j <= i; j++) s.emplace_back(i, j);
    for (ll i = 0;; i++) {
        ll vi = 0, vj = 0;
        ll v = 0;
        for (ll j = 0; j < n; j++) {
            ll vi1 = vi + 1, vj1 = f[j] ? vj : (vj + 1);
            ll v1 = get_id(vi1, vj1);
            p[get_id(vi1, vj1)] = get_id(vi, vj);
            g[v].insert(v1);
            vi = vi1, vj = vj1;
            v = v1;
        }
        if (i == n) break;
        ll j;
        cin >> j;
        j--;
        f[j] = 1;
    }
    dfs(g, ti, to, h, 0);
    ll q;
    cin >> q;
    while (q--) {
        ll vi, vj, ui, uj;
        cin >> vi >> vj >> ui >> uj;
        ll v = get_id(vi, vj), u = get_id(ui, uj);
        if (h[v] > h[u]) swap(v, u);
        while (!(ti[v] <= ti[u] && to[u] <= to[v])) {
            v = p[v], u = p[u];
        }
        cout << s[v].first << ' ' << s[v].second << '\n';
    }
}
