#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else

#endif

#include <bits/stdc++.h>

using namespace std;
using ll = int;

ll get_id(ll i, ll j) {
    return i * (i + 1) / 2 + j;
}

pair<ll, ll> get_ij(ll id) {
    for (ll i = 0;; i++) {
        if (i * (i + 1) / 2 <= id && id < (i + 1) * (i + 2) / 2) {
            return {i, id - i * (i + 1) / 2};
        }
    }
}

const ll N = 3000, M = (N + 1) * (N + 2) / 2;
ll p[M], h[M], ti[M], to[M];
set<ll> g[M];
ll T = 0;

void dfs(ll v, ll w = -1) {
    ti[v] = T++;
    if (w != -1) h[v] = h[w] + 1;
    for (ll u: g[v]) dfs(u, v);
    to[v] = T++;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll n;
    cin >> n;
    vector<ll> f(n);
    for (ll i = 0;; i++) {
        ll vi = 0, vj = 0;
        ll v = 0;
        for (ll j = 0; j < n; j++) {
            ll vi1 = vi + 1, vj1 = f[j] ? vj : (vj + 1);
            ll v1 = get_id(vi1, vj1);
            p[get_id(vi1, vj1)] = get_id(vi, vj);
            g[v].insert(v1);
            vi = vi1, vj = vj1;
            v = v1;
        }
        if (i == n) break;
        ll j;
        cin >> j;
        j--;
        f[j] = 1;
    }
    dfs(0);
    ll q;
    cin >> q;
    while (q--) {
        ll vi, vj, ui, uj;
        cin >> vi >> vj >> ui >> uj;
        ll v = get_id(vi, vj), u = get_id(ui, uj);
        if (h[v] > h[u]) swap(v, u);
        while (!(ti[v] <= ti[u] && to[u] <= to[v])) {
            v = p[v], u = p[u];
        }
        auto[i, j] = get_ij(v);
        cout << i << ' ' << j << '\n';
    }
}
