#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(i, x) for(auto& i: x)

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

int n;
int hs(int lev, int i){
    return lev * (n + 1) + i;
}
pair<int, int> obr(int h){
    return {h / (n+1), h % (n+1)};
}
const int maxn = 1000000;
int p[maxn];

pair<int, int> lca(pair<int, int> a, pair<int, int> b){
    if(a.first < b.first) swap(a, b);

        while(a.first != b.first){
            a = obr(p[hs(a.first, a.second)]);
        }
        while(a!=b){
            a = obr(p[hs(a.first, a.second)]);
            b = obr(p[hs(b.first, b.second)]);
        }
        return a;
}

void solve(){
    cin >> n;
    vector<char> x(n, 1);
    for(int cur = 0, lev = 0;lev < n; cur += x[lev], lev++){
        p[hs(lev + 1, cur + x[lev])] =  hs(lev, cur);
    }
    for(int i = 0; i < n; i++){
        int kok;
        cin >> kok;
        kok--;
        x[kok] ^= 1;
        for(int cur = 0, lev = 0;lev < n; cur += x[lev], lev++){
            p[hs(lev + 1, cur + x[lev])] =  hs(lev, cur);
        }
    }
    int q;
    cin >> q;
    while(q--){
        pair<int, int> u, v;
        cin >> u.first >> u.second >> v.first >> v.second;
        auto lc = lca(u, v);
        cout << lc.first << ' ' << lc.second << '\n';
    }
}

signed main(){
    cin.tie(nullptr)->ios::sync_with_stdio(false);
    solve();
    return 0;
}