#include <bits/stdc++.h>
using namespace std;

struct node {
    bool l_unblocked = false, r_unblocked = false;
    int l, r;
    node() {}
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<node>> tree(n + 1, vector<node>(n + 1));
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            tree[i][j].l = j;
            tree[i][j].r = j + 1;
        }
    }
    vector<int> commands(n, 1);
    vector<vector<pair<int, int>>> p(n + 1, vector<pair<int, int>>(n + 1, {-1, -1}));
    int x = 0, y = 0;
    for (int i = 0; i < n; i++) {
        if (commands[i] == 0) {
            tree[x][y].l_unblocked = true;
            p[x + 1][y] = {x, y};
        } else {
            tree[x][y].r_unblocked = true;
            p[x + 1][y + 1] = {x, y};
            y++;
        }
        x++;
    }
    for (int c = 0; c < n; c++) {
        commands[a[c] - 1]--;
        int x = 0, y = 0;
        for (int i = 0; i < n; i++) {
            if (commands[i] == 0) {
                tree[x][y].l_unblocked = true;
                p[x + 1][y] = {x, y};
            }
            else {
                tree[x][y].r_unblocked = true;
                p[x + 1][y + 1] = {x, y};
                y++;
            }
            x++;
        }
    }
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= n; j++) cout << p[i][j].first << " " << p[i][j].second << "\t";
//        cout << "\n";
//    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int a1, b1, a2, b2;
        cin >> a1 >> b1 >> a2 >> b2;
        if (a1 > a2) {
            swap(a1, a2);
            swap(b1, b2);
        }
        while (a2 > a1) {
            auto prv = p[a2][b2];
            a2 = prv.first;
            b2 = prv.second;
        }
        while (b1 != b2) {
            auto p1 = p[a1][b1];
            auto p2 = p[a2][b2];
            a1 = p1.first;
            b1 = p1.second;
            a2 = p2.first;
            b2 = p2.second;
        }
        cout << a1 << " " << b1 << "\n";
    }

}