#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>

using namespace std;

#pragma (3)


#define int long long

const int MN = 1e5 + 1;

int c[MN];
vector <int> ogr[MN];
int ans = 0;
int vy[MN];
int st[MN];
vector <int> gr[MN];
vector <vector <int>> dop[MN];
int ch = 0;



vector <vector<int>> merge(vector <vector<int>> &a, vector <vector<int>> &b) {
    vector <vector<int>> ret;
    int ida = 0;
    int idb = 0;
    while (ida < a.size() or idb < b.size()) {
        if (ida == a.size()) {
            ret.push_back(b[idb]);
            idb++;
        }
        else if (idb == b.size()) {
            ret.push_back(a[ida]);
            ida++;
        }
        else if (a[ida][0] < b[idb][0]) {
            ret.push_back(a[ida]);
            ida++;
        }
        else {
            ret.push_back(b[idb]);
            idb++;
        }
    }
    return ret;
}


void dfs (int v) {
    if (ch) {
        return;
    }
    int mxz = -1;
    int id = -1;
    for (auto nw : gr[v]) {
        dfs(nw);
        st[v] += st[nw];
        if ((int)dop[nw].size() > mxz) {
            mxz = (int)dop[nw].size();
            id = nw;
        };
    }
    if (mxz != -1) {
        swap(dop[v], dop[id]);
    }
    for (auto nw : gr[v]) {
        if (nw != id) {
            dop[v] = merge(dop[v], dop[nw]);
        }
    }
    if (st[v] > ogr[v][1]) {
        ch = 1;
        return;
    }
    dop[v].push_back({c[v], ogr[v][1] - st[v], v});
    sort(dop[v].begin(), dop[v].end());
    if (st[v] < ogr[v][0]) {
        int idd = 0;
        while (idd != dop[v].size() and st[v] < ogr[v][0]) {
            int z = dop[v][idd][2];
            if (st[v] + dop[v][idd][1] <= ogr[v][0]) {
                st[v] += dop[v][idd][1];
                ans += dop[v][idd][1] * c[z];
                vy[z] += dop[v][idd][1];
                dop[v][idd][1] = 0;
            }
            else {
                int dp = ogr[v][0] - st[v];
                st[v] = ogr[v][0];
                ans += dp * c[z];
                vy[z] += dp;
                dop[v][idd][1] -= dp;
            }
            idd++;
        }
    }
    int fr = ogr[v][1] - st[v];
    int idd = 0;
    vector <vector<int>> nd;
    while (idd != dop[v].size() and fr != 0) {
        int nw = min(dop[v][idd][1], fr);
        fr -= nw;
        nd.push_back({dop[v][idd][0], nw, dop[v][idd][2]});
        idd++;
    }
    dop[v] = nd;
}

signed main() {
     ios_base::sync_with_stdio(false);
     cin.tie(NULL);
     cout.tie(NULL);
     int t;
     cin >> t;
     while(t--) {
         int n;
         cin >> n;
         for (int i =0; i < n; i++) {
             gr[i].clear();
             st[i] = 0;
             ogr[i] = {};
             vy[i] = 0;
             dop[i].clear();
         }
         for (int i = 1; i < n; i++) {
             int p;
             cin >> p;
             p--;
             gr[p].push_back(i);
         }
         for (int i = 0; i < n; i++) {
             cin >> c[i];
         }
         for (int i = 0; i < n; i++) {
             int l, r;
             cin >> l >> r;
             ogr[i] = {l, r};
         }
         ans = 0;
         ch = 0;
         dfs(0);
         if (ch) {
             cout << -1 << "\n";
         }
         else {
             cout << ans << "\n";
             for (int i = 0;i < n; i++) {
                 cout << vy[i] << " ";
             }
             cout << "\n";
         }
     }
}
