#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

bool flag = false;
vector<int> c, l, r, maxr, minl, dp;
vector<vector<int>> g;
vector<set<pair<int, int>>> W;
vector<int> ans;

void dfs_check_l(int u) {
    for (int v : g[u]) {
        dfs_check_l(v);
        minl[u] += minl[v];
    }
    minl[u] = max(minl[u], l[u]);
    if (minl[u] > r[u]) flag = true;
}

void dfs_max_r(int u) {
    int s = 0;
    for (int v : g[u]) {
        s += minl[v];
    }
    for (int v : g[u]) {
        maxr[v] = min(maxr[u] - s + minl[v], r[v]);
        dfs_max_r(v);
    }
}

void dfs(int u) {
    int sminl = 0;
    W[u].insert({c[u], u});
    for (int v : g[u]) {
        dfs(v);
        for (auto el : W[v]) W[u].insert(el);
        sminl += minl[v];
        dp[u] += dp[v];
    }
    if (sminl >= minl[u]) return;
    int now = minl[u] - sminl;
    while (now > 0) {
        auto [cost, ind] = *W[u].begin();
        int mx = maxr[ind] - ans[ind];
        if (now <= mx) {
            ans[ind] += now;
            dp[u] += cost * now;
            now = 0;
        }
        else {
            ans[ind] += mx;
            dp[u] += cost * mx;
            now -= mx;
        }
        if (ans[ind] == maxr[ind]) W[u].erase(W[u].begin());
    }
}

void solve() {
    int n;
    cin >> n;
    g.assign(n, {}), c.assign(n, 0);
    maxr.assign(n, 0), minl.assign(n, 0);
    W.assign(n, {});
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        g[x - 1].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    l.assign(n, 0), r.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs_check_l(0);
    if (flag) {
        cout << -1 << endl;
        return;
    }
    maxr[0] = r[0];
    dfs_max_r(0);
    for (int i = 0; i < n; ++i) {
        if (maxr[i] < l[i]) {
            cout << -1 << endl;
            return;
        }
    }
    dp.assign(n, 0), ans.assign(n, 0);
    dfs(0);
    cout << dp[0] << endl;
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
