#include <bits/stdc++.h>
#define int long long

using namespace std;

bool flag = false;
vector<int> c, l, r, maxr, minl, dp, ans;
vector<int> p;
vector<vector<int>> g;
vector<deque<pair<int, int>>> st;

void dfs_check_l(int u) {
    for (int v : g[u]) {
        dfs_check_l(v);
        minl[u] += minl[v];
    }
    minl[u] = max(minl[u], l[u]);
    if (minl[u] > r[u]) flag = true;
}

void dfs_max_r(int u) {
    int s = 0;
    for (int v : g[u]) {
        s += minl[v];
    }
    for (int v : g[u]) {
        maxr[v] = min(maxr[u] - s + minl[v], r[v]);
        dfs_max_r(v);
    }
}

void minuss(int u, int now) {
    while (u != 0) {
        maxr[u] -= now;
        u = p[u];
    }
    maxr[u] -= now;
}

void dfs(int u) {
    int sminl = 0;
    for (int v: g[u]) {
        dfs(v);
        for (auto i : st[v]) {
            st[u].push_back(i);
        }
        sminl += minl[v];
        dp[u] += dp[v];
    }
    sort(st[u].rbegin(), st[u].rend());
    while (!st[u].empty() && st[u].front().first >= c[u]) {
        st[u].pop_front();
    }
    st[u].push_front({c[u], u});
//    cout << u << " : " << endl;
//    for (auto el : st[u]) {
//        cout << el.first << " " << el.second << endl;
//    }

    if (sminl >= minl[u]) return;
    int now = minl[u] - sminl;
    while (now > 0) {
        auto [cost, ind] = st[u].back();
        int mx = maxr[ind];
        if (now <= mx) {
            minuss(ind, now);
            ans[ind] += now;
            dp[u] += cost * now;
            now = 0;
        }
        else {
            minuss(ind, mx);
            ans[ind] += mx;
            dp[u] += cost * mx;
            now -= mx;
        }
        if (maxr[ind] == 0) st[u].pop_back();
    }
}

void solve() {
    int n;
    cin >> n;
    g.assign(n, {}), c.assign(n, 0);
    maxr.assign(n, 0), minl.assign(n, 0);
    l.assign(n, 0), r.assign(n, 0);
    p.assign(n, 0);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        p[i] = x - 1;
        g[x - 1].push_back(i);
    }
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];
    dfs_check_l(0);
//    if (flag) {
//        cout << -1 << endl;
//        return;
//    }
    maxr[0] = r[0];
    dfs_max_r(0);
    for (int i = 0; i < n; ++i) {
        if (maxr[i] < l[i]) {
            cout << -1 << endl;
            return;
        }
    }
    dp.assign(n, 0), ans.assign(n, 0);
    st.assign(n, {});
    dfs(0);
    cout << dp[0] << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
