#include <bits/stdc++.h>

using namespace std;

const int maxn = 3e3 + 5;

pair<int, int> pr[maxn][maxn];

void add(vector<int> s) {
    pair<int, int> nw = {0, 0};
    for (auto ch : s) {
        pr[nw.first + 1][nw.second + ch] = nw;
        nw.first++;
        nw.second += ch;
    }
}

pair<int, int> lca(pair<int, int> a, pair<int, int> b) {
    while (a.first > b.first) {
        a = pr[a.first][a.second];
    }
    while (b.first > a.first) {
        b = pr[b.first][b.second];
    }
    while (a != b) {
        a = pr[a.first][a.second];
        b = pr[b.first][b.second];
    }
    return a;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    vector<int> s(n, 1);
    add(s);
    for (int i = 0; i < n; ++i) {
        s[a[i]] = 0;
        add(s);
    }
    int q;
    cin >> q;
    while (q--) {
        pair<int, int> a, b;
        cin >> a.first >> a.second >> b.first >> b.second;
        auto c = lca(a, b);
        cout << c.first << ' ' << c.second << '\n';
    }
    return 0;
}
