#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) v.begin(), v.end()
//#define int long long

struct segTree {
    vector<int> sum;
    int size;
    segTree(int n) {
        while (size < n) size <<= 1;
        sum.resize(size << 1);
    }
    void add(int i) {
        i += size;
        while (i > 0) {
            ++sum[i];
            i >>= 1;
        }
    }
    int getSum(int l, int r) {
        int ret = 0;
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l & 1) ret += sum[l++];
            if (r & 1) ret += sum[--r];
        }
        return ret;
    }
};

bool solve() {
    int n;
    cin >> n;
    vector<int> p(n, 0), c(n);
    vector<pair<int, int>> lr(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].first >> lr[i].second;
    }
    vector<int> complects(n), allComplects(n), rubles(n);
    vector<vector<pair<int, int>>> canBeUsed(n);
    for (int i = n - 1; i >= 0; --i) {
        canBeUsed[i].emplace_back(c[i], i);
        sort(all(canBeUsed[i]));
        if (allComplects[i] > lr[i].second) return false;
        int maxJ = canBeUsed[i].size();
        for (int j = 0; allComplects[i] < lr[i].first; ++j) {
            if (j >= maxJ) return false;
            if (lr[i].first - allComplects[i] <= lr[canBeUsed[i][j].second].second - allComplects[canBeUsed[i][j].second]) {
                complects[canBeUsed[i][j].second] += lr[i].first - allComplects[i];
                allComplects[i] = lr[i].first;
            } else {
                allComplects[i] += lr[canBeUsed[i][j].second].second - complects[canBeUsed[i][j].second];
                complects[canBeUsed[i][j].second] += lr[canBeUsed[i][j].second].second - allComplects[canBeUsed[i][j].second];
            }
        }
        for (auto th: canBeUsed[i]) {
            canBeUsed[p[i]].emplace_back(th);
        }
        allComplects[p[i]] += allComplects[i];
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += complects[i] * c[i];
    }
    cout << "\n" << ans << "\n";
    for (int i = 0; i < n; ++i) {
        cout << complects[i] << " ";
    }
    return true;
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        if (!solve()) cout << "\n-1";
    }
    return 0;
}
/*
2
3
1 1
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2

 */