#include <bits/stdc++.h>

using namespace std;

struct node{
    int t_l, t_r;
    int sum;
    node(){
        t_l = -1, t_r = -1;
        sum = 0;
    }
};

vector<node> tree;
vector<int> roots;

int update_tree(int v, int t_l, int t_r, int pos){
    if(t_l > pos || t_r <= pos)
        return v;
    tree.push_back(node());
    int new_v = tree.size() - 1;
    tree[new_v].sum= tree[v].sum + 1;
    if(t_l + 1 == t_r)
        return new_v;
    if(tree[v].t_l == -1){
        tree.push_back(node());
        tree[v].t_l = tree.size() - 1;
        tree.push_back(node());
        tree[v].t_r = tree.size() - 1;
    }
    int mid = (t_l + t_r) / 2;
    int a = update_tree(tree[v].t_l, t_l, mid, pos);
    int b = update_tree(tree[v].t_r, mid, t_r, pos);
    tree[new_v].t_l = a, tree[new_v].t_r = b;
    return new_v;
}

int get_sum_tree(int v, int t_l, int t_r, int l, int r){
    //cout << v << ' ' << t_l << ' ' << t_r << ' ' << l << ' ' << r << ' ' << tree[v].sum << '\n';
    if(l >= t_r || r <= t_l)
        return 0;
    if(t_l >= l && t_r <= r || tree[v].t_l == -1)
        return tree[v].sum;
    int mid = (t_l + t_r) / 2;
    int a = get_sum_tree(tree[v].t_l, t_l, mid, l, r), b = get_sum_tree(tree[v].t_r, mid, t_r, l, r);
    return a + b;
}

int main()
{
    int n; cin >> n;
    tree.push_back(node());
    roots.push_back(0);
    for(int i = 0; i < n; ++i){
        int a; cin >> a;
        roots.push_back(update_tree(roots[i], 0, n, a - 1));
    }
    int q; cin >> q;
    for(int i = 0; i < q; ++i){
        int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
        if(r1 > r2)
            swap(r1, r2), swap(c1, c2);
        int l = -1, r = n;
        while(l + 1 < r){
            int mid = (l + r) / 2;
            int cnt = get_sum_tree(roots[mid], 0, n, 0, r1);
            if(cnt < r1 - c1)
                l = mid;
            else
                r = mid;
        }
        int u = roots[r];
        l = -1, r = n;
        while(l + 1 < r){
            int mid = (l + r) / 2;
            int cnt = get_sum_tree(roots[mid], 0, n, 0, r2);
            if(cnt < r2 - c2)
                l = mid;
            else
                r = mid;
        }
        int v = roots[r];
        for(int i = (1 << 30); i > 0; i = (i >> 1)){
            if(i > r1)
                continue;
            int r3 = (r1 - i);
            int c3 = r3 - get_sum_tree(u, 0, n, 0, r3);
            int c4_osujdayu = r3 - get_sum_tree(v, 0, n, 0, r3);
            if(c3 != c4_osujdayu)
                r1 = r3, c1 = c3;
        }
        int c4_terrorizm_eto_ploho = r1 - get_sum_tree(v, 0, n, 0, r1);
        if(c4_terrorizm_eto_ploho != c1)
            --r1, c1 = r1 - get_sum_tree(u, 0, n, 0, r1);
        cout << r1 << ' ' << c1 << '\n';
    }

    return 0;
}
