#include <bits/stdc++.h>
#define sz(n) (int)n.size()

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
void dfs1(int v, vector<ll> &l, vector<ll> &r, vector<vector<int>> &g) {
    if (g[v].empty()) {
        return;
    }
    ll L = 0, R = 0;
    for (auto u : g[v]) {
        dfs1(u, l, r, g);
        L += l[u];
        R += r[u];
    }
    l[v] = max(l[v], L);
    if (l[v] > r[v]) {
        cout << -1 << '\n';
        exit(0);
    }
}
void solve() {
    int n;
    cin >> n;
    vector<int> p(n, -1);
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int t;
        cin >> t;
        p[i] = --t;
        g[t].push_back(i);
    }
    vector<ll> c(n), l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    dfs1(0, l, r, g);
    //if here: answer exists

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);cin.tie(nullptr);
#endif
    int tt;
    cin >> tt;
    while (tt--)
        solve();
    return 0;
}