//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <unordered_set>

using namespace std;
using ll = long long;

const ll INF = 1e15;
const int maxr = 1024;

vector<vector<int>> g;
vector<int> c, l, r, d;
vector<vector<ll>> dp;

pair<int, int> easy_ans(int r1, int c1, int r2, int c2){
    if (r1 - c1 == r2 - c2){
        if (r1 > r2){
            swap(r1, r2);
            swap(c1, c2);
        }
        return {r1, c1};
//        cout << r1 << ' ' << c1 << endl;
    } else{
        return {min(r1 - c1, r2 - c2), 0};
    }
}

int main(){
#ifdef LOCAL
    ifstream cin("C.in");
#endif
    int n;
    cin >> n;
    vector<int> a(n);
//    bool f = true;
    int k = -1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        if (a[i] != i){
            if (k == -1){
                if (a[i] == n - 1){
                    k = i;
                } else{
                    return 0;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << a[i] << ' ';
    }
    cout << endl;
    for (int i = 0; i < k; ++i){
        if (a[i] != i){
            return 0;
        }
    }
    for (int i = k; i < n; ++i){
        if (a[i] != n - 1 - i + k){
            return 0;
        }
    }
    cout << k << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        if (r1 - c1 > r2 - c2) {
            swap(r1, r2);
            swap(c1, c2);
        }
        if (r1 - c1 < k) {
            if (r2 - c2 < k) {
                auto ans = easy_ans(r1, c1, r2, c2);
                cout << ans.first << ' ' << ans.second << endl;
            } else {
                cout << r1 - c1 << ' ' << 0 << endl;
            }
        } else {
            if (c1 == c2) {
                cout << min(r1, r2) << ' ' << c1 << endl;
            } else {
                cout << min(c1, c2) + k << ' ' << min(c1, c2) << endl;
            }
        }
    }
}