#include <bits/stdc++.h>

using namespace std;
#define int long long

int f(vector<pair<int, int>> vec, int w, int h) {
    sort(vec.begin(), vec.end(), [&](pair<int, int> a, pair<int, int> b) {
        return a.first > b.first or (a.first == b.first and a.second < b.second);
    });
    vector<pair<int, int>> st;
    for (auto c: vec) {
        while (!st.empty() and st.back().second >= c.second) st.pop_back();
        st.push_back(c);
    }
    int ans = 0;
    int last = w;
    for (auto c: st) {
        ans += (h - c.second) * (last - c.first);
        last = c.first;
    }
    return ans;
}

void solve1() {
    int t;
    cin >> t;
    while (t--) {
        int n, w, h;
        cin >> n >> w >> h;
        vector<pair<int, int>> vec;
        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            vec.push_back({x, y});
        }
        cout << f(vec, w, h) << "\n";
    }
}


void solve2() {
    int t;
    cin >> t;
    while (t--) {
        int n, w, h;
        cin >> n >> w >> h;
        vector<pair<int, int>> vec(n);
        for (int i = 0; i < n; ++i) cin >> vec[i].first >> vec[i].second;
        sort(vec.begin(), vec.end(), [&](pair<int, int> a, pair<int, int> b) {
            return a.second < b.second;
        });
        pair<int, int> best = vec[0];
        int ans = 0;
        {
            pair<int, int> now = {0, h};
            for (int i = 1; i < vec.size(); ++i) {
                if (vec[i].first <= best.first) {
                    now = vec[i];
                    break;
                }
            }
            int res = best.first * (h - best.second) + (w - best.first) * (h - now.second);
            vector<pair<int, int>> vec_l, vec_lp;
            for (int i = 1; i < vec.size(); ++i) {
                if (vec[i].first >= best.first and vec[i].second < now.second) vec_l.push_back({vec[i].first - best.first, vec[i].second});
            }
            ans = max(ans, res + f(vec_l, w - best.first, now.second));
            for (auto c: vec_l) {
                vec_lp.push_back({w - best.first - c.first, c.second});
            }
            ans = max(ans, res + f(vec_lp, w - best.first, now.second));
        }
        {
            pair<int, int> now = {0, h};
            for (int i = 1; i < vec.size(); ++i) {
                if (vec[i].first >= best.first) {
                    now = vec[i];
                    break;
                }
            }

            int res = (w - best.first) * (h - best.second) + best.first * (h - now.second);
            vector<pair<int, int>> vec_l, vec_lp;
            for (int i = 1; i < vec.size(); ++i) {
                if (vec[i].first <= best.first and vec[i].second < now.second) {
                    vec_l.push_back(vec[i]);
                }
            }
            ans = max(ans, res + f(vec_l, best.first, now.second));
            for (auto c : vec_l) {
                vec_lp.push_back({best.first - c.first, c.second});
            }
            ans = max(ans, res + f(vec_lp, best.first, now.second));
        }
        cout << ans << "\n";
    }

}

signed main() {
    int k;
    cin >> k;
    vector<int> vec(k);
    for (int i = 0; i < k; ++i) cin >> vec[i];
    if (vec.size() == 1) {
        solve1();
    } else {
        solve2();
    }

    return 0;
}