#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("O3")
using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define int long long
#define fi first
#define se second

const int MX = 5e5 + 100;
const int INF = 2e18;
/*=========================================*/
int n;
vector<int> g[MX];
int c[MX], L[MX], R[MX];

pair<int, int> dp1[MX];
void dfs1(int u){
    int l = 0, r = 0;
    for (int v : g[u]){
        dfs1(v);
        l += dp1[v].fi, r += dp1[v].se;
    }
    dp1[u].fi = max(l, L[u]);
    dp1[u].se = R[u];
}

int dp[MX], dpp[MX];
vector<int> vec[MX];
int min_dist[MX], ps[MX], p[MX];

void dfs2(int u){
    vec[u] = {u};
    for (int v : g[u]){
        dfs2(v);
        for (int x : vec[v]) vec[u].push_back(x);
    }
}

void dfs(int u){
    int l = 0;
    dp[0] = 0;
    for (int v : g[u]){
        dfs(v);
        l += dpp[v];
        dp[u] += dp[v];
    }
    int cost = 0;
    if (l >= L[u]){
        dpp[u] = l;
        int d = R[u] - dpp[u];
        for (int v : vec[u]) min_dist[v] = min(min_dist[v], d);
    } else {
        int dt = L[u] - l;
        for (int v : vec[u]) min_dist[v] = min(min_dist[v], R[u] - l);
        // add

        for (int v : vec[u]){
            //cout << v << "\n";
            int x = min(min_dist[v], dt);
            dt -= x;
            ps[v] += x;
            cost += c[v] * x;
            int last = v;
            while (last != u) {
                min_dist[last] -= x;
                last = p[last];
            }
            min_dist[u] -= x;
            if (!dt) break;
        }
        dpp[u] = L[u];
    }
    dp[u] += cost;
}
void solve(){
    cin >> n;
    for (int i = 0; i <= n; i++) g[i].clear();
    for (int i = 0; i <= n; i++) vec[i].clear();
    for (int i = 2; i <= n; i++){
        int pr;
        cin >> pr;
        p[i] = pr;
        g[pr].push_back(i);
    }
    fill(ps, ps + n + 10, 0);
    fill(min_dist, min_dist + n + 10, INF);
    fill(dp, dp + n + 10, 0);
    fill(dpp, dpp + n + 10, 0);

    for (int i = 1; i <= n; i++) cin >> c[i];
    for (int i = 1; i <= n; i++) cin >> L[i] >> R[i];
    dfs1(1);
    dfs2(1);
    for (int i = 1; i <= n; i++) sort(vec[i].begin(), vec[i].end(), [&](int i, int j){return c[i] < c[j];});
    int ok = 1;
    for (int i = 1; i <= n; i++) if (dp1[i].se < dp1[i].fi) ok = 0;
    if (!ok){
        cout << -1 << "\n";
        return;
    } else {
        dfs(1);
        cout << dp[1] << "\n";
        for (int i = 1; i <= n; i++) cout << ps[i] << " ";
        cout << "\n";
    }
}

signed main(){
#ifndef LOCAL
    ios::sync_with_stdio(0), cin.tie(0);
#endif

    int Test = 1;
    cin >> Test;
    while (Test--) solve();
    return 0;
}