#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 3005;

int posl[N], posr[N];
int d[N][N];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    for (int i = 0; i < n; i++)
        posl[a[i]] = posr[a[i]] = i;
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < i; j++)
            cur += (a[j] > a[i]);
        posl[a[i]] = i - cur;
    }
    for (int i = n - 1; i >= 0; i--) {
        int cur = 0;
        for (int j = i; j < n; j++)
            cur += (a[j] < a[i]);
        posr[a[i]] = i + cur;
    }
    auto b = a;
    sort(all(b));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            d[b[i]][b[j]] = max(d[b[i]][b[j]], abs(j - i));
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            d[a[i]][a[j]] = max({d[a[i]][a[j]], abs(posr[a[j]] - i), abs(posl[a[i]] - j)});
            ans += max(d[a[j]][a[i]], d[a[i]][a[j]]);
        }
    }
    cout << ans << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    solve();
}
