#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <functional>
#include <iomanip>
#include <set>
#include <map>
#include <random>

using namespace std;
using ll = long long;

const ll INF = 2.5e18;

//#define int ll
#define ve vector
#define pb push_back
#define all(h) (h).begin(), (h).end()
#define ft first
#define sd second


ve<ve<int> > g;
ve<ll> sum;
ve<int> b;
ve<int> c;
ve<pair <int, int> > h;
ll ans = 0;
bool flag = true;


void dfs(set<pair <pair <int, int>, int> > & it, int v) {
	set<pair <pair <int, int>, int> > tec;
	it.insert({ {c[v], v}, h[v].sd });
	for (auto u : g[v]) {
		tec.clear();
		dfs(tec, u);
		if (tec.size() > it.size()) {
			swap(tec, it);
		}
		for (auto& el : tec) {
			it.insert(el);
		}
		sum[v] += sum[u];
	}
	if (sum[v] > h[v].sd) {
		ans = -INF;
		flag = false;
		return;
	}
	while(!it.empty() && sum[v] < h[v].ft)  {
		auto el = *it.begin();
		it.erase(it.begin());
		if (sum[v] + el.sd <= h[v].ft) {
			sum[v] += el.sd;
			b[el.ft.sd] += el.sd;
			ans += (ll)el.sd * c[el.ft.sd];
		}
		else {
			int cnt = h[v].ft - sum[v];
			sum[v] += cnt;
			b[el.ft.sd] += cnt;
			ans += (ll)cnt * c[el.ft.sd];
			el.sd -= cnt;
			it.insert(el);
			break;
		}
	}
	if (sum[v] < h[v].ft) {
		ans = -INF;
		flag = false;
		return;
	}
	tec.clear();
	int cnt = h[v].sd - sum[v];
	while(!it.empty() && cnt) {
		auto el = *it.begin();
		it.erase(it.begin());
		if (cnt >= el.sd && el.sd) {
			cnt -= el.sd;
			tec.insert(el);
		}
		else if (el.sd) {
			tec.insert({ el.ft, cnt });
			cnt = 0;
		}
	}
	swap(it, tec);
	return;
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int T;
	cin >> T;
	while (T--) {
		int n;
		cin >> n;
		ans = 0;
		flag = true;
		g.assign(n, {});
		c.assign(n, 0);
		b.assign(n, 0);
		sum.assign(n, 0);
		h.clear();
		for (int i = 1; i < n; ++i) {
			int p;
			cin >> p;
			--p;
			g[p].pb(i);
		}
		for (auto& el : c) {
			cin >> el;
		}
		for (int i = 0; i < n; ++i) {
			int l, r;
			cin >> l >> r;
			h.pb({ l, r });
		}
		set<pair <pair <int, int>, int> > start;
		dfs(start, 0);
		if (!flag) {
			cout << -1 << "\n";
		}
		else {
			cout << ans << "\n";
			for (int i = 0; i < n; ++i) {
				cout << b[i] << " ";
			}
			cout << "\n";
		}
	}
	return 0;
}