#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<int> t, a;
int sum(int v, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l) return 0;
	if (tl >= l && tr <= r) return t[v];
	int tm = (tl + tr) >> 1;
	return sum(v * 2 + 1, tl, tm, l, r) + sum(v * 2 + 2, tm, tr, l, r);
}
int upd(int v, int tl, int tr, int i) {
	if (tl > i || tr <= i) return t[v];
	if (tr - tl == 1) return t[v] = (++a[i]);
	int tm = (tl + tr) >> 1;
	return t[v] = upd(v * 2 + 1, tl, tm, i) + upd(2 * v + 2, tm, tr, i);
}
int main()
{
	int n;
	cin >> n;
	vector<int> p(n), sp;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
	}
	sp = p;
	sort(sp.begin(), sp.end());
	vector<int> pos(n + 1);
	for (int i = 0; i < n; ++i) {
		pos[sp[i]] = i;
	}
	vector<vector<int>> dist(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			dist[i][j] = max(abs(i - j), abs(pos[p[i]] - pos[p[j]]));
		}
	}
	vector<int> ll(n, 0), rg(n, 0);
	t.assign(4 * n, 0);
	a.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		upd(0, 0, n, p[i] - 1);
		ll[i] = sum(0, 0, n, 0, p[i] - 1);
	}
	t.assign(4 * n, 0);
	a.assign(n, 0);
	for (int i = n - 1; i >= 0; --i) {
		upd(0, 0, n, p[i] - 1);
		rg[i] = sum(0, 0, n, p[i], n);
	}
	long long ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			dist[i][j] = max(dist[i][j], max(j - ll[i], n - 1 - rg[j] - i));
			ans += dist[i][j];
		}
	}
	cout << ans << endl;
}