#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define vll vector<ll>
#define vld vector<ld>
#define pll pair<ll, ll>
#define pld pair<ld, ld>
#define vpl vector<pll>
#define vpd vector<pld>
#define vbo vector<bool>

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define each(i, b) for(auto i : b)
#define ROF(i, a, b) for(ll i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define sz(a) a.size()
#define pub push_back

vector<vll> tree;
vll rot;
ll n;
vector<vll> up;
vll tout;
ll kol = 0;

void upd()
{
    ll num = 0;
    ll cur = 0;
    ll dob = 1;
    F0R(i, n){
        if (!(tree[cur].size() == 2 || (tree[cur].size() == 1 && tree[cur][0] == cur + dob + rot[num]))){
            tree[cur].pub(cur + dob + rot[num]);
            up[cur + dob + rot[num]][0] = cur;
        }
        cur += dob + rot[num];
        dob += 1;
        num++;
    }
}

ll timer = 0;

void dfs(ll v)
{
    each(i, tree[v]){
        dfs(i);
    }
    tout[v] = timer++;
}

ll lca(ll a, ll b)
{
    if (a == b){
        return a;
    }
    if (tout[a] > tout[b]){
        swap(a, b);
    }
    F0R(i, kol){
        while(tout[up[a][i]] < tout[b]){
            a = up[a][i];
        }
    }
    return up[a][0];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    tree.resize((n + 1) * (n + 2) / 2, {});
    rot.resize(n, 1);
    tout.resize((n + 1) * (n + 2) / 2, 0);
    ll R = 1;
    while(R > (n + 1) * (n + 2) / 2){
        R *= 2;
        kol++;
    }
    kol++;
    up.resize((n + 1) * (n + 2) / 2, vll(kol));
    F0R(i, n){
        upd();
        ll ind;
        cin >> ind;
        rot[ind - 1] = 0;
    }
    upd();
    F0R(i, kol){
        up[0][i] = 0;
    }
    FOR(j, 1, kol){
        F0R(i, n){
            up[i][j] = up[up[i][j - 1]][j - 1];
        }
    }
    dfs(0);
    ll q;
    cin >> q;
    vll dob(n + 1);
    dob[0] = 0;
    FOR(i, 1, n + 1){
        dob[i] = dob[i - 1] + i;
    }
    F0R(i, q){
        ll x, y, x1, y1;
        cin >> x >> y >> x1 >> y1;
        ll a = dob[x] + y;
        ll b = dob[x1] + y1;
        ll ans = lca(a, b);
        ll l = 0, r = n + 1;
        while(r - l > 1){
            ll m = (r + l) / 2;
            if (dob[m] > ans){
                r = m;
            }
            else{
                l = m;
            }
        }
        cout << l << ' ' << ans - dob[l] << '\n';
    }
}