#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el << " ";
    return out;
}



int k;
void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vector <pair <int, int> > a(n);
    for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;

    int ans = 0;
    sort(a.begin(), a.end());
    vector <pair <int, int> > b;
    for (auto el: a) {
        if (b.empty() || el.first != b.back().first) b.push_back(el);
    }

    for (int i = 0, curr_min = h; i < b.size(); i++) {
        ans += max((w - b[i].first) * (curr_min - b[i].second), 0ll);
        curr_min = min(curr_min, b[i].second);
    }

    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> k;
    vector <int> d(k);
    cin >> d;
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}