#include <iostream>
#include <vector>

using namespace std;

void sort(vector<int> &a)
{
    int n = a.size();
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n-1; j++)
        {
            if (a[j]>a[j+1])
            {
                swap(a[j],a[j+1]);
            }
        }
    }
/*
    for (int i = 0; i < n; i++)
    {
        cout << a[i] << " ";
    }
    cout << endl;
*/
}

int calc(int w, int h, int n, vector<vector<int>> &coords, vector<int> &d)
{
    vector<vector<bool>> a;
    for (int i = 0; i < n+1; i++)
    {
        vector<bool> temp;
        for (int j = 0; j < n+1; j++)
        {
            temp.push_back(false);
        }
        a.push_back(temp);
    }

    vector<int> xs;
    vector<int> ys;
    for (int i = 0; i < n; i++)
    {
        xs.push_back(coords[i][0]);
        ys.push_back(coords[i][1]);
    }
    sort(xs);
    sort(ys);

    for (int pr = 0; pr < n; pr++)
    {
        int x = coords[pr][0];
        int y = coords[pr][1];
        int i0 = 0;
        int j0 = 0;
        for (int i = 0; i < n; i++)
        {
            if (x==xs[i])
            {
                i0=i;
            }
            if (y==ys[i])
            {
                j0=i;
            }
        }

        if (d[pr]==0)
        {
            for (int i = 0; i < i0+1; i++)
            {
                for (int j = 0; j < j0+1; j++)
                {
                    a[i][j]=true;
                }
            }
        }

        else if (d[pr]==1)
        {
            for (int i = i0+1; i < n+1; i++)
            {
                for (int j = 0; j < j0+1; j++)
                {
                    a[i][j]=true;
                }
            }
        }

        else if (d[pr]==2)
        {
            for (int i = 0; i < i0+1; i++)
            {
                for (int j = j0+1; j < n+1; j++)
                {
                    a[i][j]=true;
                }
            }
        }

        else
        {
            for (int i = i0+1; i < n+1; i++)
            {
                for (int j = j0+1; j < n+1; j++)
                {
                    a[i][j]=true;
                }
            }
        }


    }

    xs.push_back(0);
    xs.push_back(w);
    ys.push_back(0);
    ys.push_back(h);

    sort(xs);
    sort(ys);

    int s = 0;

    for (int i = 0; i < n+1; i++)
    {
        for (int j = 0; j < n+1; j++)
        {
            if (a[i][j])
            {
                s+=(xs[i+1]-xs[i])*(ys[j+1]-ys[j]);
            }
        }
    }

    return s;


}

int main()
{
    int k;
    cin >> k;
    vector<int> dirs;
    for (int i = 0; i < k; i++)
    {
        int temp;
        cin >> temp;
        dirs.push_back(temp);
    }

    int t;
    cin >> t;
    for (int testnum = 0; testnum < t; testnum++)
    {
        int n;
        int w;
        int h;
        cin >> n;
        cin >> w;
        cin >> h;

        vector<vector<int>> coords;
        for (int i = 0; i < n; i++)
        {
            int x0;
            int y0;
            cin >> x0;
            cin >> y0;

            vector<int> temp;
            temp.push_back(x0);
            temp.push_back(y0);

            coords.push_back(temp);

        }

        if (n>=4)
        {
            cout << w*h << endl;
            cout << 1/0;
        }
        else
        {
            vector<int> d;
            for (int i = 0; i < n; i++)
            {
                d.push_back(0);
            }
            int smax = 0;
            while (true)
            {
               smax = max(smax, calc(w,h,n,coords,d));
               int i = 0;
               while (i < n)
               {
                   d[i]++;
                   if (d[i]!=4)
                   {
                       break;
                   }
                   d[i]=0;
                   i++;
               }
               if (i==n)
               {
                   break;
               }
            }
            cout << smax << endl;
        }


    }

}
