#include<bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")
#pragma GCC optimize("unroll-loops")
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define szof(x) (int)(x.size())
using namespace std;

const int MAXN = 3e3 + 10;
const int LOG = 10;
int binup[LOG][MAXN * MAXN], h[MAXN * MAXN];
vector<int> g[MAXN * MAXN];
unordered_set<long long> edg;
bitset<MAXN> cur;

void dfs(int v, int p) {
    binup[0][v] = p;
    for (int i = 1; i < LOG; ++i) {
        binup[i][v] = binup[i - 1][binup[i - 1][v]];
    }
    for (auto u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u, v);
    }
}

int lca(int u, int v) {
    if (h[u] > h[v]) swap(u, v);
    for (int i = LOG - 1; i >= 0; --i) {
        int w = binup[i][v];
        if (h[u] <= h[w]) {
            v = w;
        }
    }
    if (u == v) return u;
    for (int i = LOG - 1; i >= 0; --i) {
        int tu = binup[i][u], tv = binup[i][v];
        if (tu != tv) {
            u = tu;
            v = tv;
        }
    }
    return binup[0][u];
}

void solve() {
    int n; cin >> n;
    for (int i = 0; i < n + 1; ++i) {
        int r = 0, c = 0;
        for (int j = 0; j < n; ++j) {
            int v = r * (n + 1) + c;
            //cout << r << " " << c << " -> ";
            if (!cur[j]) c++;
            r++;
            int u = r * (n + 1) + c;
            int t = u * MAXN + v;
            //cout << r << " " << c << "\n";
            if (edg.count(t) == 0) {
                edg.insert(t);
                g[v].push_back(u);
            }
        }
        //cout << "\n";
        if (i == n) break;
        int x; cin >> x;
        cur[x - 1] = 1;
    }
    dfs(0, 0);
    int q; cin >> q;
    for (int tst = 0; tst < q; ++tst) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int u = r1 * (n + 1) + c1, v = r2 * (n + 1) + c2;
        int w = lca(u, v);
        cout << w / (n + 1) << " " << w % (n + 1) << "\n";
    }
}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

