#include <bits/stdc++.h>
using namespace std;
#define int long long

int inf = 1e18;
int n;
int ans = 0;
int no = 0;
vector<vector<int>> g;
vector<int> c, l, r, dp, k, sz;

void find_min(int v, int kk)
{
    kk = min(kk, r[v] - sz[v]);
    if (kk <= 0)
    {
        dp[v] = inf;
        return;
    }
    int mn = inf;
    int down = 0;
    for (int i : g[v])
    {
        mn = min(mn, dp[i]);
        if (dp[i] == dp[v])
        {
            down = 1;
            find_min(i, kk);
        }
    }
    if (!down)
    {
        ans += c[v] * kk;
        sz[v] += kk;
        k[v] += kk;
        return;
    }
    dp[v] = c[v];
    sz[v] = k[v];
    for (int i : g[v])
    {
        dp[v] = min(dp[v], dp[i]);
        sz[v] += sz[i];
    }
}

void dfs(int v)
{
    dp[v] = c[v];
    for (int i : g[v])
    {
        dfs(i);
        sz[v] += sz[i];
        dp[v] = min(dp[v], dp[i]);
    }
    if (sz[v] > r[v])
    {
        no = 1;
        return;
    }
    while (sz[v] < l[v])
    {
        find_min(v, l[v] - sz[v]);
        if (dp[v] == inf)
            break;
    }
    if (sz[v] < l[v])
        no = 1;

}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; _++)
    {
        cin >> n;
        no = 0; ans = 0;
        g.clear();
        sz.assign(n, 0); k.assign(n, 0); c.resize(n); g.resize(n); l.resize(n); r.resize(n); dp.assign(n, inf);
        for (int i = 1; i < n; i++)
        {
            int a;
            cin >> a;
            a--;
            g[a].push_back(i);
        }
        for (int i = 0; i < n; i++)
            cin >> c[i];
        for (int i = 0; i < n; i++)
        {
            cin >> l[i] >> r[i];
        }
        dfs(0);
        if (no)
        {
            cout << -1 << '\n';
        }
        else
        {
            cout << ans << '\n';
            for (int i : k)
                cout << i << ' ';
            cout << '\n';
        }
    }
}
