#include <bits/stdc++.h>

#define left left20072007

using namespace std;

const int MAXN = 1e5 + 10;

set<pair<int, int>> anses[MAXN];
vector<int> graph[MAXN];

int left[MAXN];
int l[MAXN];
int r[MAXN];
int tin[MAXN];
int tout[MAXN];
int c[MAXN];
int ans[MAXN];
int cnt[MAXN];

inline bool ispar(int u, int v) {
    return (tin[u] <= tin[v] && tout[v] <= tout[u]);
}

int getmaxcnt(int vertex, int find) {
    if (vertex == find) return left[find];
    for (auto elem : graph[vertex]) {
        if (ispar(elem, find)) return min(left[vertex], getmaxcnt(elem, find));
    }
}

void minusleft(int vertex, int find, int d) {
    left[vertex] -= d;
    if (vertex == find) {
        return;
    }
    for (auto elem : graph[vertex]) {
        if (ispar(elem, find)){
            minusleft(elem, find, d);
            return;
        }
    }
}

int t = 0;

void dfs1(int vertex) {
    tin[vertex] = t++;
    for (auto elem : graph[vertex]) {
        dfs1(elem);
    }
    tout[vertex] = t++;
}

bool dfs2(int vertex) {
    for (auto elem : graph[vertex]) {
        if (dfs2(elem)) return 1;
        cnt[vertex] += cnt[elem];
        for (auto elem2 : anses[elem]) {
            anses[vertex].insert(elem2);
        }
    }
    l[vertex] -= cnt[vertex];
    cnt[vertex] += max(0, l[vertex]);
    left[vertex] = 1e9 + 10;
    anses[vertex].insert({c[vertex], vertex});
    while (l[vertex] > 0 && !anses[vertex].empty()) {
        int cnt = getmaxcnt(vertex, anses[vertex].begin() -> second);
        if (l[vertex] > cnt) {
            ans[anses[vertex].begin() -> second] += cnt;
            l[vertex] -= cnt;
            minusleft(vertex, anses[vertex].begin() -> second, cnt);
            anses[vertex].erase(anses[vertex].begin());
        } else {
            ans[anses[vertex].begin() -> second] += l[vertex];
            l[vertex] = 0;
            minusleft(vertex, anses[vertex].begin() -> second, l[vertex]);
        }
    }
    if (r[vertex] < cnt[vertex]) return 1;
    left[vertex] = r[vertex] - cnt[vertex];
    return 0;
}

signed solve() {
    int n;
    cin >> n;
    t = 0;
    for (int i = 0; i < n; ++i) {
        anses[i].clear();
        graph[i].clear();
        ans[i] = 0;
        cnt[i] = 0;
    }
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        graph[--p].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs1(0);
    if (dfs2(0)) {
        cout << -1 << '\n';
    } else {
        long long answer = 0;
        for (int i = 0; i < n; ++i) {
            answer += (long long)ans[i] * c[i];
        }
        cout << answer << '\n';
        for (int i = 0; i < n; ++i) {
            cout << ans[i] << ' ';
        }
        cout << '\n';
    }
    return 0;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}