#include <bits/stdc++.h>

using namespace std;

#define int long long


vector<int> directions;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}

	sort(pts.begin(), pts.end());

	int min_y_covered = h;
	int area = 0;
	for(auto [x, y]: pts) {
		if(y < min_y_covered) {
			area += (min_y_covered - y) * (w - x);
			min_y_covered = y;
		}
	}

	cout << area << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}