#pragma GCC optimize("O3,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,sse4,abm,mmx,popcnt,avx,avx2,fma,avx512f)
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <string>
#include <iomanip>
#include <bitset>
#include <set>
#include <queue>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define endl '\n'
#define double long double
//#define int long long

typedef long long ll;
typedef double ld;

using namespace std;

const int inf = 1e9 + 7;
const ll inf2 = 1e18 + 6;
const int MAXN = 5e5 + 8;
const int MAXN2 = 1e7 + 8;

int arr[MAXN];
int par[MAXN2];
int dist[MAXN2];


int now[MAXN];

int lca(int a, int b) {
	if (dist[a] < dist[b]) {
		swap(a, b);
	}
	int d = dist[a] - dist[b];
	while (d--) {
		a = par[a];
	}
	while (a != b) {
		a = par[a];
		b = par[b];
	}
	return a;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int n;
	cin >> n;
	bool g3 = true;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		if (arr[i] != i + 1) {
			g3 = false;
		}
	}
	int n1 = n + 1;
	if (!g3) {
		for (int i = 0; i < n; i++) {
			now[i] = 1;
		}
		int nv = 0;
		for (int j = 0; j < n; j++) {
			int nr = 0, nc = 0;
			for (int i = 0; i < n; i++) {
				int nxtv = 0;
				nv = nr * n1 + nc;
				++nr;
				if (now[i]) {
					++nc;
					nxtv = nv + n1 + 1;
				}
				else {
					nxtv = nv + n1;
				}
				par[nxtv] = nv;
				dist[nxtv] = dist[nv] + 1;
			}
			now[arr[j] - 1] = 0;
		}
		int nr = 0, nc = 0;
		for (int i = 0; i < n; i++) {
			int nxtv = 0;
			nv = nr * n1 + nc;
			++nr;
			if (now[i]) {
				++nc;
				nxtv = nv + n1 + 1;
			}
			else {
				nxtv = nv + n1;
			}
			par[nxtv] = nv;
			dist[nxtv] = dist[nv] + 1;
		}
	}
	int q;
	cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		if (g3) {
			int d1 = r1 - c1;
			int d2 = r2 - c2;
			if (d1 == d2) {
				if (r1 < r2) {
					cout << r1 << ' ' << c1 << endl;
				}
				else {
					cout << r2 << ' ' << c2 << endl;
				}
			}
			else {
				cout << min(d1, d2) << " 0\n";
			}
		}
		else {
			int l1 = lca(r1 * n1 + c1, r2 * n1 + c2);
			cout << l1 / n1 << ' ' << l1 % n1 << endl;
		}
	}
} 