#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <assert.h>
#include <random>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = (1 << 19);
const int D = (1 << 18);

vector<int> e[N];

int l[N];
int r[N];
int c[N];

int sum[N];

int ans;

int tin[N], tout[N];
int T;

void dfs_t(int i)
{
	tin[i] = T++;
	for (int j : e[i])
	{
		dfs_t(j);
	}
	tout[i] = T;
}

int n;

bool gg;

int f[N];

int dfs(int i)
{
	int min1 = i;
	for (int j : e[i])
	{
		int now = dfs(j);
		if (c[now] < c[min1])
		{
			min1 = now;
		}
		sum[i] += sum[j];
	}
	if (sum[i] < l[i])
	{
		ans += c[min1] * (l[i] - sum[i]);
		f[min1] += (l[i] - sum[i]);
		sum[i] = l[i];
	}
	return min1;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		cin >> n;
		gg = false;
		fill(sum, sum + n, 0);
		fill(f, f + n, 0);
		for (int i = 0; i < n; i++)
		{
			e[i].clear();
		}
		for (int i = 1; i < n; i++)
		{
			int p;
			cin >> p;
			p--;
			e[p].push_back(i);
		}
		for (int i = 0; i < n; i++)
		{
			cin >> c[i];
		}
		for (int i = 0; i < n; i++)
		{
			cin >> l[i] >> r[i];
		}
		ans = 0;
		T = 0;
		dfs_t(0);
		dfs(0);
		if (gg)
		{
			cout << -1 << endl;
		}
		else
		{
			cout << ans << endl;
			for (int i = 0; i < n; i++)
			{
				cout << f[i] << " ";
			}
			cout << endl;
		}
	}
}