#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#define int long long
using namespace std;

int d(int i, int j) {
	return abs(i - j);
}

signed main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n; cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	vector <int> gol(n + 1);
	for (int i = 0; i < n; i++) {
		gol[a[i]] = i;
		int low = 0;
		for (int j = i - 1; j >= 0; j--) {
			if (a[j] < a[i])
				low++;
			gol[a[i]] = min(gol[a[i]], j + low);
		}
	}
	vector <int> gor(n + 1, n - 1);
	for (int i = 0; i < n; i++) {
		gor[a[i]] = i;
		int big = 0;
		for (int j = i + 1; j < n; j++) {
			if (a[j] > a[i])
				big++;
			gor[a[i]] = max(gor[a[i]], j - big);
		}
	}

	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int d = abs(a[i] - a[j]);
			int d1 = j - gol[a[i]];
			int d2 = gor[a[j]] - i;
			int d3 = j - i;
			ans += max({ d, d1, d2, d3 });
		}
	}
	cout << ans;

	return 0;
}