#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

const int MAXN = 1e5 + 10;

void solve1() {
    int n, w, h;
    cin >> n >> w >> h;
    int last = h;
    vector<pair<int, int> > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].fi >> v[i].se;
    }
    sort(all(v));
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (v[i].se < last) {
            ans += (w - v[i].fi) * (last - v[i].se);
            last = v[i].se;
        }
    }
    cout << ans << '\n';
}

void solve2() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int> > v(n);
    set<pair<int, int> > x, y;
    for (int i = 0; i < n; i++) {
        cin >> v[i].fi >> v[i].se;
        x.insert({v[i].fi, v[i].se});
        y.insert({v[i].se, v[i].fi});
    }
    int l = 0, r = w;
    int ans = 0;
    int cur = 0;
    while (!y.empty()) {
        pair<int, int> a = *y.begin();
        y.erase(a);
        x.erase({a.se, a.fi});
        swap(a.fi, a.se);
        if (y.empty()) {
            cur += (h - a.se) * max(a.fi - l, r - a.fi);
            ans = max(ans, cur);
            break;
        }
        pair<int, int> b = *y.begin();
        swap(b.fi, b.se);
        if (b.fi > a.fi) {
            int add = (h - a.se) * (r - a.fi);
            add += (h - b.se) * (a.fi - l);
            ans = max(ans, add + cur);
            int nh = h;
            while (!x.empty() && x.begin()->fi <= a.fi) {
                nh = min(nh, x.begin()->se);
                y.erase({x.begin()->se, x.begin()->fi});
                x.erase(*x.begin());
            }
            cur += (h - a.se) * (a.fi - l);
            l = a.fi;
            cur += (h - nh) * (r - l);
            h = nh;
            while (!y.empty() && y.rbegin()->fi >= h) {
                x.erase({y.rbegin()->se, y.rbegin()->fi});
                y.erase(*y.rbegin());
            }
        } else {
            int add = (h - a.se) * (a.fi - l);
            add += (h - b.se) * (r - a.fi);
            ans = max(ans, add + cur);
            int nh = h;
            while (!x.empty() && x.rbegin()->fi >= a.fi) {
                nh = min(nh, x.rbegin()->se);
                y.erase({x.rbegin()->se, x.rbegin()->fi});
                x.erase(*x.rbegin());
            }
            cur += (h - a.se) * (r - a.fi);
            r = a.fi;
            cur += (h - nh) * (r - l);
            h = nh;
            while (!y.empty() && y.rbegin()->fi >= h) {
                x.erase({y.rbegin()->se, y.rbegin()->fi});
                y.erase(*y.rbegin());
            }
        }
        ans = max(ans, cur);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    vector<int> k(t);
    for (int i = 0; i < t; i++) {
        cin >> k[i];
    }
    int T;
    cin >> T;
    while (T --> 0) {
        if (t == 1) {
            solve1();
        } else if (t == 2 && k[0] + k[1] == 3) {
            solve2();
        } else {
            return 1;
        }
    }

    return 0;
}
/*
2
1 2
1
3 5 5
2 2
3 3
1 4
 */
