#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define vl vector<ll>
#define pr pair<ll, ll>

const ll MAXN = 100000;
const ll INF = 1e9 + 7;

ll l[MAXN], r[MAXN], c[MAXN];
vl gr[MAXN];
ll cost[MAXN];
multiset<pair<pr, ll> >ost[MAXN];
ll get_cnt[MAXN];
ll ans[MAXN];
bool flag = true;

void dfs(ll v){
    for(auto u: gr[v]){
        dfs(u);
    }
    ll nw_cost = 0;
    ll cnt = 0;
    multiset<pair<pr, ll> >st;
    for(auto u: gr[v]){
         cnt += get_cnt[u];
         nw_cost += cost[u];
         for(auto elem: ost[u]){
             st.insert(elem);
         }
    }
    st.insert({{c[v], INF}, v});
    if(cnt > r[v]) {
        flag = false;
    }
    while(cnt < l[v]) {
        ll need = l[v] - cnt;
        if(st.empty())break;
        auto elem = *st.begin();
        if (elem.first.second > need) {
            cnt += need;
            nw_cost += need * elem.first.first;
            ans[elem.second] += need;
            st.erase(st.find(*st.begin()));
            st.insert({{elem.first.first, elem.first.second - need}, elem.second});
        } else {
            cnt += elem.first.second;
            ans[elem.second] += elem.first.second;
            nw_cost += elem.first.second * elem.first.first;
            st.erase(st.find(*st.begin()));
        }
    }
    if(cnt < l[v] || cnt > r[v]){
        flag = false;
    }
    cost[v] = nw_cost;
    get_cnt[v] = cnt;
    ll ost_cnt = r[v] - get_cnt[v];
    for(auto elem: st){
        if(elem.first.second >= ost_cnt){
            ost[v].insert({{elem.first.first, ost_cnt}, elem.second});
            ost_cnt = 0;
        }
        else{
            ost[v].insert(elem);
            ost_cnt -= elem.first.second;
        }
    }
}

void solve(){
    ll n;
    cin >> n;

    /////////////////////////////
    //очистка массивов
    flag = true;
    for(ll i =0 ; i < MAXN;i++){
        gr[i].clear();
        cost[i] = 0;
        ost[i].clear();
        get_cnt[i] = 0;
        ans[i] = 0;
    }
    /////////////////////////////

    ll num;
    for(ll i = 1; i < n;i++){
        cin >> num;
        --num;
        gr[num].push_back(i);
    }
    for(ll i =0; i < n;i++){
        cin >> c[i];
    }
    for(ll i =0 ; i < n;i++){
        cin >> l[i] >> r[i];
    }
    dfs(0);
    if(flag){
        cout << cost[0] << endl;
        for(ll i =0 ; i < n;i++){
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
    else{
        cout << -1 << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
