#include <bits/stdc++.h>

using namespace std;
//#pragma GCC optimize("Ofast")

#define ll long long
#define vl vector<ll>
#define pr pair<ll, ll>

const ll MAXN = 10000;
const ll INF = 1e10 + 7;

struct Node{
    Node *l = nullptr, *r = nullptr;
    ll cost, cnt, ver, sum_cost, prior, siz;

    Node(ll _cost, ll _cnt, ll _ver){cost = _cost, cnt = _cnt, ver = _ver, sum_cost = _cost * _cnt, prior = rand() ^ (rand() << 16), siz = 1;}
};

ll get_size(Node*p){
    return p ? p->siz : 0;
}

ll get_sum_cost(Node*p){
    return p ? p->sum_cost : 0;
}

void upd(Node *p){
    p->sum_cost = get_sum_cost(p->l) + p->cost * p->cnt + get_sum_cost(p->r);
    p->siz = get_size(p->l) + 1 + get_size(p->r);
}


Node* merge(Node* a, Node* b){
    if(!a)return b;
    if(!b)return a;
    if(a->prior < b->prior){
        a->r = merge(a->r, b);
        upd(a);
        return a;
    }
    else{
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}


#define Pair pair<Node*, Node*>

Pair split(Node *p, ll x){
    if(!p)return {0, 0};
    if(get_size(p->l) >= x){
        Pair q = split(p->l, x);
        p->l = q.second;
        upd(p);
        return {q.first, p};
    }
    else{
        Pair q = split(p->r, x - 1 - get_size(p->l));
        p->r = q.first;
        upd(p);
        return {p, q.second};
    }
}

void insert(Node*a, Node*b){

}






ll l[MAXN], r[MAXN], c[MAXN];
vl gr[MAXN];
ll cost[MAXN];
set<pair<pr, ll> >ost[MAXN];
ll get_cnt[MAXN];
ll ans[MAXN];
bool flag = true;
Node*root[MAXN];

void dfs(ll v){
    set<pair<pr, ll> >st;
    ll nw_cost = 0;
    ll cnt = 0;
    Node*root = nullptr;
    for(auto u: gr[v]){
        dfs(u);
        cnt += get_cnt[u];
        nw_cost += cost[u];
        for(auto elem: ost[u]){
            st.insert(elem);
        }
    }

    st.insert({{c[v], INF}, v});
    auto it = st.begin();
    while(cnt < l[v]) {
        ll need = l[v] - cnt;
        if(it == st.end())break;
        auto elem = *it;
        if (elem.first.second > need) {
            cnt += need;
            nw_cost += need * elem.first.first;
            ans[elem.second] += need;
            st.erase(it);
            st.insert({{elem.first.first, elem.first.second - need}, elem.second});
        } else {
            cnt += elem.first.second;
            ans[elem.second] += elem.first.second;
            nw_cost += elem.first.second * elem.first.first;
            //st.erase(st.begin());
        }
        ++it;
    }
    if(cnt < l[v] || cnt > r[v]){
        flag = false;
    }
    cost[v] = nw_cost;
    get_cnt[v] = cnt;
    ll ost_cnt = r[v] - get_cnt[v];
    for(auto elem: st){
        if(elem.first.second >= ost_cnt){
            ost[v].insert({{elem.first.first, ost_cnt}, elem.second});
            ost_cnt = 0;
        }
        else{
            ost[v].insert(elem);
            ost_cnt -= elem.first.second;
        }
    }
}

void solve(){
    ll n;
    cin >> n;

    /////////////////////////////
    //очистка массивов
    flag = true;
    for(ll i =0 ; i < n;i++){
        gr[i].clear();
        cost[i] = 0;
        ost[i].clear();
        get_cnt[i] = 0;
        ans[i] = 0;
    }
    /////////////////////////////

    ll num;
    for(ll i = 1; i < n;i++){
        cin >> num;
        --num;
        gr[num].push_back(i);
    }
    for(ll i =0; i < n;i++){
        cin >> c[i];
    }
    for(ll i =0 ; i < n;i++){
        cin >> l[i] >> r[i];
    }
    dfs(0);
    if(flag){
        cout << cost[0] << endl;
        for(ll i =0 ; i < n;i++){
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
    else{
        cout << -1 << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
