#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<int> crr;
vector<pair<int, int>> lim;
vector<int> par;
vector<int> vals;
const ll INF = 1e9 + 100;
vector<int> anss;

int getmin(int u) {
    ll res = INF;
    while (u != -1) {
        if (vals[u] < res)
            res = vals[u];
        u = par[u];
    }
    return res;
}

void add(int u, int x) {
    anss[u] += x;
    while (u != -1) {
        vals[u] -= x;
        u = par[u];
    }
}

pair<ll, ll> dfs(int v, set<pair<int, int>> &costs) {
    ll cst = 0;
    ll num = 0;
    for (int u : graph[v]) {
        set<pair<int, int>> costs1;
        auto[cst1, num1] = dfs(u, costs1);
        cst += cst1;
        num += num1;
        if (num1 == -1) {
            return {-1, -1};
        }
        if (costs1.size() > costs.size())
            swap(costs1, costs);
        for (auto &el : costs1) {
            costs.insert(el);
        }
    }
    if (num > lim[v].second)
        return {-1, -1};
    costs.emplace(crr[v], v);
    int k = lim[v].first - num;
    while (k > 0 && !costs.empty()) {
        auto[c, u] = *costs.begin();
        costs.erase(costs.begin());
        int mng = getmin(u);
        if (mng == 0)
            continue;
        int mn = min(mng, k);
        add(u, mn);
        k -= mn;
        cst += mn * 1ll * c;
        num += mn;
        if (mng - mn > 0)
            costs.emplace(c, u);
    }
    if (k > 0)
        return {-1, -1};
    return {cst, num};
}

void solve() {
    int n;
    cin >> n;
    graph.clear();
    graph.resize(n);
    par.resize(n);
    par[0] = -1;
    anss.assign(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        p--;
        graph[p].push_back(i + 1);
        par[i + 1] = p;
    }
    crr.resize(n);
    for (int &el : crr)
        cin >> el;
    lim.resize(n);
    for (auto &el : lim)
        cin >> el.first >> el.second;
    vals.resize(n);
    for (int i = 0; i < n; ++i)
        vals[i] = lim[i].second;
    set<pair<int, int>> costs;
    auto[ans, lol] = dfs(0, costs);
    if (ans == -1) {
        cout << -1;
        return;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        cout << anss[i] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}