#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx2")

typedef long long ll;
typedef long double ld;

//#define int ll

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 5e5 + 10;
vector<int> t[N], to_mrg;
int a[N];

void my_merge(int a, int b) {
    to_mrg.clear();
    int f = 0, s = 0;
    while (f != t[a].size() || s != t[b].size()) {
        if (f == t[a].size()) {
            to_mrg.pb(t[b][s]);
            s++;
        } else if (s == t[b].size()) {
            to_mrg.pb(t[a][f]);
            f++;
        } else {
            if (t[a][f] < t[b][s]) {
                to_mrg.pb(t[a][f]);
                f++;
            } else {
                to_mrg.pb(t[b][s]);
                s++;
            }
        }
    }
}

void build(int v, int l, int r) {
    if (l == r - 1) {
        t[v].pb(a[l]);
    } else {
        int mid = (r + l) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        my_merge(2 * v + 1, 2 * v + 2);
        t[v] = to_mrg;
    }
//    cout << '!' << ' ' << l << ' ' << r << endl;
//    for (auto u : t[v])
//        cout << u << ' ';
//    cout << endl;
}

int get(int v, int l, int r, int tl, int tr, int val) {
    if (tr == 0)
        return 0;
    if (tl <= l && tr >= r) {
        int l1 = 0, r1 = t[v].size() + 1;
        while (r1 > l1 + 1) {
            int mid = (r1 + l1) / 2;
            if (t[v][mid - 1] <= val)
                l1 = mid;
            else
                r1 = mid;
        }
        return l1;
    }
    if (tl >= r || tr <= l)
        return 0;
    int mid = (r + l) / 2;
    return get(2 * v + 1, l, mid, tl, tr, val) + get(2 * v + 2, mid, r, tl, tr, val);
}

int spusk(int v, int l, int r, int val, int kolvo) {
    if (l == r - 1) {
        if (kolvo == 0 && t[v][0] <= val)
            return l;
        else
            return r;
    } else {
        int mid = (r + l) / 2;
        int l1 = 0, r1 = t[2 * v + 1].size() + 1;
        while (r1 > l1 + 1) {
            int mid = (r1 + l1) / 2;
            if (t[2 * v + 1][mid - 1] <= val)
                l1 = mid;
            else
                r1 = mid;
        }
        if (l1 > kolvo){
            return spusk(2 * v + 1, l, mid, val, kolvo);
        }else{
            return spusk(2 * v + 2, mid, r, val, kolvo - l1);
        }
    }
}

int find_moment(int x, int y, int n) {
    int d = x - y;
//    cout << 1 << endl;
//    int l = 0, r = n + 1;
//    while (r > l + 1) {
//        int mid = (r + l) / 2;
//        if (get(0, 0, n, 0, mid, x) <= d) {
//            l = mid;
//        } else {
//            r = mid;
//        }
//    }
//    cout << '!' << ' ' << l << ' ' << spusk(0, 0, n, x, d) << endl;
    return spusk(0, 0, n, x, d);
//    cout << 1 << endl;
}

//map<pair<pii, int>, int> mp;

//int get(int l, int r, int val, int n) {
//    if (mp.count({{l, r}, val}))
//        return mp[{{l, r}, val}];
//    int k = get(0, 0, n, l, r, val);
//    mp[{{l, r}, val}] = k;
//    return k;
//}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int k1 = find_moment(x1, y1, n), k2 = find_moment(x2, y2, n);
        int l = 0, r = min(x1, x2) + 1;
        while (r > l + 1) {
            int mid = (r + l) / 2;
            if (get(0, k1, mid, n) == get(0, k2, mid, n)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        cout << l << ' ' << l - get(0, 0, n, 0, k1, l) << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}