#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx2")

typedef long long ll;
typedef long double ld;

//#define int ll

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 5e5 + 10, inf = 1e9;
vector<int> t[4 * N], pos[4 * N][2], to_mrg;
int a[N];

void my_merge(int a, int b) {
    to_mrg.clear();
    int f = 0, s = 0;
    while (f != t[a].size() || s != t[b].size()) {
        if (f == t[a].size()) {
            to_mrg.pb(t[b][s]);
            s++;
        } else if (s == t[b].size()) {
            to_mrg.pb(t[a][f]);
            f++;
        } else {
            if (t[a][f] < t[b][s]) {
                to_mrg.pb(t[a][f]);
                f++;
            } else {
                to_mrg.pb(t[b][s]);
                s++;
            }
        }
    }
}

void build(int v, int l, int r) {
    if (l == r - 1) {
        t[v].pb(a[l]);
        pos[v][0] = pos[v][1] = {-1};
    } else {
        int mid = (r + l) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        my_merge(2 * v + 1, 2 * v + 2);
        t[v] = pos[v][0] = pos[v][1] = to_mrg;
        int it = -1;
        for (int i = 0; i < to_mrg.size(); ++i) {
            while(it + 1 < t[2 * v + 1].size() && t[2 * v + 1][it + 1] <= to_mrg[i])
                it++;
            pos[v][0][i] = it;
        }
        it = -1;
        for (int i = 0; i < to_mrg.size(); ++i) {
            while(it + 1 < t[2 * v + 2].size() && t[2 * v + 2][it + 1] <= to_mrg[i])
                it++;
            pos[v][1][i] = it;
        }
    }
}

int get1(int v, int l, int r, int tl, int tr, int val, int position = -inf) {
    if (tr == 0 || tl == tr)
        return 0;
    int l1 = position;
    if (position == -inf) {
        l1 = 0;
        int r1 = t[v].size() + 1;
        while (r1 > l1 + 1) {
            int mid = (r1 + l1) / 2;
            if (t[v][mid - 1] <= val)
                l1 = mid;
            else
                r1 = mid;
        }
        l1--;
    }
    position = l1;
    if (tl <= l && tr >= r)
        return position + 1;
    if (tl >= r || tr <= l)
        return 0;
    int mid = (r + l) / 2;
    int x1 = position, x2 = position;
    if (x1 != -1)
        x1 = pos[v][0][x1];
    if (x2 != -1)
        x2 = pos[v][1][x2];
    if (get1(2 * v + 1, l, mid, tl, tr, val, x1))
        return 1;
    return get1(2 * v + 2, mid, r, tl, tr, val, x2);
}

int get(int v, int l, int r, int tl, int tr, int val, int position = -inf) {
    if (tr == 0 || tl == tr)
        return 0;
    int l1 = position;
    if (position == -inf) {
        l1 = 0;
        int r1 = t[v].size() + 1;
        while (r1 > l1 + 1) {
            int mid = (r1 + l1) / 2;
            if (t[v][mid - 1] <= val)
                l1 = mid;
            else
                r1 = mid;
        }
        l1--;
    }
    position = l1;
    if (tl <= l && tr >= r)
        return position + 1;
    if (tl >= r || tr <= l)
        return 0;
    int mid = (r + l) / 2;
    int x1 = position, x2 = position;
    if (x1 != -1)
        x1 = pos[v][0][x1];
    if (x2 != -1)
        x2 = pos[v][1][x2];
    return get(2 * v + 1, l, mid, tl, tr, val, x1) + get(2 * v + 2, mid, r, tl, tr, val, x2);
}

int spusk(int v, int l, int r, int val, int kolvo, int position = -inf) {
    int l1 = position;
    if (position == -inf) {
        l1 = 0;
        int r1 = t[v].size() + 1;
        while (r1 > l1 + 1) {
            int mid = (r1 + l1) / 2;
            if (t[v][mid - 1] <= val)
                l1 = mid;
            else
                r1 = mid;
        }
        l1--;
    }
    position = l1;
    if (l == r - 1) {
        if (kolvo == 0 && t[v][0] <= val)
            return l;
        else
            return r;
    } else {
        int mid = (r + l) / 2;
        int x1 = position, x2 = position;
        if (x1 != -1)
            x1 = pos[v][0][x1];
        if (x2 != -1)
            x2 = pos[v][1][x2];
        if (x1 + 1 > kolvo) {
            return spusk(2 * v + 1, l, mid, val, kolvo, x1);
        } else {
            return spusk(2 * v + 2, mid, r, val, kolvo - (x1 + 1), x2);
        }
    }
}

inline int find_moment(int x, int y, int n) {
    int d = x - y;
    return spusk(0, 0, n, x, d);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int k1 = find_moment(x1, y1, n), k2 = find_moment(x2, y2, n);
        int l = 0, r = min(x1, x2) + 1;
        while (r > l + 1) {
            int mid = (r + l) / 2;
            if (get1(0, 0, n, min(k1, k2), max(k1, k2), mid)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << l << ' ' << l - get(0, 0, n, 0, k1, l) << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}