//#pragma GCC optimize("O3,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>

#define mp std::make_pair
using ll = long long;
using pii = std::pair<int, int>;
#define all(a) a.begin(), a.end()

template<class T, class T1>
bool mx(T &a, const T1 &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<class T, class T1>
bool mn(T &a, const T1 &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

std::vector<int> dirs;

void solve() {
    int n, w, h;
    std::cin >> n >> w >> h;
    std::vector<pii> a(n);
    for (auto &i : a) std::cin >> i.first >> i.second;
    std::sort(all(a));
    ll ans = 0;
    int lasty = h;
    for (auto [x, y] : a) {
        if (y > lasty) continue;
        ans += (w - x) * (lasty - y);
        lasty = y;
    }
    std::cout << ans << '\n';
}

signed main() {
    int cd;
    std::cin >> cd;
    dirs.resize(cd);
    for (auto &i : dirs) std::cin >> i;

    int TESTS = 1;
    std::cin >> TESTS;
    while (TESTS--) {
        solve();
    }
}
