#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int get_area(pair<pair<int, int>, pair<int, int>> a) {
    return max(0LL, (a.second.first - a.first.first + 1) * (a.second.second - a.first.second + 1));
}

pair<pair<int, int>, pair<int, int>>
inter(pair<pair<int, int>, pair<int, int>> a, pair<pair<int, int>, pair<int, int>> b) {
    return {{max(a.first.first, b.first.first),   max(a.first.second, b.first.second)},
            {min(a.second.first, b.second.first), min(a.second.second, b.second.second)}};
}

void sol() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> a(n);
    for (auto &el: a) {
        cin >> el.first >> el.second;
    }
    while ((int) a.size() > 4) {
        a.pop_back();
    }
    n = a.size();
    int ans = 0;
    for (int mask = 0; mask < (1 << (2 * n)); mask++) {
        int mask2 = mask;
        vector<int> dr;
        for (int i = 0; i < n; i++) {
            dr.push_back((mask2 % 4) + 1);
            mask2 /= 4;
        }
        vector<pair<pair<int, int>, pair<int, int>>> ok;
        for (int i = 0; i < n; i++) {
            if (dr[i] == 1) {
                ok.push_back({a[i], {w - 1, h - 1}});
            } else if (dr[i] == 2) {
                ok.push_back({{0,              a[i].second},
                              {a[i].first - 1, h - 1}});
            } else if (dr[i] == 3) {
                ok.push_back({{0,              0},
                              {a[i].first - 1, a[i].second - 1}});
            } else {
                ok.push_back({{a[i].first, 0},
                              {w - 1,      a[i].second - 1}});
            }
        }
        int area = 0;
        for (int mask3 = 1; mask3 < (1 << n); mask3++) {
            int cnt = 0;
            pair<pair<int, int>, pair<int, int>> now = {{0,     0},
                                                        {w - 1, h - 1}};
            for (int b = 0; b < n; b++) {
                if (mask3 & (1 << b)) {
                    cnt++;
                    now = inter(now, ok[b]);
                }
            }
            if (cnt % 2) {
                area += get_area(now);
            } else {
                area -= get_area(now);
            }
        }
        ans = max(ans, area);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    {
        int musor;
        cin >> musor;
        vector<int> musor2(musor);
        for (int el: musor2) {
            cin >> el;
        }
    }
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}

/*
4
1 2 3 4
1
3 8 6
2 2
4 5
6 1
 */
