#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;
typedef vector<ll> v64;
typedef vector<v64> vv64;
typedef pair<ll,ll> p64;
typedef vector<p64> vp64;
typedef vector<vp64> vvp64;

#define forn(i,n) for(ll i = 0;i < n;i++)
#define forsn(i,a,n) for(ll i = a;i < n;i++)
#define rforn(i,n) for(ll i = n;i >= 0;i--)
#define all(v) v.begin(),v.end()
#define fast_cin() ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)
#define ln '\n'
vv64 def;
vv64 gr;
vp64 val;
v64 d;
const ll ident = 3000;
vvp64 sparse;
vp64 euler;
vp64 pos1;
ll m,lg;

void dfs(ll v,ll p = -1,ll depth = 0){
    pos1[v].first = euler.size();
    euler.push_back({depth,v});

    for(auto u : gr[v]){
        if(u != p){
            dfs(u,v,depth+1);
            euler.push_back({depth,v});
        }
    }
    pos1[v].second = euler.size();
    euler.push_back({depth,v});
}

void build_sparse(){
    m = euler.size();
    lg = log2(euler.size())+1;
    sparse.resize(lg,{});
    forn(i,m){
        sparse[0].resize(m);
        sparse[0][i] = euler[i];
    }

    forsn(i,1,lg){
        sparse[i].resize(m-(1<<(i))+1);
        forn(j,m-(1<<(i-1))+1){
            sparse[i][j] = min(sparse[i-1][j],sparse[i-1][j+(1<<(i-1))]);
        }
    }
}

ll getAns(ll v1,ll v2){
    if(pos1[v1].first > pos1[v2].first){
        swap(v1,v2);
    }
    if(pos1[v1].first <= pos1[v2].first && pos1[v2].second <= pos1[v1].second){
        return v1;
    }
//    cout << v1 << " " << v2 << " ";
    ll l = pos1[v1].first;
    ll r = pos1[v2].first;
    ll len = (r-l+1);
    ll lg1 = log2(len);
//    cout << l << " " << r << " ";
    p64 ans = min(sparse[lg1][l],sparse[lg1][r-(1<<lg1)]);
//    cout << ans.first << ln;
    return ans.second;
}

int main() {
    fast_cin();
    ll n;
    cin >> n;
    v64 a(n);
    v64 v(n);
    ll counter = 0;
    if(n <= ident) {
        def.resize(n + 1, v64(n + 1, 0));
        forn(i, n + 1) {
            forn(j, n + 1) {
                def[i][j] = counter++;
                val.push_back({i, j});
            }
        }
        gr.resize(counter);
        pos1.resize(counter,{});
    }
    bool isThird = true;
    forn(i,n){
        v[i] = 1;
        cin >> a[i];
        if(a[i] != i+1){
            isThird = false;
        }
    }
    ll q;
    cin >> q;

    if(isThird){
        while (q--){
            ll r1,c1,r2,c2;
            cin >> r1 >> c1 >> r2 >> c2;
            ll a1 = (r1-r2);
            ll b1 = (c1-c2);
            if(a1 == b1){
                cout << min(r1,r2) << " " << min(c1,c2) << ln;
            }
            else{
                cout << min(r1-c1,r2-c2) << " " << 0 << ln;
            }
        }
    }
    else if(n <= ident && q <= ident){
        vp64 pos(n+1,{0,0});
        forn(i,n+1){
            ll r = 0,c = 0;
            ll ver = 0;
            ll st = 0;
            if(i > 0){
                v[a[i-1]-1] = -1;
                r = pos[a[i-1]-1].first;
                c = pos[a[i-1]-1].second;
                ver = def[r][c];
                st = a[i-1]-1;
            }
//            cout << r << " " << c << ln;
            forsn(j,st,n){
                if(v[j] == 1){
                    ++r;
                    ++c;
                }
                else{
                    ++r;
                }
//                cout << r << " " << c << ln;
                pos[j+1] = {r,c};
                ll newVer = def[r][c];
                gr[ver].push_back(newVer);
                gr[newVer].push_back(ver);
                ver = newVer;
            }
        }
        dfs(0);
        build_sparse();
//        cout << "!" << endl;
        while (q--){
            ll r1,c1,r2,c2;
            cin >> r1 >> c1 >> r2 >> c2;
            ll v1 = def[r1][c1];
            ll v2 = def[r2][c2];
            ll r = -1;
            ll c = 0;
            ll b1 = getAns(v1,v2);
            r = val[b1].first;
            c = val[b1].second;
            cout << r << " " << c << ln;

        }
        return 0;
    }

    return 0;
}