#include<bits/stdc++.h>

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 10111;
const ll INF = 1e18 + 7;

int n;
vector<int> g[MXN];
ll c[MXN];
int l[MXN];
int r[MXN];
int answer[MXN];

vector<ll> dp[MXN];
vector<int> opt[MXN];
int vertex[MXN];
int added[MXN];

int tt = 0;

int mrg(int a_pos, int b_pos, int a, int b) {
    int res = tt++;
    dp[res] = vector<ll>(r[a] + 1, INF);
    opt[res] = vector<int>(r[a] + 1, 0);
    vertex[res] = a_pos;
    added[res] = b_pos;
    for (int k_a = 0; k_a < dp[a_pos].size(); ++k_a) {
    for (int k_b = l[b]; k_b <= r[b] && (k_a + k_b) < dp[res].size(); ++k_b) {
        if (dp[res][k_a + k_b] > dp[a_pos][k_a] + dp[b_pos][k_b]) {
            dp[res][k_a + k_b] = dp[a_pos][k_a] + dp[b_pos][k_b];
            opt[res][k_a + k_b] = k_b;
        }
    }}
    return res;
}

int get(int v) {
    //cout << "get" _ v << endl;
    int v_ind = tt++;
    dp[v_ind] = vector<ll>(r[v] + 1, INF);
    opt[v_ind] = vector<int>(r[v] + 1, 0);
    vertex[v_ind] = v;
    added[v_ind] = -1;
    for (int i = 0; i < dp[v_ind].size(); ++i) {
        dp[v_ind][i] = i * c[v];
    }
    for (auto to: g[v]) {
        //cout << "!" << endl;
        v_ind = mrg(v_ind, get(to), v, to);
    }
    /*cout << "get(" << v << "): ";
    for (auto to: dp[v_ind]) {
        cout << to << " ";
    } cout << endl;*/
    return v_ind;
}

void get_ans(int pos, int k) {
    if (added[pos] == -1) {
        answer[vertex[pos]] = k;
    } else {
        get_ans(added[pos], opt[pos][k]);
        get_ans(vertex[pos], k - opt[pos][k]);
    }
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) g[i].clear();
    tt = 0;
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        g[x].push_back(i);
    }
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];
    //cout << "ok1" << endl;
    int ans_pos = get(0);
    ll ans = INF;
    ll ans_k = 0;
    //cout << "ok2" << endl;
    for (int i = l[0]; i <= r[0]; ++i) {
        if (ans > dp[ans_pos][i]) {
            ans = dp[ans_pos][i];
            ans_k = i;
        }
    }
    //cout << "ok3" << endl;
    if (ans == INF) {
        cout << -1 << "\n";
    } else {
        get_ans(ans_pos, ans_k);
        cout << ans << "\n";
        for (int i = 0; i < n; ++i) {
            cout << answer[i] << " ";
        } cout << "\n";
    }
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
