#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
using namespace std;
const int N = 1e5 + 5, INF = 2e9;
int p[N], c[N], l[N], r[N], ans[N];
long long dp[N], a[N];
vector<int> g[N];
bool dfs(int v, vector<pair<int, int>> & s) {
    a[v] = dp[v] = ans[v] = 0;
    for (auto u : g[v]) {
        vector<pair<int, int>> t;
        if (dfs(u, t))
            return true;
        a[v] += a[u];
        dp[v] += dp[u];
        for (auto it : t)
            s.push_back(it);
    }
    s.push_back({c[v], v});
    if (a[v] > r[v])
        return true;
    sort(s.begin(), s.end());
    for (auto it = s.begin(); a[v] < l[v]; ++it) {
        long long c1 = s.begin()->first, x = INF;
        int j = s.begin()->second;
        for (int u = j; u != v; u = p[u])
            x = min(x, r[u] - a[u]);
        if (x <= l[v] - a[v])
            s.erase(s.begin());
        else
            x = l[v] - a[v];
        ans[j] += x;
        dp[v] += c1 * x;
        a[v] += x;
        for (int u = j; u != v; u = p[u])
            a[u] += x;
    }
    return false;
}
void solve() {
    vector<pair<int, int>> s;
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; ++i)
        cin >> c[i];
    for (int i = 1; i <= n; ++i)
        cin >> l[i] >> r[i];

    if (dfs(1, s)) {
        cout << -1 << '\n';
    } else {
        cout << dp[1] << '\n';
        for (int i = 1; i <= n; ++i)
            cout << ans[i] << ' ';
        cout << '\n';
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}

