#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define vi vector<int>
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back
#define int ll

using namespace std;

struct st {
    vector<int> t;
    int n;
    st(int n, vi &a) : n(n) {
        t.resize(4 * n);
        build(1, 0, n - 1, a);
    }
    void build(int v, int l, int r, vi &a) {
        if (l == r) {
            t[v] = a[l];
        } else {
            int tm = (l + r) / 2;
            build(2 * v, l, tm, a);
            build(2 * v + 1, tm + 1, r, a);
            t[v] = min(t[2 * v], t[2 * v + 1]);
        }
    }
    int get(int v, int tl, int tr, int l, int r, int x) {
        if (l > tr || r < tl || l > r)
            return 1e9;
        if (tl >= l && tr <= r) {
            return t[v];
        } else {
            int tm = (tl + tr) / 2;
            return min(get(2 * v, tl, tm, l, r, x), get(2 * v + 1, tm + 1, tr, l, r, x));
        }
    }
    int get(int l, int r, int x) {
        return get(1, 0, n - 1, l, r, x);
    }
};

const int maxn = 5e5 + 50;
int f[maxn];
void upd(int r, int x) {
    for (int j = r; j < maxn; j += j & -j) {
        f[j] += x;
    }
}
int get(int r) {
    int ans = 0;
    for (int j = r; j > 0; j -= j & -j) {
        ans += f[j];
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vi a(n);
    vector<pii> b;
    for (auto &i : a) {
        cin >> i;
    }
    for (int i = 0; i < n; ++i) {
        b.pb({a[i], i});
    }
    sort(b.begin(), b.end());
    st t2(n, a);
    int q;
    cin >> q;
    vector<pair<pii, pii>> qs;
    vector<pii> all;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        all.pb({r1, c1});
        all.pb({r2, c2});
        qs.pb({{r1, c1}, {r2, c2}});
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    map<pii, int> ans;
    int it = 0;
    for (int i = 0; i < all.size(); ++i) {
        while (it < b.size() && b[it].f <= all[i].f) {
            upd(b[it].s + 1, 1);
            it++;
        }
        int l = -1, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (all[i].f - get(mid) <= all[i].s)
                r = mid;
            else
                l = mid;
        }
        ans[all[i]] = r;
    }
    memset(f, 0, sizeof(f));
    pii otv[q];
    for (int i = 0; i < q; ++i)
        otv[i] = {-1, -1};
    all.clear();
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        r1 = qs[i].f.f;
        c1 = qs[i].f.s;
        r2 = qs[i].s.f;
        c2 = qs[i].s.s;
//        cin >> r1 >> c1 >> r2 >> c2;
//        first_try(r1, c1);
        int l = ans[{r1, c1}], r = ans[{r2, c2}];
//        cout << ' ' << l << ' ' << r << endl;
        if (l == r) {
            if (r1 > r2)
                swap(r1, r2), swap(c1, c2);
            otv[i] = {r1, c1};;
            continue;
        }
        if (l > r)
            swap(l, r);
        int mx = t2.get(l, r - 1, 0);
//        cout << mx << endl;

        if (mx > min(r1, r2)) {
            if (r1 > r2)
                swap(r1, r2), swap(c1, c2);
            otv[i] = {r1, c1};;
            continue;
        }
        int R = mx - 1;
        all.pb({R, r - 1});
        otv[i] = {-R - 1, r - 1};
//        cout << R << " " << C << '\n';
    }
    sort(all.begin(), all.end());
    ans.clear();
    it = 0;
    for (int i = 0; i < all.size(); ++i) {
        while (it < b.size() && b[it].f <= all[i].f) {
            upd(b[it].s + 1, 1);
            it++;
        }
//        ans[all[i]] = t.get(0, all[i].s, all[i].f);
        ans[all[i]] = get(all[i].s + 1);
    }
    for (int i = 0; i < q; ++i) {
        if (otv[i].f >= 0) {
            cout << otv[i].f << ' ' << otv[i].s << '\n';
        } else {
            otv[i].f = -otv[i].f - 1;
            cout << otv[i].f << ' ' << otv[i].f - ans[{otv[i].f, otv[i].s}] << '\n';
        }
    }
}

signed main() {
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    while(t--)
        solve();

    return 0;
}
