#include<algorithm>
#include<iostream>
#include<vector>

using namespace std;

int c[100005];
pair<int, int> b[100005];

pair<int, pair<int, int>> dfs(int curr, const vector<vector<int>>& gr, long long& res, vector<int>& ans) {
	pair<int, int> mmin = { c[curr], curr };
	int cnt = 0;
	for (int nxt : gr[curr]) {
		auto buff = dfs(nxt, gr, res, ans);
		cnt += buff.first;
		mmin = min(mmin, buff.second);
	}
	if (b[curr].first > cnt) {
		res += 1LL * (1LL * b[curr].first - cnt) * mmin.first;
		ans[mmin.second] += b[curr].first - cnt;
		cnt = b[curr].first;
	}
	return { cnt, mmin };
}

void solve() {
	int n; cin >> n;
	vector<vector<int>> gr(n);
	for (int i = 1; i < n; ++i) {
		int p; cin >> p; --p;
		gr[p].push_back(i);
	}
	for (int i = 0; i < n; ++i) { cin >> c[i]; }
	for (int i = 0; i < n; ++i) { cin >> b[i].first >> b[i].second; }

	long long res = 0;
	vector<int> ans(n, 0);
	dfs(0, gr, res, ans);
	cout << res << "\n";
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int ttt; cin >> ttt;
	for (int _ = 0; _ < ttt; ++_) {
		solve();
	}
}
