#include<bits/stdc++.h>
using namespace std;

#define int long long
#define siz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define eb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second

const int N = 3e3 + 3;
int n;
int com[N];
vector<pii> ver;
int par[N];
vector<int> gr[N];

pii model(int id, int cnt) {
	int a = 0, b = 0;
	for (int i = 0; i < cnt; ++i) {
		a += 1;
		bool le = false;
		for (int j = 0; j < id; ++j) {
			if (com[j] == i) le = true;
		}
		if (!le) b += 1;
	}
	return {a, b};
}

int binpow(int r, int c) {
	int le = -1, ri = n;
	while (ri - le > 1) {
		int m = (le + ri) / 2;
		auto v = model(m, r);
		if (v.se > c) le = m;
		else ri = m;
	}
	//cout << "bin " << r << " " << c << " " << ri << '\n';
	return ri;
}

int sonny(int r, int c) {
	int v = 2*binpow(r, c)+1;
	while (ver[par[v]].fi > r) v = par[v];
	return v;
}

void run() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> com[i]; --com[i];
	}

	ver.eb(-1, -1);
	ver.eb(n, n);
	par[1] = 0;

	int lst = 1;

	for (int i = 0; i < n; ++i) {
		pii v = model(i+1, com[i]);

		while (ver[par[lst]].fi > v.fi) lst = par[lst];

		int nid = siz(ver);
		
		ver.eb(v);
		par[nid] = par[lst];
		par[lst] = nid;
		lst = nid;
		
		nid = siz(ver);

		par[nid] = lst;
		ver.eb(model(i+1, n));
		lst = nid;
	}

	/*for (int i = 0; i < siz(ver); ++i) {
		cout << ver[i].fi << " " << ver[i].se << " " << par[i]+1 << '\n';
	}*/
	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int v1 = sonny(r1, c1), v2 = sonny(r2, c2);

		//cout << "son " << v1+1 << " " << v2+1 << '\n';

		if (v1 == v2) {
			if (r1 < r2) cout << r1 << " " << c1 << '\n';
			else cout << r2 << " " << c2 << '\n';
		} else {
			while (v1 != v2) {
				if (ver[v1].fi > ver[v2].fi) v1 = par[v1];
				else v2 = par[v2];
			}
			cout << ver[v1].fi << " " << ver[v1].se << '\n';
		}
	}
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);

	int t = 1;
	while (t--) {
		run();	
	}
}