#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 3005;

int n, a[N];

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
}

int b[N], pos[N];
int max_dist[N][N];
int pref_less[N], min_pos[N];
int suff_grea[N], max_pos[N];

int64 solve() {
    for (int i = 1; i <= n; ++i) pos[a[i]] = i;
    for (int x = 1; x <= n; ++x) {
        for (int y = x + 1; y <= n; ++y) {
            max_dist[x][y] = max(abs(pos[x] - pos[y]), abs(x - y));
        }
    }
    for (int x = 1; x <= n; ++x) {
        int p = pos[x];
        for (int i = 1; i <= p - 1; ++i) {
            pref_less[i] = pref_less[i - 1] + (a[i] < x);
        }
        min_pos[x] = p;
        for (int L = 1; L <= p - 1; ++L) {
            min_pos[x] = min(min_pos[x], L + pref_less[p - 1] - pref_less[L - 1]);
        }
        for (int py = p + 1; py <= n; ++py) {
            int y = a[py], xx = min(x, y), yy = max(x, y);
            max_dist[xx][yy] = max(max_dist[xx][yy], abs(py - min_pos[x]));
        }
    }
    for (int x = 1; x <= n; ++x) {
        int p = pos[x];
        for (int i = n; i >= p + 1; --i) {
            suff_grea[i] = suff_grea[i + 1] + (a[i] > x);
        }
        max_pos[x] = p;
        for (int R = p + 1; R <= n; ++R) {
            max_pos[x] = max(max_pos[x], R - suff_grea[p + 1] + suff_grea[R + 1]);
        }
        for (int py = 1; py <= p - 1; ++py) {
            int y = a[py], xx = min(x, y), yy = max(x, y);
            max_dist[xx][yy] = max(max_dist[xx][yy], abs(py - max_pos[x]));
        }
    }
    int64 ans = 0;
    for (int x = 1; x <= n; ++x) {
        for (int y = x + 1; y <= n; ++y) {
            ans += max_dist[x][y];
        }
    }
    return ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    cout << solve() << "\n";
    return 0;
}