#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 505;
const int MAXC = 1010;
const int INF = 1e17;

int n;
vector<int> gr[MAXN];
int arr[MAXN], lrr[MAXN], rrr[MAXN], cnt[MAXN];

void init() {
	memset(cnt, 0, sizeof(cnt));
	for (int v = 0; v < n; ++v)
		gr[v].clear();
}

ipair dfsmin(int v, int p) {
	ipair ans {arr[v], v};
	for (int u: gr[v])
		if (u != p) ans = min(ans, dfsmin(u, v));
	return ans;
}

void build() {

}

ipair dfs(int v, int p) {
	int num = 0, ans = 0;
	for (int u: gr[v]) {
		if (u == p) continue;
		auto [ansu, numu] = dfs(u, v);
		if (ansu == -1) return {-1, -1};
		ans += ansu;
		num += numu;
	}
	if (num > rrr[v]) return {-1, -1};
	for (; num < lrr[v]; ++num) {
		auto [mi, id] = dfsmin(v, p);
		if (mi == INF) return {-1, -1};
		if (++cnt[id] >= rrr[id]) arr[id] = INF;
		ans += mi;
	}
	return {ans, num};
}

int solve() {
	auto [ans, num] = dfs(0, -1);
	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	int t; cin >> t;
	while (t--) {
		cin >> n, init();
		for (int v = 1; v < n; ++v) {
			int u; cin >> u, --u;
			gr[v].push_back(u);
			gr[u].push_back(v);
		}
		for (int v = 0; v < n; ++v)
			cin >> arr[v];
		for (int v = 0; v < n; ++v)
			cin >> lrr[v] >> rrr[v];
		build();
		int ans = solve();
		cout << ans << endl;
		if (ans == -1) continue;
		for (int v = 0; v < n; ++v)
			cout << cnt[v] << ' ';
		cout << endl;
	}
}