#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 505;
const int MAXC = 1010;
const int INF = 1e17;

int n;
vector<int> gr[MAXN];
int par[MAXN], arr[MAXN], lrr[MAXN], rrr[MAXN], cnt[MAXN], dp[MAXN];

ipair dfsmin(int v) {
	if (dp[v] == rrr[v]) return {INF, INF};
	ipair ans {arr[v], v};
	for (int u: gr[v])
		ans = min(ans, dfsmin(u));
	return ans;
}

void dfspar(int v, int stop) {
	++dp[v];
	if (v == stop) return;
	dfspar(par[v], stop);
}

void build() {
	memset(cnt, 0, sizeof(cnt));
	memset(dp, 0, sizeof(dp));
	for (int v = 0; v < n; ++v)
		gr[v].clear();
	for (int v = 1; v < n; ++v)
		gr[par[v]].push_back(v);
}

int dfs(int v) {
	int ans = 0;
	for (int u: gr[v]) {
		int ansu = dfs(u);
		if (ansu == -1) return -1;
		dp[v] += dp[u];
		ans += ansu;
	}
	if (dp[v] > rrr[v]) return -1;
	while (dp[v] < lrr[v]) {
		auto [mi, id] = dfsmin(v);
		if (mi == INF) return -1;
		++cnt[id];
		dfspar(id, v);
		ans += mi;
	}
	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	int t; cin >> t;
	while (t--) {
		cin >> n;
		for (int v = 1; v < n; ++v)
			cin >> par[v], --par[v];
		for (int v = 0; v < n; ++v)
			cin >> arr[v];
		for (int v = 0; v < n; ++v)
			cin >> lrr[v] >> rrr[v];
		build();
		int ans = dfs(0);
		cout << ans << endl;
		if (ans == -1) continue;
		for (int v = 0; v < n; ++v)
			cout << cnt[v] << ' ';
		cout << endl;
	}
}