#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

vector<vector<int>> gr;
vector<int> cost;
vector<pair<int, int>> seg;
vector<int> ans;
vector<set<pair<int, int>>> to_add;

vector<int> tin, tout;
int tim = 0;

vector<int> fenw;

int ask(int r) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i+1)) - 1) {
        //res += fenw[i];
    }
    for (int i = r; i >= 0; i--) {
        res += fenw[i];
    }
    return res;
}

int ask(int l, int r) {
    return ask(r) - (l == 0 ? 0 : ask(l-1));
}

void upd(int ind, int x) {
    for (int i = ind; i < fenw.size(); i = (i | (i+1))) {
        //fenw[i] += x;
    }
    for (int i = ind; i <= ind; i++) {
        fenw[i] += x;
    }
}

void dfs0(int v) {
    tin[v] = tim; tim++;
    for (int i : gr[v]) {
        dfs0(i);
    }
    tout[v] = tim-1;
}

void dfs(int v) {
    int mx = -1;
    for (int i : gr[v]) {
        dfs(i);
        if (mx == -1 || to_add[i].size() > to_add[mx].size()) {
            mx = i;
        }
    }
    if (mx != -1) {
        swap(to_add[v], to_add[mx]);
    }
    for (int i : gr[v]) {
        if (i != mx) {
            for (auto j : to_add[i]) {
                to_add[v].insert(j);
            }
        }
    }

    to_add[v].insert({cost[v], v});
    int sum = ask(tin[v], tout[v]);
    while (sum < seg[v].fi && to_add[v].size()) {
        int i = to_add[v].begin()->se;
        int ost = seg[i].se - ask(tin[i], tout[i]);
        if (seg[v].fi - sum >= ost) {
            ans[i] += ost;
            upd(tin[i], ost);
            sum += ost;
            to_add[v].erase(to_add[v].begin());
        } else {
            ans[i] += seg[v].fi - sum;
            upd(tin[i], seg[v].fi - sum);
            sum += seg[v].fi - sum;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    to_add.assign(n, {});
    fenw.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    tim = 0;
    ans.assign(n, 0);
    gr.assign(n, {});
    cost.assign(n, 0);
    seg.assign(n, {});
    for (int i = 0; i < n-1; ++i) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i+1);
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].fi >> seg[i].se;
    }
    dfs0(0);
    dfs(0);
    int res = 0;
    for (int i = 0; i < n; ++i) {
        res += cost[i] * ans[i];
        if (ask(tin[i], tout[i]) < seg[i].fi || ask(tin[i], tout[i]) > seg[i].se) {
            cout << "-1\n";
            return;
        }
    }

    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}
