#include <iostream>
#include <vector>
#include <set>
using namespace std;
using ll = long long;

const int MAXN = 2300;
ll a[MAXN];
vector<pair<ll, pair<int, int>>> moving;
vector<pair<ll, pair<int, int>>> unmoving;

ll get_ans(vector<vector<pair<int, ll>>> hoho) {
    int n = hoho.size();
    /* for (int i = 0; i < n; ++i) {
        for (auto [r, c] : hoho[i])
            cout << "(" << i << ' ' << r << ' ' << c << ")";
    } */
    vector<ll> get(n);
    set<int> st;
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ll t = 0;
        st.erase(i);
        for (auto [r, c] : hoho[i]) {
            get[r] += c;
            st.insert(r);
        }
        while (t < a[i] && st.size()) {
            int j = *st.begin();
            if (t + get[j] <= a[i]) {
                t += get[j];
                get[j] = 0;
                st.erase(j);
            } else {
                get[j] -= a[i] - t;
                t = a[i];
            }
        }
        // cout << t << ' ';
        ans += t;
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    moving.clear();
    unmoving.clear();
    for (int i = 0; i < m; ++i) {
        int l, r, c, t;
        cin >> l >> r >> c >> t;
        --l;
        if (t == 1) {
            moving.push_back({c, {l, r}});
        } else {
            unmoving.push_back({c, {l, r}});
        }
    }
    for (int i = 0; i < n; ++i) {
        vector<vector<pair<int, ll>>> whyyy(n);
        for (auto [c, sg] : unmoving) {
            whyyy[sg.first].push_back({sg.second, c});
        }
        for (auto [c, sg] : moving) {
            whyyy[min(sg.first, i)].push_back({max(i + 1, sg.second), c});
        }
        cout << get_ans(whyyy) << ' ';
    }
    cout << '\n';

}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
