#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

#define int long long
#define vout(v) for (auto i : v) cout << i;

signed main() {
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#endif
    string s;
    cin >> s;
    int n = s.size();
    vector<int> start(n);
    for (int i = 0; i < n; ++i) {
        start[i] = s[i] - '0';
    }
    auto best = start;
    sort(best.rbegin(), best.rend());
    vout(best);
}
