#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

#define int long long
#define vout(v) for (auto i : v) cout << i;

struct query {
    int t, k, ind;
    int pl = 0;
};

bool cmp(query a, query b) {
    return a.k < b.k;
}

signed main() {
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#endif
    int n, q;
    cin >> n >> q;
    vector<int> v(n), real(n), cnt(n), w;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    w = v;
    sort(w.begin(), w.end());
    w.erase(unique(w.begin(), w.end()), w.end());
    for (int i = 0; i < n; ++i) {
        int ind = lower_bound(w.begin(), w.end(), v[i]) - w.begin();
        real[i] = ind;
        ++cnt[ind];
    }
    vector<pair<int, int>> all_d;
    for (int i = 0; i < w.size() - 1; ++i) {
        all_d.push_back({w[i + 1] - w[i], i});
    }
    sort(all_d.begin(), all_d.end());
    vector<int> ans_q(q);
    vector<query> qq;
    for (int i = 0; i < n; ++i) {
        int t, k;
        cin >> t >> k;
        if (t != 3) {
            qq.push_back({t, k, i});
        } else {
            int pl;
            cin >> pl;
            --pl;
            qq.push_back({t, k, i, pl});
        }
    }
    sort(qq.begin(), qq.end(), cmp);
    int now_q = 0;
    int diff = w.size();
    int prev_h = 0;
    int prev_sum = 0;
    int cur_sum = 0;
    int prev_k = 0;
    for (int _ = 0; _ < all_d.size(); ++_) {
        int k = all_d[_].first;
        while (now_q < q && qq[now_q].k <= k) {
            query cur = qq[now_q];
            int t = cur.t;
            if (t == 1) {
                ans_q[cur.ind] = diff;
            } else if (t == 2) {
                ans_q[cur.ind] = prev_sum + (cur.k - prev_k) * cur_sum;
            } else {
                int i = real[cur.pl];
                
            }
        }
        --diff;
    }
}
