#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
using ll = long long;

int main() {
	string x;
	ll y;
	cin >> x;
	cin >> y;
	int n = x.size();
	vector<int> digs(n);
	for (int i = 0; i < n; ++i) digs[i] = (x[i] - '0');
	if (y == 1) {
		sort(digs.begin(), digs.end());
		string res = "";
		for (int i = 0; i < n; ++i) res += (digs[n - i - 1] + '0');
		cout << res;
		return 0;
	}
	if (n <= 9) {
		vector<int> copy = digs, copy1;
		sort(copy.begin(), copy.end());
		ll bestwin = -1e18;
		vector<int> bestp;
		do {
			ll win = 0;
			for (int i = 0; i < n; ++i) win = win * 10 + copy[i];
			copy1 = copy;
			for (int i = 0; i < n; ++i) {
				for (int j = i; j < n; ++j)
					if (digs[i] == copy1[j]) {
						win -= ((ll)j - i)*y;
						int t = j;
						while (t != i) {
							swap(copy1[t], copy1[t - 1]);
							--t;
						}
					}
			}
			//for (int i = 0; i < n; ++i) cout << copy[i] << " ";
			//cout << "\n";
			//cout << win << "_\n";
			if (win >= bestwin) {
				bestwin = win;
				bestp = copy;
			}
		} while (next_permutation(copy.begin(), copy.end()));
		//cout << "a\n";
		string res = "";
		for (int i = 0; i < n; ++i) res += (bestp[i] + '0');
		cout << res;
	}
	return 0;
}