#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vi = vector<int>;

vi ten(10, 1);

int len(int n) {
    if (!n) {
        return 1;
    }
    for (int i = 9; i >= 0; --i) {
        if (ten[i] <= n) {
            return i + 1;
        }
    }
}

int integer(string s) {
    int res = 0;
    for (int i = 0; i < (int)s.size(); ++i) {
        res = res * 10 + (s[i] - '0');
    }
    return res;
}

int integer(const vi& s) {
    int res = 0;
    for (int i = 0; i < (int)s.size(); ++i) {
        res = res * 10 + s[i];
    }
    return res;
}

ll f(int x, int y, vi& p) {
    int k = 0, n = p.size();
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (p[j] < p[i]) {
                ++k;
            }
        }
    }
    return x - k * 1LL * y;
}

int cntsame(const vi& a, const vi& b) {
    int n = min(a.size(), b.size());
    for (int i = 0; i < n; ++i) {
        if (a[i] != b[i]) {
            return i;
        }
    }
    return n;
}

vector<int> op(const vector<int>& a, int l, int r) {
    vi v(a);
    int x = v[r];
    for (int i = r; i > l; --i) {
        v[i] = v[i - 1];
    }
    v[l] = x;
    return v;
}

void solve() {
    string str;
    cin >> str;
    int n = str.size(), x = integer(str), xnew;
    vector<int> dig(n), cp;
    for (int i = 0; i < n; ++i) {
        dig[i] = str[i] - '0';
    }
    vector<int> s(dig);
    sort(s.rbegin(), s.rend());
    ll y;
    cin >> y;

    int win = x, ans = x, curwin;
    for (int mask = 0, e = (1 << n), k; mask < e; ++mask) {
        k = 0;
        cp.assign(dig.begin(), dig.end());
        int sum = 0;
        for (int i = 0, cur; i < n; ++i) {
            if (mask & (1 << i)) {
                ++sum;
                cur = i;
                while (cur >= sum) {
                    swap(cp[cur - 1], cp[cur]);
                    --cur;
                    ++k;
                }
            }
        }
        for (int i = 0; i < sum; ++i) {
            for (int j = 1; j < sum; ++j) {
                if (s[j - 1] < s[j]) {
                    swap(s[j - 1], s[j]);
                    ++k;
                }
            }
        }
        xnew = integer(cp);
        curwin = xnew - k * y;
        if (curwin >= win && xnew > ans) {
            win = curwin;
            ans = xnew;
        }
    }

    for (int i = n - len(ans); i > 0; --i) {
        cout << 0;
    }
    cout << ans << '\n';
}

int main() {
    for (int i = 1; i < 10; ++i) {
        ten[i] = 10 * ten[i - 1];
    }
    solve();
    return 0;
}
