#include <bits/stdc++.h>


using namespace std;
vector<vector<int>> g;
vector<int> tin, fup, ver;
map<pair<int, int>, int> col;
vector<bool> used, us;
int t = 0;


void dfs(int v, int p){
    used[v] = true;
    tin[v] = fup[v] = t++;
    int cnt = 0;
    for(auto u:g[v]){
        if (u == p) continue;
        if (used[u]) fup[v] = min(fup[v], tin[u]);
        else {
            if (v == 0) cnt++;
            dfs(u, v);
            fup[v] = min(fup[v], fup[u]);
            if (fup[u] >= tin[v] && !us[v] && v != 0) ver.push_back(v), us[v] = true;
        }
    }
    if (v == 0 && cnt > 1) ver.push_back(0);
}


void colc(int v, int cl){
    for(auto u:g[v]){
        if (col.count({min(v, u), max(v, u)}) || (us[v] && fup[u] >= tin[v])) continue;
        col[{min(v, u), max(v, u)}] = cl;
        colc(u, cl);
    }
}

bool cmp(int a, int b){
    return tin[a] < tin[b];
}


void solve(){
    int n, m;
    cin >> n >> m;
    t = 0;
    ver.clear(), col.clear();
    g.assign(n, {}), used.assign(n, false), tin.assign(n, 0), fup.assign(n, 0), us.assign(n, false);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u), g[u].push_back(v);
    }
    dfs(0, -1);
    int cl = 1;
    sort(ver.begin(), ver.end());
    for(auto v:ver){
        for(auto u:g[v]){
            if (!col.count({min(v, u), max(v, u)})){
                col[{min(v, u), max(v, u)}] = cl;
                colc(u, cl);
                cl++;
            }
        }
    }
    vector<int> dist((cl + 1) * n, 1e9);
    vector<bool> used1((cl + 1) * n);
    used1[0] = true;
    dist[0] = 0;
    queue<int> q;
    q.push(0);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto u:g[v / (cl + 1)]){
            int v1 = v / (cl + 1);
            if (v % (cl + 1)) {
                if (col[{min(v1, u), max(v1, u)}] != v % (cl + 1) - 1 || used1[(cl + 1) * u]) continue;
                dist[(cl + 1) * u] = dist[v] + 1;
                used1[(cl + 1) * u] = true;
                q.push((cl + 1) * u);
            } else {
                if (used1[(cl + 1) * u + col[{min(v1, u), max(v1, u)}] + 1]) continue;
                dist[(cl + 1) * u + col[{min(v1, u), max(v1, u)}] + 1] = dist[v] + 1;
                used1[(cl + 1) * u + col[{min(v1, u), max(v1, u)}] + 1] = true;
                q.push((cl + 1) * u + col[{min(v1, u), max(v1, u)}] + 1);
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (!used1[(cl + 1) * i]) cout << "-1 ";
        else cout << dist[(cl + 1) * i] << " ";
    }
    cout << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t1;
    cin >> t1;
    while(t1--){
        solve();
    }
}