#include "bits/stdc++.h"
using namespace std;
#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)(a.size())
#define F first
#define S second
const int MAXN = 1e5 + 10;
deque<int> cnt[10];
struct Fenwick {
    vector<int> t;
    int n = 1;
    void init(int k){
        n = k;
        t.resize(n + 1, 0ll);
    }
    int sum(int l, int r){
        return sum(r) - sum(l - 1);
    }
    int sum(int k){
        int res = 0;
        for(;k;k -= (k & -k)){
            res += t[k];
        }
        return res;
    }
    void add(int k, int v){
        for(;k <= n;k += (k & -k)){
            t[k] += v;
        }
    }
};
const int inf = 1e18;
int pow_ten(int k){
    int res = 1;
    for(int i = 0;i < k;i++){
        res *= 10;
    }
    return res;
}
signed main() {
    string s;
    cin >> s;
    int n = sz(s);
    int y;
    cin >> y;
    for(int i = 0;i < sz(s);i++){
        cnt[s[i] - '0'].push_back(i);
    }
    Fenwick t;
    t.init(n);
    string ans = "";
    for(int i = 0;i < n;i++){
        int now = -inf;
        int ind = -1;
        for(int j = 0;j < 10;j++){
            if(!sz(cnt[j]))continue;
            //перебираем какой символ ставим
            //тогда выберем тот за который получаем наибольшую выгоду
            int cur = pow_ten(n - i - 1) * j;
            int need = 0;
            need = t.sum(cnt[j].front() + 1, n);
            int pos = cnt[j].front() + need;
            need = (pos - i) * y;
            cur -= need;
            if(now < cur){
                now = cur;
                ind = j;
            }
        }
        ans += (ind + '0');
        int j = ind;
        int need = t.sum(1, cnt[j].front());
        int pos = cnt[j].front() + need;
        t.add(pos + 1, 1);
        cnt[ind].pop_front();
    }
    cout << ans << endl;
    return 0;
}
/*
170
15

170
600

314599
17713

001
1000
 */