#include <bits/stdc++.h>

#define debug(x) cout << (#x) << " = " << (x) << "\n"
#define len(x) ((int) (x).size())

using namespace std;
typedef long long ll;

void config_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed;
    cout.precision(20);
}

void solve();

int main() {
    config_io();
    solve();
    return 0;
}


int len_n(__int64 num) {
    if (num == 0) return 1;
    int c = 0;
    while (num > 0) {
        num /= 10;
        c++;
    }
    return c;
}


//void solve(string s, ll y) {
void solve() {
    string s;
    __int64 n, y, m;
//    __int64 n;

    cin >> s >> y;
    n = len(s);

    int c12 = 0;
    for (char c : s) {
        if (c == '1' || c == '2') {
            c12++;
        }
    }

    map<string, int> d;

    if (y == 1) {
        sort(s.rbegin(), s.rend());
    } else if (c12 == n) {
        __int64 j = (int) (find(s.begin(), s.end(), '2') - s.begin());
        for (__int64 i = 0; i < n; ++i) {
            if (i == j) continue;
            if (j < i) {
                j++;
            }
            while (j < n && s[j] != '2') {
                j++;
            }
            if (j >= n) break;
            ll ni = n - 1 - i, nj = n - 1 - j;
            if (ni > len_n(y * (j - i))) {
                swap(s[i], s[j]);
            } else {
                __int64 a2 = 0;
                for (__int64 k = 0; k < ni - nj; ++k) {
                    a2 = a2 * 10 + 9;
                }
                for (__int64 k = 0; k < nj; ++k) {
                    a2 *= 10;
                }
                if (a2 >= y * (j - i)) {
                    swap(s[i], s[j]);
                } else {
                    break;
                }
            }
        }
    } else {
        m = len_n(y * n * n);

        sort(s.rend() - max(0ll, n - m - 1), s.rend());

        queue<string> q;
        d[s] = 0;
        q.push(s);
        while (!q.empty()) {
            string s2 = q.front();
            q.pop();

            int dk = d[s2];
            for (int i = 0; i < n - 1; ++i) {
                if (s2[i + 1] <= s2[i]) {
                    continue;
                }
                swap(s2[i], s2[i + 1]);
                if (d.find(s2) == d.end() || d[s2] > dk + 1) {
                    d[s2] = dk + 1;
                    q.push(s2);
                }
                swap(s2[i], s2[i + 1]);
            }
        }

        ll best = stol(s);

        for (auto const &z : d) {
            __int64 e = 0;
            for (char c : z.first) {
                e = (e * 10) + (c - '0');
            }
            e -= y * z.second;
            if (e >= best) {
                best = e;
                s = z.first;
            }
        }
    }

    for (char c : s) {
        cout << c;
    }
    cout << "\n";
}