#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

struct Query {
	int i, k, t, ind;
};

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;

	vector<ll> c(n);
	for(ll &i : c)
		cin >> i;
	vector<Query> qs;
	for(int ind = 0; ind < q; ++ind) {
		int t;
		cin >> t;
		--t;
		int k;
		cin >> k;
		qs.push_back(Query{t, 0, k});
		qs.back().ind = ind;
		if(t == 2) {
			cin >> qs.back().i;
			--qs.back().i;
		}
	}

	std::sort(qs.begin(), qs.end(), [](auto& a, auto& b){
		return a.k < b.k;
	});

	vector<ll> ans(q);
	
	int pos = 0;
	int cur = 0;
	vector<ll> c1 = c;
	ll sum = 0;
	while(pos < q) {
		vector<int> add(n);
		for(int i = 0; i < n; ++i) {
			std::set<int> s;
			for(int j = 0; j < n; ++j)
				if(c1[j] > c1[i])
					s.insert(c1[j]);
			add[i] = s.size();
			sum += s.size();
		}
		for(int i = 0; i < n; ++i)
			c1[i] += add[i];
		for(; pos < q && qs[pos].k == cur; ++pos) {
			int t = qs[pos].t;
			int i = qs[pos].i;
			if(t == 1) {
				std::set<int> s;
				for(int i = 0; i < n; ++i)
					s.insert(c1[i]);
				ans[qs[pos].ind] = s.size();
			} else if (t == 2) {
				ans[qs[pos].ind] = sum;
			} else if (t == 3) {
				int ind;
				cin >> ind;
				--ind;
				ans[qs[pos].ind] = c1[ind];
			}
		}
	}

	return 0;
}
