#include <bits/stdc++.h>

using namespace std;

#define int long long 
#define all(c) (c).begin(), (c).end()

const int deb = 1;

struct robot {
	int l, r, c, t, i;
};

int best;

bool operator <(robot a, robot b) {
	int ra = a.r, rb = b.r;
	if (a.t == 1) ra = max(ra, best);
	if (b.t == 1) rb = max(rb, best);
	if (ra != rb) return ra < rb;
	return a.i < b.i;
}

int left(robot a) {
	int la = a.l;
	if (a.t == 1) la = min(la, best);
	return la;
}

int right(robot a) {
	int ra = a.r;
	if (a.t == 1) ra = max(ra, best);
	return ra;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int _t;
	cin >> _t;
	while (_t--) {
		best = 0;
		int n, m;
		cin >> n >> m;
		vector<int> vec(n);
		for (int &x: vec) cin >> x;
		vector<robot> rob(m);
		for (int i = 0; i < m; ++i) {
			int l, r, c, t;
			cin >> l >> r >> c >> t;
			--l;
			--r;
			rob[i] = {l, r, c, t, i};
		}
		for (best = 0; best < n; ++best) {
			sort(all(rob));
			for (int i = 0; i < m; ++i) rob[i].i = i;
			vector<int> ost(m);
			for (int i = 0; i < m; ++i) ost[i] = rob[i].c;
			set<robot> s;
			int cnt = 0;
			vector<vector<int>> inds(n);
			for (int i = 0; i < m; ++i) {
				inds[left(rob[i])].push_back(i);
			}
			vector<vector<int>> inder(n);
			for (int i = 0; i < m; ++i) {
				inder[right(rob[i])].push_back(i);
			}
			for (int i = 0; i < n; ++i) {
				for (int x: inds[i]) {
					s.insert(rob[x]);
				}
				int need = vec[i];
				while (need != 0 && s.size()) {
					robot rick = (*s.begin());
					while (right(rick) <= i && s.size()) {
						s.erase(s.begin());
						rick = (*s.begin());
					}
					if (!s.size()) break;
					int x = min(need, ost[rick.i]);
					need -= x; 
					ost[rick.i] -= x;
					if (ost[rick.i] == 0) s.erase(s.begin());
					cnt += x;
				}
				for (int x: inder[i]) {
					s.erase(rob[x]);
				}
			}
			cout << cnt << ' ';
		}
		cout << '\n';
	}
}