#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define ll long long
#define pii pair<int, int>
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define mp(x, y) make_pair(x, y)
#define mt make_tuple
#define sz(x) ((int) size(x))

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
bool ckmx(T& a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool ckmn(T& a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

const int infI = 1e9 + 7;
const ll infL = 2e18;
const ll mod = 98244353;
const int N = (300000) + 1;

ll pw[15];

void solve() {
    string ss;
    cin >> ss;
    int n = sz(ss);
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        a[i] = ss[i] - '0';
    }
    ll y;
    cin >> y;
    ll mx = LONG_LONG_MIN;
    vector<int> ans;
    vector<int> zz = a;
    sort(all(zz));
    do {
        vector<int> u = a;
        ll now = 0;
        ll gg = 1;
        for (int i = sz(zz) - 1; i > -1; --i) {
            now += gg * zz[i];
            gg *= 10;
        }
        assert(sz(zz) == sz(u));
        ll k = 0;
        for (int i = 0; i < sz(zz); ++i) {
            bool ok = false;
            for (int j = i; j < sz(zz); ++j) {
                if (u[j] == zz[i]) {
                    for (int g = j - 1; g >= i; --g) {
                        swap(u[g], u[g + 1]);
                        ++k;
                    }
                    ok = true;
                    break;
                }
            }
            assert(ok);
        }
        assert(u == zz);
        now -= k * y;
        if (now >= mx) {
            mx = now;
            ans = u;
        }
    } while (next_permutation(all(zz)));
    for (int x : ans) cout << x;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    pw[0] = 1;
    for (int i = 1; i <= 14; ++i) pw[i] = pw[i - 1] * 10;
    solve();
    return 0;
}
