#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 
#include <deque>


using namespace std;
typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n & 1)
		return a * bin_pow(a, n - 1);
	ll b = bin_pow(a, n / 2);
	return b * b;
}

void solve() {
	string s; cin >> s;
	ll y;
	cin >> y;
	int n = s.size();
	vector<set<int>>ind(10);
	for (int i = 0; i < s.size(); i++) {
		ind[s[i] - '0'].insert(i);
	}
	for (int i = 0; i < s.size(); i++) {
		ll win = 0, c = -1;
		for (int x = 9; x > s[i]-'0'; x--) {
			if (ind[x].empty())
				continue;
			int j = *ind[x].begin();
			ll win_now = -(j - i) * y;
			ll my_p = n - i - 1, p = n - j - 1;
			win_now += ll(x - (s[i] - '0')) * bin_pow(10, my_p) - ll(x - (s[i] - '0')) * bin_pow(10, p);
			if (win_now > win) {
				win = win_now;
				c = x;
			}
		}
		if (c != -1) {
			int j = *ind[c].begin();
			for (int k = j; k - 1 >= i; k--) {
				ind[s[k] - '0'].erase(k);
				ind[s[k - 1] - '0'].erase(k - 1);
				swap(s[k], s[k - 1]);
				ind[s[k] - '0'].insert(k);
				ind[s[k - 1] - '0'].insert(k - 1);
			}
		}
		ind[s[i] - '0'].erase(ind[s[i]-'0'].begin());
	}
	cout << s;
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}