#include <bits/stdc++.h>
#define int long long
using namespace std;

const int inf = 1e18;

vector<int> get_v() {
    string s;
    cin >> s;
    vector<int> t;
    for (auto &x: s) {
        t.push_back(x - '0');
    }
    return t;
}



const int maxn = 255;

int SUM[4 * maxn];

void build(int v = 1, int l = 0, int r = maxn) {
    if (l == r - 1) {
        SUM[v] = 0;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    SUM[v] = 0;
}

int get_sum(int tl, int tr, int v = 1, int l = 0, int r = maxn) {
    if (l >= tr || tl >= r)
        return 0;
    if (l >= tl && r <= tr) {
        return SUM[v];
    }
    int m = (l + r) / 2;
    return get_sum(tl, tr, 2 * v, l, m) + get_sum(tl, tr, 2 * v + 1, m, r);
}

void upd_sm(int i, int x, int v = 1, int l = 0, int r = maxn) {
    if (l == r - 1) {
        SUM[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        upd_sm(i, x, 2 * v, l, m);
    } else {
        upd_sm(i, x, 2 * v + 1, m, r);
    }
    SUM[v] = SUM[2 * v] + SUM[2 * v + 1];
}



struct node {
    int mx, i;
    node(int _x = 0, int _i = 0) {
        mx = _x;
        i = _i;
    }
};

node merge(node a, node b) {
    if (a.mx >= b.mx)
        return a;
    return b;
}

node MX[4 * maxn];

void build(vector<int> &b, int v = 1, int l = 0, int r = maxn) {
    if (l == r - 1) {
        MX[v] = { ( l < b.size() ? b[l] : -inf), l };
        return;
    }
    int m = (l + r) / 2;
    build(b, 2 * v, l, m);
    build(b, 2 * v + 1, m, r);
    MX[v] = merge(MX[2 * v], MX[2 * v + 1]);
}

node get_mx() {
    return MX[1];
}

void upd_mx(int i, int x, int v = 1, int l = 0, int r = maxn) {
    if (l == r - 1) {
        MX[v] = { x, i };
        return;
    }
    int m = (l + r) / 2;
    if (i < m)
        upd_mx(i, x, 2 * v, l, m);
    else
        upd_mx(i, x, 2 * v + 1, m, r);
    MX[v] = merge(MX[2 * v], MX[2 * v + 1]);
}

vector<int> rrrr;
int f(int m, vector<int> v, int y) {
    build();
    build(v);
    int n = v.size();
    int k = m;

    vector<int> res;

    while (k) {
        node nd = get_mx();
        if (nd.mx == -inf)
            break;
        int ind = nd.i - get_sum(0, nd.i);

        if (ind > k) {

            int newind = nd.i - k;
            for (int i = 0; i < n; ++i) {
                if (get_sum(i, i + 1)) continue;
                res.push_back(v[i]);
                if (res.size() == newind + 1) {
                     res.push_back(nd.mx);
                     upd_sm(nd.i, 1);
                }
            }

            break;
        }

        k -= ind;
        res.push_back(nd.mx);
        upd_mx(nd.i, -inf);
        upd_sm(nd.i, 1);
    }

    for (int i = 0; res.size() < n && i < n; ++i) {
        if (get_sum(i, i + 1))
            continue;
        res.push_back(v[i]);
    }

    int tt = 0;
    reverse(res.begin(), res.end());
    for (int i = res.size() - 1; i > -1; --i) {
        tt *= 10;
        tt += res[i];
    }

    reverse(res.begin(), res.end());
    rrrr = res;

    tt -= y * m;
    return tt;
}


signed main() {
    vector<int> v = get_v();
    int y; cin >> y;

    int l = 0, r = 1e5;
    for (int i = 0; i < 200; ++i) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        int f1 = f(m1, v, y);
        int f2 = f(m2, v, y);
        if (f2 >= f1)
            l = m1;
        else
            r = m2;
    }

    vector<int> ans;
    int mxm = 0;
    for (int i = 0; i <= v.size() * v.size(); ++i) {
        int ff = f(i, v, y);
        if (ff > mxm) {
            ans = rrrr;
            mxm = ff;
        } else if (ff == mxm) {
            ans = max(ans, rrrr);
        }
    }

    for (auto &x : ans) {
        cout << x;
    }

}