#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e18, SIZE = 10000 + 1;

vector<vector<int>> g;

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v), g[v].push_back(u);
    }
    deque<int> q = {0};
    vector<int> dist1(n, INF), dist(n, INF);
    for (int i : g[0]) dist[i] = 1;
    dist1[0] = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop_front();
        for (int k : g[u]) {
            dist[k] = min(dist1[k], dist1[u] + 1);
            for (int v : g[k]) {
                if (dist1[v] == INF) {
                    q.push_back(v);
                    dist1[v] = dist[k] + 1;
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (dist1[i] == INF) cout << -1 << " ";
        else cout << dist1[i] << " ";
    }
    cout << endl;
}

signed main() {
    int t;
    cin >> t;
    while (t--) solve();
}
