#include <bits/stdc++.h>
using namespace std;

struct Query {
    int type, k, i, id;
    void scan(int idd) {
        id = idd;
        cin >> type >> k;
        if (type == 3) {
            cin >> i;
            --i;
        }
        else
            i = 0;
    }
    bool operator < (const Query& other) const {
        if (k != other.k)
            return k < other.k;
        if (type != other.type)
            return type < other.type;
        return i < other.i;
    }
};

vector<int> make_uniq(const vector<pair<long long, int>>& a) {
    vector<int> uniq;
    int prev = -1;
    for (auto e : a) {
        if (e.first != prev) {
            uniq.push_back(e.first);
            prev = e.first;
        }
    }
    return uniq;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    //freopen("B.in", "r", stdin);
    //freopen("B.out", "w", stdout);
    int n, q_num;
    cin >> n >> q_num;
    vector<pair<long long, int>> expa(n);
    for (int  i = 0; i < n; ++i) {
        cin >> expa[i].first;
        expa[i].second = i;
    }
    sort(expa.begin(), expa.end());
    vector<Query> queries(q_num);
    for (int i = 0; i < q_num; ++i)
        queries[i].scan(i);
    sort(queries.begin(), queries.end());
    long long k = 0;
    vector<int> uniq = make_uniq(expa);
    long long sm = 0;
    vector<pair<int, long long>> ans;
    for (Query q :queries) {
        while (k < q.k) {
            int pt = 0;
            for (int i = 0; i < n; ++i) {
                while (pt < uniq.size() && uniq[pt] == expa[i].first)
                    ++pt;
                long long delta = uniq.size() - pt;
                expa[i].first += delta;
                sm += delta;
            }
            uniq = make_uniq(expa);
            ++k;
        }
        if (q.type == 1) {
            ans.push_back({q.id, uniq.size()});
        }
        else if (q.type == 2) {
            ans.push_back({q.id, sm});
        }
        else {
            for (int i = 0; i < n; ++i) {
                if (expa[i].second == q.i) {
                    ans.push_back({q.id, expa[i].first});
                    break;
                }
            }
        }
    }
    sort(ans.begin(), ans.end());
    for (auto a :ans)
        cout << a.second << '\n';
}
