#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;

struct Dsu {
	vector<ll> p;
	vector<ll> k;
	void init(ll n) {
		p.assign(n, 0);
		k.assign(n, 1);
		for (ll i = 0; i < n; i++) p[i] = i;
	}
	ll get(ll v) {
		if (v == p[v]) return v;
		p[v] = get(p[v]);
		return p[v];
	}
	bool unite_(ll a, ll b) {
		a = get(a), b = get(b);
		if (a == b) return 0;
		p[b] = a;
		k[a] += k[b];
		return 1;
	}
};

struct O {
	ll d, a, b;
	bool operator<(const O& other) const {
		return d < other.d;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, q;
	cin >> n >> q;
	vector<ll> c(n);
	for (ll i = 0; i < n; i++) cin >> c[i];
	sort(c.begin(), c.end());
	vector<ll> c1 = { c[0] };
	for (ll i = 1; i < n; i++) {
		if (c[i] != c[i - 1]) c1.push_back(c[i]);
	}
	swap(c, c1);
	vector<O> d;
	for (ll i = 1; i < c.size(); i++) {
		d.push_back({ c[i] - c[i - 1], c[i-1], c[i] });
	}
	sort(d.begin(), d.end());
	for (ll qq = 0; qq < q; qq++) {
		ll t, k;
		cin >> t >> k;
		if (t == 1) {
			cout << c.size() - (upper_bound(d.begin(), d.end(), k) - d.begin()) << "\n";
		}
		else if (t == 2) {
			map<ll, ll> mp;
			for (ll j = 0; j < c1.size(); j++) {
				mp[c1[j]]++;
			}
			ll p = 0;
			ll ans = 0;
			for (ll i = 0; i < d.size(); i++) {
				if (d[i].d > k) break;
				ll j = 0;
				ll ansl = 0;
				for (auto x : mp) {
					j++;
					ansl += x.second * (mp.size() - j);
				}
				ans += ansl * 
				mp[d[i].b] += mp[d[i].a];
				mp.erase(d[i].a);
				p = d[i].d;
			}
		}
		else if (t == 3) {
			ll x;
			cin >> x;
		}
	}
	return 0;
}