#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define pb push_back
#define eb emplace_back
#define fi first
#define se second
const int inf = (int)1e9 + 1;
struct segtree{
    vector<pair<int, int>> tree;
    int len;
    void init(vector<int> &a){
        int n = a.size();
        len = 1;
        while (len < n) len *= 2;
        tree.assign(2 * len, {-1, -1});
        for (int i = 0; i < a.size(); i++){
            tree[i + len] = {a[i], i};
        }
        for (int i = len - 1; i > 0; i--){
            tree[i] = max(tree[2 * i], tree[2 * i + 1]);
        }
    }
    pair<int, int> get(int v, int l, int r, int ql, int qr){
        if (max(ql, l) >= min(r, qr)){
            return {-1, -1};
        }
        if (ql <= l && r <= qr){
            return tree[v];
        }
        int m = (l + r) / 2;
        return max(get(2 * v, l, m, ql, qr), get(2 * v + 1, m, r, ql, qr));
    }
    pair<int, int> get(int l, int r){
        return get(1, 0, len, l, r + 1);
    }
    void update(int pos, int x){
        pos += len;
        tree[pos] = {x, pos - len};
        while (pos > 1){
            pos /= 2;
            tree[pos] = max(tree[2 * pos], tree[2 * pos + 1]);
        }
    }
};
int get_cnt(ll y){
    int cnt = 0;
    while (y > 0){
        cnt++;
        y /= 10;
    }
    return cnt;
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    string s;
    cin >> s;
    int n = s.size();
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        a[i] = s[i] - '0';
    }
    ll y;
    cin >> y;
    int m = get_cnt(y);
    for (int i = 0; i < n; i++){
        __int128_t best = 0;
        for (int j = 0; j < n; j++){
            best *= 10;
            best += a[j];
        }
        int ind = i;
        for (int j = i + 1; j < n; j++){
            int d = a[j], o = a[ind];
            vector<int> old = a;
            a.erase(a.begin() + j);
            a.insert(a.begin() + i, d);
            __int128_t cur = 0;
            for (int f = 0; f < n; f++){
                cur *= 10;
                cur += a[f];
            }
            __int128_t sb = y;
            cur -= sb * (j - i);
            if (best < cur){
                best = cur, ind = j;
            }
            else if (best == cur && o < d){
                best = cur, ind = j;
            }
            a = old;
        }
        int d = a[ind];
        a.erase(a.begin() + ind);
        a.insert(a.begin() + i, d);
    }
    for (int i : a){
        cout << i;
    }
}