#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(time(0));

typedef long long ll;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

template <typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void solve() {
    string x;
    ll y;

    cin >> x >> y;

    ll n = x.size();

    string ans;

    vector<deque<ll>> pos(10);
    for (ll i = 0; i < n; ++i) {
        pos[x[i] - '0'].push_back(i);
    }

    for (ll i = 0; i < n - 17; ++i) {
        for (ll j = 9; j >= 0; --j) {
            if (pos[j].size()) {
                ans += ('0' + j);
                pos[j].pop_front();
                break;
            }
        }
    }

    vector<ll> ost;

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j <= 9; ++j) {
            if (pos[j].size() && pos[j][0] == i) {
                ost.push_back(j);
                pos[j].pop_front();

                // cout << i << endl;
            }
        }
    }

//    if (ost.size() >= 10) {
//        cout << -1;
//        return;
//    }

    vector<ll> the_best = ost;
    ll now_vyig = 0;
    ll mnoggg = 1;

    for (ll i = the_best.size() - 1; i >= 0; --i) {
        now_vyig += the_best[i] * mnoggg;
        mnoggg *= 10;
    }

    for (ll qw = 0; qw < 250000; ++qw) {
        vector<ll> i(ost.size());
        ordered_set<ll> X;

        for (ll j = 0; j < ost.size(); ++j) {
            X.insert(j);
        }

        for (ll j = 0; j < ost.size(); ++j) {
            ll num = rnd() % X.size();

            i[j] = *X.find_by_order(num);
            X.erase(i[j]);
        }

        vector<deque<ll>> rt(10);
        for (ll j = 0; j < ost.size(); ++j) {
            rt[ost[j]].push_back(j);
        }

        ll loc_ans = 0;
        ll mnog = 1;

        for (ll j = i.size() - 1; j >= 0; --j) {
            loc_ans += ost[i[j]] * mnog;
            mnog *= 10;
        }

        for (ll j = 0; j < i.size(); ++j) {
            ll now = ost[i[j]];
            ll blig_pos = rt[now][0];
            loc_ans -= y * (blig_pos - j);
            if (loc_ans < 0) break;
            rt[now].pop_front();

            for (ll r = 0; r < 10; ++r) {
                for (ll g = 0; g < rt[r].size(); ++g) {
                    if (rt[r][g] < blig_pos) ++rt[r][g];
                }
            }
        }

        vector<ll> dop(the_best.size());
        for (ll j = 0; j < i.size(); ++j) dop[j] = ost[i[j]];

        if (loc_ans > now_vyig || (loc_ans == now_vyig && the_best < dop)) {
            now_vyig = loc_ans;
            the_best = dop;
        }
    }

    cout << ans;

    for (auto i : the_best) cout << i;
}

signed main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}