#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef string str;
typedef vector<bool> vb;
typedef vector<pii> vii;

void solve() {
    int n, m;
    cin >> n >> m;
    vi a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<pii> seg(m);
    vi c(m), t(m);
    for (int i = 0; i < m; i++) {
        cin >> seg[i].X >> seg[i].Y >> c[i] >> t[i];
        seg[i].X--;
        seg[i].Y--;
    }
    for (int x = 0; x < n; x++) {
        vi new_a = a;
        vector<pair<pii, int>> new_seg(m);
        for (int i = 0; i < m; i++) {
            if (t[i] == 1) {
                new_seg[i] = {{min(seg[i].X, x), max(seg[i].Y, x)}, c[i]};
            } else {
                new_seg[i] = {seg[i], c[i]};
            }
        }
        sort(all(new_seg));
        int now = 0;
        multiset<pair<pii, int>> mm;
        for (int i = 0; i < n; i++) {
            while (now < m && new_seg[now].X.X == i) {
                mm.insert({{new_seg[now].X.Y, new_seg[now].X.X}, new_seg[now].Y});
                now++;
            }
            while (!mm.empty()) {
                pair<pii, int> p = *mm.begin();
                mm.erase(mm.begin());
                if (p.Y <= new_a[i]) {
                    new_a[i] -= p.Y;
                } else {
                    mm.insert({p.X, p.Y - new_a[i]});
                    new_a[i] = 0;
                    break;
                }
            }
            while (!mm.empty() && (*mm.begin()).X.X == i) {
                mm.erase(mm.begin());
            }
        }
        int ans = 0;
        for (int i = 0; i < n; i++) {
            ans += a[i] - new_a[i];
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}