#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    string s;
    cin >> s;

    ll y;
    cin >> y;

    int n = s.length();
    vector <int> indexes(n);
    iota(indexes.begin(), indexes.end(), 0);

    auto get_penalty = [&] () {
        ll penalty = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (indexes[j] > indexes[i] && s[indexes[i]] != s[indexes[j]]) {
                    penalty += y;
                }
            }
        }

        return penalty;
    };

    auto long_swap = [&] (int l, int r) {
        for (int i = r - 1; i >= l; i--) {
            swap(indexes[i], indexes[i + 1]);
        }
    };

    auto undo_swap = [&] (int l, int r) {
        for (int i = l; i < r; i++) {
            swap(indexes[i], indexes[i + 1]);
        }
    };

    auto get_s = [&] () {
        string result;
        for (int i: indexes)
            result += s[i];
        return result;
    };

    ll ans = stoll(s);
    for (int i = 0; i < n; i++) {
        ll br = i, dt = ans;
        vector <bool> seen(10);
        for (int j = i + 1; j < n; j++) {
            long_swap(i, j);

            ll newdt = stoll(get_s()) - get_penalty();

            if (newdt > dt) {
                dt = newdt, br = j;
            }

            undo_swap(i, j);
        }

        long_swap(i, br);
        ans = stoll(get_s()) - get_penalty();
    }

    cout << get_s() << '\n';
    cout << ans << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
