#include <bits/stdc++.h>
using namespace std;

using ll = long long;
//#define int long long


void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            g[a - 1].push_back(b - 1);
            g[b - 1].push_back(a - 1);
        }
        deque<int> bfs;
        vector<int> dist(n, 1e9);
        dist[0] = 0;
        bfs.push_back(0);
        while (!bfs.empty()) {
            int nw = bfs.front();
            bfs.pop_front();
            for (auto to : g[nw]) {
                if (dist[nw] + 1 < dist[to]) {
                    dist[to] = dist[nw] + 1;
                    bfs.push_back(to);
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            if (dist[i] > n + 1) {
                cout << "-1 ";
            } else {
                cout << dist[i] + 2 * dist[i] % 2 << ' ';
            }
        }
        cout << '\n';
    }
}

signed main() {
#ifdef Debugg
    freopen(R"(C:\Users\roi\CLionProjects\untitled\ain.txt)", "r", stdin);
    freopen(R"(C:\Users\roi\CLionProjects\untitled\aout.txt)", "w", stdout);
#endif
    solve();
    return 0;
}
