#pragma GCC optimize("Ofast", "no-stack-protector")

#include <bits/stdc++.h>
#define int long long
#define endl "\n"
#define X first
#define Y second
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);

using namespace std;

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a)
        in >> it;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto &it : a)
        out << it << ' ';
    return out;
}

struct first_q {
    vector<int> diff;

    void init (vector<int>& c) {
        vector<int> b = c;
        sort(all(b));

        b.erase(unique(all(b)), b.end());

        for (int i = 0; i + 1 < b.size(); i++) {
            diff.push_back(b[i + 1] - b[i]);
        }


        sort(all(diff));
    }

    int get (int k) {
        return diff.end() - upper_bound(all(diff), k) + 1;
    }
};
const int MAXN = 1e7;
struct SegmentPersTree {
    struct node {
        int l, r;
        int sum;
        int mod;
    };


    vector<node> tree;
    int n;
    int ind = 0;
    void init (int sz) {
        tree.resize(MAXN);
        build(1, 0, sz);
        n = sz;
        ind = 4 * n;
    }

    void build (int v, int tl, int tr) {
        node a;
        a.sum = 0;
        a.mod = 0;
        a.l = -1;
        a.r = -1;

        if (tl == tr - 1) {
            tree[v] = a;
            return;
        }

        int tm = (tl + tr) / 2;
        a.l = 2 * v;
        a.r = 2 * v + 1;

        build(a.l, tl, tm);
        build(a.r, tm, tr);

        tree[v] = a;
    }

    int upd (int v, int tl, int tr, int l, int r, int diff) {
        if (tl >= tr || l >= tr || r <= tl) {
            return v;
        }

        node a = tree[v];
        if (l <= tl && tr <= r) {
            a.mod += diff;
            tree[ind] = a;
            return ind++;
        }

        int tm = (tl + tr) / 2;
        a.l = upd(a.l, tl, tm, l, r, diff);
        a.r = upd(a.r, tm, tr, l, r, diff);

        tree[ind] = a;
        return ind++;
    }

    int upd (int rt, int l, int r, int diff) {
        return upd(rt, 0, n, l, r, diff);
    }

    int get (int v, int tl, int tr, int pos) {
        if (tl >= tr || tr <= pos || tl > pos)
            return 0;

        if (tl == tr - 1)
            return tree[v].mod;

        int tm = (tl + tr) / 2;
        return get(tree[v].l, tl, tm, pos) + get(tree[v].r, tm, tr, pos) + tree[v].mod;
    }

    int get (int v, int pos) {
        return get(v, 0, n, pos);
    }
};


struct query {
    int l, r;
};
struct third_q {
    vector<int> c;
    vector<vector<int>> numbers;


    void init (vector<int>& a) {
        c = a;
        c.erase(unique(all(c)), c.end());
        sort(all(c));

        numbers.push_back(c);

        for (int i = 1; i <= 10; i++) {
            vector<int> a1 = numbers.back();
            for (int j = 0; j < a1.size(); j++) {
                set<int> how_many;
                for (int l = j + 1; l < a1.size(); l++) {
                    how_many.insert(a1[l]);
                }
                a1[j] += how_many.size();
            }
            numbers.push_back(a1);
//            cout << a1 << endl;
        }
    }

    int get (int k, int num) {
        return numbers[k][lower_bound(all(c), num) - c.begin()];
    }
};

struct second_q {
    vector<int> pref_sums;
    vector<int> sum;
    vector<int> diff;

    void init (vector<int>& c) {
        vector<int> fg = c;
        sort(all(fg));

        int last = fg[0];
        int cnt = 1;
        vector<pii> b;

        fg.push_back(-1);

        for (int i = 1; i < fg.size(); i++) {
            if (fg[i] == fg[i - 1]) {
                cnt++;
            }
            else {
                b.push_back({last, cnt});
                last = fg[i];
                cnt = 1;
            }
        }

        vector<int> sum_sz(b.size() + 1, 0);

        for (int i = 0; i < b.size(); i++) {
            sum_sz[i + 1] = sum_sz[i] + b[i].Y;
        }

        int f_sum = 0;
        for (int i = 0; i < b.size(); i++) {
//            cout << b[i].X << ' ' << b[i].Y << endl;
            f_sum += b[i].Y * (b.size() - i - 1);
        }

        sum.push_back(f_sum);

        fg.pop_back();
        fg.erase(unique(all(fg)), fg.end());

        for (int i = 0; i + 1 < fg.size(); i++) {
            diff.push_back(fg[i + 1] - fg[i]);
        }

//        cout << diff << endl;

        sort(all(diff));

        vector<int> sum1(diff.size(), 0);

        for (int i = 0; i + 1 < b.size(); i++) {
            int df = b[i + 1].X - b[i].X;
            int diff_sum = sum_sz[i + 1];

//            cout << df << ' ' << diff_sum << endl;
            int ind = lower_bound(all(diff), df) - diff.begin();
            sum1[ind] += diff_sum;
        }

        for (auto &it : sum1) {
            sum.push_back(sum.back() - it);
        }


        diff.push_back(0);
        sort(all(diff));



        pref_sums.push_back(0);
        for (int i = 1; i < diff.size(); i++) {
            int nm = pref_sums.back() + (diff[i] - diff[i - 1]) * sum[i - 1];
            pref_sums.push_back(nm);
        }

    }

    int get (int k) {
        if (k > diff.back())
            return pref_sums.back();

        auto it = upper_bound(all(diff), k);
        --it;

        int id = it - diff.begin();
        return pref_sums[id] + (k - diff[id]) * sum[id];
    }
};


signed main () {
    fast;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
#elif defined(LOCAL)
    freopen("./input.txt", "r", stdin);
#endif

    int n, q;
    cin >> n >> q;

    vector<int> c(n);
    cin >> c;

    first_q q1;
    q1.init(c);

    second_q q2;
    q2.init(c);

    third_q q3;
    q3.init(c);
//    return 0;


    while (q--) {
        int t;
        cin >> t;

        if (t == 1) {
            int k;
            cin >> k;

            cout << q1.get(k) << endl;
        }
        else if (t == 2) {
            int k;
            cin >> k;

            cout << q2.get(k) << endl;
        }
        else {
            int k, i;
            cin >> k >> i;

            cout << q3.get(k, c[i - 1]) << endl;
        }
    }

}

