#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("O3")
using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define int long long
#define fi first
#define se second

const int MX = 5e5 + 2022;
const int INF = 2e18;
/*=========================================*/
int n, m;
vector<int> g[MX];
set<pair<int, int>> br;

int up[MX], tin[MX], used[MX], timer = 0;
int used2[MX], res[MX], d[MX];

void dfs(int u, int p){
    up[u] = tin[u] = timer++;
    used[u] = 1;
    for (int v : g[u]){
        if (v == p) continue;
        if (used[v]){
            up[u] = min(up[u], tin[v]);
        } else {
            dfs(v, u);
            up[u] = min(up[u], up[v]);
            if (up[v] > tin[u]){
                br.insert({u, v});
                br.insert({v, u});
            }
        }
    }
}

void dfs2(int u){
    used2[u] = 1;
    for (int v : g[u]){
        if (br.find({u, v}) == br.end() && !used2[v]){
            dfs2(v);
        }
    }
}


void bfs(){
    deque<int> dq = {1};
    fill(d, d + n + 10, INF);
    d[1] = 0;
    while (!dq.empty()){
        int x = dq.front();
        dq.pop_front();
        for (int v : g[x]){
            if (used2[v] && d[v] > d[x] + 1){
                d[v] = d[x] + 1;
                dq.push_back(v);
            }
        }
    }
}

void solve(){
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
    }
   for (int i = 2; i <= n; i++){
       int x = i - 1, y = n - (i - 1);
       if (x > y) swap(x, y);
       if (x % 2 == 0) cout << x << " ";
       else if (y % 2 == 0) cout << y << " ";
       else cout << -1 << " ";
   }
   cout << "\n";
}

signed main(){
#ifndef LOCAL
    ios::sync_with_stdio(0), cin.tie(0);
#endif

    int Test = 1;
    cin >> Test;
    while (Test--) solve();
    return 0;
}