#include <bits/stdc++.h>

using namespace std;

long long to_int(string xs) {
	long long res = 0;
	for (char c : xs) {
		res = res * 10 + c - '0';
	}
	return res;
}

string to_str(long long x, int n) {
	string res = "";
	for (int i = 0; i < n; ++i) {
		res.push_back('0' + x % 10);
		x /= 10;
	}
	reverse(res.begin(), res.end());
	return res;
}

struct Fenwick {
	int n;
	vector<int> f;

	void add(int i, int val) {
		for (++i; i <= n; i += i & -i) {
			f[i] += val;
		}
	}

	int get(int i) {
		int res = 0;
		for (; i > 0; i -= i & -i) {
			res += f[i];
		}
		return res;
	}

	int get(int l, int r) {
		return get(r) - get(l);
	}

	Fenwick(int n) : n(n) {
		f = vector<int>(n + 1, 0);
	}
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	__int128 a = 123;
	cout << (long long)a << endl;
	return 0;	
}