#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vii = vector<int>;
using str = string;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (ll)(a).size()
#define ff first
#define ss second
#define pb push_back
#define forn(i, n) for (ll i = 0; i < n; ++i)
#define rforn(i, n) for (ll i = n - 1; i >= 0; --i)
#define endl '\n'

const ll Maxn = 5010;
const ll INF = 1e16;

struct event {
    ll tm, spd, sm;
};

vector<event> ap[Maxn];


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<pll> a(n);
    vll down(n);
    forn (i, n) {
        cin >> a[i].ff;
        down[i] = a[i].ff;
        a[i].ss = i;
    }
    sort(rall(a));
    ll last = a[0].ff;
    vll cur = {a[0].ss};
    vector<vll> to;
    vll b;
    vector<pair<ll, pll>> timer;
    for (ll i = 1; i < n; ++i) {
        if (a[i].ff == last) {
            cur.pb(a[i].ss);
            continue;
        }
        to.pb(cur);
        ll fr = last - a[i].ff;
        b.pb(fr);
        last = a[i].ff;
        cur = {a[i].ss};
    }
    to.pb(cur);
    reverse(all(b));
    reverse(all(to));
    vll s = b;
    sort(all(s));
    ll dlt = 0;
    forn (i, sz(to)) {
        ll cr = sz(to) - i - 1;
        dlt += sz(to[i]) * (sz(to) - i - 1);
        for (ll el : to[i]) {
            ap[el].pb({0, cr, 0});
        }
     }
    vector<event> pos;
    pos.pb({0, dlt, 0});
    for (ll i = 0; i < sz(s);) {
        ll tm = s[i];
        while (i < sz(s) && s[i]==tm) {
            ++i;
        }
        vector<vll> nto;
        vll nb;
        for (ll j = 0; j < sz(to); ++j) {
            vll ncnt = to[j];
            while (j < sz(b) && b[j] == tm) {
                for (ll el : to[j + 1]) ncnt.pb(el);
                ++j;
            }
            nto.pb(ncnt);
            if (j < sz(b) && b[j] != tm) {
                nb.pb(b[j]);
            }
        }
        b = nb;
        to = nto;
        dlt = 0;
        forn (j, sz(to)) {
            ll cr = sz(to) - j - 1;
            dlt += sz(to[j]) * (cr);
            for (ll el : to[j]) {
                ll ws = tm - ap[el].back().tm;
                ap[el].pb({tm, cr, ap[el].back().sm + ws * ap[el].back().spd});
            }
        }
        ll sss = (tm - pos.back().tm) * pos.back().spd;
        pos.pb({tm, dlt, pos.back().sm + sss});
    }
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll k;
            cin >> k;
            ll nu = upper_bound(all(s), k) - s.begin() - 1;
            cout << sz(s) - nu<< endl;
        } else if (t == 2) {
            ll k;
            cin >> k;
            ll lhs = 0;
            ll rhs = sz(pos);
            while (rhs - lhs > 1) {
                ll mid = (lhs + rhs) / 2;
                if (pos[mid].tm <= k) {
                    lhs = mid;
                } else {
                    rhs = mid;
                }
            }
            ll dl = k - pos[lhs].tm;
            cout << pos[lhs].sm + dl * pos[lhs].spd << endl;
        } else {
            ll k, i;
            cin >> k >> i;
            --i;
            ll lhs = 0;
            ll rhs = sz(ap[i]);
            while (rhs - lhs > 1) {
                ll mid = (lhs + rhs) / 2;
                if (ap[i][mid].tm <= k) {
                    lhs = mid;
                } else {
                    rhs = mid;
                }
            }
            ll dl = k - ap[i][lhs].tm;
            cout << down[i] + ap[i][lhs].sm + dl * ap[i][lhs].spd << endl;
        }

    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    // cin >> t;
    forn (i, t) solve();
    return 0;
}
