#include <bits/stdc++.h>
using namespace std;

#define int long long

int get_pow(int y) {
    int res = 0;
    int cur = 1;
    while (9*cur < y) {
        res++;
        cur *= 10LL;
    }
    return res;
}

int dec(int n) {
    int res = 1;
    for (int i = 0; i<n; ++i) res *= 10;
    return res;
}

int sz(int x) {
    if (x == 0) return 1;
    int res = 0;
    int cur = 1;
    while (x >= cur) {
        cur *= 10;
        res++;
    }
    return res;
}

string add_zeros(int n, int x) {
    int len = sz(x);
    string res = "";
    for (int i = 0; i<n; ++i) res += ' ';
    for (int i = 0; i<n-len; ++i) res[i] = '0';
    for (int i = n-1; i>=n-len; --i) {
        res[i] = ('0' + (x%10));
        x /= 10;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    string s;
    cin >> s;
    int n = s.size();
    vector <int> x(n);
    for (int i = 0; i<n; ++i) x[i] = (s[i] - '0');

    vector <int> cnt(10, 0);
    for (int i = 0; i<n; ++i) cnt[x[i]]++;


    int y;
    cin >> y;
    int k = get_pow(y);

    //cout << n << ' ' << k << endl;

    if (n <= k) {
        for (auto el: x) cout << el;
        cout << endl;
        return 0;
    }
    if (n == k+1) {
        int best_score = 0;
        int x_num = 0;
        int ibest = -1;
        for (int i = 0; i<n; ++i) x_num = (x_num*10) + x[i];
        for (int i = 0; i<k; ++i) {
            vector <int> x2 = x;
            int penalty = (i+1) * y;
            int score = 0;
            for (int j = i; j>=0; --j) {
                score += (x2[j+1] - x2[j]) * 9 * dec(k-1-j);
                swap(x2[j+1], x2[j]);
            }

            if (score - penalty >= best_score +- (ibest+1)*y) {
                best_score = score;
                ibest = i;
            }
        }
        cout << add_zeros(n, x_num + best_score) << endl;
        return 0;
    }
    set <pair <int,int>> digits;
    for (int i = 0; i<n; ++i) digits.insert({-x[i], i});
    for (int i = 0; i<n-k-1; ++i) {
        int d = -(digits.begin() -> first);
        digits.erase(digits.begin());
        cout << d;
    }
    set <pair <int,int>> d2;
    for (auto el: digits) d2.insert({el.second, -el.first});


    x.clear();
    for (auto el: d2) x.push_back(el.second);
    n = k+1;
    int best_score = 0;
    int x_num = 0;
    int ibest = -1;
    for (int i = 0; i<n; ++i) x_num = (x_num*10) + x[i];
    for (int i = 0; i<k; ++i) {
        vector <int> x2 = x;
        int penalty = (i+1) * y;
        int score = 0;
        for (int j = i; j>=0; --j) {
            score += (x2[j+1] - x2[j]) * 9 * dec(k-1-j);
            swap(x2[j+1], x2[j]);
        }
        if (score - penalty >= best_score +- (ibest+1)*y) {
            best_score = score;
            ibest = i;
        }
    }
    cout << add_zeros(n, x_num + best_score) << endl;
    return 0;

}
