#include <bits/stdc++.h>
using namespace std;

#define int long long

struct qu {
    int k, t, qnum, i;
    bool operator<(qu y) const {
        return make_tuple(k, t, qnum, i) < make_tuple(y.k, y.t, y.qnum, y.i);
    }
};

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    vector <pair<int,int>> srt(n);
    set<int> s;
    for (int i = 0; i<n; ++i) cin >> a[i];
    for (auto el: a) s.insert(el);
    for (int i = 0; i<n; ++i) {
        srt[i] = {a[i], i};
    }
    sort(srt.rbegin(), srt.rend());
    //for (auto el: srt) cout << el.first << ' ' << el.second << ", ";
    //cout << endl;
    //cout << endl;

    vector <int> ans(q);
    set <qu> b;
    for (int qnum = 0; qnum<q; ++qnum) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            b.insert({k,t,qnum, -1});
        }
        if (t == 2) {
            int k;
            cin >> k;
            b.insert({k,t,qnum, -1});
        }
        if (t == 3) {
            int k, i;
            cin >> k >> i;
            b.insert({k,t,qnum,i-1});
        }
    }

    int cur = 0;
    int total = 0;
    int cnt = 0;
    for (int pos = 1; pos<n; ++pos) if (srt[pos].first < srt[pos-1].first) cnt++;

    vector <int> add(n);

    for (auto query: b) {
        auto [k, t, qnum, i] = query;

        while (cur < k) {
            //cout << ':'; for (auto el: add) cout << el << ' ';
            //cout << endl;
            cur++;
            cnt = 0;
            for (int pos = 1; pos<n; ++pos) {
                if (srt[pos].first < srt[pos-1].first) cnt++;
                add[srt[pos].second] += cnt;
                total += cnt;
            }
            for (int pos = 1; pos<n; ++pos) srt[pos].first += add[srt[pos].second];
            cnt = 0;
            for (int pos = 1; pos<n; ++pos) {
                if (srt[pos].first < srt[pos-1].first) cnt++;
            }
        }
        //cout << k << ' ' << t << ' ' << qnum << ' ' << i << ' ' << total << endl;
        if (t == 1) {
            ans[qnum] = cnt+1;
        }
        if (t == 2) {
            ans[qnum] = total;
        }
        if (t == 3) {
            ans[qnum] = a[i] + add[i];
        }
    }
    for (int qnum = 0; qnum<q; ++qnum) {
        cout << ans[qnum] << "\n";
    }
    cout << endl;
    return 0;
}
