#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
vector<vector<long long>> t1, t2;
vector<long long> sc;
void build(int v, int tl, int tr) {
	t1[v] = {};
	for (int i = min(tr - 1, int(sc.size() - 2)); i >= tl; --i) {
		if (sc[i] != sc[i + 1]) t1[v].push_back(sc[i + 1] - sc[i]);
	}
	sort(t1[v].begin(), t1[v].end());
	t2[v].assign(t1[v].size() + 1, 0);
	for (int i = 0; i < t1[v].size(); ++i) t2[v][i + 1] = t2[v][i] + t1[v][i];
	if (tr - tl == 1) return;
	int tm = (tl + tr) / 2;
	build(2 * v + 1, tl, tm);
	build(2 * v + 2, tm, tr);
}
long long Ans(int v, int tl, int tr, int l, int r, long long k) {
	if (tl >= r || tr <= l) return 0;
	if (tl >= l && tr <= r) {
		int L = -1, R = t1[v].size();
		while (R - L > 1) {
			int m = (L + R) / 2;
			if (t1[v][m] > k) R = m;
			else L = m;
		}
		return t2[v][R] + k * (t1[v].size() - R);
	}
	int tm = (tl + tr) / 2;
	return Ans(2 * v + 1, tl, tm, l, r, k) + Ans(2 * v + 2, tm, tr, l, r, k);
}
int main() {
	int n, q;
	scanf("%d", n, q);
	vector<long long> c(n);
	for (int i = 0; i < n; ++i) scanf("%lld", &c[i]);
	sc = c;
	sort(sc.begin(), sc.end());
	vector<long long> d = {};
	for (int i = 1; i < n; ++i) {
		if (sc[i] != sc[i - 1]) {
			d.push_back(sc[i] - sc[i - 1]);
		}
	}
	sort(d.begin(), d.end());
	vector<pair<long long, long long>> d1 = {};
	for (int i = n - 2; i >= 0; --i) {
		if (sc[i] != sc[i + 1]) d1.push_back({ sc[i + 1] - sc[i], i + 1 });
	}
	sort(d1.begin(), d1.end());
	vector<long long> p1(d1.size() + 1, 0), p2(d1.size() + 1, 0);
	for (int i = 0; i < d1.size(); ++i) {
		p1[i + 1] = p1[i] + d1[i].first * d1[i].second;
		p2[i + 1] = p2[i] + d1[i].second;
	}
	t1.resize(4 * n);
	t2.resize(4 * n);
	build(0, 0, n);
	while (q--) {
		long long t, k, i;
		scanf("%lld %lld", &t, &k);
		if (t == 1) {
			int l = -1, r = d.size();
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (d[m] > k) r = m;
				else l = m;
			}
			printf("%lld\n", d.size() - r + 1);
		}
		else if (t == 2) {
			int l = -1, r = d1.size();
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (d1[m].first > k) r = m;
				else l = m;
			}
			printf("%lld\n", p1[r] + (p2.back() - p2[r]) * k);
		}
		else {
			scanf("%lld", &i);
			int l = -1, r = n;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (sc[m] >= c[i - 1]) r = m;
				else l = m;
			}
			printf("%lld\n", c[i - 1] + Ans(0, 0, n, r, n, k));
		}
	}
}