#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;

template <class T>
istream& operator >> (istream& in, vector <T> &a) {
    for (auto &el: a) in >> el;
    return in;
}

template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el: a) out << el;
    return out;
}

int n, m;
int solve(vector <int> a, vector <int> c, vector <pair <int, int> > b) {
    vector <array <int, 3> > v;
    vector <int> R(m);
    for (int i = 0; i < m; i++) {
        v.push_back({b[i].first, 1, i});
        v.push_back({b[i].second + 1, -1, i});
        R[i] = b[i].second + 1;
    }
    sort(v.begin(), v.end());
    int pt = 0;

    int ans = 0;
    set <pair <int, int> > st;
    for (int i = 0; i < n; i++) {
        while (pt < v.size() && v[pt][0] == i) {
            int ind = v[pt][2];
            if (v[pt][1] == -1) {
                st.erase({R[ind], ind});
            } else {
                st.insert({R[ind], ind});
            }
            pt++;
        }

        while (a[i] && st.size()) {
            int ind = st.begin() -> second;
            int d = min(a[i], c[ind]);
            ans += d;
            a[i] -= d;
            c[ind] -= d;
            if (c[ind] == d) st.erase(st.begin());
        }
    }

    return ans;
}


void full_solve() {
    cin >> n >> m;
    vector <int> a(n);
    cin >> a;
    vector <pair <int, int> > b(m);
    vector <int> c(m), t(m);

    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second >> c[i] >> t[i];
        b[i].first--;
        b[i].second--;
    }

    for (int i = 0; i < n; i++) {
        vector <pair <int, int> > now(m);
        for (int j = 0; j < m; j++) {
            if (t[j]) now[j] = {min(b[j].first, i), max(b[j].second, i)};
            else now[j] = b[j];
        }
        cout << solve(a, c, now) << " ";
    }
    cout << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        full_solve();
    }
}
