// #define __GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#define int long long
#define real long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define elif else if
#define pi M_PI
#define f first
#define s second
typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;


const int INF = 1e18, MOD = 1e9 + 7, RANDOM = chrono::steady_clock::now().time_since_epoch().count();
const real EPS = 1e-12;
mt19937 rng(RANDOM);


const int maxn = 10, maxn2 = 19;
int deg[maxn2];
string s;
int n, y;
int perm[maxn];
string answer;


int calc(){
	int ind[n]; iota(ind, ind + n, 0);
	int ans = 0;
	for (int i=0; i<n; ++i){
		ans += (ind[perm[i]] - i) * y;
		for (int j=0; j<n; ++j){
			if (ind[j] < i or ind[j] >= ind[perm[i]]) continue;
			++ind[j];
		}
		ind[perm[i]] = i;
	}
	return ans;
}


int search(){
	answer = s;
	int ans = 0;
	do{
		int cur = 0;
		for (int i=n - 1; i>=0; --i) cur += (s[perm[i]] - '0') * deg[n - i - 1];
		int d = calc();
		cur -= d;
		if (cur > ans){
			ans = cur;
			string q;
			for (int i=0; i<n; ++i) q += s[perm[i]];
			answer = q;
			// cerr << answer << " " << ans << "\n";
		}
	} while (next_permutation(perm, perm + n));
	return ans;
}


void debug(){
	cerr << "\n";

	cerr << "\n";
}


signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	deg[0] = 1;
	for (int i=1; i<maxn2; ++i) deg[i] = deg[i - 1] * 10;
	cin >> s >> y;
	n = s.size();
	iota(perm, perm + n, 0);
	int res = search();
	cerr << res << "\n";
	cout << answer;
}

/*

314599
17713

931459

*/