#ifndef ONPC
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <iostream>
#include <iomanip>
#include <cmath>
#include <utility>
#include <algorithm>
#include <numeric>
#include <string>
#include <sstream>
#include <vector>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <limits>
#include <random>
#include <functional>

using namespace std;
using ll = int64_t;
using ld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using vc = vector<char>;
using vvi = vector<vi>;
using ii = pair<int,int>;
using vii = vector<ii>;

#define all(x) (x).begin(), (x).end()
#define endl '\n'

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vll c(n);
    for (auto &e : c)
        cin >> e;
    sort(all(c));

    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            ll k;
            cin >> k;
            ll ans = 1;
            for (int i = 1; i < n; ++i) {
                if (c[i] - c[i - 1] > k)
                    ++ans;
            }
            cout << ans << endl;
        }
    }
}