#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(x) x.begin(),x.end()

struct Qs{
    int t,k;
    int id;

    Qs(int t,int k):t(t),k(k){};

    Qs(int t,int k,int id):t(t),k(k),id(id){};

    Qs(){};
};

int n,q;
vector<Qs> qs;
vector<int> incorrect(vector<int> a){
    vector<pair<int,int> > a2;
    for(int i=0;i<n;i++){
        a2.push_back({a[i],i});
    }

    sort(all(a));
    sort(all(a2));

    vector<int> ids(n);
    for(int i=0;i<n;i++){
        ids[a2[i].second] = i;
    }

    vector<vector<int> > arr;
    vector<int> arr2;
    int sm = 0;
    arr2.push_back(sm);

    while(true){
        arr.push_back(a);
        int cnt =0,last = -1;
        for(int i=n-1;i>=0;i--){
            if(a[i] != last){
                cnt++;
                last = a[i];
                a[i]+=cnt-1;
            }else{
                last = a[i];
                a[i]+=cnt-1;
            }
            sm+=cnt-1;
        }
        arr2.push_back(sm);

        if(cnt==1){
            break;
        }
    }

    vector<int> ans;
    for(int _i=0;_i<q;_i++){
        int t = qs[_i].t;

        if(t==1){
            int k = qs[_i].k;

            if(k<(int)arr.size()){
                int cnt = 0;
                int last = -1;
                for(int i=0;i<arr[k].size();i++){
                    if(arr[k][i]!=last){
                        cnt++;
                    }
                    last = arr[k][i];
                }

                ans.push_back(cnt);
            }else{
                ans.push_back(1);
            }
        }else if(t==2){
            int k = qs[_i].k;

            if(k<(int)arr2.size()){
                ans.push_back(arr2[k]);
            }else{
                ans.push_back(arr2[k]);
            }
        }else{
            int k =  qs[_i].k,id = qs[_i].id;

            if(k<(int)arr.size()){
                ans.push_back(arr[k][ids[id]]);
            }else{
                ans.push_back(arr[0].back());
            }
        }
    }

    return ans;
}

struct my_tree{
    vector<vector<int> > tree;
    vector<int> a;
    int n;

    my_tree(vector<int> &_a){
        a  = _a;
        n = (int)a.size();

        tree.assign(4*n,vector<int> ());
        build(0,0,n);
    }

    void build(int v,int l,int r){
        if(l+1==r){
            tree[v].push_back(a[l]);
            return;
        }
        int m = (l+r)/2;
        build(2*v+1,l,m);
        build(2*v+2,m,r);

        merge(all(tree[2*v+1]),all(tree[2*v+2]), back_inserter(tree[v]));
    }

    int getCntMore(int v,int l,int r,int L,int R,int x){
        if(r<=L||l>=R){
            return 0;
        }

        if(l>=L&&r<=R){
            int res= lower_bound(all(tree[v]),x)-tree[v].begin();

            return res;
        }
    }
};

struct node{
    node *l,*r;
    int sm = 0;
    int add = 0;

    node(){
        l = nullptr;
        r = nullptr;

        sm = 0;
        add = 0;
    }
};

struct my_tree2{
    void makeSons(node *v){
        if(v->l== nullptr){
            v->l = new node();
        }

        if(v->r== nullptr){
            v->r = new node();
        }
    }

    void push(node *v,int l,int r){
        if(l==r) return;
        if(v->add!=0){
            v->sm += (r-l)*v->add;

            makeSons(v);
            v->l->add += v->add;
            v->r->add += v->add;

            v->add = 0;
        }
    }

    void update(node *v,int l,int r,int L,int R,int x){
        push(v,l,r);
        if(r<=L||l>=R){
            return;
        }

        if(l>=L&&r<=R){
            v->add+=x;
            push(v,l,r);
            return;
        }

        int m = (l+r)/2;
        makeSons(v);
        update(v->l,l,m,L,R,x);
        update(v->r,m,r,L,R,x);

        push(v->l,l,m);
        push(v->r,m,r);
        v->sm = v->l->sm + v->r->sm;
    }

    int getAns(node *v,int l,int r,int L,int R){
        push(v,l,r);
        if(r<=L||l>=R){
            return 0;
        }

        if(l>=L&&r<=R){
            return v->sm;
        }

        int m = (l+r)/2;
        makeSons(v);
        int res = getAns(v->l,l,m,L,R) + getAns(v->r,m,r,L,R);

        push(v->l,l,m);
        push(v->r,m,r);
        v->sm = v->l->sm + v->r->sm;
        return res;
    }
};

vector<int> correct(vector<int> a){
    vector<int> dp1(n);
    int cnt = 0,last = -1;
    sort(all(a));
    int sm_all = 0;
    for(auto i:a){
        sm_all+=i;
    }

    for(int i=n-1;i>=0;i--){
        if(a[i]!=last){
            cnt++;
        }
        dp1[i] = (a.back()-a[i])-(cnt-1);
    }

    vector<int> dif(n,0);
    dif[0] = 1;
    for(int i=1;i<n;i++){
        if(a[i]!=a[i-1]){
            dif[i]=dif[i-1]+1;
        }else{
            dif[i] = dif[i-1];
        }
    }
    vector<int> dif2(n,0);
    my_tree2 tree;
    node *root = new node();
    int sz = 1e0+100;

    for(int i=0;i<n-1;i++){
        dif2[i] = a[i+1]-a[i];
        tree.update(root,0,sz,0,dif2[i]+1,i+1);
    }

    vector<int> dif_arr = dif2;
    sort(all(dif_arr));

    vector<int> pref_dif(n+1,0),suf_dif(n+1,0);
    for(int i=1;i<pref_dif.size();i++){
        pref_dif[i] = pref_dif[i-1]+dif_arr[i-1];
        suf_dif[i] = suf_dif[i-1]+dif_arr[n-i];
    }


    vector<int> ans;
    for(int _i=0;_i<q;_i++){
        int t= qs[_i].t;

        if(t==1){
            int k = qs[_i].k;

            int res = (int)dif_arr.size()-(upper_bound(all(dif_arr),k)-dif_arr.begin());
            ans.push_back(res+1);
        }else if(t==2){
            int k = qs[_i].k;

            int res = tree.getAns(root,0,sz,1,k+1);
            ans.push_back(res);
        }else{

        }
    }

    return ans;

}

signed main() {
    ios::ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("input.txt","r",stdin);
#endif

    cin>>n>>q;

    vector<int> a(n);
    for(int i=0;i<n;i++){
        cin>>a[i];
    }

    qs.clear();
    for(int _i=0;_i<q;_i++){
        int t;
        cin>>t;

        if(t==1){
            int k;
            cin>>k;

            qs.push_back(Qs(t,k));
        }else if(t==2){
            int k;
            cin>>k;

            qs.push_back(Qs(t,k));
        }else{
            int k,id;
            cin>>k>>id;
            id--;

            qs.push_back(Qs(t,k,id));
        }
    }

    vector<int> ans;
    ans = correct(a);
    for(auto i:ans){
        cout<<i<<endl;
    }
}
