#include "bits/stdc++.h"

using namespace std;

typedef unsigned long long ull;

int n, m;
vector<vector<int>> g;
vector<bool> used;
int pos;
vector<int> ans;

queue<int> q;

void dfs(int v, int st) {
    used[v] = true;
    //cout << v << '\n';
    for(auto u: g[v]) {
        if(used[u]) continue;
        if(u == pos) {
            if(ans[v] == -1) {
                ans[v] = ans[st] + 2;
                q.push(v);
            }
            continue;
        }
        dfs(u, st);
    }
}

int main() {
    int t;
    cin >> t;
    for(int q1 = 0; q1 < t; ++q1) {
        cin >> n >> m;
        g.resize(n);
        used.resize(n);
        ans.resize(n);
        for(int i = 0; i < n; ++i) {
            g[i] = {};
            used[i] = false;
            ans[i] = -1;
        }
        for(int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            --a; --b;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        ans[0] = 0;
        q.push(0);
        while(!q.empty()) {
            int v = q.front();
            q.pop();
            //cout << v << '\n';
            for(auto u: g[v]) {
                pos = u;
                //cout << "POS: " << pos << '\n';
                for(int i = 0; i < n; ++i) used[i] = false;
                dfs(v, v);
            }

        }
        for(int i = 1; i < n; ++i) cout << ans[i] << ' ';
        cout << '\n';
    }
    return 0;
}
/*
4
4 4
1 2
2 3
3 4
4 1
5 5
1 2
2 3
3 4
4 5
5 1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3


1
4 4
1 2
2 3
3 4
4 1

*/