// KiruxaLight
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector <int> a(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
		}
		vector <tuple <int, int, int, int>> p(m);
		for (int i = 0; i < m; ++i) {
			int l, r, c, t;
			cin >> l >> r >> c >> t;
			--l, --r;
			p[i] = make_tuple(l, r, c, t);
		}
		for (int x = 0; x < n; ++x) {
			vector <tuple <int, int, int, int>> p1 = p;
			for (int i = 0; i < m; ++i) {
				if (get<3>(p1[i]) == 1) {
					int& l = get<0>(p1[i]);
					int& r = get<1>(p1[i]);
					l = min(l, x);
					r = max(r, x);
				}
			}
			sort(all(p1), [&](const tuple <int, int, int, int>& one, const tuple <int, int, int, int>& two) {
				return get<1>(one) < get<1>(two);
				});
			vector <int> b = a;
			int ans = 0;
			vector <int> ukaz(n);
			for (int i = 0; i < n; ++i) {
				ukaz[i] = i;
			}
			for (int i = 0; i < m; ++i) {
				int& c = get<2>(p1[i]);
				int l = get<0>(p1[i]);
				int r = get<1>(p1[i]);
				for (int j = l; j <= r; ++j) {
					if (c == 0) {
						break;
					}
					while (b[j] == 0) {
						j = ukaz[j];
					}
					if (j > r) {
						break;
					}
					int add = min(b[j], c);
					c -= add;
					b[j] -= add;
					if (b[j] == 0) {
						if (j + 1 < n) {
							ukaz[j] = ukaz[j + 1];
						}
					}
					ans += add;
				}
			}
			cout << ans << " ";
		}
		cout << "\n";
	}
}