#include <bits/stdc++.h>
//#define int long long

using namespace std;

const int maxn = 1e6 + 228;

vector<int> g[maxn];

void solve(){
    int n, m;
    cin >> n >> m;
    for(int i=0; i<n * 2 + 2; i++)
        g[i].clear();
    for(int i=0; i<m; i++){
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a * 2].push_back(b * 2 + 1);
        g[a * 2 + 1].push_back(b * 2);
        g[b * 2].push_back(a * 2 + 1);
        g[b * 2 + 1].push_back(a * 2);
    }
    queue<int> q;
    vector<int> dist(n * 2 + 2, -1);
    dist[0] = 0;
    q.push(0);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(int i:g[v]){
            if(dist[i] == -1 || dist[i] > dist[v] + 1){
                dist[i] = dist[v] + 1;
                q.push(i);
            }
        }
    }
    for(int i=1; i<n; i++){
        cout << dist[i * 2] << " ";
    }
    cout << endl;
}

/*
1
4 3
3 3 2 2
1 2 2 0
3 3 3 0
2 2 4 1
 */

signed main() {
    int q;
    cin >> q;
    while(q-->0){
        solve();
    }
    return 0;
}