#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for(int i=0; i<n; i++){
        cin >> a[i];
    }
    vector<vector<int>> segs(m);
    for(int i=0; i<m; i++){
        int l, r, c, t;
        cin >> l >> r >> c >> t;
        r--, l--;
        segs[i] = {r, l, c, t};
    }
    for(int i=0; i<n; i++){
        priority_queue<vector<int>> q;
        vector<vector<int>> to_push(n);
        for(int j=0; j<m; j++){
            int l = segs[j][1];
            if(segs[j][3] == 1)
                l = min(l, i);
            to_push[l].push_back(j);
        }
        int ans = 0;
        for(int j=0; j<n; j++){
            for(int l:to_push[j]){
                vector<int> psh = segs[l];
                if(psh[3] == 1){
                    psh[0] = max(psh[0], i);
                    psh[1] = min(psh[1], i);
                }
                psh[0] = -psh[0];
                q.push(psh);
            }
            while(q.size() && -q.top()[0] < j) {
                q.pop();
            }
            int add = 0;
            while(q.size() && add < a[j]){
                vector<int> v = q.top();
                q.pop();
                if(v[2] > a[j] - add){
                    v[2] -= a[j] - add;
                    add = a[j];
                    q.push(v);
                } else{
                    add += v[2];
                }
            }
            ans += add;
        }
        cout << ans << " ";
    }
    cout << endl;
}

/*
1
4 3
3 3 2 2
1 2 2 0
3 3 3 0
2 2 4 1
 */

signed main() {
    int q;
    cin >> q;
    while(q-->0){
        solve();
    }
    return 0;
}
