#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int> > costs;
vector<int> per;

void generate_next() {
    int l = per.size() - 1;
    while (per[l - 1] > per[l]) {
        l--;
    }
    l--;
    int r = per.size() - 1;
    while (per[r] < per[l]) {
        r--;
    }
    swap(per[r], per[l]);
    l++;
    r = per.size() - 1;
    while (r - l > 0) {
        swap(per[r], per[l]);
        r--;
        l++;
    }
}
string get_str(string s) {
    string t;
    for (int i = 1; i < per.size(); ++i) {
        t += s[per[i] - 1];
    }
    return t;
}

bool is_lower(string s, string t) {
    for (int i = 0; i < min(s.size(), t.size()); ++i) {
        if (s[i] < t[i]) {
            return true;
        }
        if (s[i] > t[i]) {
            return false;
        }
    }
    if (s.size() < t.size()) {
        return true;
    }
    return false;
}

long long get_ans(string t, long long x) {
    long long ans = 0;
    long long st = 1;
    for (int i = t.size() - 1; i >= 0; --i) {
        ans += st * (t[i] - '0');
        st *= 10;
    }
    long long k = 0;
    for (int i = 0; i < per.size(); ++i) {
        k += abs(i - per[i]);
    }
    k /= 2;
    return ans - x * k;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    long long y;
    cin >> y;
    int n = s.size();
    if (n <= 9) {
        per.resize(n + 1);
        for (int i = 0; i < n + 1; ++i) {
            per[i] = i;
        }
        string ans = s;
        long long answer = get_ans(s, y);
        while (per[0] == 0) {
            /*for (int i = 0; i < per.size(); ++i) {
                cout << per[i] << ' ';
            }
            cout << endl;*/

            string t = get_str(s);
            long long p = get_ans(t, y);
            if (p > answer || (p == answer && is_lower(t, ans))) {
                ans = t;
                answer = p;
            }
            generate_next();
        }
        cout << ans;
    }
    else {
        vector<int> data(n);
        for (int i = 0;  i< n; ++i) {
            data[i] = s[i] - '0';
        }
        sort(data.begin(), data.end());
        for (int i = 0; i < n; ++i) {
            cout << data[i];
        }
    }
    return 0;
}
