#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

int calc(vector<int> a, array<vector<int>, 10> pos) {
	int n = a.size();
	int cnt = 0;
	array<int, 10> it;
	fill(all(it), 0);
	for (int i = 0; i < n; ++i) {
		cnt += abs(i - pos[a[i]][it[a[i]]]);
		++it[a[i]];
	}
	return cnt;
}

long long to_int(vector<int> a) {
	int n = a.size() - 1;
	long long pow = 1;
	for (int i = 1; i <= n; ++i)
		pow *= 10;
	long long ans = 0;
	for (int i = 0; i <= n; ++i) {
		ans += a[i] * pow;
		pow /= 10;
	}
	return ans;
}

int main() {
	#ifndef LOCAL
		ios_base::sync_with_stdio(0);
		cin.tie(0);
	#endif

	string s;
	cin >> s;
	int n = s.size();
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		a[i] = s[i] - '0';
	long long x;
	cin >> x;
	array<vector<int>, 10> pos;
	for (int i = 0; i < n; ++i) {
		pos[a[i]].push_back(i);
	}
	array<int, 10> it;
	fill(all(it), 0);
	for (int i = 0; i <= n - 12; ++i) {
		for (int j = 0; j < 10; ++j) {
			if (it[j] != (int) pos[j].size()) {
				++it[j];
				cout << j;
			}
		}
	}
	vector<int> ost;
	for (int i = n - 1; i >= 0; --i) {
		if (it[a[i]] != (int) pos[a[i]].size()) {
			ost.push_back(a[i]);
			--it[a[i]];
		}
	}
	reverse(all(ost));
	array<vector<int>, 10> _pos;
	for (int i = 0; i < (int) ost.size(); ++i) {
		_pos[ost[i]].push_back(i);
	}
	sort(all(ost));
	pair<long long, string> ans = {-1, ""};
	do {
		int cnt = calc(ost, _pos);
		string tmp;
		for (int i : ost)
			tmp += (char) ('0' + i);
		ans = max(ans, {to_int(ost) - 1ll * x * cnt, tmp});
	} while (next_permutation(all(ost)));
	cout << ans.second << '\n';
}