#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 5e3 + 100, K = 8, INF = 1e18;

int t, n, m, dist[N], ban, fr, tt;
bool used[N];
vector<int> a[N];
set<int> go[N][N];

void dfs(int v) {
    go[fr][tt].insert(v);
    used[v] = true;
    for (int to : a[v]) {
        if (used[to] || to == ban) continue;
        dfs(to);
    }
}

void solve() {
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            a[i].clear();
            dist[i] = INF;
        }
        for (int i = 0; i < m; i++) {
            int f, s;
            cin >> f >> s;
            f--, s--;
            a[f].push_back(s);
            a[s].push_back(f);
        }
        for (int i = 0; i < n; i++) {
            for (int to : a[i]) {
                if (go[i][to].empty()) {
                    fill(used, used + n, false);
                    ban = to;
                    fr = i;
                    tt = to;
                    dfs(i);
                }
            }
        }
        queue<int> q;
        q.push(0);
        dist[0] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int to : a[v]) {
                for (int to2 : a[to]) {
                    if (dist[to2] == INF && go[v][to].count(to2)) {
                        dist[to2] = dist[v] + 2;
                        q.push(to2);
                    }
                }
            }
        }
        for (int i = 1; i < n; i++) {
            if (dist[i] != INF) {
                cout << dist[i] << " ";
            } else {
                cout << -1 << " ";
            }
        }
        cout << '\n';
    }
}