#include <iostream>
#include <vector>
#include <algorithm>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pair<long long, int>> a(n), t(n);
    vector<long long> b(n), c(n), d(n);
    vector<int> p(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i + 1;
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; ++i)
        p[a[i].second] = i;

    for (int i = 1; i < n; ++i) {
        t[i].first = a[i].first - a[i - 1].first;
        t[i].second = i;
    }
    sort(t.begin(), t.end());
    d[0] = (long long)n * (n - 1) / 2;
    for (int i = 1; i < n; ++i) {
        b[i] = t[i].first;
        d[i] = d[i - 1] - t[i].second;
        c[i] = c[i - 1] + d[i - 1] * (b[i] - b[i - 1]);
    }

    while (q--) {
        int type;
        long long k;
        cin >> type >> k;
        int m = upper_bound(b.begin(), b.end(), k) - b.begin() - 1;
        if (type == 1) {
            cout << n - m << '\n';
        } else if (type == 2) {
            cout << c[m] + d[m] * (k - b[m]) << '\n';
        } else {
            cout << 4 << '\n';
        }
    }
    return 0;
}