#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define int ll
#define pii pair<int, int>
#define vi vector<int>
#define f first
#define s second
#define pb push_back

using namespace std;

mt19937 rnd(time(0));

struct node {
    node *l, *r;
    int x, y;
    int sum = 0;
    int cnt = 0;
    int func = 0;
    int sz = 0;
    node(int x, int cnt) : x(x), y(rnd()), l(0), r(0), cnt(cnt), sz(1), sum(cnt), func(0) {

    }
};

int getSum(node *v) {
    return v ? v->sum : 0;
}

int getSize(node *v) {
    return v ? v->sz : 0;
}

int getFunc(node *v) {
    return v ? v->func : 0;
}

void upd(node *v) {
    assert(v);
    v->sum = getSum(v->l) + getSum(v->r) + v->cnt;
    v->sz = getSize(v->l) + getSize(v->r) + 1;
    v->func = getFunc(v->l) + getSum(v->l) * (1 + getSize(v->r)) + getFunc(v->r) + v->cnt * getSize(v->r);
}

pair<node*, node*> split(node *v, int x) {
    if (!v)
        return {0, 0};
    if (v->x <= x) {
        auto p = split(v->r, x);
        v->r = p.f;
        upd(v);
        return {v, p.s};
    } else {
        auto p = split(v->l, x);
        v->l = p.s;
        upd(v);
        return {p.f, v};
    }
}

node* merge(node *a, node *b) {
    if (!a)
        return b;
    if (!b)
        return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        upd(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}
int getmin(node *v) {
    if (!v)
        assert(false);
    if (v->l)
        return getmin(v->l);
    return v->x;
}

int getmax(node *v) {
    if (!v)
        assert(false);
    if (v->r)
        return getmax(v->r);
    return v->x;
}

//struct mst {
//    vector<vector<pii>> t;
//    int n;
//    mst(int n, vi &a) : n(n) {
//        t.resize(4 * n);
//        build(1, 0, n - 1, a);
//    }
//    void build(int v, int tl, int tr, vi &a) {
//        if (tl == tr) {
//            t[v] = {a[tl], a[tl]};
//        } else {
//            int tm = (tl + tr) / 2;
//            build(2 * v, tl, tm, a);
//            build(2 * v + 1, tm + 1, tr, a);
//            merge(t[2 * v].begin(), t[2 * v].end(), t[2 * v + 1].begin(), t[2 * v + 1].end(), back_inserter(t[v]));
//            for (int i = 0; i < t[v].size(); ++i) {
//                t[v][i].s = t[v][i].f;
//                if (i)
//                    t[v][i].s += t[v][i].s - 1;
//            }
//        }
//    }
//
//    auto get = [&] (int l, int r, int k) {
//
//    };
//};

void solve() {
    int n, q;
    cin >> n >> q;
    vi a(n);
    for (auto &i : a)
        cin >> i;
    vector<pii> qs[2];
    vector<tuple<int, int, int>> qs3;
    for (int i = 0; i < q; ++i) {
        int t, k;
        cin >> t >> k;
        t--;
        if (t <= 1) {
            qs[t].pb({k, i});
        } else {
            int j;
            cin >> j;
            j--;
            qs3.pb({k, j, i});
        }
    }
    int ans[q];
    memset(ans, -1, sizeof(ans));
    vi sa = a;
    sort(sa.begin(), sa.end());
    map<int, int> cnt;
    for (auto &i : a)
        cnt[i]++;
    sa.resize(unique(sa.begin(), sa.end()) - sa.begin());
    for (int i = 1; i < sa.size(); ++i) {
        qs[1].pb({sa[i] - sa[i - 1], ~sa[i - 1]});
    }
    for (int i = 0; i < 2; ++i) {
        sort(qs[i].begin(), qs[i].end());
    }
    auto solveqs0 = [&] {
        vi b;
        for (int i = 1; i < sa.size(); ++i) {
            if (sa[i] - sa[i - 1] != 0)
                b.pb(sa[i] - sa[i - 1]);
        }
        int dif = b.size() + 1;
        sort(b.begin(), b.end());
        for (int i = 0; i < qs[0].size(); ++i) {
            int k = qs[0][i].f;
            int j = qs[0][i].s;
            int cnt = upper_bound(b.begin(), b.end(), k) - b.begin();
            ans[j] = dif - cnt;
        }
    };

    auto solveqs1 = [&] {
        node *root = 0;
        int func = 0;
        for (int i = 0; i < sa.size(); ++i) {
            root = merge(root, new node(sa[i], cnt[sa[i]]));
            func += cnt[sa[i]] * (sa.size() - i - 1);
        }
//        cout << func << endl;
        int answer = 0;
        int last = 0;
        for (auto &[k, j] : qs[1]) {
            answer += func * (k - last);
            last = k;
            if (j < 0) {
                j = ~j;
                auto p = split(root, j);
//                cout << ' ' << func << endl;
                int gmin = getmin(p.s);
                int gmax = getmax(p.f);
                int sz = getSize(p.s);
                auto p2 = split(p.s, gmin);
                auto p0 = split(p.f, gmax - 1);
                p0.s->cnt += p2.f->cnt;
                upd(p0.s);
                root = merge(merge(p0.f, p0.s), p2.s);
                func = getFunc(root);
            } else {
                ans[j] = answer;
            }
        }
    };

    auto solveqs2 = [&] {
        sort(qs3.begin(), qs3.end(), [&] (auto b, auto c) {
            auto [k1, i1, q1] = b;
            auto [k2, i2, q2] = c;
            if (a[i1] != a[i2])
                return a[i1] > a[i2];
            return make_pair(k1, q1) < make_pair(k2, q2);
        });
        node* root = 0;
        int it = int(sa.size()) - 2;
        for (auto [k, i, qi] : qs3) {
            while (it >= 0 && sa[it] >= a[i]) {
                auto p = split(root, sa[it + 1] - sa[it]);
                root = merge(p.f, merge(new node(sa[it + 1] - sa[it], sa[it + 1] - sa[it]), p.s));
                it--;
            }
            auto p = split(root, k);
            int dif = getSum(p.f) + k * getSize(p.s);
//            cout << qi << ' ' << a[i] + dif << endl;
            ans[qi] = a[i] + dif;
            root = merge(p.f, p.s);
        }
    };

    solveqs0();
    solveqs1();
    solveqs2();


    for (int i = 0; i < q; ++i) {
        cout << ans[i] << '\n';
    }

}

signed main() {
    cin.tie(0);
    std::ios_base::sync_with_stdio(0);
    int t;
    t = 1;
    solve();
    return 0;
}
