#include <bits/stdc++.h>
#define int long long
#define ff first
#define ss second

using namespace std;

const int INF = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttt;
    cin >> ttt;
    while (ttt--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n), edge(n, vector<int> (n, 0));
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            g[u].push_back(v);
            g[v].push_back(u);
            edge[u][v] = 1;
            edge[v][u] = 1;
        }
    	deque<pair<int, int>> q;
        vector<vector<int> > d(n, vector<int>(n + 1, INF));
        vector<int> ans(n, INF);
        d[0][n] = 0;
        q.push_front({0, n});
        while (!q.empty()) {
            auto t = q.front();
            int u = t.ff;
            int v = t.ss;
            q.pop_front();
            if (u != 0 && v == n && ans[u] == INF) {
                ans[u] = d[u][v];
            }
            if (v == n) {

            	for (int to : g[u]) {
            		if (d[u][to] == INF) {
            			d[u][to] = d[u][v] + 1;
            			q.push_back({u, to});
            		}
            	}
            } else {
            	if (edge[u][v]) {
            		if (d[u][n] == INF) {
            			d[u][n] = d[u][v] + 1;
            			q.push_back({u, n});
            		}
            	}
           		for (int to : g[u]) {
           			if (v != to && d[to][v] == INF) {
           				d[to][v] = d[u][v];
           				q.push_front({to, v});
           			}
           		}

            }

        }
        for (int i = 1; i < n; i++) {
        	if (ans[i] != INF) {
	        	cout << ans[i] << " ";
	        } else {
	        	cout << "-1 ";
	        }
        }
        cout << "\n";
    }
}

