#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define pb emplace_back
#define sz(x) (x).size()
#define all(x) (x).begin(), (x).end()
#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

const int N = 3e5 + 10;
const int INF = 2e9 + 10;

int n, q, s = 1;
ll a[N], b[N], bb[N], iz[N], mas[N];
vector<ll> suf[4 * N], tr[4 * N];

ll func(ll k) {
    ll ret = 0;
    for (int i = 0; i < n; ++i)
        bb[i] = b[i];

    while (k--) {
        ll pref = 0;
        for (int i = n - 1; i >= 0; --i) {
            if (!bb[i]) ret += pref;
            else {
                ++pref;
                ret += pref;
                --bb[i];
            }
        }
    }
    return ret;
}

ll funct(ll k, int i) {
    ll lvl = a[i];
    for (int j = 0; j < n; ++j)
        bb[j] = b[j];
    while (k--) {
        ll pl = 0;
        for (int j = n - 1; j >= i; --j) {
            if (!bb[j]) continue;
            ++pl;
            --bb[j];
        }
        lvl += pl;
    }
    return lvl;
}

void merge(vector<ll> &v, vector<ll> &S, vector<ll> &l, vector<ll> &r) {
    int pl = 0, pr = 0;
    ll sum = 0;
    while (pl < sz(l) || pr < sz(r)) {
        if (pr == sz(r) || (pl < sz(l) && l[pl] < r[pr]))
            v.pb(l[pl++]);
        else v.pb(r[pr++]);
        sum += v.back();
        S.pb(sum);
    }
}

void build() {
    for (int i = s - 1; i; --i)
        merge(tr[i], suf[i], tr[i << 1], tr[i << 1 | 1]);
}

ll f(int v, ll k) {
    int l = -1, r = sz(tr[v]);
    while (r - l > 1) {
        int m = (l + r) >> 1;
        (tr[v][m] <= k ? l : r) = m;
    }

    int gt = 0;
    if (l >= 0) gt = suf[v][l];
    return gt + (sz(tr[v]) - r) * k;
}

ll get(ll val, ll k) {
    int l = 0, r = n;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        (a[m] <= val ? l : r) = m;
    }

    l += s;
    r = 2 * s - 1;
    ll ret = 0;

    while (l <= r) {
        if (l & 1) ret += f(l, k);
        l = (l + 1) >> 1;
        r = (r - 1) >> 1;
    }
    return ret;
}

signed main() {
    fastio();

    cin >> n >> q;
    while (s < n) s <<= 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        iz[i] = a[i];
    }

    sort(a, a + n);
    for (int i = 1; i < n; ++i) {
        b[i - 1] = a[i] - a[i - 1];
        mas[i - 1] = b[i - 1];
    }
    mas[n - 1] = b[n - 1] = 0;
    sort(mas, mas + n);

    int pref = 0;
    for (int i = n - 1; i >= 0; --i) {
        int New = b[i];
        if (!New) New = pref;
        else pref = b[i];
        tr[i + s].pb(New);
    }
    build();

    while (q--) {
        int tp, i;
        ll k;

        cin >> tp >> k;
        if (tp == 1) {
            int l = 0, r = n;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                (mas[m] <= k ? l : r) = m;
            }
            cout << n - l << '\n';
        }
        else if (tp == 2) {
            cout << func(k) << '\n';
        }
        else {
            cin >> i;
            ll val = iz[i - 1];
            int l = 0, r = n;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                (a[m] <= val ? l : r) = m;
            }
            cout << funct(k, l) << '\n';
        }
    }
}

/*
6 6
5 4 4 2 2 2
3 1 5

 */