#include <bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

const int N = 5e5 + 10;
const int INF = 2e9 + 10;

int t, n, m, timer = 0, hv[N], d[N], s[N], a[N], b[N];
bool used[N], go[N];
queue<int> q;
vector<int> g[N];

void init() {
    for (int i = 0; i < n; ++i) {
        d[i] = INF;
        g[i].clear();
        used[i] = go[i] = 0;
    }
    d[0] = 0;
}

void dfs(int v, int wout, int D) {
    hv[v] = timer;
    bool have = 0;
    for (int to : g[v]) {
        if (to == wout) have = 1;
        if (to == wout || hv[to] == timer) continue;
        dfs(to, wout, D);
    }

    if (have && D + 1 < d[v]) {
        d[v] = D + 1;
        q.push(v);
    }
}

void bfst(int v) {
    q.push(v);
    used[v] = 1;
    while (!q.empty()) {
        v = q.front();
        q.pop();

        for (int u : g[v]) {
            if (go[u]) continue;
            ++timer;
            dfs(v, u, d[v]);
        }
    }
}

void bfs(int v) {
    q.push(v);
    used[v] = 1;
    while (!q.empty()) {
        v = q.front();
        q.pop();

        for (int u: g[v]) {
            if (go[u]) continue;
            go[u] = 1;

            for (int to: g[u]) {
                if (used[to]) continue;

                used[to] = 1;
                if (d[v] + 1 < d[to]) {
                    d[to] = d[v] + 1;
                    q.push(to);
                }
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    init();
    for (int i = 0, u, v; i < m; ++i) {
        cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }

    if (n <= 1000 && m <= 2000) bfst(0);
    else bfs(0);

    for (int i = 1; i < n; ++i)
        cout << (d[i] == INF ? -1 : d[i] * 2) << ' ';
    cout << '\n';
}

int main() {
    fastio();

    cin >> t;
    while (t--) solve();
}