#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int> > gr;
/*vector<int> tin;
vector<int> fup;
int timer = 0;

void dfs(int v, int pr){
    tin[v] = ++timer;
    fup[v] = tin[v];
    for(int i = 0; i < gr[v].size(); ++i){
        int to = gr[v][i];
        if(tin[to] == -1){
            dfs(to, v);
            fup[v] = min(fup[v], fup[to]);
        }else{
            if(to != pr){
                fup[v] = min(fup[v], tin[to]);
            }
        }
    }
}*/

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T;
    cin >> T;
    for(int t = 0; t < T; ++t){
        int n, m;
        cin >> n >> m;
        gr = vector<vector<int> >(n);
        vector<char> us(n, true);
        for(int i = 0; i < m; ++i){
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            gr[u].push_back(v);
            gr[v].push_back(u);
        }
        vector<int> d(n, -1);
        d[0] = 0;
        queue<int> q;
        q.push(0);
        while(!q.empty()){
            int v = q.front();
            q.pop();
            for(int i = 0; i < gr[v].size(); ++i){
                int to = gr[v][i];
                if(us[to]){
                    for(int j = 0; j < gr[to].size(); ++j){
                        int to2 = gr[to][j];
                        if(d[to2] == -1){
                            d[to2] = d[v] + 2;
                            q.push(to2);
                        }
                    }
                    us[to] = false;
                }
            }
        }
        cout << d[1];
        for(int i = 2; i < n; ++i){
            cout << ' ' << d[i];
        }
        cout << endl;
    }
    return 0;
}
