//#define _CRT_SECURE_NO_WARNINGS
//#pragma GCC target ("avx,avx2,sse,sse2,sse3,sse4,fma,popcnt")
//#pragma GCC optimize ("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <random>
#include <map>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const long long INF = 4e18;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<long long> a(n);
	vector<pair<long long, int>> hah(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		hah[i] = { a[i], i };
	}
	sort(all(hah));
	vector<long long> q1;
	q1.reserve(n - 1);
	int beg = n;
	for (int i = 0; i < n - 1; ++i) {
		if (hah[i].first == hah[i + 1].first)
			beg--;
		else
			q1.push_back(hah[i + 1].first - hah[i].first);
	}
	sort(all(q1));

	map<long long, vector<int>> m;
	int cnt = beg - 1;
	long long st = 0;
	for (int i = 0; i < n - 1; ++i) {
		st += cnt;
		if (hah[i].first != hah[i + 1].first) {
			cnt--;
			m[hah[i + 1].first - hah[i].first].push_back(i);
		}
	}
	vector<array<long long, 3>> q2 = { {0, 0, st} }; //proshlo, summ, change
	q2.reserve(m.size() + 1);
	for (auto& [d, v] : m) {
		long long sm = q2.back()[1] + q2.back()[2] * (d - q2.back()[0]);
		for (auto i : v)
			st -= i + 1;
		q2.push_back({ d, sm, st });
	}

	while (q--) {
		int t;
		long long k;
		cin >> t >> k;
		if (t == 1) {
			cout << beg - (upper_bound(all(q1), k) - q1.begin()) << '\n';
		}
		else if (t == 2) {
			auto it = upper_bound(all(q2), array<long long, 3>{ k, INF, INF });
			it--;
			cout << (*it)[1] + (k - (*it)[0]) * (*it)[2] << '\n';
		}
	}
}
