#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define endl '\n'
#define int long long

struct ask {
    int num;
    int a_num;
    int type, pos;
    ask(int _num, int _type, int _a_num): num(_num), type(_type), a_num(_a_num) {}
    ask() {}
    ask(int _num, int _type, int _pos, int _a_num): num(_num), type(_type), pos(_pos), a_num(_a_num) {}
};

bool cmp(const ask& a, const ask& b) {
    return a.num < b.num;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    int summ = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        summ += a[i];
    }
    vector<pair<int, int>> mas(n);
    for (int i = 0; i < n; i++) {
        mas[i] = {a[i], i};
    }
    vector<ask> asks;
    for (int i = 0; i < q; i++) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            asks.push_back(ask(k, t, i));
        } else if (t == 2) {
            asks.push_back(ask(k, t, i));
        } else {
            int pos;
            cin >> pos;
            asks.push_back(ask(k, t, pos, i));
        }
    }
    sort(mas.begin(), mas.end());
    reverse(mas.begin(), mas.end());
    sort(asks.begin(), asks.end(), cmp);
    int p = 0;
    vector<int> ans(q);
//    cout << asks[p].num << " " << asks[p].type << endl;
    while (p < asks.size() && asks[p].num == 0) {
        if (asks[p].type == 1) {
            int num = 0;
            for (int i = 0; i < n; i++) {
                if (i == 0 || mas[i].first != mas[i - 1].first) {
                    num++;
                }
            }
            ans[asks[p].a_num] = num;
        } else if (asks[p].type == 2) {
            ans[asks[p].a_num] = 0;
        } else if (asks[p].type == 3) {
            for (int i = 0; i < n; i++) {
                if (mas[i].second == asks[p].pos - 1) {
                    ans[asks[p].a_num] = mas[i].first;
                    break;
                }
            }
        }
        p++;
    }
    for (int i = 1; i <= 10000 && p < asks.size(); i++) {
        int num = 0;
        for (int j = 0; j < n; j++) {
            mas[j].first += num;
            if (j == n - 1 || mas[j].first - num > mas[j + 1].first) {
                num++;
            }
        }
        sort(mas.begin(), mas.end());
        reverse(mas.begin(), mas.end());
//        for (auto j : mas) {
//            cout << j.first << " ";
//        }
//        cout << endl << endl;
        while (p < asks.size() && asks[p].num == i) {
//            cout << asks[p].num << " " << asks[p].a_num << endl;
//            cout << asks[p].num << " " << asks[p].a_num << endl;
            if (asks[p].type == 1) {
                int nnum = 0;
                for (int j = 0; j < n; j++) {
                    if (j == 0 || mas[j].first != mas[j - 1].first) {
                        nnum++;
                    }
                }
                ans[asks[p].a_num] = nnum;
            } else if (asks[p].type == 2) {
                int summ_new = 0;
                for (int j = 0; j < n; j++) {
                    summ_new += mas[j].first;
                }
                ans[asks[p].a_num] = summ_new - summ;
            } else if (asks[p].type == 3) {
                for (int j = 0; j < n; j++) {
                    if (mas[j].second == asks[p].pos - 1) {
                        ans[asks[p].a_num] = mas[j].first;
                        break;
                    }
                }
            }
            p++;
        }
    }
    for (int i : ans) {
        cout << i << endl;
    }
}
