#include <bits/stdc++.h>
#define vec vector
#define fi first
#define se second
#define all(x) x.begin(),x.end()
#define ll long long
#define endl "\n"
#define int long long

using namespace std;

struct SNM{
    vec<int> pr, sz;
    SNM(int n) {
        pr.resize(n);
        sz.resize(n, 1);
        for (int i = 0; i < n; ++i) pr[i] = i;
    }
    int get_lead(int x) {
        if (pr[x] != x) return pr[x] = x;
        return x;
    }
    bool merg(int a, int b) {
        a = pr[a];
        b = pr[b];
        if (a == b) return false;
        if (sz[a] < sz[b]) swap(a, b);
        sz[a] += sz[b];
        pr[b] = a;
        return true;
    }
};

struct ST{
    vec<int> tree;
    int sz = 2;
    ST(vec<int> v) {
        while (sz < v.size()) sz *= 2;
        tree.resize(sz * 2, 0);
        for (int i = 0; i < v.size(); ++i) {
            tree[i + sz] = v[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = tree[i * 2] + tree[i * 2 + 1];
        }
    }
    int get_sum(int id, int l, int r, int lb, int rb) {
        if (r <= lb ||rb <= l) return 0;
        if (lb <= l && r <= rb) return tree[id];

        int la = get_sum(id * 2, l, (l + r) / 2, lb, rb);
        int ra = get_sum(id * 2 + 1,(l + r) / 2, r, lb, rb);
        return la + ra;
    }
    void add_val(int id, int l, int r, int lb, int rb, int val) {
        if (r <= lb ||rb <= l) return;
        if (lb <= l && r <= rb) {tree[id] += val; return;}

        add_val(id * 2, l, (l + r) / 2, lb, rb, val);
        add_val(id * 2 + 1,(l + r) / 2, r, lb, rb, val);
        tree[id] = tree[id * 2] + tree[id * 2 + 1];
    }
    void print() {
        for (int i = 0; i < sz; ++i) cout << tree[i + sz] << ' ';
        cout << endl;
    }
};

void solve() {
    int n, q; cin >> n >> q;
    vec<int> v(n);
    for (auto& it: v) cin >> it;
    map<int, int> mp;
    SNM snm(n);
    set<pair<int, int>> col;
    int kol = 0;
    for (int i = 0; i < n; ++i) {
        if (mp.count(v[i])) {
            snm.merg(i, mp[v[i]]);
        } else {
            kol++;
            col.insert({v[i], i});
        }
        mp[v[i]] = i;
        //cout << "SNM " << i << ' ' << kol << endl;
    }
    vec<int> ans(q, -1);
    vec<pair<int, int>> zp;
    vec<pair<int, int>> zpq(q);
    vec<pair<int, int>> upd;
    set<int> st;
    vec<int> dop;
    for (auto it: col) dop.push_back(it.fi);
    vec<int> dop2(dop.size());
    map<int, int> mp2;
    for (int i = 0; i < dop.size(); ++i) mp2[dop[i]] = i;
    for (int i = 0; i < n; ++i) {
        dop2[mp2[v[i]]]++;
    }
    int valad = 0, alr = 0, p = 0;
    for (int i = 0; i < dop2.size(); ++i) {
        valad += dop2[i] * (dop2.size() - 1 - i);
    }
    vec<int> dop3(dop.size(), 1);
    ST tree(dop2), tree2(dop3);
    //for (auto it: dop) cout << it << ' ';
    //cout << endl;
    for (int i = 1; i < dop.size(); ++i) {
        st.insert(dop[i] - dop[i - 1]);
        upd.push_back({dop[i] - dop[i - 1], i - 1});
    }
    sort(all(upd));
    for (int i = 0; i < q; ++i) {
        int a, b; cin >> a >> b;
        if (a == 3) {
            int c; cin >> c;
            zpq[i] = {a, c};
        } else zpq[i] = {a, -1};
        zp.push_back({b, i});
        st.insert(b);
    }
    sort(all(zp));
    int num1 = 0, num2 = 0;
    for (auto tim: st) {
        alr += (tim - p) * valad;
        p = tim;
        //cout << "NOW " << tim << ' ' << num1 << ' ' << num2 << ' ' << alr << endl;
        while (num1 < upd.size() && upd[num1].fi == tim) {
            int nw = upd[num1].se;
            /*cout << "UPD " << upd[num1].fi << ' ' << upd[num1].se << ' ' << nw << ' ' << dop[nw] << endl;
            for (auto it: col) cout << it.fi << ' ' << it.se << endl;
            cout << "---" << endl;
            cout << valad << endl;
            tree.print();
            tree2.print();*/
            auto it = col.lower_bound({dop[nw], -1});
            int now = (*it).se;
            it++;
            int ne = (*it).se;
            int nw2 = mp2[v[ne]];
            //cout << "VR " << nw << ' '<< nw2 << ' ' << now << ' ' << ne << endl;
            it--;

            int x = tree.get_sum(1, 0, tree.sz, nw, nw + 1);
            valad -= x * tree2.get_sum(1, 0, tree2.sz, nw + 1, tree2.sz);
            //cout << valad << endl;
            valad -= tree.get_sum(1, 0, tree.sz, 0, nw);
            //cout << valad << endl;
            valad += x * tree2.get_sum(1, 0, tree2.sz, nw2 + 1, tree2.sz);
            //cout << valad << endl;
            tree.add_val(1, 0, tree.sz, nw, nw + 1, -x);
            tree.add_val(1, 0, tree.sz, nw2, nw2 + 1, x);
            tree2.add_val(1, 0, tree2.sz, nw, nw + 1, -1);

            col.erase(it);
            kol--;
            snm.merg(now, ne);
            num1++;
            /*cout << valad << endl;
            tree.print();
            tree2.print();
            cout << kol << endl;
            cout << "===" << endl;*/
        }
        while (num2 < zp.size() && zp[num2].fi == tim) {
            //cout << "ZP " << zp[num2].fi << ' ' << zp[num2].se << ' ' << kol << endl;
            int ind = zp[num2].se;
            if (zpq[ind].fi == 1) {
                ans[ind] = kol;
            } else if (zpq[ind].fi == 2) {
                ans[ind] = alr;
            }
            num2++;
        }
        //cout << "END " << tim << endl;
    }
    for (auto it: ans) cout << it << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.in", "r", stdin);
    int tests = 1;
    //cin >> tests;
    while (tests > 0) {
        solve();
        tests--;
    }
}
