#include <bits/stdc++.h>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//#pragma GCC optimise("O3, unroll-loops")
//#pragma GCC target("avx2")

//template <typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define _ << " " <<
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#ifdef LOCAL
#define err cerr
#else
#define err if(0) cerr
#endif

#define int ll

mt19937 rnd(time(0));

const int N = 5e5 + 10;

vector<pair<int, int> > g[N];
set<int> b;
int d[N][2];
bool fl[N];
bool col[N];
int tin[N];
int up[N];
int timer = 1;

void fnd_b(int v, int p) {
    tin[v] = up[v] = timer++;
    int c = 0;
    for (auto [to, num] : g[v]) {
        if (to == p) continue;
        ++c;
        if (tin[to] == 0) {
            fnd_b(to, v);
            up[v] = min(up[v], up[to]);
            if (up[to] > tin[v]) {
                b.insert(num);
            }
            if (up[to] >= tin[v] && p != -1) {
                fl[v] = 1;
            }
        } else {
            up[v] = min(up[v], tin[to]);
        }
    }

    if (p == -1 && c == 1) fl[v] = 1;
}

void get_c(int v) {
    col[v] = 1;
    for (auto [to, num] : g[v]) {
        if (fl[to] || col[to] || b.count(num)) continue;
        get_c(to);
    }
}

void bfs() {
    priority_queue<vector<int> > q;
    q.push({0, 0, 1});
    while (!q.empty()) {
        auto tmp = q.top();
        q.pop();

        int dst = -tmp[0];
        int c = tmp[1];
        int v = tmp[2];

        if (dst != d[v][c]) continue;

        for (auto [to, num] : g[v]) {
            if (to == 1) continue;
            if (b.count(num)) continue;

            int w = 1;
            if (fl[v] && !col[to] && c == 1) w = 3;
            if (d[to][c ^ 1] == 0 || d[to][c ^ 1] > d[v][c] + w) {
                d[to][c ^ 1] = d[v][c] + w;
                q.push({-d[to][c ^ 1], (c ^ 1), to});
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    b.clear();
    for (int i = 0; i <= n; ++i) {
        g[i].clear();
        d[i][0] = d[i][1] = 0;
        tin[i] = 0;
        up[i] = 0;
        timer = 1;
        fl[i] = 0;
        col[i] = 0;
    }

    int a, b;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    fnd_b(1, -1);
    get_c(1);
    bfs();

    for (int i = 2; i <= n; ++i) {
        if (d[i][0] == 0) cout << -1 << " ";
        else cout << d[i][0] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
        cout << "\n";
    }
}
