#include <bits/stdc++.h>

using namespace std;
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) (int)((x).size())
const char nl = '\n';

typedef long long ll;
typedef long double ld;

const int maxn = 500000;

const int inf = 1e9;
int timer = 0;
vector<int> g[maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }


    vector<int> td(n, inf);
    queue<int> q;
    q.push(0);
    td[0] = 0;


    vector<bool> tused(n, false);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int k: g[v]) {
            if (tused[k]) continue;
            for (int u: g[k]) {
                if (td[u] == inf) {
                    q.push(u);
                    td[u] = td[v] + 2;
                }
            }
            tused[k] = true;
        }
    }
    for (int i = 1; i < n; i++) {
        if (td[i] == inf) cout << -1 << ' ';
        else cout << td[i] << ' ';
    }
    cout << nl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}