#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
#define x first
#define y second
using ll = long long;
using ld = long double;

const int N = 3e5 + 10;

struct Query {
	int type;
	ll k;
	int i;
} qs[N];

ll a[N];
int order[N];
ll dlta[N];
ll ans[N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, q;
	cin >> n >> q;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	iota(order, order + n, 0);
	sort(order, order + n, [](auto x, auto y) {
		return a[x] < a[y];
	});

	for (int i = 0; i < q; ++i) {
		cin >> qs[i].type >> qs[i].k;
		if (qs[i].type == 3) {
			cin >> qs[i].i;
			qs[i].i = order[qs[i].i - 1];
		}
	}
	sort(a, a + n);
	map<ll, vector<int>> events;
	for (int i = 0; i < n - 1; ++i) {
		dlta[i] = a[i + 1] - a[i];
		events[dlta[i]].push_back(-i - 1);
	}
	sort(dlta, dlta + n - 1);
	for (int i = 0; i < q; ++i) {
		auto [type, k, ci] = qs[i];
		if (type == 1) {
			ans[i] = n - int(lower_bound(dlta, dlta + n - 1, k + 1) - dlta);
		} else if (type == 2) {
			events[k].push_back(i);
		}
	}
	ll prv = 0, added = 0, k = ll(n) * (n - 1) / 2;
	for (const auto &[where, curr] : events) {
		added += (where - prv) * k;
		prv = where;
		for (auto u : curr) {
			if (u < 0) {
				k += u;
			} else {
				ans[u] = added;
			}
		}
	}
	for (int i = 0; i < q; ++i) {
		cout << ans[i] << "\n";
	}
}