#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

struct query {
	int t, k, idx, idx2, w;
};

const int maxn = 3e5;
int p[maxn], sz[maxn], mx[maxn], val[maxn], pl[maxn];
set<int> f;
int num, cnt, s = 0, lt = 0, n;

int par(int v) {
	if (p[v] == v)
		return v;
	return p[v] = par(p[v]);
}

void unit(int u, int v, int tm) {
	u = par(u), v = par(v);
	if (sz[v] > sz[u])
		swap(u, v);
	sz[u] += sz[v];
	p[v] = u;
	s += (tm - lt) * (cnt);
	//if (tm == 1)
		//int z = -1;
	cnt -= min(mx[u], mx[v]);
	
	mx[u] = max(mx[u], mx[v]);
	f.erase(v);
	if (val[u] > val[v]) {
		for (auto& i : f) {
			if (val[i] < max(val[u], val[v])) {
				val[i] += pl[i] * (tm - lt);
				pl[i]--;
			}
			else
				val[i] += pl[i] * (tm - lt);
		}
	}
	else {
		val[u] = val[v], pl[u] = pl[v];
		for (auto& i : f) {
			if (val[i] < max(val[u], val[v])) {
				val[i] += pl[i] * (tm - lt);
				pl[i]--;
			}
			else
				val[i] += pl[i] * (tm - lt);
		}
	}
	//for (auto& i : f)
		//cout << i << ' ' << pl[i] << ',';
	//cout << '\n';
}

signed main()
{
	int q;
	cin >> n >> q;
	num = n;
	cnt = (n * (n - 1)) / 2;
	vector<int> A(n), I(n);
	for (int i = 0; i < n; ++i)
		I[i] = i;
	for (int i = 0; i < n; ++i) {
		cin >> A[i];
		val[i] = A[i];
	}
	sort(I.begin(), I.end(), [&](int i, int j) {return A[i] < A[j]; });
	for (int i = 0; i < n; ++i) {
		mx[I[i]] = i + 1;
		pl[I[i]] = n - mx[I[i]];
	}
	vector<query> Q;
	sort(A.begin(), A.end());
	vector<int> d(n - 1);
	for (int i = 0; i < n - 1; ++i) {
		d[i] = A[i + 1] - A[i];
		Q.push_back({ 4, d[i], I[i], I[i+1], 0});
	}
	for (int i = 0; i < q; ++i) {
		int t, k;
		cin >> t >> k;
		if (t == 3) {
			int w;
			cin >> w;
			w--;
			Q.push_back({ t, k, i, 0, w });
		}
		else
			Q.push_back({ t, k, i, 0, 0 });
	}
	sort(Q.begin(), Q.end(), [](query a, query b) {return a.k < b.k || (a.k == b.k && a.t > b.t); });
	for (int i = 0; i < n; ++i) {
		p[i] = i;
		sz[i] = 1;
		f.insert(i);
	}
	vector<int> ans(q);
	for (auto& qq : Q) {
		if (qq.t == 4) {
			unit(qq.idx, qq.idx2, qq.k);
			lt = qq.k;
		}
		else {
			if (qq.t == 1)
				ans[qq.idx] = (int)f.size();
			if (qq.t == 2)
				ans[qq.idx] = s + (qq.k - lt) * cnt;
			if (qq.t == 3)
				ans[qq.idx] = val[par(qq.w)];
		}
	}
	for (int i =0; i<q; ++i)
		cout<<ans[i]<<'\n';
}