#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

#ifdef _DEBUG
#define __int128_t __int64
ll __builtin_popcount(ll x) {
	ll ret = 0;
	while (x) {
		ret++;
		x &= (x - 1);
	}
	return ret;
}
#endif

typedef __int128_t ii;

const ll inf = 4e18 + 228;

void ex() {
	cout.flush();
	exit(0);
}

ll y;

ll pw10[18];

void solve(string s) {
	vector<ll> dp((1ll << s.size()), -1);
	vector<string> pr((1ll << s.size()), "");
	dp[0] = 0;
	for (ll mask = 0; mask < (1ll << s.size()); mask++) {
		if (dp[mask] < 0) continue;
		ll pp = __builtin_popcount(mask);
		ll cn = 0;
		for (ll bt = 0; bt < s.size(); bt++) {
			if ((mask >> bt) & 1) {
				cn++;
				continue;
			}
			ll nv = dp[mask] + pw10[s.size() - pp - 1] * (s[bt] - '0') - y * (bt - pp - pp - cn);
			if (dp[mask | (1ll << bt)] < nv) {
				dp[mask | (1ll << bt)] = nv;
				pr[mask | (1ll << bt)] = pr[mask] + s[bt];
			}
			else if (dp[mask | (1ll << bt)] == nv && pr[mask | (1ll << bt)] < pr[mask] + s[bt]) {
				pr[mask | (1ll << bt)] = pr[mask] + s[bt];
			}
		}
	}
	cout << pr[(1ll << s.size()) - 1];
}

string s;

string answ;

set<pair<ll, ll>> st;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	pw10[0] = 1;
	for (ll i = 1; i < 18; i++) pw10[i] = 10 * pw10[i - 1];
	cin >> s >> y;
	ll n = s.size();
	for (ll i = 0; i < n; i++) {
		st.insert({ s[i], n - i });
	}
	while (st.size() > 18) {
		auto p = *st.rbegin();
		st.erase(p);
		answ.push_back(p.first);
	}
	string ns = "";
	vector<pair<ll, ll>> vc;
	for (auto i : st) vc.push_back({ n - i.second, i.first });
	sort(all(vc));
	for (auto i : vc) ns.push_back(i.second);
	cout << answ;
	solve(ns);
	ex();
}
