#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")
 
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
 
#define endl '\n'
#define all(arr) arr.begin(), arr.end()
//define int long long
#define out(x) cout << (x) << endl, exit(0)
 
using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
 
typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;
 
const int C = 30;
 
int n, k;
string s;
__int128 po[C];
 
void build() {
    n = s.size();
    assert(n <= 20);
    *po = 1;
    for (int i = 1; i < C; ++i)
        po[i] = po[i - 1] * 10;
}
 
inline __int128 val(__int128 x, int i) {
    return po[n - i - 1] * x;
}
 
pair<__int128, string> go(string s, int i, int c) {
    auto it = find(s.begin() + i, s.end(), c);
    if (it == s.end()) return {-1, "#"};
    __int128 cost = -(it - s.begin() - i) * k - val(c - '0', it - s.begin()) + val(c - '0', i);
    for (int j = i; j < it - s.begin(); ++j)
        cost -= 9 * val(s[j] - '0', j + 1);
//  cerr << i << ' ' << c << ' ' << cost << endl;
    s.erase(it);
    s.insert(s.begin() + i, c);
    return {cost, s};
}
 
string solve() {
    pair<__int128, string> ans {0, s};
    for (int _ = 0; _ < n; ++_) {
        ans.first = -1;
        for (int i = 0; i < n; ++i)
            for (char c = s[i] + 1; c <= '9'; ++c)
                ans = max(ans, go(s, i, c));
        s = ans.second;
    }
    return s;
}
 
int32_t main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
    cout.setf(ios::fixed), cout.precision(10);
    cin >> s >> k;
    build();
    cout << solve() << endl;
}