#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 5050;
const int MAXT = MAXN;
const int INF = 1e18;

int n, q, m, t, id, k;
int arr[MAXN], brr[MAXN], A[MAXT][MAXN], cnt[MAXT];

inline int go(int x, int dlt) {
	auto it = upper_bound(brr, brr + m, x);
	return (m - (it - brr)) * dlt;
}

void build() {
	memcpy(A[0], arr, n * sizeof(int));
	t = 1;
	while (m != 1) {
		assert(t < MAXT)
		memcpy(brr, arr, n * sizeof(int));
		sort(brr, brr + n);
		m = unique(brr, brr + n) - brr;
		int dlt = INF;
		for (int i = 0; i + 1 < m; ++i)
			dlt = min(dlt, brr[i + 1] - brr[i]);
		cnt[t] = cnt[t - 1] + (dlt == INF ? 0 : dlt);
		for (int i = 0; i < n; ++i)
			arr[i] += go(arr[i], dlt);
		memcpy(A[t++], arr, n * sizeof(int));
	}
}

int solve1() {
	return m;
}

int solve2() {
	int ans = accumulate(A[id], A[id] + n, 0) - accumulate(A[0], A[0] + n, 0);
	for (int i = 0; i < n; ++i)
		ans += go(A[id][i], k);
	return ans;
}

int solve3(int i) {
	int ans = A[id][i];
	ans += go(ans, k);
	return ans;
}

void solve() {
	id = upper_bound(cnt, cnt + t, k) - cnt - 1;
	k -= cnt[id];
	memcpy(brr, A[id], n * sizeof(int));
	sort(brr, brr + n);
	m = unique(brr, brr + n) - brr;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	cin >> n >> q;
	assert(n <= 5000);
	for (int i = 0; i < n; ++i)
		cin >> arr[i];
	build();
	while (q--) {
		int tp; cin >> tp >> k;
		solve();
		if (tp == 1) cout << solve1() << endl;
		else if (tp == 2) cout << solve2() << endl;
		else if (tp == 3) {
			int i; cin >> i, --i;
			cout << solve3(i) << endl;
		}
	}
}